unit T_gp;

interface
uses
   Classes,
   Elements,
   Tools,
   e_DClass;

type

TGP = class(TResultTool)
private
   FDB: TDatabaseClass;
   FPropertyName: string;
   FPathToProperty: string;
   FKeyProperties: TstringList;
   function  GetKeyProperties: TStringList;
   procedure SetPathToProperty(const aValue: string);
   procedure SetNewKeyProperty(const aValue: string);
   procedure SetNextKeyProperty(const aValue: string);
protected
   function NumberToPropertyName(aNumber: longInt): string; override;
public
   destructor Destroy; override;
   procedure  DoIt; override;
   property   KeyProperties: TStringList read GetKeyProperties;
published
   property DB: TDatabaseClass read FDB write FDB;
   property PropertyName: string read FPropertyName write FPropertyName;
   property PathToProperty: string read FpathToProperty write SetpathToProperty;
   property NewKeyProperty: string write SetNewKeyProperty;
   property NextKeyProperty: string write SetNextKeyProperty;
end;

implementation

uses
   e_Class,
   t_CmdLn;

{ TGP }


destructor TGP.Destroy;
begin
   if FKeyProperties <>  nil then FKeyProperties.Free;
   inherited Destroy;
end;


function  TGP.GetKeyProperties: TStringList;
begin
   if FKeyProperties = nil then FKeyProperties := TStringList.Create;
   result := FKeyProperties;
end;


procedure TGP.SetNewKeyProperty(const aValue: string);
begin
   KeyProperties.Clear;
   SetNextKeyProperty(aValue);
end;

procedure TGP.SetNextKeyProperty(const aValue: string);
begin
   KeyProperties.Add(aValue);
end;


procedure TGP.SetPathToProperty(const aValue: string);
var
   CL: TCommandLine;
   P: TPropertyInfo;
begin
   FillChar(P, SizeOf(P), 0);
   CL := TCommandLine.Create;
   CL.CompileLine(aValue, P);
   if P.Element is TDatabaseClass then DB := TDatabaseClass(P.Element)
                                  else DB := nil;
   PropertyName := P.PropertyName;
   CL.Free;
end;


function  TGP.NumberToPropertyName(aNumber: longInt): string;
begin
   if aNumber = 0 then result := 'PathToProperty'
                  else result := 'NextKeyProperty';
end;


procedure TGP.DoIt;
var
   i: longInt;
   S: string;
begin
   if Input = nil then exit;
   if DB = nil then exit;
   S := '';
   for i := 0 to KeyProperties.Count - 1 do
   begin
      if S <> '' then S := S + ',';
      S := S + Input.GetPropertyStringByName(KeyProperties.Strings[i]);
   end;
   Result := DB.PropertyValueN[PropertyName, S];
end;

BEGIN
   RegisterOrbisClass(TGP);
END.
