unit f_LHCFinderForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  f_OrbisForm, StdCtrls,
  e_LHCModel,e_KatastrModel, Buttons, ExtCtrls, ComCtrls;

type
  TLHCFinder_Form = class(TORBISForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    l_LHC: TLabel;
    l_Oddeleni: TLabel;
    l_Dilec: TLabel;
    l_Porost: TLabel;
    l_Skupina: TLabel;
    Panel_Porost: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label9: TLabel;
    Label3: TLabel;
    ed_LHC: TComboBox;
    ed_LS: TComboBox;
    ed_Oddeleni: TComboBox;
    ed_Dilec: TComboBox;
    ed_Porost: TComboBox;
    ed_Skupina: TComboBox;
    BitBtn1: TBitBtn;
    cb_ZAK: TCheckBox;
    ed_KU: TComboBox;
    ed_SkParc: TComboBox;
    ed_Parcela: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    BitBtn2: TBitBtn;
    ed_ParcelaSK: TComboBox;
    Label10: TLabel;
    l_KU: TLabel;
    l_SKP: TLabel;
    l_PAR: TLabel;
    l_LS: TLabel;
    ed_KUNazev: TComboBox;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ed_LHCClick(Sender: TObject);
    procedure ed_LSClick(Sender: TObject);
    procedure ed_OddeleniClick(Sender: TObject);
    procedure ed_PorostClick(Sender: TObject);
    procedure ed_DilecClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure cb_ZAKClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure ed_KUClick(Sender: TObject);
    procedure ed_SkParcClick(Sender: TObject);
    procedure ed_ParcelaSKClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure ed_KUNazevClick(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
  private
    FForestModel: Tgis_ForestModel;
    FParcelModel: Tgis_ParcelModel;
    NazevSetting: boolean;
    FSraf: boolean;
    procedure SetForestModel(const Value: Tgis_ForestModel);
    procedure SetParcelModel(const Value: Tgis_ParcelModel);
    procedure SetSraf(const Value: boolean);
    { Private declarations }
  public
     property ForestModel: Tgis_ForestModel read FForestModel write SetForestModel;
     property ParcelModel: Tgis_ParcelModel read FParcelModel write SetParcelModel;
     property Sraf: boolean read FSraf write SetSraf;
  end;


implementation
uses
   Elements,
   t_GraphicForm,
   m_Orbis;
{$R *.DFM}

procedure TLHCFinder_Form.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   inherited;
   if Tool <> nil then
      Tool.PostMsg(tm_Hide,Tool,nil,false);
   CanClose := true;
end;

procedure TLHCFinder_Form.SetForestModel(const Value: Tgis_ForestModel);
var
   i: integer;
begin
   FForestModel := Value;
   if Value = nil then exit;
   ed_LHC.Items.Clear;
   for i := 0 to Value.LastIndex do
      ed_LHC.Items.Add(Value.Elements[i].Name);
end;

procedure TLHCFinder_Form.ed_LHCClick(Sender: TObject);
var
   i,j: integer;
begin
   ed_LS.Items.Clear;
   ForestModel.LHC_Cislo := StrToInt(ed_LHC.Text);
   ed_Oddeleni.Items.Clear;
   ed_Oddeleni.Text := '';
   if (ForestModel.ActualLHC <> nil) and not ForestModel.ActualLHC.NoItems then
   for i := 0 to ForestModel.ActualLHC.Items.LastIndex do
   begin
      ed_LS.Items.Add(ForestModel.ActualLHC.Items.elements[i].Name);
      ForestModel.LS_Cislo := StrToInt(ForestModel.ActualLHC.Items.elements[i].Name);
      if (ForestModel.ActualLS <> nil) and not ForestModel.ActualLS.NoItems then
      for j := 0 to ForestModel.ActualLS.Items.LastIndex do
      begin
         ed_Oddeleni.Items.Add(ForestModel.ActualLS.Items.Elements[j].Name);
      end;
   end;
   if Sender <> nil then
   begin
      ed_LS.Text := '';
      ed_Dilec.Items.Clear;
      ed_Dilec.Text := '';
      ed_Porost.Items.Clear;
      ed_Porost.Text := '';
      ed_Skupina.Items.Clear;
      ed_SKupina.Text := '';
   end;
end;

procedure TLHCFinder_Form.ed_LSClick(Sender: TObject);
var
   i: integer;
begin
   ed_Oddeleni.Items.Clear;
   ForestModel.LS_Cislo := StrToInt(ed_LS.Text);
   if (ForestModel.ActualLS <> nil) and not ForestModel.ActualLS.NoItems then
   for i := 0 to ForestModel.ActualLS.Items.LastIndex do
   begin
      ed_Oddeleni.Items.Add(ForestModel.ActualLS.Items.elements[i].Name);
   end;
   if Sender <> nil then
   begin
      ed_Oddeleni.Text := '';
      ed_Dilec.Items.Clear;
      ed_Dilec.Text := '';
      ed_Porost.Items.Clear;
      ed_Porost.Text := '';
      ed_Skupina.Items.Clear;
      ed_SKupina.Text := '';
   end;
end;

procedure TLHCFinder_Form.ed_OddeleniClick(Sender: TObject);
var
   i: integer;
begin
   ed_Dilec.Items.Clear;
   ForestModel.LS_Cislo := StrToIntDef(ed_LS.Text,-1);
   ForestModel.Oddeleni_Cislo := StrToInt(ed_Oddeleni.Text);
   if (ForestModel.ActualOddeleni <> nil)and  not ForestModel.ActualOddeleni.NoItems then
   for i := 0 to ForestModel.ActualOddeleni.Items.LastIndex do
   begin
      ed_Dilec.Items.Add(ForestModel.ActualOddeleni.Items.elements[i].Name);
   end;
   if Sender <> nil then
   begin
      ed_Dilec.Text := '';
      ed_Porost.Items.Clear;
      ed_Porost.Text := '';
      ed_Skupina.Items.Clear;
      ed_SKupina.Text := '';
   end;
end;

procedure TLHCFinder_Form.ed_PorostClick(Sender: TObject);
var
   i: integer;
begin
   ed_Skupina.Items.Clear;
   ForestModel.Porost_Name := ed_Porost.Text;
   if (ForestModel.ActualPorost <> nil) and not ForestModel.ActualPorost.NoItems then
   for i := 0 to ForestModel.ActualPorost.Items.LastIndex do
   begin
      ed_Skupina.Text := '';
      ed_Skupina.Items.Add(ForestModel.ActualPorost.Items.elements[i].Name);
   end;
end;

procedure TLHCFinder_Form.ed_DilecClick(Sender: TObject);
var
   i: integer;
begin
   ed_Porost.Items.Clear;
   ForestModel.Dilec_Name := ed_Dilec.Text;
   if (ForestModel.ActualDilec <> nil) and not ForestModel.ActualDilec.NoItems then
   for i := 0 to ForestModel.ActualDilec.Items.LastIndex do
   begin
      ed_Porost.Items.Add(ForestModel.ActualDilec.Items.elements[i].Name);
   end;
   if Sender <> nil then
   begin
      ed_Porost.Text := '';
      ed_Skupina.Items.Clear;
      ed_SKupina.Text := '';
   end;
end;

procedure TLHCFinder_Form.BitBtn1Click(Sender: TObject);
var
   e: TElement;
   GF: TGraphicForm;
begin
   if ForestModel = nil then exit;
   ForestModel.LHC_Cislo := StrToIntDef(ed_LHC.Text,-1);
   ForestModel.LS_Cislo := StrToIntDef(ed_LS.Text,-1);
   ForestModel.Oddeleni_Cislo := StrToIntDef(ed_Oddeleni.Text,-1);
   ForestModel.Dilec_Name := ed_Dilec.Text;
   ForestModel.Porost_Name := ed_Porost.Text;
   ForestModel.Skupina_Name := ed_Skupina.Text;
   e := nil;
   e := ForestModel.ActualSkupina;
   if e = nil then
      e := ForestModel.ActualPorost;
   if e = nil then
      e := ForestModel.ActualDilec;
   if e = nil then
      e := ForestModel.ActualOddeleni;
   if e = nil then
      e := ForestModel.ActualLS;
   if e = nil then
      e := ForestModel.ActualLHC;
   if Tool <> nil then
   begin
      if e = nil then exit;
      GF := TGraphicForm(Tool.FindClassInOwners(TGraphicForm));
      if GF <> nil then
      begin
         if not Sraf then
         begin
            GF.ElementForProjection := e;
            Application.ProcessMessages;
         end;
         GF.ElementForPattern := e;
      end
   end;
end;

procedure TLHCFinder_Form.cb_ZAKClick(Sender: TObject);
begin
   Tool.SetPropertyBooleanByName('FindByZAK',cb_ZAK.Checked);
end;

procedure TLHCFinder_Form.SetParcelModel(const Value: Tgis_ParcelModel);
var
   i: integer;
   S: string;
begin
   FParcelModel := Value;
   if Value = nil then exit;
   ed_KU.Items.Clear;
   ed_KUNazev.Items.Clear;
   for i := 0 to Value.LastIndex do
   begin
      ed_KU.Items.Add(Value.Elements[i].Name);
      S := Tgis_Katastr(Value.Elements[i]).Nazev;
      if S = '' then
         S := '?';
      ed_KUNazev.Items.Add(S);
   end;
end;

procedure TLHCFinder_Form.BitBtn2Click(Sender: TObject);
var
   e: TElement;
   GF: TGraphicForm;
   SKP: Tgis_SkupinaParcel;
   aKU: Tgis_Katastr;
begin
   if ParcelModel = nil then exit;
   ParcelModel.Katastr_Cislo := StrToIntDef(ed_KU.Text,0);
   //if ed_SKParc.Text <> '' then
    ParcelModel.SkupinaParcel_Cislo := StrToIntDef(ed_SkParc.Text,-1);
   if ed_Parcela.Text <> '' then
      ParcelModel.Parcela_CisloPodlomeni := ed_Parcela.Text;
   e := nil;
   e := ParcelModel.ActualParcela;
   if e = nil then
      e := ParcelModel.ActualSkupinaParcel;
   if e = nil then
      e := ParcelModel.ActualKatastr;
   if e = nil then exit;
   if Tool <> nil then
   begin
      GF := TGraphicForm(Tool.FindClassInOwners(TGraphicForm));
      if GF <> nil then
      begin
         if not Sraf then
         begin
            GF.ElementForProjection := e;
            Application.ProcessMessages;
         end;
         {
         if Sraf then
         if e is Tgis_SkupinaParcel then
         begin
            SKP := Tgis_SkupinaParcel(e);
            if SKP.NoGeometry then
               GF.ElementForPattern := SKP
            else
               GF.ElementForPattern := SKP.Geometry;
         end
         else
         }
         if e is Tgis_Katastr then
         begin
            aKU := TGis_Katastr(e);
            if aKU.NoGeometry then
               e := aKU.Parcely;
         end;
         GF.ElementForPattern := e;
      end;
   end;
end;

procedure TLHCFinder_Form.ed_KUClick(Sender: TObject);
var
   i: integer;
begin
   if not NazevSetting then
      ed_KUNazev.ItemIndex := ed_KU.ItemIndex;
   ed_SkParc.Items.Clear;
   ed_Parcela.Items.Clear;
   ParcelModel.Katastr_Cislo := StrToIntDef(ed_KU.Text,0);
   if (ParcelModel.ActualKatastr <> nil) and not ParcelModel.ActualKatastr.NoSkupinaParcel then
   for i := 0 to ParcelModel.ActualKatastr.SkupinyParcel.LastIndex do
   begin
      ed_SkParc.Items.Add(ParcelModel.ActualKatastr.SkupinyParcel.elements[i].Name);
   end;
   if (ParcelModel.ActualKatastr <> nil) and not ParcelModel.ActualKatastr.NoParcela then
   for i := 0 to ParcelModel.ActualKatastr.Parcely.LastIndex do
   begin
      ed_Parcela.Items.Add(ParcelModel.ActualKatastr.Parcely.elements[i].Name);
   end;
   if Sender <> nil then
   begin
      ed_SKParc.Text := '';
      ed_Parcela.Text := '';
      ed_ParcelaSK.Text := '';
   end;
end;

procedure TLHCFinder_Form.ed_SkParcClick(Sender: TObject);
var
   i: integer;
   PC: Tgis_ParcelaCast;
   P: Tgis_Parcela;
   e: TElement;
begin
   ed_ParcelaSK.Items.Clear;
   ParcelModel.SkupinaParcel_Cislo := StrToIntDef(ed_SkParc.Text,-1);
   if (ParcelModel.ActualSkupinaParcel <> nil) and not ParcelModel.ActualSkupinaParcel.NoParcela then
   for i := 0 to ParcelModel.ActualSkupinaParcel.Parcely.LastIndex do
   begin
      ed_ParcelaSK.Items.Add(ParcelModel.ActualSkupinaParcel.Parcely.elements[i].Name);
   end;
   if (ParcelModel.ActualSkupinaParcel <> nil) and not ParcelModel.ActualSkupinaParcel.NoParCast then
   for i := 0 to ParcelModel.ActualSkupinaParcel.ParCasti.LastIndex do
   begin
      e := ParcelModel.ActualSkupinaParcel.ParCasti.elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC := Tgis_ParcelaCast(e);
      P := PC.Parcela;
      if P = nil then continue;
      ed_ParcelaSK.Items.Add(P.Name);
   end;
   if Sender <> nil then
   begin
      ed_ParcelaSK.Text := '';
   end;
end;

procedure TLHCFinder_Form.ed_ParcelaSKClick(Sender: TObject);
begin
   ed_Parcela.Text := ed_ParcelaSK.Text;
end;

procedure TLHCFinder_Form.PageControl1Change(Sender: TObject);
begin
   if PageControl1.ActivePage = TabSheet1 then
      Tool.SetPropertyBooleanByName('PAR',false)
   else
      Tool.SetPropertyBooleanByName('PAR',true);
end;

procedure TLHCFinder_Form.ed_KUNazevClick(Sender: TObject);
begin
   NazevSetting := true;
   ed_KU.ItemIndex := ed_KUNazev.ItemIndex;
   ed_KUClick(nil);
   NazevSetting := false;
end;

procedure TLHCFinder_Form.SetSraf(const Value: boolean);
begin
  FSraf := Value;
end;

procedure TLHCFinder_Form.BitBtn3Click(Sender: TObject);
begin
   Sraf := true;
   BitBtn1Click(nil);
   Sraf := false;
end;
procedure TLHCFinder_Form.BitBtn4Click(Sender: TObject);
begin
   Sraf := true;
   BitBtn2Click(nil);
   Sraf := false;
end;

end.
