unit f_MapSpaceForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  f_OrbisForm, StdCtrls, ComCtrls, ExtCtrls;

type
  TMapSpaces_Form = class(TORBISForm)
    ColorDialog: TColorDialog;
    MSPages: TPageControl;
    TabSMO: TTabSheet;
    TabGusterberg: TTabSheet;
    TabStepan: TTabSheet;
    PageControl1: TPageControl;
    TabSheet4: TTabSheet;
    l_50: TLabel;
    l_10: TLabel;
    l_5: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    l_25: TLabel;
    l_2: TLabel;
    TabSheet5: TTabSheet;
    cb_ShowSMO: TCheckBox;
    SMOPanel: TPanel;
    Label6: TLabel;
    Label7: TLabel;
    c_SMOScale: TComboBox;
    SMOColorPanel: TPanel;
    cb_ShowSMOOverlay: TCheckBox;
    SMOOverlayPanel: TPanel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    ed_SMOOverlayH: TEdit;
    SMOOverlayColorPanel: TPanel;
    ed_SMOOverlayV: TEdit;
    l_Gusterberg: TLabel;
    l_Stepan: TLabel;
    cb_ShowGusterberg: TCheckBox;
    cb_ShowStepan: TCheckBox;
    GusterbergColorPanel: TPanel;
    StepanColorPanel: TPanel;
    cb_ShowGusterbergSections: TCheckBox;
    cb_ShowStepanSections: TCheckBox;
    StepanSectionColorPanel: TPanel;
    GusterbergSectionColorPanel: TPanel;
    Combo_G_Q: TComboBox;
    Label12: TLabel;
    Combo_G_C: TComboBox;
    Combo_G_R: TComboBox;
    b_FindGusterberg: TButton;
    Label13: TLabel;
    Combo_S_Q: TComboBox;
    Combo_S_C: TComboBox;
    Combo_S_R: TComboBox;
    b_FindStepan: TButton;
    Combo_S_S: TComboBox;
    l_S_S: TLabel;
    l_G_S: TLabel;
    Combo_G_S: TComboBox;
    Combo_SMO_50: TComboBox;
    Combo_SMO_Col: TComboBox;
    Combo_SMO_Row: TComboBox;
    Button1: TButton;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure cb_ShowSMOClick(Sender: TObject);
    procedure cb_ShowSMOOverlayClick(Sender: TObject);
    procedure SMOColorPanelClick(Sender: TObject);
    procedure SMOOverlayColorPanelClick(Sender: TObject);
    procedure c_SMOScaleChange(Sender: TObject);
    procedure ed_SMOOverlayHChange(Sender: TObject);
    procedure ed_SMOOverlayVChange(Sender: TObject);
    procedure cb_ShowGusterbergClick(Sender: TObject);
    procedure cb_ShowStepanClick(Sender: TObject);
    procedure GusterbergColorPanelClick(Sender: TObject);
    procedure StepanColorPanelClick(Sender: TObject);
    procedure cb_ShowGusterbergSectionsClick(Sender: TObject);
    procedure cb_ShowStepanSectionsClick(Sender: TObject);
    procedure GusterbergSectionColorPanelClick(Sender: TObject);
    procedure StepanSectionColorPanelClick(Sender: TObject);
    procedure Combo_G_QClick(Sender: TObject);
    procedure Combo_G_CClick(Sender: TObject);
    procedure Combo_S_QClick(Sender: TObject);
    procedure Combo_S_CClick(Sender: TObject);
    procedure b_FindGusterbergClick(Sender: TObject);
    procedure b_FindStepanClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    FSetting: boolean;
    procedure SetSetting(const Value: boolean);
    { Private declarations }
  public
     procedure SetEnabling;
     property Setting: boolean read FSetting write SetSetting;
  end;


implementation
uses
   Elements,
   m_Orbis;

{$R *.DFM}

procedure TMapSpaces_Form.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   inherited;
   if Tool <> nil then
      Tool.PostMsg(tm_Hide,Tool,nil,false);
   CanClose := true;
end;

procedure TMapSpaces_Form.cb_ShowSMOClick(Sender: TObject);
begin
   if Tool = nil then exit;
   if Setting then exit;
   Tool.SetPropertyBooleanByName('ShowSMO',cb_ShowSMO.Checked);
   SetEnabling;
end;

procedure TMapSpaces_Form.SetSetting(const Value: boolean);
begin
  FSetting := Value;
end;

procedure TMapSpaces_Form.SetEnabling;
begin
   SMOPanel.Visible := cb_ShowSMO.Checked;
   cb_ShowSMOOverlay.Enabled := cb_ShowSMO.Checked;
   SMOOverlayPanel.Visible := cb_ShowSMO.Checked and cb_ShowSMOOverlay.Checked;
end;

procedure TMapSpaces_Form.cb_ShowSMOOverlayClick(Sender: TObject);
begin
   if Tool = nil then exit;
   if Setting then exit;
   Tool.SetPropertyBooleanByName('ShowSMOOverlay',cb_ShowSMOOverlay.Checked);
   SetEnabling;
end;

procedure TMapSpaces_Form.SMOColorPanelClick(Sender: TObject);
begin
   ColorDialog.Color := SMOColorPanel.Color;
   if not ColorDialog.Execute then exit;
   SMOColorPanel.Color := ColorDialog.Color;
   if Tool = nil then exit;
   //if Setting then exit;
   Tool.SetPropertyLongIntByName('ShowSMOColor',SMOColorPanel.Color);
end;

procedure TMapSpaces_Form.SMOOverlayColorPanelClick(Sender: TObject);
begin
   ColorDialog.Color := SMOOverlayColorPanel.Color;
   if not ColorDialog.Execute then exit;
   SMOOverlayColorPanel.Color := ColorDialog.Color;
   if Tool = nil then exit;
   //if Setting then exit;
   Tool.SetPropertyLongIntByName('ShowSMOOverlayColor',SMOOverlayColorPanel.Color);
end;

procedure TMapSpaces_Form.c_SMOScaleChange(Sender: TObject);
begin
   if Setting then exit;
   if Tool = nil then exit;
   Tool.SetPropertyStringByName('ShowSMOScale',c_SMOScale.Text);
end;

procedure TMapSpaces_Form.ed_SMOOverlayHChange(Sender: TObject);
begin
   if Setting then exit;
   if Tool = nil then exit;
   Tool.SetPropertyStringByName('ShowSMOOverlayH',ed_SMOOverlayH.Text);
end;

procedure TMapSpaces_Form.ed_SMOOverlayVChange(Sender: TObject);
begin
   if Setting then exit;
   if Tool = nil then exit;
   Tool.SetPropertyStringByName('ShowSMOOverlayV',ed_SMOOverlayV.Text);
end;

procedure TMapSpaces_Form.cb_ShowGusterbergClick(Sender: TObject);
begin
   if Tool = nil then exit;
   if Setting then exit;
   Tool.SetPropertyBooleanByName('ShowGusterberg',cb_ShowGusterberg.Checked);
   //SetEnabling;
end;

procedure TMapSpaces_Form.cb_ShowStepanClick(Sender: TObject);
begin
   if Tool = nil then exit;
   if Setting then exit;
   Tool.SetPropertyBooleanByName('ShowStepan',cb_ShowStepan.Checked);
   //SetEnabling;
end;

procedure TMapSpaces_Form.GusterbergColorPanelClick(Sender: TObject);
begin
   ColorDialog.Color := GusterbergColorPanel.Color;
   if not ColorDialog.Execute then exit;
   GusterbergColorPanel.Color := ColorDialog.Color;
   if Tool = nil then exit;
   //if Setting then exit;
   Tool.SetPropertyLongIntByName('ShowGusterbergColor',GusterbergColorPanel.Color);
end;

procedure TMapSpaces_Form.StepanColorPanelClick(Sender: TObject);
begin
   ColorDialog.Color := StepanColorPanel.Color;
   if not ColorDialog.Execute then exit;
   StepanColorPanel.Color := ColorDialog.Color;
   if Tool = nil then exit;
   //if Setting then exit;
   Tool.SetPropertyLongIntByName('ShowStepanColor',StepanColorPanel.Color);
end;

procedure TMapSpaces_Form.cb_ShowGusterbergSectionsClick(Sender: TObject);
begin
   if Tool = nil then exit;
   l_G_S.Visible := cb_ShowGusterbergSections.Checked;
   Combo_G_S.Visible := cb_ShowGusterbergSections.Checked;
   if Setting then exit;
   Tool.SetPropertyBooleanByName('ShowGusterbergSections',cb_ShowGusterbergSections.Checked);
end;

procedure TMapSpaces_Form.cb_ShowStepanSectionsClick(Sender: TObject);
begin
   if Tool = nil then exit;
   l_S_S.Visible := cb_ShowStepanSections.Checked;
   Combo_S_S.Visible := cb_ShowStepanSections.Checked;
   if Setting then exit;
   Tool.SetPropertyBooleanByName('ShowStepanSections',cb_ShowStepanSections.Checked);
   //SetEnabling;
end;

procedure TMapSpaces_Form.GusterbergSectionColorPanelClick(
  Sender: TObject);
begin
   ColorDialog.Color := GusterbergSectionColorPanel.Color;
   if not ColorDialog.Execute then exit;
   GusterbergSectionColorPanel.Color := ColorDialog.Color;
   if Tool = nil then exit;
   //if Setting then exit;
   Tool.SetPropertyLongIntByName('ShowGusterbergSectionsColor',GusterbergSectionColorPanel.Color);
end;

procedure TMapSpaces_Form.StepanSectionColorPanelClick(Sender: TObject);
begin
   ColorDialog.Color := StepanSectionColorPanel.Color;
   if not ColorDialog.Execute then exit;
   StepanSectionColorPanel.Color := ColorDialog.Color;
   if Tool = nil then exit;
   //if Setting then exit;
   Tool.SetPropertyLongIntByName('ShowStepanSectionsColor',StepanSectionColorPanel.Color);
end;

procedure TMapSpaces_Form.Combo_G_QClick(Sender: TObject);
var
   i: integer;
   En: TEntity;
   E: TElement;
begin
   Combo_G_C.Items.Clear;
   En := TEntity(Combo_G_Q.Items.Objects[Combo_G_Q.ItemIndex]);
   if En = nil then exit;
   for i := 0 to En.LastIndex do
   begin
      E := En.Elements[i];
      Combo_G_C.Items.AddObject(E.Name,E);
   end;
   Combo_G_C.ItemIndex := 0;
   Combo_G_CClick(nil);
end;

procedure TMapSpaces_Form.Combo_G_CClick(Sender: TObject);
var
   i: integer;
   En: TEntity;
   E: TElement;
begin
   Combo_G_R.Items.Clear;
   En := TEntity(Combo_G_C.Items.Objects[Combo_G_C.ItemIndex]);
   if En = nil then exit;
   for i := 0 to En.LastIndex do
   begin
      E := En.Elements[i];
      Combo_G_R.Items.AddObject(E.Name,E);
   end;
   Combo_G_R.ItemIndex := 0;
   //Combo_G_RClick(nil);
end;

procedure TMapSpaces_Form.Combo_S_QClick(Sender: TObject);
var
   i: integer;
   En: TEntity;
   E: TElement;
begin
   Combo_S_C.Items.Clear;
   En := TEntity(Combo_S_Q.Items.Objects[Combo_S_Q.ItemIndex]);
   if En = nil then exit;
   for i := 0 to En.LastIndex do
   begin
      E := En.Elements[i];
      Combo_S_C.Items.AddObject(E.Name,E);
   end;
   Combo_S_C.ItemIndex := 0;
   Combo_S_CClick(nil);
end;

procedure TMapSpaces_Form.Combo_S_CClick(Sender: TObject);
var
   i: integer;
   En: TEntity;
   E: TElement;
begin
   Combo_S_R.Items.Clear;
   En := TEntity(Combo_S_C.Items.Objects[Combo_S_C.ItemIndex]);
   if En = nil then exit;
   for i := 0 to En.LastIndex do
   begin
      E := En.Elements[i];
      Combo_S_R.Items.AddObject(E.Name,E);
   end;
   Combo_S_R.ItemIndex := 0;
   //Combo_S_RClick(nil);
end;

procedure TMapSpaces_Form.b_FindGusterbergClick(Sender: TObject);
begin
   if Tool = nil then exit;
   Tool.SetPropertyStringByName('FindGusterbergName',Combo_G_R.Text);
end;

procedure TMapSpaces_Form.b_FindStepanClick(Sender: TObject);
begin
   if Tool = nil then exit;
   Tool.SetPropertyStringByName('FindStepanName',Combo_S_R.Text);
end;

procedure TMapSpaces_Form.Button1Click(Sender: TObject);
begin
   if Tool = nil then exit;
   Tool.SetPropertyStringByName('FindSMOName',Combo_SMO_50.Text);
end;

end.
