unit f_RasterTransformer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, f_OrbisForm, ComCtrls, StdCtrls, ToolWin, Buttons, ExtCtrls,
  CheckLst, Gauges;

type
  TRasterTransformer_Form = class(TORBISForm)
    OpenDialog1: TOpenDialog;
    ToolBar1: TToolBar;
    b_Open: TSpeedButton;
    b_ZoomIn: TSpeedButton;
    b_ZoomOut: TSpeedButton;
    Panel1: TPanel;
    Splitter1: TSplitter;
    b_Hand: TSpeedButton;
    Panel2: TPanel;
    Image: TImage;
    b_Zoom1: TSpeedButton;
    b_ZoomAll: TSpeedButton;
    b_Point: TSpeedButton;
    ToolButton1: TToolButton;
    lb: TCheckListBox;
    StatusBar: TStatusBar;
    Gauge: TGauge;
    b_Transform: TSpeedButton;
    ToolButton2: TToolButton;
    SaveDialog1: TSaveDialog;
    procedure b_OpenClick(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure b_ZoomInClick(Sender: TObject);
    procedure b_ZoomOutClick(Sender: TObject);
    procedure ImageStartDrag(Sender: TObject; var DragObject: TDragObject);
    procedure ImageDragOver(Sender, Source: TObject; X, Y: Integer;State: TDragState; var Accept: Boolean);
    procedure ImageEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure ImageDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure b_Zoom1Click(Sender: TObject);
    procedure b_ZoomAllClick(Sender: TObject);
    procedure b_PointClick(Sender: TObject);
    procedure b_HandClick(Sender: TObject);
    procedure b_TransformClick(Sender: TObject);
    procedure lbClickCheck(Sender: TObject);
  private
  public
    Picture: TPicture;
    ImageWidth: integer;
    ImageHeight: integer;
    LockMouseUp: boolean;
    RealyDraged: boolean;
    DragShift: TShiftState;
  end;


implementation
uses
   t_Device,
   m_Orbis,
   m_Intera;
{$R *.dfm}

procedure TRasterTransformer_Form.b_OpenClick(Sender: TObject);
begin
   Tool.SetPropertyStringByName('DoOpen','true');
end;

procedure TRasterTransformer_Form.Panel2Resize(Sender: TObject);
begin
   try
      if not Visible then exit;
      if (ImageHeight = Image.Height) and (ImageWidth = Image.Width) then exit;
      Image.Picture.Bitmap.Height:= Image.Height;
      Image.Picture.Bitmap.Width:= Image.Width;
      //if SizeMove  then exit;
      if Tool = nil then exit;
      if Tool.Idle then exit;
      //Tool.PostTextMsg(tm_AddToProtocol, 'Resize', nil);
      Tool.PostMsg(tm_ReSize, Tool, nil, false);
      Application.ProcessMessages;
      ImageHeight := Image.Height;
      ImageWidth := Image.Width;
   except
      //Tool.PostTextMsg(tm_AddToProtocol, 'except', nil);
   end;
end;

procedure TRasterTransformer_Form.FormMouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
    Handled := true;
    TDeviceTool(Tool).PostMouseEvent(tm_MouseWheelDown, Tool, mbMiddle, Shift, MousePos.X, MousePos.Y, true);
end;

procedure TRasterTransformer_Form.FormMouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
    Handled := true;
    TDeviceTool(Tool).PostMouseEvent(tm_MouseWheelUp, Tool, mbMiddle, Shift, MousePos.X, MousePos.Y, true);
end;

procedure TRasterTransformer_Form.b_ZoomInClick(Sender: TObject);
begin
   Tool.SetPropertyStringByName('Zoom','IN');
end;

procedure TRasterTransformer_Form.b_ZoomOutClick(Sender: TObject);
begin
   Tool.SetPropertyStringByName('Zoom','OUT');
end;

procedure TRasterTransformer_Form.ImageStartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
   inherited;
   if Tool = nil then exit;
   TDeviceTool(Tool).PostMouseEvent(tm_StartDrag, Tool, mbLeft, DragShift, 0, 0, true);
end;

procedure TRasterTransformer_Form.ImageDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
   inherited;
   Accept := true;
   RealyDraged := true;
   if Tool = nil then exit;
   TDeviceTool(Tool).PostMouseEvent(tm_DragOver, Tool, mbLeft, DragShift, X, Y, true);
end;

procedure TRasterTransformer_Form.ImageEndDrag(Sender, Target: TObject; X,Y: Integer);
var
   P: TPoint;
begin
   inherited;
   Image.DragCursor := crDrag;
   if Tool = nil then exit;
   TDeviceTool(Tool).PostMouseEvent(tm_DragEnd, Tool, mbLeft, DragShift, X, Y, true);
   if not RealyDraged then
   begin
      P.X := X;
      P.Y := Y;
      P := Image.ScreenToClient(P);
      TDeviceTool(Tool).PostMouseEvent(tm_MouseUp, Tool, mbLeft, DragShift, P.X, P.Y, true);
   end;
   //Tool.PostTextMsg(tm_AddToProtocol,'EndDrag',nil);
   RealyDraged := false;
   LockMouseUp := false;
end;

procedure TRasterTransformer_Form.ImageDragDrop(Sender, Source: TObject; X,Y: Integer);
begin
   inherited;
   if Tool = nil then exit;
   TDeviceTool(Tool).PostMouseEvent(tm_DragDrop, Tool, mbLeft, DragShift, X, Y, true);
end;

procedure TRasterTransformer_Form.ImageMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
   inherited;
   if Tool = nil then exit;
   TDeviceTool(Tool).PostMouseEvent(tm_MouseMove, Tool, mbLeft, Shift, X, Y, true);
   //Tool.PostTextMsg(tm_AddToProtocol,'MouseMove '+ IntToStr(X)+' '+IntToStr(Y),nil);
   if ssLeft in Shift then
   begin
      LockMouseUp := true;
      DragShift := Shift;
      Image.BeginDrag(false,1);
   end;

end;

procedure TRasterTransformer_Form.ImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   inherited;
   if Tool = nil then exit;
   if LockMouseUp then exit;
   TDeviceTool(Tool).PostMouseEvent(tm_MouseUp, Tool, Button, Shift, X, Y, true);
   //Tool.PostTextMsg(tm_AddToProtocol,'MouseUp',nil);
   //IsActive := true;
end;

procedure TRasterTransformer_Form.b_Zoom1Click(Sender: TObject);
begin
   Tool.SetPropertyStringByName('Zoom','1');
end;

procedure TRasterTransformer_Form.b_ZoomAllClick(Sender: TObject);
begin
   Tool.SetPropertyStringByName('Zoom','ALL');
end;

procedure TRasterTransformer_Form.b_PointClick(Sender: TObject);
begin
   Tool.SetPropertyStringByName('WaitForCoords','true');
end;

procedure TRasterTransformer_Form.b_HandClick(Sender: TObject);
begin
   Tool.SetPropertyStringByName('WaitForCoords','false');
end;

procedure TRasterTransformer_Form.b_TransformClick(Sender: TObject);
begin
   Tool.SetPropertyStringByName('DoTransform','true');
end;

procedure TRasterTransformer_Form.lbClickCheck(Sender: TObject);
begin
   Tool.SetPropertyStringByName('IDPointCheck','true');
end;

end.
