unit t_30LEDLoader;

interface

uses
   e_Geometry,
   Elements,
   e_TopolElements,
   T_Loader;

type

TLed30Loader = class(TStreamLoader)
  private
    FPNT_SRF: TEntity;
    FARE_TEZ: TEntity;
    FPNT_TEZ: TEntity;
    FARE_SRF: TEntity;
    F_AT: integer;
    F_PT: integer;
    F_PS: integer;
    F_AS: integer;
    FLastGeometry: TGeometry;
    FLastTopE: TTopolElement;
    FTopolElements: TEntity;
    procedure SetARE_SRF(const Value: TEntity);
    procedure SetARE_TEZ(const Value: TEntity);
    procedure SetPNT_SRF(const Value: TEntity);
    procedure SetPNT_TEZ(const Value: TEntity);
    procedure Set_AS(const Value: integer);
    procedure Set_AT(const Value: integer);
    procedure Set_PS(const Value: integer);
    procedure Set_PT(const Value: integer);
    procedure SetLastGeometry(const Value: TGeometry);
    procedure SetLastTopE(const Value: TTopolElement);
    procedure SetTopolElements(const Value: TEntity);
public
   procedure   LoadClass; override;
   //procedure   LoadAll; override;
   procedure   SetProperty(aIndex: integer; aType: integer; var aValue); override;
   function    NumberToPropertyName(aNumber: longInt): string; override;
   property    LastGeometry: TGeometry read FLastGeometry write SetLastGeometry;
   property    LastTopE: TTopolElement read FLastTopE write SetLastTopE;
   property    _AS: integer read F_AS write Set_AS;
   property    _PS: integer read F_PS write Set_PS;
   property    _AT: integer read F_AT write Set_AT;
   property    _PT: integer read F_PT write Set_PT;
published
   property    ARE_SRF: TEntity read FARE_SRF write SetARE_SRF;
   property    PNT_SRF: TEntity read FPNT_SRF write SetPNT_SRF;
   property    ARE_TEZ: TEntity read FARE_TEZ write SetARE_TEZ;
   property    PNT_TEZ: TEntity read FPNT_TEZ write SetPNT_TEZ;
   property    TopolElements: TEntity read FTopolElements write SetTopolElements;
end;

implementation
uses
   SysUtils,
   TypInfo,
   g_Elems,
   e_Class,
   e_GeometryElement,
   e_LHCElements;

{ TLed30Loader }




procedure   TLed30Loader.LoadClass;
var
   aClassName: string;
   aClassID: longInt;
   aPropertyName: string;
   aPropertyType: integer;
begin
   aClassName := Reader.ReadString;
   aClassID   := Reader.ReadInteger;
   if AnsiSameText(aClassName,'TTopolAreaProps') then
   begin
      aClassName := 'TTopolAreaElement';
      _AS := aClassID;
   end
   else
   if AnsiSameText(aClassName,'TTopolLineProps') then
   begin
      aClassName := 'TTopolLineElement';
      _AS := aClassID;
   end
   else
   if AnsiSameText(aClassName,'TTopolPointProps') then
   begin
      aClassName := 'TTopolPointElement';
      _AS := aClassID;
   end
   else
   if AnsiSameText(aClassName,'TTopolTextProps') then
   begin
      aClassName := 'TTopolTextElement';
      _AS := aClassID;
   end
   else
      _AS := -1;
   AddClass(aClassName);
   Reader.ReadListBegin;
   while not Reader.EndOfList do
   begin
      begin
         aPropertyName := Reader.ReadString;
         aPropertyType := Reader.ReadInteger;
         AddClassProperty(aPropertyName, aPropertyType);
      end;
   end;
   Reader.ReadListEnd;
end;
{
procedure   TLed30Loader.LoadAll;
var
   aClass: longInt;
   aId: longInt;
   aSRF: TSRFPlocha;
   aTEZ: TTezPlocha;
   GE: TGeometryElement;
   IsGeom: boolean;
   i1,i2: integer;
   S: string;
begin
   Reader.ReadListBegin;
   while not Reader.EndOfList do
   begin
      aClass := Reader.ReadInteger;
      if aClass = -1 then LoadClass
      else
      begin
         try
         NewElement(aClass);
         if ActualElement is TTopolElement then
         begin
            LastTopE := TTopolElement(ActualElement);
            if TopolElements <> nil then
               TopolElements.AddElement(LastTopE);
         end;
         IsGeom :=  ActualElement is TGeometry;
         aId := Reader.ReadInteger;
         if aId = 143888 then
         begin
            aId := aId;
         end;
         if IsGeom then
            LastTopE := nil;
         LoadProperties;
         LoadElements;
         LastElementIndex := aId;
         if IsGeom then
         begin
            if LastTopE <> nil then
            begin
               //TGeometryELement(ActualElement).Geometry := LastGeometry;
               if TopolElements <> nil then
               begin
                  LastTopE.Geometry := TGeometry(ActualELement);
               end
               else
               begin
                  S := LastTopE.GetPropertyStringByName('Druh')+','+LastTopE.GetPropertyStringByName('Barva')+','+LastTopE.GetPropertyStringByName('Znacka')+','+LastTopE.GetPropertyStringByName('Presnost');
                  ActualElement.Name := S;
               end;
               //i1 := Container.IndexOf(ActualElement);
               //i2 := COntainer.IndexOf(LastGeometry);
               //Container.Elements[i1] := LastGeometry;
               //Container.Elements[i2] := ActualElement;
            end;
            LastTopE := nil;
         end;
         except
            aId := aId;
         end;
      end;
      UpdateGauge;
   end;
   Reader.ReadListEnd;
end;
}




procedure TLed30Loader.SetARE_SRF(const Value: TEntity);
begin
  FARE_SRF := Value;
end;

procedure TLed30Loader.SetARE_TEZ(const Value: TEntity);
begin
  FARE_TEZ := Value;
end;

procedure TLed30Loader.SetPNT_SRF(const Value: TEntity);
begin
  FPNT_SRF := Value;
end;

procedure TLed30Loader.SetPNT_TEZ(const Value: TEntity);
begin
  FPNT_TEZ := Value;
end;

procedure TLed30Loader.Set_AS(const Value: integer);
begin
  F_AS := Value;
end;

procedure TLed30Loader.Set_AT(const Value: integer);
begin
  F_AT := Value;
end;

procedure TLed30Loader.Set_PS(const Value: integer);
begin
  F_PS := Value;
end;

procedure TLed30Loader.Set_PT(const Value: integer);
begin
  F_PT := Value;
end;

procedure TLed30Loader.SetLastGeometry(const Value: TGeometry);
begin
  FLastGeometry := Value;
end;

procedure TLed30Loader.SetLastTopE(const Value: TTopolElement);
begin
  FLastTopE := Value;
end;

function TLed30Loader.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result := 'FileName';
      1: result := 'TopolElements';
   end;
end;

procedure TLed30Loader.SetTopolElements(const Value: TEntity);
begin
  FTopolElements := Value;
end;

procedure TLed30Loader.SetProperty(aIndex, aType: integer; var aValue);
var
   TE: TTopolElement;
   S: string;
begin
   if (TTypeKind(aType) = tkClass) and (TObject(aValue) is TTopolElement) and (ActualElement is TGeometry) then
   begin
      TE := TTopolElement(aValue);
      if TopolElements <> nil then
      begin
         TE.Geometry := TGeometry(ActualELement);
      end
      else
      begin
         S := TE.GetPropertyStringByName('Druh')+','+TE.GetPropertyStringByName('Barva')+','+TE.GetPropertyStringByName('Znacka')+','+TE.GetPropertyStringByName('Presnost');
         ActualElement.Name := S;
      end;
   end
   else
      inherited;
end;

INITIALIZATION
   RegisterOrbisClass(TLED30Loader);
END.
