unit t_ExtractSymbolsFromLines;

interface
uses
   Tools;

type

TExtractSymbolsFromLines = class(TTool)
  private
    FGroup: integer;
    procedure SetGroup(const Value: integer);
public
   procedure DoIt; override;
published
   property Group: integer read FGroup write SetGroup;
end;

implementation
uses
   Elements,
   g_Elems,
   e_Class,
   e_Geometry,
   e_GeometryElement,
   e_TopolElements;

{ TExtractSymbolsFromLines }

procedure TExtractSymbolsFromLines.DoIt;
var
   ei,eo: TEntity;
   e: TElement;
   i: integer;
   L: TTopolLineElement;
   TP: TTopoLPointElement;
   P: TPointElement;
begin
   if Input = nil then exit;
   if not (Input is TEntity) then exit;
   ei := TEntity(Input);
   if Output = nil  then
   begin
      eo := TPointCollection.Create;
      Output := eo;
      AddElement(eo);
   end
   else
      eo := TEntity(Output);
   for i := 0 to ei.LastIndex  do
   begin
      e := ei.Elements[i];
      if not (e is TTopolLineElement) then continue;
      L := TTopolLineElement(e);
      if L.Symbol <= 0 then continue;
      P := TPointElement.Create;
      P.X := L.X;
      P.Y := L.Y;
      TP := TTopolPointElement.Create;
      TP.Geometry := P;
      TP.Barva := L.Barva;
      TP.Znacka := L.Symbol;
      TP.Druh := Group;
      P.Angle := L.Geometry.Angle+Pi/2;
      eo.AddElement(TP);
   end;
   if (eo is TRectEntity) then TRectEntity(eo).Update;
end;

procedure TExtractSymbolsFromLines.SetGroup(const Value: integer);
begin
  FGroup := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TExtractSymbolsFromLines);
END.

