unit t_TestTool;

interface
uses
   Elements,
   Tools;

type

TTestTool=class(TTool)
private
    FAreasEntity: TEntity;
    FLinesEntity: TEntity;
    FAreaColor: integer;
    procedure SetAreasEntity(const Value: TEntity);
    procedure SetLinesEntity(const Value: TEntity);
    procedure SetAreaColor(const Value: integer);
public
   procedure DoIt; override;
published
   property AreasEntity: TEntity read FAreasEntity write SetAreasEntity;
   property LinesEntity: TEntity read FLinesEntity write SetLinesEntity;
   property AreaColor: integer read FAreaColor write SetAreaColor;
end;

implementation
uses
   Forms,
   SysUtils,
   e_Geometry,
   e_KatastrModel,
   e_TopolElements,
   e_Class;

{ TTestTool }

procedure TTestTool.DoIt;
var
   e: TElement;
   P: Tgis_Parcela;
   L: TTopolLineElement;
   IDel: integer;
   i: integer;
   Ti: integer;
begin
   if AreasEntity = nil then exit;
   if LinesEntity = nil then exit;
   if AreasEntity.NoElements then exit;
   StartProgress('Ruen parcel se patnou barvou',0,AreasEntity.LastIndex);
   IDel := 0;
   Ti := AreasEntity.LastIndex;
   For i := Ti downto 0 do
   begin
      e := AreasEntity.elements[i];
      if not (e is Tgis_Parcela) then continue;
      P := Tgis_Parcela(e);
      if P.Barva = AreaColor then
      begin
         P.Free;
         Inc(IDel);
      end;
      Progress := Ti - i;
      ProgressText := 'plochy '+IntToStr(i)+'/'+IntToStr(IDel);
      if i mod 50 = 0 then
         Application.ProcessMessages;
   end;
   if LinesEntity.NoElements then exit;
   Ti := LinesEntity.LastIndex;
   MaxProgress := Ti;
   IDel := 0;
   for i := Ti downto 0 do
   begin
      e := LinesEntity.elements[i];
      if not (e is TTopolLineElement) then exit;
      L := TTopolLineElement(e);
      if L.Geometry.FindClassInOwners(TAreaElement) = nil then
      begin
         L.Free;
         Inc(IDel);
      end;
      Progress := Ti - i;
      ProgressText := 'linie '+IntToStr(i)+'/'+IntToStr(IDel);
      if i mod 50 = 0 then
         Application.ProcessMessages;
   end;
end;


procedure TTestTool.SetAreaColor(const Value: integer);
begin
  FAreaColor := Value;
end;

procedure TTestTool.SetAreasEntity(const Value: TEntity);
begin
  FAreasEntity := Value;
end;

procedure TTestTool.SetLinesEntity(const Value: TEntity);
begin
  FLinesEntity := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TTestTool);
END.

 