unit F_seldir;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, FileCtrl,
  Elements, Tools, ComCtrls;


type
  Tf_SelectDir = class(TForm)
    Panel1: TPanel;
    NewDir: TBitBtn;
    b_OK: TBitBtn;
    b_Cancel: TBitBtn;
    Panel2: TPanel;
    Directory: TDirectoryListBox;
    Drive: TDriveComboBox;
    ed_NewDir: TEdit;
    StatusBar: TStatusBar;
    b_NDOK: TButton;
    procedure NewDirClick(Sender: TObject);
    procedure DirectoryChange(Sender: TObject);
    procedure Panel1Exit(Sender: TObject);
    procedure ed_NewDirKeyPress(Sender: TObject; var Key: Char);
    procedure b_NDOKClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


TSelectDirDialog = class(TTool)
private
  FDirectory: string;
  FCaption: string;
  FLeft, FTop: integer;
    Fresult: boolean;
  function GetDirectory: string;
    function GetLeft: integer;
    function GetTop: integer;
    procedure SetLeft(const Value: integer);
    procedure SetTop(const Value: integer);
    procedure Setresult(const Value: boolean);
public
  procedure DoIt; override;
published
  property Directory: string read GetDirectory write FDirectory;
  property Caption: string read FCaption write FCaption;
  property Left: integer read GetLeft write SetLeft;
  property Top: integer read GetTop write SetTop;
  property result: boolean read Fresult write Setresult;
end;


implementation
{$R *.DFM}

uses
  Dialogs,
  SysUtils,
  e_Class,
  F_names,
  t_MainTl,
  Worlds,
  U_String;




function TSelectDirDialog.GetDirectory: string;
begin
  result:= FDirectory
end;



procedure Tf_SelectDir.NewDirClick(Sender: TObject);
begin
  ed_NewDir.Text := '';
  ed_NewDir.Visible := true;
  b_NDOK.Visible := true;
  ed_NewDir.SetFocus;
  {
  NameDlg:= TF_Name.Create(Application);
  try
    aDir:= Directory.Directory;
    NameDlg.Caption := aDir;
    NameDlg.Left := Left;
    NameDlg.Top := Top;
    NameDlg.ShowModal;
    if NameDlg.ModalResult = mrOK then
    begin
       MkDir(AddBackSlash(aDir) + NameDlg.ed_Name.Text);
       Directory.UpDate
    end;
  except
    on E:Exception do
    begin
      ShowMessage(E.Message + ': ' + AddBackSlash(aDir) + NameDlg.ed_Name.Text);
      Screen.Cursor:= crDefault;
    end;
  end;
  NameDlg.Free;
  }
end;



procedure  TSelectDirDialog.DoIt;
var
   DD: TF_SelectDir;
   S: string;
begin
    if  Assigned(TOldMainTool(World.MainTool).On_SelectDirectory_Event) then
    begin
       result := TOldMainTool(World.MainTool).On_SelectDirectory_Event(FCaption,'',FDirectory);
       exit;
    end;

   //result := SelectDirectory(FCaption,FDirectory,FDirectory{$IF RTLVersion >= 18},[sdNewFolder, sdShowEdit, sdShowShares, sdNewUI]{$IFEND});
   //result := SelectDirectory(FDirectory,[sdAllowCreate, sdPerformCreate, sdPrompt],0);
   //result :=  SelectDirectory(FDirectory, [sdAllowCreate, sdPerformCreate, sdPrompt], 0);
   //exit;

   result := false;
   DD:= TF_SelectDir.Create(Application);
   try
     if FCaption <> '' then
        DD.Caption:= FCaption;

     if FDirectory <> '' then
     begin
        if not DirectoryExists(FDirectory) then
           FDirectory := '';
     end;
     DD.Directory.Directory:= FDirectory;

     if (FLeft > 0) and (FTop > 0) then
     begin
       DD.Position:= poDesigned;
       DD.Left:= FLeft;
       DD.Top := FTop;
     end;

     if DD.ShowModal = mrOK then
     begin
        FDirectory := DD.Directory.Directory;
        result := true;
     end;
   except
     on E:Exception do
     begin
       ShowMessage(E.Message + ': ' + FDirectory);
       Screen.Cursor:= crDefault;
       FDirectory:= ''
     end;
   end;
   FLeft:= DD.Left;
   FTop := DD.Top;
   DD.Free;
end;


function TSelectDirDialog.GetLeft: integer;
begin
  result:= FLeft;
end;

function TSelectDirDialog.GetTop: integer;
begin
  result:= FTop;
end;

procedure TSelectDirDialog.SetLeft(const Value: integer);
begin
  FLeft:= Value;
end;

procedure TSelectDirDialog.SetTop(const Value: integer);
begin
  FTop:= Value
end;

procedure TSelectDirDialog.Setresult(const Value: boolean);
begin
  Fresult := Value;
end;

procedure Tf_SelectDir.DirectoryChange(Sender: TObject);
begin
   StatusBar.SimpleText := Directory.Directory;
end;

procedure Tf_SelectDir.Panel1Exit(Sender: TObject);
begin
   ed_NewDir.Text := '';
   ed_NewDir.Visible := false;
   b_NDOK.Visible := false;
end;


procedure Tf_SelectDir.ed_NewDirKeyPress(Sender: TObject; var Key: Char);
begin
   if Key = #13 then b_NDOKClick(nil);
end;

procedure Tf_SelectDir.b_NDOKClick(Sender: TObject);
var
   aDir: string;
begin
   if ed_NewDir.Text = '' then exit;
  try
    aDir:= Directory.Directory;
    CheckBackSlash(aDir);
    MkDir(aDir + ed_NewDir.Text);
    Directory.UpDate
  except
    on E:Exception do
    begin
      ShowMessage(E.Message + ': ' + AddBackSlash(aDir) + ed_NewDir.Text);
      Screen.Cursor:= crDefault;
    end;
  end;
  ed_NewDir.Text := '';
  ed_NewDir.Visible := false;
  b_NDOK.Visible := false;
end;


INITIALIZATION
  RegisterOrbisClass(TSelectDirDialog);
END.
