unit t_ControlGroup;

interface
uses
   f_ControlGroupForm,
   Elements,
   t_FormTool;
type

TControlGroup = class(TFormTool)
  private
    function GetForm: TControlGroupForm;
public
   procedure CreateForm; override;
   procedure SetVisible(const Value: boolean); override;
   procedure HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
   property  Form: TControlGroupForm read GetForm;
end;

implementation
uses
   Forms,
   e_Class,
   m_Orbis,
   Tools;

{ TControlGroup }

procedure TControlGroup.CreateForm;
begin
   aForm := TControlGroupForm.Create(Application);
   Form.Tool := Self;
end;

function TControlGroup.GetForm: TControlGroupForm;
begin
   result := TControlGroupForm(aForm);
end;

procedure TControlGroup.HandleMessage(var aMessage: TOrbisMessage;
  var Handled: boolean);
var
   i: longInt;
   T: TTool;
begin
   Case aMessage.Message of
      tm_QuitTask:
      begin
         On_tm_QuitTask;
         exit;
      end;
   end;
   if Tools.NoElements then Exit;
   for i := 0 to Tools.LastIndex do
   begin
      T := Tool[i];
      if T <> aMessage.Sender then
      begin
         T.HandleMessage(aMessage, Handled);
      end;
      if Handled then break;
   end;
end;

procedure TControlGroup.SetVisible(const Value: boolean);
var
   i: integer;
   Msg: integer;
begin
   //inherited SetVisible(Value);
   for i := 0 to Tools.LastIndex do
   begin
      if Value then Msg := tm_Show
               else Msg := tm_Hide;
      PostMsg(Msg,Tools.Elements[i],nil,false);
   end;
end;

initialization
   RegisterOrbisClass(TControlGroup);
end.
