unit t_UserLHCAreaDialog;

interface
uses
   Elements,
   e_GeometryElement,
   t_OrbisDialog;

type

TOnUserLHCAreaDialog = procedure (NewObject: boolean; Area: double; Skupina: TElement; var UserID,Group,Color,Symbol,aresult: integer; var Props: string) of object;

TUserLHCAreaDialog = class (TOrbisDialog)
  private
    FCarryAreaFromFrame: boolean;
    FFrameAreaPropertyName: string;
    FBigFrame: TElement;
    FFrame: TElement;
    FOnUserLHCAreaDialog: TOnUserLHCAreaDialog;
    function GetSkupina: TGeometryElement;
    procedure SetBigFrame(const Value: TElement);
    procedure SetCarryArea(const Value: boolean);
    procedure SetCarryAreaFromFrame(const Value: boolean);
    procedure SetFrame(const Value: TElement);
    procedure SetFrameAreaPropertyName(const Value: string);
    procedure SetOnUserLHCAreaDialog(const Value: TOnUserLHCAreaDialog);
public
   procedure DoIt; override;
   procedure CreateForm; override;
   property  Skupina: TGeometryElement read GetSkupina;
   property  OnUserLHCAreaDialog: TOnUserLHCAreaDialog read FOnUserLHCAreaDialog write SetOnUserLHCAreaDialog;
published
   property  BigFrame: TElement read FBigFrame write SetBigFrame stored false;
   property  Frame: TElement read FFrame write SetFrame stored false;
   property  CarryAreaFromFrame: boolean read FCarryAreaFromFrame write SetCarryAreaFromFrame;
   property  FrameAreaPropertyName: string read FFrameAreaPropertyName write SetFrameAreaPropertyName;
   property  CarryArea: boolean write SetCarryArea stored false;
end;

implementation
uses
   Classes,
   e_Props,
   e_Type,
   e_Class,
   e_Geometry,
   e_LHCElements,
   e_LHCModel;


{ TUserLHCAreaDialog }

procedure TUserLHCAreaDialog.CreateForm;
begin

end;

procedure TUserLHCAreaDialog.DoIt;
var
   Are: TAreaElement;
   GAre: TGeometryElement;
   UC: Tgis_UserCollection;
   NewObject: boolean;
   AreArea: double;
   S: string;
   Druh,Barva,Znacka,UserID,aResult: integer;
   PropsString: string;
   SLE: TStringListElement;
   SE: TStringElement;
   i: integer;
   UA: Tgis_UserAreaElement;
   P: TDynamicProperties;
begin
   Are := nil;
   GAre := nil;
   if input = nil then exit;

   if Input is TAreaElement then Are := TAreaElement(Input)
   else
   if Input is TGeometryElement then
   begin
      GAre := TGeometryElement(Input);
      Are := TAreaElement(GAre.Geometry);
   end
   else
      exit;
   AreArea := Are.Area;
   if GAre <> nil then
   begin
      NewObject := false;
      Znacka := GAre.GetPropertyLongIntByName('ZNACKA');
      Barva  := GAre.GetPropertyLongIntByName('Barva');
      Druh  := GAre.GetPropertyLongIntByName('Druh');
      UserID := GAre.GetPropertyLongIntByName('UserID');
   end
   else
   begin
      NewObject := true;
      Druh   := 1;
      Znacka := 1;
      Barva  := 14;
      UserID := 1;
      if Skupina <> nil then
      begin
         UC := Tgis_UserCollection(Skupina.FindElementClass(Tgis_UserCollection));
         if UC <> nil then
         begin
            UserID := UC.FindUserID;
         end;
      end;
   end;
   Result := 2;
   aResult := 2;
   if Assigned(OnUserLHCAreaDialog) then
   begin
      OnUserLHCAreaDialog(NewObject,AreArea,Skupina,UserID,Druh,Barva,Znacka,aResult,PropsString);
   end
   else
   begin
      exit;
   end;
   Result := aResult;
   if Result = 1 then
   begin
      if GAre = nil then
      begin
         GAre := Tgis_UserAreaElement.Create;
         GAre.Geometry := Are;
      end;
      Output := GAre;
      {
      if not SRFOnly then
      begin
         Are.SetPropertyStringByName('FixedArea',Form.ed_Area.Text);
         GAre.SetPropertyStringByName('NALEHAVOST',Form.ed_Nalehavost.Text);
         GAre.SetPropertyStringByName('ZPUSOB',Form.ed_Zpusob.Text);
      end;
      }
      GAre.SetPropertyLongIntByName('Druh',Druh);
      GAre.SetPropertyLongIntByName('Barva',Barva);
      GAre.SetPropertyLongIntByName('ZNACKA',Znacka);
      GAre.SetPropertyLongIntByName('UserID',UserID);
      GAre.SetPropertyIntByName('_Skupina',NativeInt(Skupina));
      if PropsString <> '' then
      begin
         UA :=Tgis_UserAreaElement(GAre);
         P := TDynamicProperties(UA.Properties);
         if P = nil  then
         begin
            P := TDynamicProperties.Create;
            UA.Properties := P;
         end;
         SLE := TStringListElement.Create;
         SLE.NamesString := PropsString;
         for i := 0 to SLE.LastIndex do
         begin
            SE := SLE.StringElements[i];
            SE.NameIsValue := SE.Name;
            P.SetPropertyStringByName(SE.Name,SE.Value);
         end;
         SLE.Free;
      end;
   end;
end;

function TUserLHCAreaDialog.GetSkupina: TGeometryElement;
begin
   result := TGeometryElement(BigFrame);
end;

procedure TUserLHCAreaDialog.SetBigFrame(const Value: TElement);
begin
  FBigFrame := Value;
end;

procedure TUserLHCAreaDialog.SetCarryArea(const Value: boolean);
begin

end;

procedure TUserLHCAreaDialog.SetCarryAreaFromFrame(const Value: boolean);
begin
  FCarryAreaFromFrame := Value;
end;

procedure TUserLHCAreaDialog.SetFrame(const Value: TElement);
begin
  FFrame := Value;
end;

procedure TUserLHCAreaDialog.SetFrameAreaPropertyName(const Value: string);
begin
  FFrameAreaPropertyName := Value;
end;

procedure TUserLHCAreaDialog.SetOnUserLHCAreaDialog(const Value: TOnUserLHCAreaDialog);
begin
  FOnUserLHCAreaDialog := Value;
end;

initialization
   RegisterOrbisClass(TUserLHCAreaDialog);
end.

