unit U_BdeObj;

interface

uses
  BDE,
  Classes,
  Controls,
  DB,
  DbTables,
  E_SortElements,
  Elements,
  Registry,
  SysUtils,
  Windows,
  u_BdeLib,
  u_DBTyps,
  u_SQLList;

const
  RootPath = '\';
  DriverPath = '\DRIVERS\';
  DBPath = '\DATABASES\';
  SystemPath = '\SYSTEM\INIT\';
  DatePath = '\SYSTEM\FORMATS\DATE\';
  TimePath = '\SYSTEM\FORMATS\TIME\';
  NumberPath = '\SYSTEM\FORMATS\NUMBER\';
  cDbInfo = '\DATABASES\%s\DB INFO';
  cDbOpen = '\DATABASES\%s\DB OPEN';

  RecBufSize = 10000;
  MaxFields = 200 * sizeof(FLDDesc);


  Driver = 'Driver';
  Alias = 'Aliases';
  System1 = 'System';
  Date = 'Date';
  Time = 'Time';
  Number = 'Number';

  ConfigKey = 'SOFTWARE\Borland\Database Engine';
  ConfigFileKey = 'CONFIGFILE01';
  DLLPathKey = 'DLLPATH';
  SaveConfigKey ='SaveConfig';

  cWin31 = 'WIN31';
  cWin95 = 'WIN95';

type

  TDateMode = (MDY, DMY, YMD);

  {
  upravena struktura pMyLDDesc z unity BDE
  }

   pMyLDDesc = ^TMyLDDesc;
   TMyLDDesc = packed record   { Lang Driver description }
      Cislo: Word;                              {Zatim nevim}
      szDesc: packed array[0..19] of char;      { Description }
      szCountry             : DBINAME;          {}
      szName                : DBINAME;          { Driver symbolic name }
      PrimaryCpPlatform     : Word;
      iCodePage             : Word;
      AlternateCodePage     : Word;
   end;


{
 Zkladn iformace o language driveru z BDE pro zadan TDaSet
}
   TorbMyLdDesc = class
   private
      FDataSet: TDataSet;
      MypLdObj: pMyLDDesc;

      function GetAlternateCodePage: Word;
      function GetIsAnsiDrive: Boolean;
      function GetCodePage: Word;
      function GetCountry: String;
      function GetDescription: String;
      function GetName: String;
      function GetPlatform(aPlatform: Word): String;
      function GetPrimaryCodePagePlatform: String;

      procedure SetDataSet(aDataSet: TDataSet);
   public

      constructor CreateAll(aDataSet: TDataSet);
      destructor destroy; override;

   published
      property AlternateCodePage: word read GetAlternateCodePage;
      property CodePage: word read GetCodePage;
      property Country:     string read GetCountry;
      property DataSet: TDataSet read FDataSet write SetDataSet;
      property Description: string read GetDescription;
      property IsAnsiDrive: Boolean read GetIsAnsiDrive;
      property Name:        string read GetName;
      property PrimaryCodePagePlatform: string read GetPrimaryCodePagePlatform;
   end;



{Informace o BDE v registru}
   TBDERegistry = class(TRegistry)

   private
      FConfigFilePath: String;
      FDLLPath: String;
      FisModifyConfigFile: Boolean;
      FisOpenConfigFile: Boolean;
      FSaveChanges: Boolean;
      FSaveTypeConfig: String;
      FShowMsgBox: Boolean;
      FWin31Checked: Boolean;
      FhCfg: hDBICfg;

      function GetConfigFilePath: String;
      function GetDLLPath: String;
      function GetSaveTypeConfig: String;
      function IsOpenKey: Boolean;

      procedure SetConfigFilePath(const Value: String);
      procedure SethCfg(Value: hDBICfg);
      procedure SetDLLPath(const Value: String);
      procedure SetSaveChanges(const Value: Boolean);
      procedure SetSaveTypeConfig(const Value: String);
      procedure SetWin31Checked(const Value: Boolean);
      procedure SetisOpenFile(const Value: Boolean);
      procedure SetisModifyConfigFile(const Value: Boolean);
      procedure SetShowMsgBox(const Value: Boolean);
   public
      constructor Create;  virtual;
      destructor  Destroy; override;

      procedure CloseConfigFile;
      procedure OpenConfigFile;
      procedure SaveConfigFile;
      property hCfg: hDBICfg read FhCfg write SethCfg;

   published
      property isModifyConfigFile: Boolean read FisModifyConfigFile write SetisModifyConfigFile;
      property isOpenConfigFile: Boolean read FisOpenConfigFile write SetisOpenFile;
// Cesta na konfiguran soubor BDE32
      property ConfigFilePath: String read GetConfigFilePath write SetConfigFilePath;
// Cesta na DLL knihovny BDE32
      property DLLPath: String read GetDLLPath write SetDLLPath;
      property SaveChanges: Boolean read FSaveChanges write SetSaveChanges;
// Uloen BDE informac pro Win31 i Win32 ('WIN31') nebo pouze Win32 ('WIN95')
      property SaveTypeConfig: String read GetSaveTypeConfig write SetSaveTypeConfig; // "WIN31' nebo 'WIN32'
// Kdy je konfiguran soubor modifikovn, zda zobrazit dialog o uloen
      property ShowMsgBox: Boolean read FShowMsgBox write SetShowMsgBox;
      property Win31Checked: Boolean read FWin31Checked write SetWin31Checked;
   end;

   TorbAliases = class;

   TorbTables = class;

{
 Zkladn prce s Aliasem
}
   TorbAlias = class(TSortOwnerEntity)
   private
      FAliasName: String;
      FAliasPersist: Boolean;  // trval nebo doasn alias
      FAliasParams: TStringList;
      FAliasState: TAliasState;
      FAliasDriveType: String;
      FDatabase: TDatabase;
//      FIsConnected: Boolean;
      FUserName: string;
      FPassword: string;
      FIsConnected: Boolean;

//      function  GetDriveTypeFromParams: String;
      function  GetAliases: TorbAliases;
      function  GetIsAlias: Boolean;
      function  GetIsSQL: Boolean;
      function  GetDatabase: TDatabase;
      function  GetDotazy: TorbSqlList;
      function  GetTables: TorbTables;

      procedure AddSQLAlias(hCfg: hDBICfg; Driver, Name: string);
      procedure AddStandardAlias(hCfg: hDBICfg; Name: string);
      procedure GetCfgParams(hCfg: hDBICfg; Path, Section: String; List: TStrings);
      procedure SetAliasDriveType(aName: String);
      procedure SetAliasName(aName: String);
      procedure SetAliasPersist(aPersist: Boolean);
      procedure SetAliasState(aState: TAliasState);
      procedure SetDatabase(aDatabase: TDatabase);
      procedure SetIsConnected(const Value: Boolean);
      procedure SetPassword(const Value: string);
      procedure SetUserName(const Value: string);
   public
      constructor CreateAll(aName: String); virtual;
      destructor  Destroy; override;
      function  AliasStateAsString: String;

      procedure CreateNewAlias(hCfg: hDBICfg; aName, aDriveType: String);
//      procedure DeleteAlias;
      procedure GetInfoAlias(hCfg: hDBICfg);
      procedure GetInfoExistsAlias;
      procedure GetUserNameFromCfgParams;
      procedure ModifyAlias(aName: string);

   protected
      function  GetAliasParams: TStringList; virtual;
      procedure SetAliasParams(aStrList: TStringList); virtual;
   published
      property Aliases: TorbAliases read GetAliases stored false;
      property AliasDriveType: string read FAliasDriveType write SetAliasDriveType;
      property AliasName: string read FAliasName write SetAliasName;
      property AliasPersist: Boolean read FAliasPersist write SetAliasPersist ;
      property AliasParams: TStringList read GetAliasParams write SetAliasParams;
      property AliasState: TAliasState read FAliasState write SetAliasState default alsNone;
      property Database: TDatabase read GetDatabase write SetDatabase;
      property IsConnected: Boolean read FIsConnected write SetIsConnected;
      property Password: string read FPassword write SetPassword;
      property UserName: string read FUserName write SetUserName;

      property isSQL: Boolean read GetIsSQL;
      property isAlias: Boolean read GetisAlias;
      property Tables: TorbTables read GetTables;
      property Dotazy: TorbSqlList read GetDotazy;

   end;



   TorbAliases = class(TSortOwnerEntity)
   private
      FAliasDrivers: TStringList;
      FAliasNames: TStringList;
      FIsBDEOk: Boolean;
      FReg: TBDERegistry;

      function  GetAliasNames: TStringList;
      function  GetAliasNames2: TStringList;
      function  GetAliasDrivers: TStringList;
      function  GetBDERegistry: TBDERegistry;
      function  isAliasDriver(aDriver: String): Boolean;

      procedure GetAliasesForDriver(aDriver: String);
      procedure GetAliasesFromCfg;
      procedure SetBDERegistry(const Value: TBDERegistry);
      procedure SetIsBDEOk(const Value: Boolean);
   public
      constructor Create; override;
      destructor  Destroy; override;

      // Zjiuje existenci aliasu a kdy neexistuje tak je nil
      function FindAlias(aName: string): TOrbAlias;
      // Zjiuje existenci aliasu a kdy neexistuje tak ho vytvo
      function  GetAlias(aName: string): TOrbAlias;
      function  GetAliasForDriver(aName, aDriver: string): TOrbAlias;
//      function  GetInfoAlias(aName: String): TStringList;

      function AddAliasToCfg(aName: String): Boolean;

//      procedure DeleteAlias(aName: String);
      procedure DeleteAlias(aName: string; Confirm: Boolean);

{
      procedure AddAliasToCfg(DBICfg: hDBICfg; aName, aDriveType: String;
          aParams: TStringList; aPersist: Boolean);
}
      procedure SaveConfigFile;

   published
      // Ukldn cfg Informac do BDE16
      property AliasNames: TStringList read GetAliasNames2;
//      property AliasLanguages: TStringList read GetAliasLanguages;
      property AliasDrivers: TStringList read GetAliasDrivers;
      property IsBDEOk: Boolean read FIsBDEOk write SetIsBDEOk;
      property Reg: TBDERegistry read GetBDERegistry write SetBDERegistry;
   end;


(*
   TorbTable = class(TOwnerEntity)
   private
      FTableName: String;
      FAliasName: string;
      FQuery: TQuery;
      function GetAlias: TOrbAlias;

      function GetQuery: TQuery;
      procedure SetQuery(const Value: TQuery);      //   Char  Specifies the time separator character (for example, ".").
   public
      constructor CreateAll(aName: String); virtual;
   published
      property Alias: TOrbAlias read GetAlias;
      property TableName: String read GetTable;
      property Query: TQuery read GetQuery write SetQuery;
   end;

*)

{
    Zkladn prce se seznamem tabulek
}

   TorbTables = class(TSortOwnerEntity)
   private
      FTableNames: TStringList;
      FAliasName: string;
      FQuery: TQuery;
      FShowSQLTables: Boolean;
      FShowSysTables: Boolean;

      function  GetAlias: TOrbAlias;
      function  GetQuery: TQuery;
      function  GetShowSQLTables: Boolean;
      function  GetTableNames: TStringList;

      procedure SetAliasName(const Value: string);
      procedure SetQuery(const Value: TQuery);
      procedure SetShowSQLTables(const Value: Boolean);
    procedure SetShowSysTables(const Value: Boolean);      //   Char  Specifies the time separator character (for example, ".").
   public
      constructor CreateAll(aName: String); virtual;
      destructor Destroy; override;
      // Zjiuje existenci tabulky
//      function  GetTable(aName: string): TTable;
   published
      property Alias: TOrbAlias read GetAlias;
      property AliasName: string read FAliasName write SetAliasName;
      property TableNames: TStringList read GetTableNames;
      property ShowSQLTables: Boolean read GetShowSQLTables write SetShowSQLTables;
      property ShowSysTables: Boolean read FShowSysTables write SetShowSysTables;
      property Query: TQuery read GetQuery write SetQuery;
   end;


   TorbTable = class(TSortOwnerEntity);

   TorbFields = class(TSortOwnerEntity);

   TorbField = class(TSortOwnerEntity);
 (*
   private
      FTableName: String;
      FTableExists: Boolean;
   public
      constructor Create; override;
      destructor  Destroy; override;
   protected

   published
//      property Alias: TorbAlias read GetAlias;
      property TableName: string read FTableName write SetTableName;
      property TableExists: Boolean read FTableExists write SetTableExists;
   end;
 *)




  TdbiTimeFormat = class(TOwnerEntity)
  private
     FTimeSeparator: Char;      //   Char  Specifies the time separator character (for example, ".").
     FbTwelveHour: Boolean;     //   INT8  If TRUE, represent as 12-hour time.
     FszAmString: String;    //   Specifies the string to use for designating AM time (only for 12-hour time).
     FszPmString: String;    //   Specifies the string to use for designating PM time (only for 12-hour time).
     FbSeconds: Boolean;        //   INT8  If TRUE, show seconds.
     FbMiliSeconds: Boolean;

     procedure SetbMiliSeconds(const Value: Boolean);
     procedure SetbSeconds(const Value: Boolean);
     procedure SetbTwelveHour(const Value: Boolean);
     procedure SetszAmString(const Value: String);
     procedure SetszPmString(const Value: String);
     procedure SetTimeSeparator(const Value: Char);     //   INT8  If TRUE, show milliseconds.
  public
      constructor Create;  override;

      procedure SetTimeFormat(aTimeSep: Char; abTwelveHour: Boolean;
                aAmString, aPmString: String; abSeconds, abMiliSeconds: Boolean);
      procedure fDbiSetTimeFormat;
      procedure fDbiGetTimeFormat;
  published
     property TimeSeparator: Char read FTimeSeparator write SetTimeSeparator;
     property bTwelveHour: Boolean read FbTwelveHour write SetbTwelveHour;
     property szAmString: String read FszAmString write SetszAmString;
     property szPmString: String read FszPmString write SetszPmString;
     property bSeconds: Boolean read FbSeconds write SetbSeconds;
     property bMiliSeconds: Boolean read FbMiliSeconds write SetbMiliSeconds;
  end;


  TdbiNumberFormat = class(TOwnerEntity)
  private
     FcDecimalSeparator: Char;       //  CHAR	Specifies the character to be used as the decimal separator (for example, ".").
     FcThousandSeparator: Char;      //  CHAR	Specifies the character to be used as the thousands separator (for example, ",").
     FiDecimalDigits: SmallInt;      //  INT8	Specifies the number of decimal digits.
     FbLeadingZero: Boolean;         //  INT8	 If TRUE, use leading zeros.

     procedure SetcDecimalSeparator(const Value: Char);
     procedure SetcThousandSeparator(const Value: Char);
     procedure SetiDecimalDigits(const Value: SmallInt);
     procedure SetbLeadingZero(const Value: Boolean);
  public
      constructor Create;  override;

      procedure SetNumberFormat(aDecimalSep: Char; aThousandSep: Char;
                aDecimalDigits: SmallInt; abLeadingZero: Boolean);
      procedure fDbiSetNumberFormat;
      procedure fDbiGetNumberFormat;
  published
     property cDecimalSeparator: Char read FcDecimalSeparator write SetcDecimalSeparator;
     property cThousandSeparator: Char read FcThousandSeparator write SetcThousandSeparator;
     property iDecimalDigits: SmallInt read FiDecimalDigits write SetiDecimalDigits;
     property bLeadingZero: Boolean read FbLeadingZero write SetbLeadingZero;
  end;


  TdbiDateFormat = class(TOwnerEntity)
  private
     FszDateSeparator: String;    // CHAR[4]    Specifies the date separator character.
     FtiDateMode: TDateMode;      // INT8	Specifies the date format: 0 = MDY, 1 = DMY, 2=YMD.
     FbFourDigitYear: Boolean; 	  // INT8	If TRUE, write year as four digits.
     FbYearBiased: Boolean; 	  // INT8	If TRUE, on input add 1900 to year.
     FbMonthLeadingZero: Boolean; // INT8	If TRUE, the month is displayed with a leading zero.
     FbDayLeadingZero: Boolean;

    procedure SetbDayLeadingZero(const Value: Boolean);
    procedure SetbFourDigitYear(const Value: Boolean);
    procedure SetbMonthLeadingZero(const Value: Boolean);
    procedure SetbYearBiased(const Value: Boolean);
    procedure SetszDateSeparator(const Value: String);
    procedure SettiDateMode(const Value: TDateMode);   // INT8	If TRUE, the day is displayed with a leading zero.
  public
      constructor Create; override;

      procedure SetDateFormat(aszDateSep: String; atDateMode: TDateMode;
                bFourDigitYear, bYearBiased, bMonthLeadingZero,
                bDayLeadingZero: Boolean);
      procedure fDbiSetDateFormat;
      procedure fDbiGetDateFormat;
  published
     property szDateSeparator: String read FszDateSeparator write SetszDateSeparator;
     property tiDateMode: TDateMode read FtiDateMode write SettiDateMode;
     property bFourDigitYear: Boolean read FbFourDigitYear write SetbFourDigitYear;
     property bYearBiased: Boolean read FbYearBiased write SetbYearBiased;
     property bMonthLeadingZero: Boolean read FbMonthLeadingZero write SetbMonthLeadingZero;
     property bDayLeadingZero: Boolean read FbDayLeadingZero write SetbDayLeadingZero;
  end;



implementation

uses
   Dialogs,
   e_class,
   FileCtrl,
   u_Dblib;



// ****************************
// **  TorbMyLdDesc
// ****************************

constructor TorbMyLdDesc.CreateAll(aDataSet: TDataSet);
begin
   inherited create;

   DataSet := aDataSet;
end;


destructor TorbMyLdDesc.Destroy;
begin
{
   if FDataSet <> nil then
   begin
      FDataSet.Free;
      FDataSet := nil;
   end;
}
   inherited Destroy;
end;



procedure TorbMyLdDesc.SetDataSet(aDataSet: TDataSet);
begin
   FDataSet := aDataSet;

//   if FDataSet = nil then exit;

   if FDataSet is TTable then
      Check(DbiGetLdObj(TTable(FDataSet).Handle, Pointer(MypLdObj)))
   else if  FDataSet is TQuery then
      Check(DbiGetLdObj(TQuery(FDataSet).Handle, Pointer(MypLdObj)));
end;



function TorbMyLdDesc.GetCountry: String;
begin
   if DataSet = nil then
      Result := ''
   else
      Result := MypLdObj^.szCountry;
end;



function TorbMyLdDesc.GetDescription: String;
begin
   if DataSet = nil then
      Result := ''
   else
      Result := MypLdObj^.szDesc;
end;



function TorbMyLdDesc.GetName: String;
begin
   if DataSet = nil then
      Result := ''
   else
      Result := MypLdObj^.szName;
end;



function TorbMyLdDesc.GetPrimaryCodePagePlatform: String;
begin
   if DataSet = nil then
      Result := ''
   else
      Result := GetPlatform(MypLdObj^.PrimaryCpPlatform);
end;



function TorbMyLdDesc.GetAlternateCodePage: Word;
begin
   if DataSet = nil then
      Result := 0
   else
      Result := MypLdObj^.AlternateCodePage;
end;



function TorbMyLdDesc.GetCodePage: Word;
begin
   if DataSet = nil then
      Result := 0
   else
      Result := MypLdObj^.iCodePage;
end;



function TorbMyLdDesc.GetPlatform(aPlatform: Word): String;
begin
   case aPlatform of
      1: Result := 'DOS(OEM)';
      2: Result := '(ANSI)';
      6: Result := 'HP UNIX (ROMAN8)';
   else
      Result := Format('Other (%d)', [aPlatform]);
   end;
end;



function TorbMyLdDesc.GetIsAnsiDrive: Boolean;
begin
   Result := False;

   if DataSet <> nil then
   begin
      if Pos('ANSI',UpperCase(Name)) > 0 then Result := True;
   end;
end;



// ****************************
// **  TorbAliases
// ****************************

constructor TorbAliases.Create;
begin
   inherited create;

   Name := 'Aliasy';

   IsBDEOk := orbfDbiInit;

   FReg := TBDERegistry.Create;
   FReg.OpenConfigFile;

   FAliasDrivers := TStringList.Create;
//   FAliasLangages := TStringList.Create;
//   FAliasNames := TStringList.Create;

end;



destructor TorbAliases.Destroy;
begin
   if FAliasDrivers <> nil then
   begin
      FAliasDrivers.Free;
      FAliasDrivers := nil;
   end;

   if FAliasNames <> nil then
   begin
      FAliasNames.Free;
      FAliasNames := nil;
   end;

   if FReg <> nil then
   begin
      FReg.Free;
      FReg := nil;
   end;

   inherited Destroy;
end;



function TorbAliases.AddAliasToCfg(aName: String): Boolean;
var
  al: TorbAlias;
begin
   Result:= False;
   al := GetAlias(aName);
   if (al = nil) then Exit;

   if not Reg.isOpenConfigFile then Reg.OpenConfigFile;

   orbfDbiAddAlias(Reg.hCfg, aName, al.AliasDriveType, al.AliasParams, al.AliasPersist);
end;


(*
procedure TorbAliases.DeleteAlias(aName: String);
var
  al: TOrbAlias;
begin
   {pro default DestCfgFile je aDestCfgFile nil}
   al:= TOrbAlias(FindElementName(aName)); {zkusm najt jestli existuje}

   if al = nil then exit;

   if not Reg.isOpenConfigFile then Reg.OpenConfigFile;

   try
      if al.isAlias then
         orbDbiDeleteAlias(Reg.hCfg, aName);

      al.free;
      Reg.isModifyConfigFile := True;
      SaveConfigFile;
   except
   end;
end;
*)



procedure TorbAliases.DeleteAlias(aName: string; Confirm: Boolean);
var
  Delete: Boolean;
  al: TOrbAlias;
  Path: PChar;
begin
   al:= TOrbAlias(FindElementName(aName)); {zkusm najt jestli existuje}

  if al = nil then exit;

  Delete := True;

  if Confirm = True then
  begin
    if  MessageDlg('Chcete opravdu vymazat alias: ' + aName,
        mtConfirmation, [mbYes, mbNo], 0) = mrNo then Delete := False;
  end;

  if Delete = True then
  begin
    Path := PChar(DBPath + aName);

    if not Reg.isOpenConfigFile then Reg.OpenConfigFile;

    try
       Check(DbiCfgDropRecord(Reg.hCfg, Path));
       al.free;
       Reg.isModifyConfigFile := True;

    finally

    end;
  end;
end;



function TorbAliases.GetAlias(aName: string): TOrbAlias;
var
  al: TOrbAlias;
begin

   al := FindAlias(aName); {zkusm najt jestli existuje}

   if TObject(al) is TOrbAlias then
   begin
      result:= al;
      exit;
   end;

   al:= TOrbAlias.CreateAll(aName);
   al.Name:= aName;

   result:= al;
//   AddElement(al);
   AddSortElement(al);
 end;



function TorbAliases.FindAlias(aName: string): TOrbAlias;
begin
   result := TOrbAlias(FindElementName(aName)); {zkusm najt jestli existuje}
end;



function TorbAliases.GetAliasDrivers: TStringList;
begin
   if FAliasDrivers = nil then FAliasDrivers := TStringList.Create;

   // Nate seznam vech driver pro BDE do StringListu
   Session.GetDriverNames(FAliasDrivers);
   Result := FAliasDrivers;
end;


function TorbAliases.isAliasDriver(aDriver: String): Boolean;
var
  i: Integer;
begin
   Result := False;

   if ((aDriver = '') OR (AliasDrivers.Count <= 0)) then exit;

   aDriver := UpperCase(aDriver);

   for i := 0 to AliasDrivers.Count - 1 do
   begin
      if (UpperCase(AliasDrivers.Strings[i]) = aDriver) then
      begin
         Result := True;
         Break;
      end;
   end;
end;

{
function TorbAliases.GetAliasLanguages: TStringList;
begin
   if FAliasLanguages = nil then FAliasLanguages := TStringList.Create;

   // Nate seznam vech language driver pro BDE do StringListu
   orbDbiOpenLdList(FAliasLanguages);
   Result := FAliasLanguages;
end;
}


function TorbAliases.GetAliasNames: TStringList;
begin
   if FAliasNames = nil then FAliasNames := TStringList.Create;
      // Nate seznam vech alias do StringListu
    Session.GetAliasNames(FAliasNames);


   Result := FAliasNames;
end;



function TorbAliases.GetAliasNames2: TStringList;
var
  rslt: DBIResult;
  NodePath: string;
begin
   if FAliasNames = nil then FAliasNames := TStringList.Create;

   FAliasNames.BeginUpdate;

   try
      FAliasNames.Clear;

      try
         Check(DbiCfgPosition(Reg.hCfg, PChar(DBPath)));
         rslt := DBIERR_NONE;

         while (rslt <> DBIERR_EOF) or (rslt = DBIERR_NONE) do
         begin
           SetLength(NodePath, DBIMAXNAMELEN + 1);
           rslt := DbiCfgGetNextNode(Reg.hCfg, PChar(NodePath));

           if rslt <> DBIERR_EOF then Check(rslt);

           SetLength(NodePath, StrLen(PChar(NodePath)));

           if rslt = DBIERR_NONE then FAliasNames.Add(NodePath);
         end;
      except
         raise Exception.Create(Exception(ExceptObject).Message);
      end;
   except
   end;


   FAliasNames.EndUpdate;
   Result := FAliasNames;

end;



procedure TorbAliases.GetAliasesFromCfg;
var
  i: integer;
begin
   if (AliasNames.Count > 0) then
   begin
      for i := 0 to AliasNames.Count - 1 do
      begin
         GetAlias(AliasNames.Strings[i]);
      end;

   end;
end;



function TorbAliases.GetAliasForDriver(aName, aDriver: string): TOrbAlias;
var
  al: TOrbAlias;
begin
   result := nil;

   if not isAliasDriver(aDriver) then exit;

   aDriver := UpperCase(aDriver);

   al:= TOrbAlias(FindElementName(aName)); {zkusm najt jestli existuje}

   if TObject(al) is TOrbAlias then
   begin
      if (UpperCase(al.AliasDriveType) = aDriver) then
      begin
         result:= al;
      end;
      exit;
   end;

   al:= TOrbAlias.CreateAll(aName);
   al.Name:= aName;

   if (UpperCase(al.AliasDriveType) = aDriver) then
   begin
      result:= al;
      AddElement(al);
   end;
end;



procedure TorbAliases.GetAliasesForDriver(aDriver: String);
var
  i: integer;
begin

   if not isAliasDriver(aDriver) then exit;

   if (AliasNames.Count > 0) then
   begin
      for i := 0 to AliasNames.Count - 1 do
          GetAliasForDriver(AliasNames.Strings[i], aDriver);
   end;
end;

(*
function TorbAliases.GetInfoAlias(aName: String): TStringList;
var
   i: Integer;
   Nasel: Boolean;
   aStrList, pomStrList: TStringList;
begin
   // Zjistit zda alias existuje v BDE Configu
   Nasel := False;
   Result := nil;

   for i := 0 to AliasNames.Count - 1 do
   begin
      if (UpperCase(aName) = UpperCase(AliasNames.Strings[i])) then
      begin
         Nasel := True;
         Break;
      end;
   end;

   //Kdy ano, tak nast parametry aliasu
   if Nasel = True then
   begin
      aStrList := TStringList.Create;
      pomStrList := TStringList.Create;

      with Session do
      begin
         GetConfigParams('\DATABASES\%s\DB INFO' , aName, aStrList);

         if aStrList.Values['TYPE'] <> 'STANDARD' then
         begin
            GetAliasParams(aName, pomStrList);
            for i:= 0 to pomStrList.Count - 1 do
                aStrList.Add(pomStrList.Strings[i]);
         end;
      end;

      Result.Assign(aStrList);
      aStrList.Free;
      pomStrList.Free;
   end;
end;
*)


function TorbAliases.GetBDERegistry: TBDERegistry;
begin
   if (FReg = nil) then Freg := TBDERegistry.Create;

   Result := Freg;
end;



procedure TorbAliases.SaveConfigFile;
begin
   if Reg <> nil then Reg.SaveConfigFile;
end;



procedure TorbAliases.SetBDERegistry(const Value: TBDERegistry);
begin
   FReg := Value;
end;



procedure TorbAliases.SetIsBDEOk(const Value: Boolean);
begin
   FIsBDEOk := Value;
end;




// ****************************
// **  TorbAlias
// ****************************

constructor TorbAlias.CreateAll(aName: String);
begin
   inherited create;

   AliasName := aName;
   AliasState := alsNone;
   AliasPersist := False;


   GetInfoExistsAlias; // otestuje zda alias existuje a nacte parametry
end;



destructor TorbAlias.Destroy;
begin

   if (((AliasState = alsNew) or ( AliasState = alsChanged)) and AliasPersist) then
   begin
      if Aliases <> nil then Aliases.SaveConfigFile;
   end;

   if  FAliasParams <> nil then
   begin
      FAliasParams.Free;
      FAliasParams := nil;
   end;

   if FDatabase <> nil then
   begin
      FDatabase.Free;
      FDatabase := nil;
   end;

   inherited Destroy;
end;



function TorbAlias.GetAliases: TorbAliases;
var
  aClass: TEntity;
begin
   aClass := FindOwnerClass(TorbAliases);

   if (aCLass = nil) then
      Result := nil
   else
      Result := TorbAliases(aClass);
end;



function TorbAlias.GetTables: TorbTables;
begin
   result := TOrbTables(FindElementClass(TorbTables));
   if (result = nil) then
   begin
      if isAlias then
      begin
         Result := TorbTables.CreateAll(AliasName);

         if ((Result <> nil) {and (Result.TableNames.Count > 0)}) then
         begin
            Result.Name := 'Tabulky';
            AddElement(result);
         end;
      end;
   end;
end;



function TorbAlias.GetDotazy: TorbSqlList;
begin
   result := TorbSqlList(FindElementClass(TorbSqlList));

   if (result = nil) then
   begin
         Result := TorbSqlList.CreateAll(AliasName);

         if (Result <> nil) then
         begin
            Result.Name := 'Dotazy';
            AddElement(result);
         end;
   end;
end;




function TorbAlias.GetIsAlias: Boolean;
begin
   if AliasName = '' then
   begin
      AliasState := alsNone;
      Result := False;
      Exit;
   end
   else
      Result := Session.IsAlias(AliasName);

   if not result then
       if ((AliasState <> alsNone) or (AliasState <> alsNew)) then
          AliasState := alsNone;

end;



function TorbAlias.GetIsSQL: Boolean;
var
  aDr: String;
begin
   if AliasDriveType = '' then
   begin
      Result := False;
      Exit;
   end
   else
   begin
      aDr := UpperCase(AliasDriveType);

      if aDr = 'STANDARD' then result := FALSE
      else if aDr = 'INTRBASE' then result := TRUE
      else if aDr = 'ORACLE' then result := TRUE
      else if aDr = 'SYBASE' then result := TRUE
      else if aDr = 'MSSQL' then result := TRUE
      else if aDr = 'MSACCESS' then result := TRUE
      else if aDr = 'FOXPRO' then result := FALSE
      else if aDr = 'INFORMIX' then result := TRUE
      else if aDr = 'DB2' then result := TRUE
      else result := FALSE;
   end

end;

procedure TorbAlias.GetCfgParams(hCfg: hDbiCfg; Path, Section: string; List: TStrings);
var
  Cursor: HDBICur;
  ConfigDesc: CFGDesc;
begin
   try
     Check(DbiOpenCfgInfoList(hCfg, dbiREADONLY, cfgPERSISTENT, PChar(Format(Path,
       [Section])), Cursor));
   finally

   end;

   try
      while DbiGetNextRecord(Cursor, dbiNOLOCK, @ConfigDesc, nil) = 0 do
      with ConfigDesc do
      begin
         OemToChar(szValue, szValue);
         List.Add(Format('%s=%s', [szNodeName, szValue]));
      end;
   finally
      DbiCloseCursor(Cursor);
   end;
end;



function TorbAlias.GetDatabase: TDatabase;
begin
   Result := FDatabase;
end;



procedure TorbAlias.SetDatabase(aDatabase: TDatabase);
begin
   FDatabase := aDatabase;
end;



procedure TorbAlias.GetInfoAlias(hCfg: hDbiCfg);
var
  SAlias: DBIName;
//  Desc: DBDesc;
begin
  if {(}(AliasName = ''){ or (AliasDriveType = ''))} then
  begin
     AliasState := AlsNone;
     exit;
  end;

  AliasParams.BeginUpdate;

  try
    AliasParams.Clear;
    StrPLCopy(SAlias, AliasName, SizeOf(SAlias) - 1);
    CharToOEM(SAlias, SAlias);
(*
 //    LockSession;
    try
      Check(DbiGetDatabaseDesc(SAlias, @Desc));
    finally
//      UnlockSession;
    end;

    if Desc.szDBType[sizeOf(Desc.szDBType) - 1] <> #0 then
      Desc.szDBType[sizeOf(Desc.szDBType) - 1] := #0;

    if StrIComp(Desc.szDbType, szCFGDBSTANDARD) = 0 then
 *)
    if AliasDriveType = cStandard then
    begin
       GetCfgParams(hCfg, cDbInfo, SAlias, AliasParams);
       AliasParams.Values[szCFGDBTYPE] := '';
    end
    else
       GetCfgParams(hCfg, cDbOpen, SAlias, AliasParams);
  finally
     AliasParams.EndUpdate;
  end;
end;



procedure TorbAlias.SetIsConnected(const Value: Boolean);
begin
  FIsConnected := Value;
end;



procedure TorbAlias.GetInfoExistsAlias;
begin
  if (AliasName = '') then
  begin
     AliasState := AlsNone;
     exit;
  end;

  if not isAlias then exit;

  try
     AliasParams.Clear;
     Session.GetAliasParams(AliasName, AliasParams);
     AliasState := alsBrowse;
     AliasDriveType := Session.GetAliasDriverName(AliasName);
  finally

  end;

end;



procedure TorbAlias.SetAliasDriveType(aName: String);
begin
   if (aName = '') then
   begin
      AliasState := alsNone;
      exit;
   end
   else if (FAliasDriveType <> aName) then
   begin
      // Zde vyeit zmnu driveru vymazat parametry a znovu je vytvoit
      // kdy u existuje v konfiguranm souboru musm alias vymazat a
      // znovu jej vytvoit;

   end;

   FAliasDriveType := aName;

   //   SetDefaultAliasParams;
end;



procedure TorbAlias.SetAliasName(aName: String);
begin
   FAliasName := aName;
//   GetInfoAlias(FAliasName);
end;



procedure TorbAlias.SetAliasPersist(aPersist: Boolean);
begin
   FAliasPersist := aPersist;
end;



procedure TorbAlias.SetAliasState(aState: TAliasState);
begin
   FAliasState := aState;
end;



function TorbAlias.GetAliasParams: TStringList;
begin
   if FAliasParams = nil then FAliasParams := TStringList.Create;

   Result := FAliasParams;
end;



procedure TorbAlias.SetAliasParams(aStrList: TStringList);
begin
   FAliasParams := aStrList;
end;


function TorbAlias.AliasStateAsString: String;
begin
   case AliasState of
      alsNone: Result:= 'None';
      alsBrowse: Result:= 'Browse';
      alsChanged: Result:= 'Changed';
      alsNew: Result:= 'New';
   else
      Result:= '';
   end;
end;



procedure TorbAlias.CreateNewAlias(hCfg: hDBICfg; aName, aDriveType: String);
begin
   if ((aName = '') or (aDriveType = '') or (hCfg = nil)) then exit;
   AliasDriveType := aDriveType;

   if aDriveType = cStandard then
      AddStandardAlias(hCfg, aName)
   else
      AddSQLAlias(hCfg, aDriveType, aName);

   GetInfoAlias(hCfg);
end;



procedure TorbAlias.AddSQLAlias(hCfg: hDBICfg; Driver, Name: string);
var
   pRecBuf, pInfoRecBuf: pBYTE;
   pFields, pInfoFields: pFLDDesc;
   AddPath, Path: string;
   Count: word;
begin
//  screen.cursor := crHourGlass;

   Count := 0;
   pRecBuf := AllocMem(RecBufSize);
   pInfoRecBuf := AllocMem(RecBufSize);
   pFields := AllocMem(MaxFields);
   pInfoFields := AllocMem(MaxFields);

   try
      AddPath := Format('%s%s\DB INFO\', [DBPath, Name]);

      pInfoFields.iUnits1 := 127;
      pInfoFields.iLen := 128;
      pInfoFields.iOffset := 128 * 0;
      pInfoFields.iFldNum := 1;
      StrCopy(pInfoFields.szName, 'TYPE');
      Inc(pInfoFields);
      pInfoFields.iUnits1 := 127;
      pInfoFields.iLen := 128;
      pInfoFields.iOffset := 128 * 1;
      pInfoFields.iFldNum := 2;
      StrCopy(pInfoFields.szName, 'PATH');
      Dec(pInfoFields);
      StrPCopy(pCHAR(pInfoRecBuf), Driver);
      Inc(pInfoRecBuf, 128);
      StrPCopy(pCHAR(pInfoRecBuf), '');
      Dec(pInfoRecBuf, 128);

      Check(DbiCfgAddRecord(hCfg, PChar(AddPath), 2, pInfoFields, pInfoRecBuf));

      Path := DriverPath + Driver + '\DB OPEN\'; // Default Driver Path...
      Check(DbiCfgPosition(hCfg, PChar(Path)));
      Check(DbiCfgGetRecord(hCfg, PChar(Path), Count, pFields, pRecBuf));
      AddPath := Format('%s%s\DB OPEN\', [DBPath, Name]);
      Check(DbiCfgAddRecord(hCfg, PChar(AddPath), Count, pFields, pRecBuf));
      AliasState := alsNew;
   finally
{
     screen.cursor := crDefault;
     if AliasNode.Expanded = True then
     begin
       AliasNode.Collapse(True);
       AddChildNodes(AliasNode);
       TreeView1Expanding(self, AliasNode, Expand);
       AliasNode.Expand(False);
     end;
}
      if pRecBuf <> nil then FreeMem(pRecBuf, RecBufSize);
      if pFields <> nil then FreeMem(pFields, MaxFields);
      if pInfoRecBuf <> nil then FreeMem(pInfoRecBuf, RecBufSize);
      if pInfoFields <> nil then FreeMem(pInfoFields, MaxFields);
   end;

end;



procedure TorbAlias.AddStandardAlias(hCfg: hDBICfg; Name: string);
var
   pFlds, pFld: pFLDDesc;
   pRecBuf, pRec: pByte;
begin
   pFlds := nil;
   pRecBuf := nil;
//   screen.cursor := crHourGlass;

   try
      pRecBuf := AllocMem(RecBufSize);
      pRec := pRecBuf;
      pFlds := AllocMem(4 * Sizeof(FLDDesc));
      pFld := pFlds;
      pFld.iUnits1 := 127;
      pFld.iLen := 128;
      pFld.iOffset := 128 * 0;
      pFld.iFldNum := 1;
      StrCopy(pFld.szName, 'TYPE');
      Inc(pFld);
      pFld.iUnits1 := 127;
      pFld.iLen := 128;
      pFld.iOffset := 128 * 1;
      pFld.iFldNum := 2;
      StrCopy(pFld.szName, cPath);
      Inc(pFld);
      pFld.iUnits1 := 127;
      pFld.iLen := 128;
      pFld.iOffset := 128 * 2;
      pFld.iFldNum := 3;
      StrCopy(pFld.szName, cDefaultDrv);
      Inc(pFld);
      pFld.iUnits1 := 127;
      pFld.iLen := 128;
      pFld.iOffset := 128 * 3;
      pFld.iFldNum := 4;
      StrCopy(pFld.szName, 'ENABLE BCD');

      StrCopy(PChar(pRec), cStandard);
      Inc(pRec, 128);
      StrCopy(PChar(pRec), '');
      Inc(pRec, 128);
      StrCopy(PChar(pRec), cPdox);
      Inc(pRec, 128);
      StrCopy(PChar(pRec), 'FALSE');

      Check(DbiCfgAddRecord(hCfg,
             PChar(DBPath +  '\' + Name + '\DB INFO\'), 4, pFlds, pRecBuf));
      AliasState := alsNew;
   finally
 {
     if AliasNode.Expanded = True then
     begin
       AddChildNodes(AliasNode);
       TreeView1Expanding(self, AliasNode, Expand);
       AliasNode.Expand(False);
     end;
  }
      if pFlds <> nil then FreeMem(pFlds, 4 * sizeof(FLDDesc));
      if pRecBuf <> nil then FreeMem(pRecBuf, RecBufSize);

//     screen.cursor := crDefault;
   end;

end;



(*
procedure TorbAlias.DeleteAlias;
begin
   {pro default DestCfgFile je aDestCfgFile nil}
   orbDbiDeleteAlias(nil, AliasName);
end;
*)



procedure TorbAlias.GetUserNameFromCfgParams;
begin
   UserName := AliasParams.Values['USER NAME'];
end;



procedure TorbAlias.SetPassword(const Value: string);
begin
   FPassword := Value;
end;



procedure TorbAlias.SetUserName(const Value: string);
begin
   FUserName := Value;
end;



procedure TorbAlias.ModifyAlias(aName: string);
begin
   // Zjistit zda alias existuje
   // Kdy ano, tak opravit parametry aliasu
end;




// *******************
// ** TBDERegistry
// *******************

constructor TBDERegistry.Create;
begin
   inherited Create;

   LazyWrite := False;
   RootKey := HKEY_LOCAL_MACHINE;

   ConfigFilePath := '';
   DLLPath := '';
   SaveTYpeConfig := cWIN95;
   SaveChanges := False;
   isOpenConfigFile := False;
   isModifyConfigFile := False;
   ShowMsgBox :=  True;
end;



destructor TBDERegistry.Destroy;
begin
   if isOpenConfigFile then
   begin
      if isModifyConfigFile then SaveConfigFile;

      CloseConfigFile;
   end;

   inherited Destroy;
end;



procedure TBDERegistry.CloseConfigFile;
begin
   if hCfg <> nil then                          // Default config file
   begin
      try
         Check(DbiCloseConfigFile(FhCfg, SaveChanges, False, Win31Checked));
         isOpenConfigFile := False;
      except
      end;
   end;
end;



function TBDERegistry.GetConfigFilePath: String;
begin
   if IsOpenKey then
   begin
      FConfigFilePath := ReadString(ConfigFileKey);
      CloseKey;
   end;

   Result := FConfigFilePath;
end;



function TBDERegistry.GetDLLPath: String;
begin
   if IsOpenKey then
   begin
      FDLLPath := ReadString(DLLPathKey);
      CloseKey;
   end;

   Result := FDLLPath;
end;



function TBDERegistry.GetSaveTypeConfig: String;
begin
   if IsOpenKey then
   begin
      FSaveTypeConfig := ReadString(SaveConfigKey);
      CloseKey;
   end;

   Result := FSaveTypeConfig;

end;



function TBDERegistry.IsOpenKey: Boolean;
begin

   if OpenKey(ConfigKey, False) = False then
   begin
      Result := False;
      ShowMessage('Konfiguran soubor pro BDE32 nebyl nalezen')
   end
   else
      Result := True;
end;



procedure TBDERegistry.OpenConfigFile;
begin
   try
      Check(DbiOpenConfigFile(PChar(ConfigFilePath), FALSE, FhCfg));
      isOpenConfigFile := True;
   except
      MessageDlg(Exception(ExceptObject).Message, mtError, [mbOk], 0);
   end;
end;



procedure TBDERegistry.SaveConfigFile;
begin
   if ShowMsgBox then
      if (MessageDlg('Provdn zmny v konfiguranm souboru nejsou uloeny, chcete je uloit?',
          mtConfirmation, [mbYes, mbNo], 0) <> mrYes) then exit;

   try
      Check(DbiCfgSave(FhCfg, nil, Win31Checked));
      isModifyConfigFile := False;
// zmeny v IDAPI.CFG neni videt dokud se neprovede close 
      CloseConfigFile;
      OpenConfigFile;
   except
      MessageDlg(Exception(ExceptObject).Message, mtError, [mbOk], 0);
   end;
end;


procedure TBDERegistry.SetConfigFilePath(const Value: String);
begin
   if DirectoryExists(Value) then
      if isOpenKey then
      begin
         WriteString(ConfigFileKey, Value);
         CloseKey;
      end;
end;



procedure TBDERegistry.SetDLLPath(const Value: String);
begin
   if DirectoryExists(Value) then
      if isOpenKey then
      begin
         WriteString(DLLPathKey, Value);
         CloseKey;
      end;

end;



procedure TBDERegistry.SethCfg(Value: hDBICfg);
begin
   FhCfg := Value;
end;



procedure TBDERegistry.SetisModifyConfigFile(const Value: Boolean);
begin
  FisModifyConfigFile := Value;
end;



procedure TBDERegistry.SetisOpenFile(const Value: Boolean);
begin
   FisOpenConfigFile := Value;
end;



procedure TBDERegistry.SetSaveChanges(const Value: Boolean);
begin
   FSaveChanges:= Value;
end;



procedure TBDERegistry.SetSaveTypeConfig(const Value: String);
begin
   if ((Value = cWin31) or (Value = cWin95)) then
   begin
      if isOpenKey then
      begin
         WriteString(SaveConfigKey, Value);
         CloseKey;
      end;

      if Value = cWin31 then
         Win31Checked := True
      else
         Win31Checked := False;
   end;
end;



procedure TBDERegistry.SetWin31Checked(const Value: Boolean);
begin
   FWin31Checked := Value;
end;



procedure TBDERegistry.SetShowMsgBox(const Value: Boolean);
begin

end;



{ TdbiTimeFormat }

procedure TdbiTimeFormat.SetbMiliSeconds(const Value: Boolean);
begin
  FbMiliSeconds := Value;
end;



procedure TdbiTimeFormat.SetbSeconds(const Value: Boolean);
begin
  FbSeconds := Value;
end;



procedure TdbiTimeFormat.SetbTwelveHour(const Value: Boolean);
begin
  FbTwelveHour := Value;
end;

procedure TdbiTimeFormat.SetszAmString(const Value: String);
begin
  FszAmString := Value;
end;



procedure TdbiTimeFormat.SetszPmString(const Value: String);
begin
   FszPmString := Value;
end;



procedure TdbiTimeFormat.SetTimeFormat(aTimeSep: Char;
  abTwelveHour: Boolean; aAmString, aPmString: String; abSeconds,
  abMiliSeconds: Boolean);
begin
   TimeSeparator := aTimeSep;
   bTwelveHour := abTwelveHour;
   szAmString := aAmString;
   szPmString := aPmString;
   bSeconds := abSeconds;
   bMiliSeconds := abMiliSeconds;
end;



procedure TdbiTimeFormat.fDbiSetTimeFormat;
var
   aFmtTime: FmtTime;
   i: integer;
begin
{
cTimeSeparator 	CHAR	Specifies the time separator character (for example, ".").
bTwelveHour 	INT8	If TRUE, represent as 12-hour time.
szAmString[6] 	CHAR	Specifies the string to use for designating AM time (only for 12-hour time).
szPmString[6] 	CHAR	Specifies the string to use for designating PM time (only for 12-hour time).
bSeconds 	INT8	If TRUE, show seconds.
bMilSeconds 	INT8	If TRUE, show milliseconds.
}
   aFmtTime.cTimeSeparator := TimeSeparator;
   aFmtTime.bTwelveHour := bTwelveHour;
   for i := 0 to Length(szAmString) - 1 do
      aFmtTime.szAmString[i] := szAmString[i];

   for i := 0 to Length(szAmString) - 1 do
       aFmtTime.szPmString[i] := szPmString[i];

   aFmtTime.bSeconds := bSeconds;
   aFmtTime.bMilSeconds := bMiliSeconds;

   Check(DbiSetTimeFormat (aFmtTime));
end;



procedure TdbiTimeFormat.fDbiGetTimeFormat;
var
   aFmtTime: FmtTime;
begin
{
cTimeSeparator 	CHAR	Specifies the time separator character (for example, ".").
bTwelveHour 	INT8	If TRUE, represent as 12-hour time.
szAmString[6] 	CHAR	Specifies the string to use for designating AM time (only for 12-hour time).
szPmString[6] 	CHAR	Specifies the string to use for designating PM time (only for 12-hour time).
bSeconds 	INT8	If TRUE, show seconds.
bMilSeconds 	INT8	If TRUE, show milliseconds.
}
   Check(DbiGetTimeFormat (aFmtTime));

   TimeSeparator := aFmtTime.cTimeSeparator;
   bTwelveHour := aFmtTime.bTwelveHour;
   szAmString := aFmtTime.szAmString;
   szPmString := aFmtTime.szPmString;
   bSeconds := aFmtTime.bSeconds;
   bMiliSeconds := aFmtTime.bMilSeconds;

end;



constructor TdbiTimeFormat.Create;
begin
   inherited create;

   fDbiGetTimeFormat;

end;



procedure TdbiTimeFormat.SetTimeSeparator(const Value: Char);
begin
  FTimeSeparator := Value;
end;



{ TdbiNumberFormat }

constructor TdbiNumberFormat.Create;
begin
   inherited create;
   fDbiGetNumberFormat;

end;



procedure TdbiNumberFormat.fDbiGetNumberFormat;
var
   aFmtNumber: FmtNumber;
begin
{
   cDecimalSeparator 	CHAR	Specifies the character to be used as the decimal separator (for example, ".").
   cThousandSeparator 	CHAR	Specifies the character to be used as the thousands separator (for example, ",").
   iDecimalDigits 	INT8	Specifies the number of decimal digits.
   bLeadingZero 	INT8	 If TRUE, use leading zeros.
}
   Check(DbiGetNumberFormat (aFmtNumber));

   cDecimalSeparator := aFmtNumber.cDecimalSeparator;
   cThousandSeparator := aFmtNumber.cThousandSeparator;
   iDecimalDigits := aFmtNumber.iDecimalDigits;
   bLeadingZero := aFmtNumber.bLeadingZero;
end;



procedure TdbiNumberFormat.fDbiSetNumberFormat;
var
   aFmtNumber: FmtNumber;
begin

   aFmtNumber.cDecimalSeparator := cDecimalSeparator;
   aFmtNumber.cThousandSeparator := cThousandSeparator;
   aFmtNumber.iDecimalDigits := iDecimalDigits;
   aFmtNumber.bLeadingZero := bLeadingZero;

   Check(DbiSetNumberFormat (aFmtNumber));
end;



procedure TdbiNumberFormat.SetbLeadingZero(const Value: Boolean);
begin
   FbLeadingZero := Value;
end;

procedure TdbiNumberFormat.SetcDecimalSeparator(const Value: Char);
begin
   FcDecimalSeparator := Value;
end;

procedure TdbiNumberFormat.SetcThousandSeparator(const Value: Char);
begin
   FcThousandSeparator := Value;
end;

procedure TdbiNumberFormat.SetiDecimalDigits(const Value: SmallInt);
begin
   FiDecimalDigits := Value;
end;



procedure TdbiNumberFormat.SetNumberFormat(aDecimalSep, aThousandSep: Char;
  aDecimalDigits: SmallInt; abLeadingZero: Boolean);
begin
   cDecimalSeparator := aDecimalSep;
   cThousandSeparator := aThousandSep;
   iDecimalDigits := aDecimalDigits;
   bLeadingZero := abLeadingZero;

end;



{ TdbiDateFormat }

constructor TdbiDateFormat.Create;
begin
   inherited create;
   fDbiGetDateFormat;
end;



procedure TdbiDateFormat.fDbiGetDateFormat;
var
   aFmtDate: FmtDate;
begin
{
   szDateSeparator[4] 	CHAR	Specifies the date separator character.
   iDateMode       	INT8	Specifies the date format: 0 = MDY, 1 = DMY, 2=YMD.
   bFourDigitYear 	INT8	If TRUE, write year as four digits.
   bYearBiased 	        INT8	If TRUE, on input add 1900 to year.
   bMonthLeadingZero 	INT8	If TRUE, the month is displayed with a leading zero.
   bDayLeadingZero 	INT8	If TRUE, the day is displayed with a leading zero.
}
   Check(DbiGetDateFormat (aFmtDate));

   szDateSeparator := aFmtDate.szDateSeparator;
   tiDateMode := TDateMode(aFmtDate.iDateMode);
   bFourDigitYear := aFmtDate.bFourDigitYear;
   bYearBiased := aFmtDate.bYearBiased;
   bMonthLeadingZero := aFmtDate.bMonthLeadingZero;
   bDayLeadingZero := aFmtDate.bDayLeadingZero;

end;



procedure TdbiDateFormat.fDbiSetDateFormat;
var
   aFmtDate: FmtDate;
   i: Integer;
begin
   for i := 0 to Length(szDateSeparator) - 1 do
       aFmtDate.szDateSeparator[i] := szDateSeparator[i];

   aFmtDate.iDateMode := ord(tiDateMode);
   aFmtDate.bFourDigitYear := bFourDigitYear;
   aFmtDate.bYearBiased := bYearBiased;
   aFmtDate.bMonthLeadingZero := bMonthLeadingZero;
   aFmtDate.bDayLeadingZero := bDayLeadingZero;

   Check(DbiGetDateFormat (aFmtDate));

end;



procedure TdbiDateFormat.SetbDayLeadingZero(const Value: Boolean);
begin
   FbDayLeadingZero := Value;
end;



procedure TdbiDateFormat.SetbFourDigitYear(const Value: Boolean);
begin
   FbFourDigitYear := Value;
end;



procedure TdbiDateFormat.SetbMonthLeadingZero(const Value: Boolean);
begin
   FbMonthLeadingZero := Value;
end;



procedure TdbiDateFormat.SetbYearBiased(const Value: Boolean);
begin
   FbYearBiased := Value;
end;



procedure TdbiDateFormat.SetDateFormat(aszDateSep: String;
   atDateMode: TDateMode; bFourDigitYear, bYearBiased, bMonthLeadingZero,
   bDayLeadingZero: Boolean);
begin

end;



procedure TdbiDateFormat.SetszDateSeparator(const Value: String);
begin
   FszDateSeparator := Value;
end;



procedure TdbiDateFormat.SettiDateMode(const Value: TDateMode);
begin
   FtiDateMode := Value;
end;



{ TorbTables }

constructor TorbTables.CreateAll(aName: String);
begin
   inherited create;

   AliasName := aName;
   ShowSysTables := False;
end;



destructor TorbTables.Destroy;
begin
   if FTableNames <> nil then
   begin
      FTableNames.Free;
      FTableNames := nil;
   end;

   if FQuery <> nil then
   begin
      FQuery.Free;
      FQuery := nil;
   end;

   inherited destroy;
end;



function TorbTables.GetAlias: TOrbAlias;
var
  aClass: TEntity;
begin
   aClass := FindOwnerClass(TorbAlias);

   if (aCLass = nil) then
   begin
      Result := TorbAlias.CreateAll(AliasName);
   end
   else
      Result := TorbAlias(aClass);

end;



function TorbTables.GetQuery: TQuery;
begin
   result := FQuery;
end;



function TorbTables.GetShowSQLTables: Boolean;
begin
   Result := FShowSQLTables;
end;



function TorbTables.GetTableNames: TStringList;
var
   alsTbl: TStringList;
   aDrv, aPath: String;
   i: Integer;
//   aTable: TOwnerEntity;
   aTable: TorbTable;
   Pole: TorbFields;
begin
    aDrv := Alias.AliasDriveType;
//    aQry := TQuery.create();

    if aDrv = 'STANDARD' then
       aDrv := Alias.AliasParams.Values['DEFAULT DRIVER'];

    aPath := Alias.AliasParams.Values['PATH'];


    if ((Alias.AliasState = alsNew) or (aDrv = '')) then
       result := TStringList.Create
    else
    begin

       if Query <> nil then
          Query.DatabaseName := Alias.AliasName;

       result := TStringList.Create;

       if aDrv = cDbase then
       begin
          orbGetTblFromDir(aPath, cExtDbase, result);
       end
       else if aDrv = cInterbase then
       begin
          orbGetTblFromServer(aDrv, result, ShowSysTables, Query);
       end
       else if aDrv = cOracle then
       begin
          orbGetTblFromServer(aDrv, result, ShowSysTables, Query);
       end
       else if aDrv = cPdox then
       begin
          orbGetTblFromDir(aPath, cExtPdox, result);
       end
       else if aDrv = cSybase then
       begin
          orbGetTblFromServer(aDrv, result, ShowSysTables, Query);
       end;
    end;

    if result.count > 0 then
    begin
       for i := 0 to result.count - 1 do
       begin
//          aTable := TOwnerEntity(FindElementName(result[i]));
          aTable := TorbTable(FindElementName(result[i]));

          if aTable = nil then
          begin
//             aTable := TOwnerEntity.Create;
             aTable := TorbTable.Create;
             aTable.Name := result[i];
//             AddElement(aTable);
             AddSortElement(aTable);
          end;

          pole := TorbFields(aTable.FindElementName('Pole'));

          if (pole = nil) then
          begin
             Pole := TorbFields.Create;
             Pole.Name := 'Pole';
             aTable.AddSortElement(Pole);
          end;

       end;
    end;
end;



procedure TorbTables.SetAliasName(const Value: string);
begin
  FAliasName := Value;
end;


procedure TorbTables.SetQuery(const Value: TQuery);
begin
   FQuery := Value;
end;


procedure TorbTables.SetShowSQLTables(const Value: Boolean);
begin
   FShowSQLTables := Value;
end;


procedure TorbTables.SetShowSysTables(const Value: Boolean);
begin
   FShowSysTables := Value;
end;

INITIALIZATION
//   RegisterOrbisClass(TBDERegistry);
   RegisterOrbisClass(TOrbAlias);
   RegisterOrbisClass(TOrbAliases);
   RegisterOrbisClass(TOrbField);
   RegisterOrbisClass(TOrbFields);
   RegisterOrbisClass(TOrbTable);
   RegisterOrbisClass(TOrbTables);
   RegisterOrbisClass(TdbiTimeFormat);
   RegisterOrbisClass(TdbiNumberFormat);
   RegisterOrbisClass(TdbiDateFormat);
   RegisterOrbisClass(TdbiTimeFormat);
END.
