program Test;

uses
   msElems, BlokType, MatProc,
   TCB, Typky, _Music,
   Objects;

const
  cc = 100000;

var
  F     : File;
  FLin  : File of TLin;
  FSour : File of TSour;
  FT    : Text;
  Linie : TLin;
  Sour  : TSour;
  Header: Word;
  WTF   : Word;
  Pozice: LongInt;
  RLine : TLine_2d;
  RText : Ttext_2d;
  RLineString: Tline_string_2d;
  RLine3: TLine_3d;
  RLineString3: Tline_string_3d;
  RText3: Ttext_3d;
  EH    : Ehdr;
  CLin  : LongInt;
  CSour : LongInt;
  Prvni : Boolean;
  S     : String;
  i     : Word;
  P2D   : Point2D;
  P3D   : Point3D;
  TCBB  : TTCB;
  Je3d  : Boolean;
  JeTCB : Boolean;
  Prep  : LongInt;



function SwapLong( L: longInt ): LongInt; assembler;
  asm
    mov   ax, word ptr L + 2
    mov   dx, word ptr L
  end;

function LL(L: LongInt): Real;
  var
     PomR: Real;
  begin
     PomR   := SwapLong(L);
     LL     := PomR/Prep;
  end;

function Level: Word;
  begin
     Level := EH.Header and mskLevel;
  end;

procedure Bod2DnaSour(B: Point2D; var S: TSour);
  begin
     S.y := LL(B.x);
     S.x := LL(B.y);
  end;

function Complex: Word;
  begin
     Complex := (EH.Header and mskComplex) shr 7;
  end;

function Typ: Word;
  begin
     Typ := EH.Header and mskType ;
  end;

function Deleted: Word;
  begin
     Deleted := (EH.Header and mskDeleted) shr 15;
  end;

{-------------------------------------------}
procedure UpravObd;

  procedure UpravATak(var LL: LongInt);
  begin
     LL := SwapLong(LL);
     if LL > 0 then
        LL := LL - MaxLongInt - 1 else
        LL := LL + MaxLongInt + 1;
  end;

  begin
     UpravATak(EH.xlow);
     UpravATak(EH.ylow);
     UpravATak(EH.xhigh);
     UpravATak(EH.yhigh);
  end;

{-------------------------------------------}

procedure UpravObd1;
  begin
     EH.xlow  := ( SwapLong( EH.xlow ) - MaxLongInt ) - 1;
     EH.ylow  := ( SwapLong( EH.ylow ) - MaxLongInt ) - 1;
     EH.xhigh := ( SwapLong( EH.xhigh ) - MaxLongInt ) - 1;
     EH.yhigh := ( SwapLong( EH.yhigh ) - MaxLongInt ) - 1;
  end;


procedure KontrolaObd;
  const
     mx = 20000;
  begin
     with Linie do
     begin
        {
        if OpsanyObdelnik.PH.y > mx then
        begin
           Bell;
        end;
        }
     end;
  end;

begin
  Bell  := GRINDER;
  Je3D  := False;
  JeTCB := False;
  CLin  := 0;
  CSour := 0;
  {MkDir('d:\data\tl25\T.Blk');}
  Assign(FLin ,'c:\data\pwgdrk\T.Blk\TN.LIN');
  Assign(FSour,'c:\data\pwgdrk\T.Blk\TN.CRD');
  Assign(F,'c:\data\pwgdrk\MStation\Mapa1.DGN');
  Assign(FT,'c:\data\pwgdrk\MStation\Sour.pas');
  Reset(F,1);
  Rewrite(FLin);
  Rewrite(FSour);
  Rewrite(FT);
  (*
  repeat
     Pozice := FilePos(F);
     BlockRead(F,Header,SizeOf(Word));
     BlockRead(F,WTF,SizeOf(Word));
     Seek(F,Pozice + 4 + WTF shl 1);
     Writeln('H: ',(Header and mskType) div $100 );
  until Header and mskType = LINE_ELM;
  Readln;
  Seek(F,Pozice);
  *)
  Prvni := True;
  CLin  := 0;
  CSour := 0;

  Write(FLin,Linie);
  Write(FSour,Sour);
  Inc(CLin);
  Inc(CSour);
  while not Eof(F) do
  begin
     if Prvni then
     begin
        Prvni := False;
     end
     else begin
             if Pozice + 4 + EH.Words shl 1 + SizeOf(Ehdr) >= FileSize(F)
                then break;
             Seek(F,Pozice + 4 + EH.Words shl 1);
          end;
     Pozice := FilePos(F);
     BlockRead(F,EH,SizeOf(Ehdr));

     Writeln('H: ',(EH.Header and mskType) div $100 );
     case  Typ of
       DGNFIL_HEADER_ELM:
       begin
          if not JeTCB then
          begin
             JeTCB := True;
             BlockRead(F,TCBB,SizeOf(TTCB));
             if Design3D in TCBB.fbfdcn then Je3D := True;
             Prep := SwapLong(TCBB.MastUnits);
          end;
       end;
       LINE_ELM:
       begin
          UpravObd;
          BlockRead(F,RLine,SizeOf(TLine_2D));
          Writeln(FT,' Linie:');
          Writeln(FT,'     O:');
          with Linie do
          begin
             Cislo         := CLin;
             Druh          := 1;
             Atributy      := [Netopologicka];
             Vybrana       := false;
             Barva         := 13;
             case RLine.Disp_Hdr.Symb and mskSymbStyle of
                0: Znacka := 0;
                1: Znacka := 1;
                2: Znacka := 2;
                3: Znacka := 3;
                4: Znacka := 24;
                5: Znacka := 23;
                6: Znacka := 26;
                7: Znacka := 25;
             else  Znacka := 9;
             end;
             PrvniSour     := CSour;
             PosledniSour  := CSour + 1;
             Delka         := 0;
             OpsanyObdelnik.PH.y := EH.XHigh;
             OpsanyObdelnik.PH.y := OpsanyObdelnik.PH.y / Prep;
             OpsanyObdelnik.PH.x := EH.YHigh;
             OpsanyObdelnik.PH.x := OpsanyObdelnik.PH.x / Prep;
             KontrolaObd;
               Str(OpsanyObdelnik.PH.y:10:3,S);
               Write(FT,S);
               Str(OpsanyObdelnik.PH.x:10:3,S);
               WriteLN(FT,S);
             OpsanyObdelnik.LD.y := EH.XLow;
             OpsanyObdelnik.LD.y := OpsanyObdelnik.LD.y / Prep;
             OpsanyObdelnik.LD.x := EH.YLow;
             OpsanyObdelnik.LD.x := OpsanyObdelnik.LD.x / Prep;
               Str(OpsanyObdelnik.LD.y:10:3,S);
               Write(FT,S);
               Str(OpsanyObdelnik.LD.x:10:3,S);
               WriteLN(FT,S);
          end;
          Write(FLin,Linie);
          Inc(CLin);
          Writeln(FT,'     S:');
          Writeln('*');
          Bod2dnaSour(RLine.StartP,Sour);
          Write(FSour,Sour);
          Str(Sour.y:10:3,S);
          Write(FT,S);
          Str(Sour.x:10:3,S);
          WriteLN(FT,S);
          Writeln('***');
          Inc(CSour);
          Bod2dnaSour(RLine.EndP,Sour);
          Write(FSour,Sour);
          Str(Sour.y:10:3,S);
          Write(FT,S);
          Str(Sour.x:10:3,S);
          WriteLN(FT,S);
          Inc(CSour);
       end;
       LINE_STRING_ELM,
       SHAPE_ELM:
       begin

          UpravObd;

          BlockRead(F,RLineString,SizeOf(Tline_string_2d));
          Writeln(FT,' Linie:');
          Writeln(FT,'     O:');
          with Linie do
          begin
             Cislo         := CLin;
             Druh          := 1;
             Atributy      := [Netopologicka];
             Vybrana       := false;
             if Typ = LINE_STRING_ELM Then Barva := 9
                                      else Barva := 12;
             Znacka        := 9;
             PrvniSour     := CSour;
             PosledniSour  := CSour + RLineString.NumVerts -1;
             Delka         := 0;
             OpsanyObdelnik.PH.y := EH.XHigh;
             OpsanyObdelnik.PH.y := OpsanyObdelnik.PH.y / Prep;
             OpsanyObdelnik.PH.x := EH.YHigh;
             OpsanyObdelnik.PH.x := OpsanyObdelnik.PH.x / Prep;
             KontrolaObd;
               Str(OpsanyObdelnik.PH.y:10:3,S);
               Write(FT,S);
               Str(OpsanyObdelnik.PH.x:10:3,S);
               WriteLN(FT,S);
             OpsanyObdelnik.LD.y := EH.XLow;
             OpsanyObdelnik.LD.y := OpsanyObdelnik.LD.y / Prep;
             OpsanyObdelnik.LD.x := EH.YLow;
             OpsanyObdelnik.LD.x := OpsanyObdelnik.LD.x / Prep;
               Str(OpsanyObdelnik.LD.y:10:3,S);
               Write(FT,S);
               Str(OpsanyObdelnik.LD.x:10:3,S);
               WriteLN(FT,S);
          end;
          Write(FLin,Linie);
          Inc(CLin);
          Writeln(FT,'     S:');
          Writeln('*');
          Bod2dnaSour(RLineString.Vertice,Sour);
          Write(FSour,Sour);
          Str(Sour.y:10:3,S);
          Write(FT,S);
          Str(Sour.x:10:3,S);
          WriteLN(FT,S);
          Writeln('********************************************');
          Inc(CSour);
          for i := 2 to RLineString.NumVerts do
          begin
             BlockRead(F,P2D,SizeOf(Point2D));
             Bod2dnaSour(P2D,Sour);
             Write(FSour,Sour);
             Str(Sour.y:10:3,S);
             Write(FT,S);
             Str(Sour.x:10:3,S);
             WriteLN(FT,S);
             Inc(CSour);
          end;
       end;
       TEXT_ELM:
       begin
          BlockRead(F,RText,SizeOf(Ttext_2d));
          S[1] := RText.Pis;
          BlockRead(F,S[2],RText.numchars - 1);
          S[0] := Chr(RText.numchars);
          Writeln(FT,'----------- Text : -------------');
          Writeln(FT,S);
       end;
     end;{case}
     Writeln('*****');
  end;
  Writeln(' Konec...');
  Close(F);
  Close(FLin);
  Close(FSour);
  Close(FT);
  Readln;
end.