unit F_protcl;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,
  Elements, StdCtrls;

type
  TF_protclForm = class(TForm)
    Memo: TMemo;
    btSave: TButton;
    SaveDialog: TSaveDialog;
    procedure btSaveClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FileName: string;
    procedure Add(const aMessage: string);
  end;



TProtocol = class(TElement)
private
  F_protclForm: TF_protclForm;

public
  constructor Create; override;
  destructor Destroy; override;
  procedure AddMessage(const aMessage: string);
  procedure ShowModal;
  procedure Name(const aName: string);
end;


implementation

{$R *.DFM}


procedure TF_protclForm.btSaveClick(Sender: TObject);
begin
  SaveDialog.FileName:= FileName;
  SaveDialog.Execute;
  if SaveDialog.FileName <> '' then
     Memo.Lines.SaveToFile(SaveDialog.FileName)
end;


procedure TF_protclForm.Add(const aMessage: string);
begin
  Memo.Lines.Add(aMessage)
end;


constructor TProtocol.Create;
begin
  inherited Create;
  F_ProtclForm:= TF_ProtclForm.Create(Application);
end;


destructor  TProtocol.Destroy;
begin
  F_ProtclForm.Free;
  inherited Destroy
end;

procedure TProtocol.AddMessage(const aMessage: string);
begin
  F_ProtclForm.Add(aMessage)
end;


procedure TProtocol.ShowModal;
var
  TheCursor: TCursor;
begin
  TheCursor:= Screen.Cursor;
  Screen.Cursor := crArrow;
  F_ProtclForm.Cursor:= crArrow;
  F_ProtclForm.ShowModal;
  Screen.Cursor := TheCursor;
end;

procedure TProtocol.Name(const aName: string);
begin
  F_ProtclForm.Caption:= 'PROTOKOL (' + aName + ')';
  F_ProtclForm.FileName:= copy(aName, 1, 8) + '.PCL'
end;


end.
