unit T_Explor;
{
[Unit_Description]
Description=Nstroj Explorer
Admin=Petr
TechTopic=Tools
Topic=Interface
Version=1.0
}

interface

uses
   WinTypes,
   Elements,
   f_Explor,
   Tools;

type

TExplorer = class(TTool)
private
   FForm: TExplorerForm;
   FCorb: TNameEntity;
   FModal: boolean;
   FMasterTool: TTool;
   FShowOwners: boolean;
   FDontShowList: boolean;

   function  GetForm: TExplorerForm;
   function  GetCorb: TNameEntity;
   procedure SetCorb(aValue: TNameEntity);
   function  GetMTool: TTool;
   procedure SetMTool(aValue: TTool);

   function    GetLeft: longInt; virtual;
   function    GetTop: longInt; virtual;
   function    GetWidth: longInt; virtual;
   function    GetHeight: longInt; virtual;
   procedure   SetLeft(aValue: longInt); virtual;
   procedure   SetTop(aValue: longInt); virtual;
   procedure   SetWidth(aValue: longInt); virtual;
   procedure   SetHeight(aValue: longInt); virtual;

   function    GetCaption: string; virtual;
   procedure   SetCaption(const aValue: string); virtual;
public
   procedure   DoIt; override;
   property    Corb: TNameEntity read GetCorb write SetCorb;
   property    MasterTool: TTool read GetMTool write SetMTool;
published
   property Form: TExplorerForm read GetForm;
   property Modal: boolean read FModal write FModal;
   property Left: longInt   read GetLeft   write SetLeft;
   property Top: longInt    read GetTop    write SetTop;
   property Width: longInt  read GetWidth  write SetWidth;
   property Height: longInt read GetHeight write SetHeight;
   property Caption: string read GetCaption write SetCaption;
   property ShowOwners: boolean read FShowOwners write FShowOwners;
   property DontShowList: boolean read FDontShowList write FDontShowList;
end;


implementation

uses
   Forms,
   e_Class,
   M_Orbis;



function  TExplorer.GetForm: TExplorerForm;
begin
  if FForm = nil then
  begin
    FForm:= TExplorerForm.Create(Application);
    FForm.Tool := Self;
  end;
  result:= FForm
end;


function  TExplorer.GetCorb: TNameEntity;
begin
    if not assigned(FCorb) then
    begin
       FCorb := TNameEntity.Create;
       FCorb.Name := 'Kbl na odpadky';
       AddElement(FCorb);
    end;
    result := FCorb;
end;


procedure TExplorer.SetCorb(aValue: TNameEntity);
begin
   if assigned(FCorb) then
   begin
      FreeElement(FCorb);
      FCorb := nil;
   end;
   FCorb := aValue;
end;

function  TExplorer.GetMTool: TTool;
begin
   result := FMasterTool;
end;

procedure TExplorer.SetMTool(aValue: TTool);
begin
   FMasterTool := aValue;
end;



procedure   TExplorer.DoIt;
begin
  if not (Input is TElement) then exit;
  Form.ShowOwners:= ShowOwners;
  Form.DontShowList:= DontShowList;
  Form.Model := Input;
  if Modal then
     Form.ShowModal
  else
     Form.Show
end;



function    TExplorer.GetLeft: longInt;
begin
   result := Form.Left;
end;

function    TExplorer.GetTop: longInt;
begin
   result := Form.Top;
end;

function    TExplorer.GetWidth: longInt;
begin
   result := Form.Width;
end;

function    TExplorer.GetHeight: longInt;
begin
   result := Form.Height;
end;

procedure   TExplorer.SetLeft(aValue: longInt);
begin
   Form.Left := aValue;
end;

procedure   TExplorer.SetTop(aValue: longInt);
begin
   Form.Top := aValue;
end;

procedure   TExplorer.SetWidth(aValue: longInt);
begin
   Form.Width := aValue;
end;

procedure   TExplorer.SetHeight(aValue: longInt);
begin
   Form.Height := aValue;
end;

function    TExplorer.GetCaption: string;
begin
   result := Form.Caption;
end;

procedure   TExplorer.SetCaption(const aValue: string);
begin
   Form.Caption := aValue;
end;





BEGIN
   RegisterOrbisClass(TExplorer);
END.
