unit T_AreMak;


interface

uses
// KERNEL
   Elements,
   t_Sort,//@@@
   Tools,
// SPACE
    e_QTree,
    E_QTLin,
    e_GeometryElement;
  //e_Space;

{
const
  MojePlocha: TPolyLineAreaElement = nil;
}

type

TClearLines = class(TTool)
private
   FFixedLines: TEntity;
    FSnapDistance: double;
    FSelfTest: boolean;
    FOnlyEnds: boolean;
   procedure SetFixedLines(const Value: TEntity);
    procedure SetSnapDistance(const Value: double);
    procedure SetSelfTest(const Value: boolean);
    procedure SetOnlyEnds(const Value: boolean);
//vstup - linern entita obsahujc linie
//vstup - sprvn rozdlen a napojen linie
//FixedLines - liniov objekty u spojen, ke kterm se vstup pipoj
public
    constructor Create; override;
    procedure DoIt; override;
published
    property SnapDistance: double read FSnapDistance write SetSnapDistance;
    property SelfTest: boolean read FSelfTest write SetSelfTest;
    property FixedLines: TEntity read FFixedLines write SetFixedLines;
    property OnlyEnds: boolean read FOnlyEnds write SetOnlyEnds;
end;



TAreasFromClearLines = class(TTool)
private
   FQTree: TSpaceLineBegEndCell;
   procedure SetQTree(const Value: TSpaceLineBegEndCell);
//vstup - sprvn rozdlen a napojen linie
//vstup - seznam ploch
public
   procedure DoIt; override;
   property QTree: TSpaceLineBegEndCell read FQTree write SetQTree;
end;

TSortAreasByAbsWholeArea = class(TSortElementsByFloat)
public
   function CompareElements(E1,E2: TElement): integer; override;
end;

TSubAreasLinear = class(TTool)
public
   procedure DoIt; override;
end;

TCreateAreasFromLinesTool =  class(TSeqTechnology)
public
   constructor Create; override;
end;


implementation

uses
  //SysUtils,
  //!!!Test
  Worlds,
  //!!!Test
  Dialogs,
  Forms,
// KERNEL
  e_Class,
// GLIB
  G_Elems,
// SPACE
  e_Geometry,
// SPACETOOL
//t_GeometryChecks,
  T_Topol,
  T_ToTool,
  T_LinJoi,
  T_Applac,
// TOPOL
  T_SAMake
// EDITOR
  //T_ClearAreas
  ;




{TClearLines}


constructor TClearLines.Create;
begin
   SelfTest := true;
   inherited;
end;

procedure TClearLines.DoIt;
var
  QTTL: TQTreeTopLin;
  PomLine: TRectEntity;
  HL1: THledacLinii;
  HL2: THledacLinii;
  JL: TJoinLines;
  S: string;
  FixLin: TRectEntity;
begin
  S := 'Extrakce Geom. lini';
  if not (input is TRectEntity) then
     Exit;

  //PomLine:= TRectEntity(Input);
  PomLine:= TRectEntity.Create;
  FixLin := nil;

try
  if (FixedLines <> nil) and not(FixedLines.NoElements) then
  begin
     FixLin := TRectEntity.Create;
     HL1:= THledacLinii.Create;
     HL1.Name := S+' FIX';
     HL1.Input:= FixedLines;
     HL1.Output:= FixLin;
     HL1.DoIt;

     HL1.Free;
  end;
  HL1:= THledacLinii.Create;
  HL1.Name := S;
  HL1.Input:= Input;
  HL1.Output:= PomLine;
  HL1.DoIt;

  HL1.Free;
except
  ShowMessage('Chyba pi hledn lini');
  exit;
end;


try
  JL:= TJoinLines.Create;
  JL.Input:= PomLine;
  JL.FixedLines := FixLin;
  //JL.SnapDistance:= 0.00;
  //!!!!Test
  SnapDistance := SnapDistance; //Odstrann 0 hodnoty
  JL.SnapDistance:= SnapDistance;
  //!!!!Test
  JL.CompareOnlyDifferentSource:= false;
  JL.SelfTest:= SelfTest;
  JL.OnlyEnds := OnlyEnds;
  //!!!!!!Test
  //JL.UseProtocol:= true;
  //JL.ProtocoledLine:= 62;
  //JL.Protocol:= 'E:\protocol.txt';

  //!!!!!!Test
{ !!!!!!!!!!!
  JL.Protocol:= 'k:\orbis32\XXX.TXT';
  JL.UseProtocol:= true;
  JL.ProtocoledLine:= -1;
}
  JL.DoIt;
  QTTL:= TQtreeTopLin(JL.Output);

  PomLine.Free;
  FixLin.Free;
except
  ShowMessage('Chyba pi spojovn lini');
  exit;
end;
  {
  PomLine:= TRectEntity.Create;

  HL2:= THledacLinii.Create;
  HL2.Name := S + ' z QTree';
  HL2.Input:= JL.Output;
  HL2.Output:= PomLine;
  HL2.DoIt;
  HL2.Free;
  }
  QTTL.Free;
  JL.Free;

//  TEntity(Input).AddElement(PomLine);
  {
  TEntity(Input).FreeAll;
  TEntity(Input).AddAllFrom:= PomLine;
  PomLine.Free;
  }
  Output:= Input;
end;

procedure TClearLines.SetFixedLines(const Value: TEntity);
begin
   FFixedLines := Value;
end;

procedure TClearLines.SetOnlyEnds(const Value: boolean);
begin
  FOnlyEnds := Value;
end;

procedure TClearLines.SetSelfTest(const Value: boolean);
begin
  FSelfTest := Value;
end;

procedure TClearLines.SetSnapDistance(const Value: double);
begin
  if Value <= 0 then
     FSnapDistance := 0.01
  else
     FSnapDistance := Value;
end;

{TAreasFromClearLines}

procedure TAreasFromClearLines.DoIt;
var
  Tool: TProchazecLiniiGauge;
  DoNodes: TPutNodesIntoQTree;
//  TvorPlochy: TCreateAreasForQTree;
  NodeCon: TNodesConector;
  RusTrc: TRemoveSingleLinesInQTree;
  RusLin: TDeleteDirectRelationsToLinesInQTree;


  TvorPlo: TCreateAreasForQTree;
  SubArM: TSubAreaMakerInQTree;
  SubA: TSubAreasLinear;
  QTreePloch: TRectEntityQTree;
  Plochy: TAreaString;

  Hledac: THledacPloch;
  APP: TMultiAreaPointPlacer;
//  aCL: TClearNoValidLines;
  S: string;
  //CistiPlo: TClearAreas;
begin
  if not (Input is TRectEntity) then
     Exit;
// Vytvoen ploch ze sprvn rozdlench a napojench lini
//  aCL := TClearNoValidLines.Create;
//  aCL.Input := Input;
//  aCL.WithoutPrompt := true;
//  aCL.DoIt;
//  aCL.Free;

  if TEntity(Input).Count > 100 then
     StartProgress('Tvorba ploch',0,7);
  S := 'Natn lini do QTREE';
  ProgressText := S;
  Tool:= TReadLinesIntoQTree.Create;
  Tool.Input:= Input;
  Tool.Name:= S;
  Tool.DoIt;
  Progress := 1;
  QTree:= TSpaceLineBegEndCell(Tool.Output);
  Tool.Free;

  S := 'Vytven uzl v QTREE';
  ProgressText := S;
  DoNodes:= TPutNodesIntoQTree.Create;
  DoNodes.Name:= S;
  DoNodes.Input:= QTree;
  DoNodes.DoIt;
  DoNodes.Free;
  Progress := 2;

  S := 'Zapojovn uzl v QTree';
  ProgressText := S;
  NodeCon:= TNodesConector.Create;
  NodeCon.Name:= S;
  NodeCon.Input:= QTree;
  NodeCon.DeletePseudoNodes:= false; //ReadIniBoolean('EXPORT', 'RusitPseudouzly', false);
  NodeCon.JoinDifferentLines:= false; //ReadIniBoolean('EXPORT', 'RusitPseudouzlyIProRuzneDruhy', true);
  NodeCon.MaxCoordsCount:= 200; //ReadIniInteger('EXPORT', 'MaxPocetSouradnic', 100);
  NodeCon.DoIt;
  NodeCon.Free;
  Progress := 3;

  // !!!Test nodes
  //World.ObjectModel.NextElement := QTree;
  //exit;
  // !!!Test end;

  RusTrc:= TRemoveSingleLinesInQTree.Create;
  RusTrc.Input:= QTree;
  RusTrc.DoIt;
  RusTrc.Free;

  S := 'Ruen QTree vazeb na linie';
  ProgressText := S;
  RusLin:= TDeleteDirectRelationsToLinesInQTree.Create;
  RusLin.Name:= S;
  RusLin.Input:= QTree;
  RusLin.DoIt;
  RusLin.Free;
  Progress := 4;

  S := 'Tvorba ploch v QTree';
  ProgressText := S;
  TvorPlo:= TCreateAreasForQTree.Create;
  TvorPlo.Input:= QTree;
  TvorPlo.Name:= S;
  TvorPlo.DoIt;
  QTreePloch:= TRectEntityQTree(TvorPlo.Output);
  TvorPlo.Free;
  Progress := 5;
  (*
  CistiPlo:= TClearAreas.Create;
  CistiPlo.Input:= QTreePloch;
  // !!!Test
  //World.ObjectModel.NextElement := QTreePloch;
  //exit;
  // !!!Test end;
  CistiPlo.DontRemoveConectionAreaArea:= False;
  CistiPlo.DoIt;
  CistiPlo.Free;
   *)
  // !!!Test
  //World.ObjectModel.NextElement := QTreePloch;
  //exit;
  // !!!Test end;

  S := 'Tvorba Enklv v QTree';
  ProgressText := S;
  { @@@ppk
  SubArM:= TSubAreaMakerInQTree.Create;
  SubArM.Input:= QTreePloch;
  SubArM.DoIt;
  SubArM.Free;

  Plochy:= TAreaString.Create;
  Hledac:= THledacPloch.Create;
  Hledac.input:= QTreePloch;
  Hledac.Output:= Plochy;
  Hledac.DoIt;
  }

  Suba := TSubAreasLinear.Create;
  Suba.Input := QTreePloch;
  Suba.DoIt;
  Plochy := TAreaString(Suba.Output);
  Suba.Free;
  Progress := 6;

  S := 'Tvorba popisovch bod ploch';
  ProgressText := S;
  APP:= TMultiAreaPointPlacer.Create;
  APP.Input:= Plochy;
  APP.DoIt;
  //ShowMessage('MP: '+IntToStr(APP.ProcessAreaCount)+' P: '+IntToStr(Plochy.Count));
  APP.Free;
//  TEntity(Input).AddElement(Plochy);
  Output:= Plochy;
  Progress := 7;

  S := 'OK.';
  ProgressText := S;
  {@@@ppk
  Hledac.Free;
  }
  //Tool.Free;
  QTreePloch.Free;
  //QTree.Free .. je vloeno jako element a pro ppadn dal pouit
end;

procedure TAreasFromClearLines.SetQTree(const Value: TSpaceLineBegEndCell);
begin
    ExchangeFieldElement(TElement(FQTree),Value);
end;


{ TCreateAreasFromLinesTool }

constructor TCreateAreasFromLinesTool.Create;
begin
   inherited;
   AddTool(TClearLines.Create);
   AddTool(TAreasFromClearLines.Create);
end;



{ TSortAreasByAbsWholeArea }

function TSortAreasByAbsWholeArea.CompareElements(E1, E2: TElement): integer;
var
   Ex1,Ex2: Double;
begin
   Ex1 := Abs(TAreaElement(E1).FixedArea);
   Ex2 := Abs(TAreaElement(E2).FixedArea);
   result := -1;
   if Ex1 > Ex2 then
      result := 1
   else
   if Ex1 = Ex2 then
      result := 0;
end;


{ TSubAreasLinear }

procedure TSubAreasLinear.DoIt;
var
   Plochy: TAreaString;
   Hledac: THledacPloch;
   QTreePloch: TRectEntityQTree;
   Sort: TSortAreasByAbsWholeArea;
   i, ii: integer;
   E: TElement;
   aHole, anArea, OverArea: TAreaElement;
   aHole_A, anArea_A, OverArea_A: double;
begin
   // Tvorba Linearniho seznamu
   QTreePloch := TRectEntityQTree(Input);
   Plochy:= TAreaString.Create;
   Output := Plochy;
   Hledac:= THledacPloch.Create;
   Hledac.input:= QTreePloch;
   Hledac.Output:= Plochy;
   Hledac.IncludeHoles := true;
   Hledac.DoIt;
   Hledac.Free;
   if Plochy.Count > 100 then
   begin
      StartProgress('Holes',0,Plochy.Count);
   end;
   ProgressText := 'Whole areas';
   Application.ProcessMessages;
   for i := 0 to Plochy.LastIndex do
   begin
       if (i mod 10) = 0 then
       begin
          Progress := i;
          Application.ProcessMessages;
       end;
      aHole := TAreaElement(Plochy.Elements[i]);
      //aHole.FixedArea := Abs(aHole.WholeArea);  nastaveno pri vytvoreni plochy
      aHole.IsDone := false;
   end;
   ProgressText := 'Sort';
   Application.ProcessMessages;
   // Trideni ploch
   Sort := TSortAreasByAbsWholeArea.Create;
   Sort.Input := Plochy;
   Sort.DoIt;
   Sort.Free;
   ProgressText := 'Process holes';
   for i := 0 to Plochy.LastIndex do
   begin
       if (i mod 10) = 0 then
       begin
          Progress := i;
          Application.ProcessMessages;
       end;
       aHole := TAreaElement(Plochy.Elements[i]);
       if aHole.IsDone then Continue;
       if not aHole.IsHole then Continue;
       aHole.IsDone := true;
       for ii := i + 1 to Plochy.LastIndex do
       begin
          anArea := TAreaElement(Plochy.Elements[ii]);
          if anArea.IsHole then continue;
          if not anArea.RegionIsInside(aHole.MinX, aHole.MinY, aHole.MaxX, aHole.MaxY) then continue;
          if not aHole.IsIsolatedFrom(anArea) then continue;
          if not anArea.XYIsInside(aHole.Xi[0], aHole.Yi[0]) then continue;
          anArea.AddHole(aHole);
          break;
       end;
   end;
   ProgressText := 'Remove holes';
   for i := Plochy.LastIndex downto 0 do
   begin
      aHole := TAreaElement(Plochy.Elements[i]);
      aHole.FixedArea := 0; // nulovani ulozene plochy
      if aHole.IsHole then Plochy.RemoveElement(aHole);
   end;
end;


INITIALIZATION
  RegisterOrbisClass(TCreateAreasFromLinesTool);
  RegisterOrbisClass(TClearLines);
  RegisterOrbisClass(TAreasFromClearLines);
END.
