unit U_file;

interface
uses
  Classes;


type


  TDirSurfer = class
  { Vytvo se TStringListElement soubor
  }
  private
    BasicDir: string;
    FMask: string;
    Attr: word;
    procedure FindInDir(aDir: string);
    procedure AddPathsFromSubDir(aDir: string);
  public
    Paths: TStringList;
    function  OKFilter(aPath: string): boolean; virtual;
    procedure AddToList(List: TStringList; aPath: string); virtual;
    procedure AddDirToPaths(List: TStringList); virtual;
    constructor Create(const aBasicDir, aMask: string; aAttr: word);
  end;


function GetFilesInSubDirs(BasicDir, aMask: string; Attr: word): TStringList;

function GetFilesInDir(BasicDir, aMask: string; Attr: word): TStringList;

procedure UseNotePadFor(FileName: string);

function SizeOfFile(FileName: string): longInt;

function DeleteDirectory(aDir: string): boolean;


implementation
uses
  SysUtils,WinProcs, WInTypes, FileCtrl, Dialogs,
  {!T_Main,}
  u_xestring,
  U_String;



constructor TDirSurfer.Create(const aBasicDir, aMask: string; aAttr: word);
begin
  inherited Create;
  BasicDir:= expandFileName(aBasicDir);
  FMask:= aMask;
  Attr:= aAttr;
  FindInDir(BasicDir);
end;


function  TDirSurfer.OKFilter(aPath: string): boolean;
begin
  result:= true;
end;



procedure TDirSurfer.AddToList(List: TStringList; aPath: string);
begin
  if not OKFilter(aPath) then exit;
  List.Add(aPath)
end;


procedure TDirSurfer.AddDirToPaths(List: TStringList);
begin
  List.Sort;

  if Paths = nil then
  begin
    Paths:= TStringList.Create;
  end;

  Paths.AddStrings(List)
end;



procedure TDirSurfer.AddPathsFromSubDir(aDir: string);
var
  SearchRec: TSearchRec;
  List: TStringList;
begin
  List:= TStringList.Create;

  { cyklus hledn soubor v danm adresi }
  if findFirst(aDir + FMask, Attr, SearchRec) = 0 then
  repeat
    if (SearchRec.Name <> '.') and (SearchRec.Name <> '..')
       and
       (
         ((SearchRec.Attr and Attr) <> 0)
          or
         (SearchRec.Attr = 0)
        ) then
    AddToList(List, aDir + SearchRec.Name)
  until SysUtils.findNext(SearchRec) <> 0;
  SysUtils.findClose(SearchRec);

  AddDirToPaths(List);
  List.Free;
end;



procedure TDirSurfer.FindInDir(aDir: string);
var
  SearchDir: TSearchRec;
begin
  aDir:= AddBackSlash(aDir);

  AddPathsFromSubDir(aDir);

  { cyklus prohledvn podadres }
  if findFirst(aDir + '*.*', faDirectory, SearchDir) = 0 then
  repeat
    if (SearchDir.Name <> '.') and (SearchDir.Name <> '..') and
       ((faDirectory and SearchDir.Attr) <> 0) then
       FindInDir(aDir + SearchDir.Name)
  until SysUtils.findNext(SearchDir) <> 0;
  SysUtils.findClose(SearchDir);
end;




function GetFilesInSubDirs(BasicDir, aMask: string; Attr: word): TStringList;
var
  DSurf: TDirSurfer;
begin
  DSurf:= TDirSurfer.Create(BasicDir, aMask, Attr);
  result:= DSurf.Paths;
  DSurf.Free
end;



function GetFilesInDir(BasicDir, aMask: string; Attr: word): TStringList;
var
  StringList: TStringList;
  SearchRec: TSearchRec;


  procedure AddToList(aName: string);
  begin
    if StringList = nil then
       StringList:= TStringList.Create;
    StringList.Add(aName)
  end;

begin
  StringList:= nil;
  if findFirst(BasicDir + aMask, Attr, SearchRec) = 0 then
  repeat
    if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') and
       ((SearchRec.Attr and Attr) <> 0) then
    AddToList(BasicDir + SearchRec.Name)
  until SysUtils.findNext(SearchRec) <> 0;

  SysUtils.findClose(SearchRec);

  result:= StringList;
end;



procedure UseNotePadFor(FileName: string);
var
  S: _xstring;
  PomStr: array[0..250] of _xchar;
begin
  S:= 'NOTEPAD ' + FileName;
  StrPCopy(PomStr, S);

  WinExec(PomStr, SW_SHOW)
end;


{ Pklad pouit

procedure CreateMapSheetL;
var
  List: TStringList;
begin
  List:= GetFilesInSubDirs('h:\', '*.BLK', faDirectory);

  if List <> nil then
  begin
    List.SaveToFile('H:\bloky.txt');
    List.Free
  end;
end;

}


function SizeOfFile(FileName: string): longInt;
var
  f: file of Byte;
  aRes: integer;
begin
  result:= 0;
  AssignFile(f, FileName);
  fileMode:= 0;
  {$I-}  Reset(f); {$I+}
  aRes:= ioResult;
  if aRes <> 0 then exit;
  result := FileSize(f);
  CloseFile(f);
end;




function DeleteDirectory(aDir: string): boolean;
var
  S: TSearchRec;
  CChyby: integer;
begin
  result:= false;

{ Nejdrive se pokusi smazat vsechny soubory }
  if aDir[length(aDir)] = '\' then SetLength(aDir,Length(aDir) - 1);

  if not DirectoryExists(aDir) then
  begin
    result:= true;
    exit;
  end;

  if findFirst(aDir + '\*.*', faAnyFile-faDirectory, S) = 0 then
  repeat
    if not sysutils.DeleteFile(aDir + '\' + S.Name) then
    begin
      ShowMessage('Pi ruen adrese nelze smazat soubor ' + #13 + #10 +
                   aDir + '\' + S.Name);
      sysutils.findClose(S);
      exit
    end;
  until  (findNext(S) <> 0);
  sysutils.findClose(S);

{ Nyni se pokusi smazat adresar }
  {$I-} RmDir(aDir); {$I+}

  CChyby:= IOResult;


  if CChyby <> 0 then
  begin
    ShowMessage('Adres ' + aDir + 'nelze zruit !');
    exit
  end;

  result:= true
end;






end.
