unit e_SysReg;
{
[Unit_Description]
Description=Systmov registr
Admin=Petr
TechTopic=Elements
Topic=System
Version=1.0
}

interface
uses
   e_InhMdl,
   e_Type,
   Elements;

type

TRegisterPropertyModel = class(TOwnerEntity)
private
   FAlias: string;
   FImageIndex: integer;
   FEditor: string;
published
   property Alias: string read FAlias write FAlias;
   property ImageIndex: integer read FImageIndex write FImageIndex;
   property Editor: string read FEditor write FEditor;
end;

TRegisterClassModel = class(TInheritanceModel)
private
   FAlias: string;
   FImageIndex: integer;
   FImageSelectedIndex: integer;
   FEditor: string;
   FInterpret: string;
   FSubClass: string;
   FPropertyModels: TOwnerEntity;
   FShell: TOwnerEntity;
   function GetPropertyModels: TOwnerEntity;
   function GetShell: TOwnerEntity;
published
   property Alias: string read FAlias write FAlias;
   property ImageIndex: integer read FImageIndex write FImageIndex;
   property ImageSelectedIndex: integer read FImageSelectedIndex write FImageSelectedIndex;
   property Editor: string read FEditor write FEditor;
   property Interpret: string read FInterpret write FInterpret;
   property SubClass: string read FSubClass write FSubClass;
   property PropertyModels: TOwnerEntity read GetPropertyModels stored false;
   property Shell: TOwnerEntity read GetShell stored false;
end;

TRegisterClassModels = class(TInheritanceModelEntity)
private
   function  GetActualClassModel: TRegisterClassModel;
public
   function  GetItemClass: TInheritanceModelClass; override;
published
   property ActualClassModel: TRegisterClassModel read GetActualClassModel stored false;
end;

TSystemRegister = class(TOwnerEntity)
private
   FImages: TStringListElement;
   FCursors: TStringListElement;
   FClassModels: TRegisterClassModels;
   function GetImages: TStringListElement;
   Function GetClassModels: TRegisterClassModels;
    function GetCursors: TStringListElement;
published
   property Images: TStringListElement read GetImages stored false;
   property Cursors: TStringListElement read GetCursors stored false;
   property ClassModels: TRegisterClassModels read GetClassModels stored false;
end;

implementation

uses
   e_Class;

{ TRegisterClassModels }

function  TRegisterClassModels.GetActualClassModel: TRegisterClassModel;
begin
   result := TRegisterClassModel(ActualItem);
end;

function  TRegisterClassModels.GetItemClass: TInheritanceModelClass;
begin
   result := TRegisterClassModel;
end;


{ TRegisterClassModel }

function TRegisterClassModel.GetPropertyModels: TOwnerEntity;
begin
   if FPropertyModels = nil then
   begin
      FPropertyModels := TOwnerEntity.Create;
      FPropertyModels.Name := 'PROPERTY MODELS';
      AddElement(FPropertyModels);
   end;
   result := FPropertyModels;
end;

function TRegisterClassModel.GetShell: TOwnerEntity;
begin
   if FShell = nil then
   begin
      FShell := TOwnerEntity.Create;
      FShell.Name := 'SHELL';
      AddElement(FShell);
   end;
   result := FShell;
end;


{ TSystemRegister }

function TSystemRegister.GetImages: TStringListElement;
begin
   if FImages = nil then
      FImages := TStringListElement(FindOrCreateElementName(TStringListElement,'IMAGES'));
   result := FImages;
end;

Function TSystemRegister.GetClassModels: TRegisterClassModels;
begin
   if FClassModels = nil then
      FClassModels := TRegisterClassModels(FindOrCreateElementName(TRegisterClassModels,'CLASS MODELS'));
   result := FClassModels;
end;

function TSystemRegister.GetCursors: TStringListElement;
begin
   if FCursors = nil then
      FCursors := TStringListElement(FindOrCreateElementName(TStringListElement,'CURSORS'));
   result := FCursors;
end;

INITIALIZATION
   RegisterOrbisClass(TSystemRegister);
   RegisterOrbisClass(TRegisterClassModel);
   RegisterOrbisClass(TRegisterClassModels);
   RegisterOrbisClass(TRegisterPropertyModel);
END.

