unit e_LHCElements;

interface
uses
   e_TopoLElements,
   e_LHCModel;

type

Tgis_UserAreaElement = class(Tgis_PorostniSkupina)
private
    FDruh: integer;
    FUserID: integer;
protected
   function GetGroup: integer; override;
   procedure SetGroup(const Value: integer); override;

   function Get_Skupina: Tgis_PorostniSkupina; virtual;
   procedure Set_Skupina(const Value: Tgis_PorostniSkupina); virtual;
   procedure SetUserID(const Value: integer); virtual;
   function  GetName: string; override;
   function  Get_Porost: Tgis_Porost; override;
   function  GetSkupina: string; override;
   function  GetMultiElement: boolean; override;
   procedure SetSkupina(const Value: string); override;
published
   property _Skupina: Tgis_PorostniSkupina read Get_Skupina write Set_Skupina stored false;
   property Druh: integer read FDruh write FDruh;
   property UserID: integer read FUserID write SetUserID;
end;

TTEZPlocha = class(Tgis_UserAreaElement) // predelat na potomka userArea
private
   FNalehavost: integer;
   FZpusob: integer;
   procedure SetNalehavost(const Value: integer);
   procedure SetZpusob(const Value: integer);
protected
   function GetGroup: integer; override;
   function Get_Skupina: Tgis_PorostniSkupina; override;
   procedure Set_Skupina(const Value: Tgis_PorostniSkupina); override;
   function  GetName: string; override;
published
   property Zpusob: integer read FZpusob write SetZpusob;
   property Nalehavost: integer read FNalehavost write SetNalehavost;
end;

TTEZBod = class(TTopolPointElement)
private
   FNalehavost: integer;
   procedure SetNalehavost(const Value: integer);
published
   property Nalehavost: integer read FNalehavost write SetNalehavost;
end;


TSRFPlocha = class(Tgis_ForestUnit)
protected
   function GetGroup: integer; override;
end;

TSRFBod = class(TTopolPointElement)
private
    FVEK_ST: integer;
    procedure SetVEK_ST(const Value: integer);
published
   property VEK_ST: integer read FVEK_ST write SetVEK_ST;
end;

Tgis_LT = class(Tgis_ForestUnit)
private
   FVymera: double;
   FPlocha: double;
    FLES_OBL: integer;
    FSLT: string;
    FLT: string;
    FLO_CAST: string;
    FUdrzba: integer;
    FZmena: string;
    FTVL: string;
    FPLT: string;
    FPLT_Nazev: string;
    FCHS: integer;
    FPCHS: string;
    procedure SetLES_OBL(const Value: integer);
    procedure SetLO_CAST(const Value: string);
    procedure SetLT(const Value: string);
    procedure SetSLT(const Value: string);
    procedure SetUdrzba(const Value: integer);
    procedure SetZmena(const Value: string);
    procedure SetTVL(const Value: string);
    procedure SetPLT(const Value: string);
    procedure SetPLT_Nazev(const Value: string);
    function getPLT_: string;
    procedure SetCHS(const Value: integer);
    procedure SetPCHS(const Value: string);
protected
   function GetPlocha: double; override;
   function GetVymera: double; override;
   procedure SetVymera(const Value: double); override;
published
   property Plocha;
   property Vymera;
   property LT: string read FLT write SetLT;
   property SLT: string read FSLT write SetSLT;
   property LES_OBL: integer read FLES_OBL write SetLES_OBL;
   property LO_CAST: string read FLO_CAST write SetLO_CAST;
   property Udrzba: integer read FUdrzba write SetUdrzba;
   property Zmena: string read FZmena write SetZmena;
   property TVL: string read FTVL write SetTVL;
   property PLT: string read FPLT write SetPLT;
   property PLT_: string read getPLT_ stored false;
   property PLT_Nazev: string read FPLT_Nazev write SetPLT_Nazev;
   property CHS: integer read FCHS write SetCHS;
   property PCHS: string read FPCHS write SetPCHS;
end;


implementation
uses
   SysUtils,
   StrUtils,
   e_Class,
   e_Geometry;
   //e_Space;

{ TTEZPlocha }





function TTEZPlocha.GetGroup: integer;
begin
   result := 135;
end;

function TTEZPlocha.GetName: string;
begin
   result := 'TEZ '+IntToStr(Zpusob)+':'+IntToStr(Nalehavost);
end;

function TTEZPlocha.Get_Skupina: Tgis_PorostniSkupina;
var
   c: Tgis_TezbaCollection;
begin
   result := nil;
   c := Tgis_TezbaCollection(FindOwnerClass(Tgis_TezbaCollection));
   if c = nil then exit;
   result := Tgis_PorostniSkupina(c.FindOwnerClass(Tgis_PorostniSkupina));
end;

procedure TTEZPlocha.SetNalehavost(const Value: integer);
begin
   FNalehavost := Value;
end;




procedure TTEZPlocha.SetZpusob(const Value: integer);
begin
   FZpusob := Value;
end;



procedure TTEZPlocha.Set_Skupina(const Value: Tgis_PorostniSkupina);
var
   c: Tgis_TezbaCollection;
   Sk: Tgis_PorostniSkupina;
begin
   c := Tgis_TezbaCollection(FindOwnerClass(Tgis_TezbaCollection));
   if c <> nil then
   begin
      Sk := Tgis_PorostniSkupina(c.FindOwnerClass(Tgis_PorostniSkupina));
      if Sk = Value then exit;
      c.RemoveElement(Self);
   end;
   if Value = nil then exit;
   c := Tgis_TezbaCollection(Value.FindElementClass(Tgis_TezbaCollection));
   if c = nil then
   begin
      c := Tgis_TezbaCollection.Create;
      Value.AddElement(c);
   end;
   c.AddElement(Self);
end;

{ TTezBod }

procedure TTEZBod.SetNalehavost(const Value: integer);
begin
   FNalehavost := Value;
end;



{ TSRFBod }

procedure TSRFBod.SetVEK_ST(const Value: integer);
begin
  FVEK_ST := Value;
end;

{ Tgis_UserAreaElement }

function Tgis_UserAreaElement.Get_Porost: Tgis_Porost;
var
   Sk: Tgis_PorostniSkupina;
begin
   result := nil;
   Sk := _Skupina;
   if Sk = nil then exit;
   result := Sk._Porost;
end;

function Tgis_UserAreaElement.Get_Skupina: Tgis_PorostniSkupina;
var
   c: Tgis_UserCollection;
begin
   result := nil;
   c := Tgis_UserCollection(FindOwnerClass(Tgis_UserCollection));
   if c = nil then exit;
   result := Tgis_PorostniSkupina(c.FindOwnerClass(Tgis_PorostniSkupina));
end;

function Tgis_UserAreaElement.GetGroup: integer;
begin
   result := FDruh;
end;

function Tgis_UserAreaElement.GetMultiElement: boolean;
begin
   result := false;
end;

function Tgis_UserAreaElement.GetSkupina: string;
var
   PS: Tgis_PorostniSkupina;
begin
   result := '';
   PS := _Skupina;
   if PS = nil then exit;
   result := PS.Skupina;
end;

procedure Tgis_UserAreaElement.Set_Skupina(const Value: Tgis_PorostniSkupina);
var
   c: Tgis_UserCollection;
   Sk: Tgis_PorostniSkupina;
begin
   c := Tgis_UserCollection(FindOwnerClass(Tgis_UserCollection));
   if c <> nil then
   begin
      Sk := Tgis_PorostniSkupina(c.FindOwnerClass(Tgis_PorostniSkupina));
      if Sk = Value then exit;
      c.RemoveElement(Self);
   end;
   if Value = nil then exit;
   c := Tgis_UserCollection(Value.FindElementClass(Tgis_UserCollection));
   if c = nil then
   begin
      c := Tgis_UserCollection.Create;
      Value.AddElement(c);
   end;
   c.AddElement(Self);
end;

procedure Tgis_UserAreaElement.SetGroup(const Value: integer);
begin
   FDruh := Value;
end;

procedure Tgis_UserAreaElement.SetSkupina(const Value: string);
begin

end;

procedure Tgis_UserAreaElement.SetUserID(const Value: integer);
begin
  FUserID := Value;
end;

function Tgis_UserAreaElement.GetName: string;
begin
   result := IntToStr(UserID);
end;

{ Tgis_LT }

function Tgis_LT.GetPlocha: double;
begin
   result := 0;
   if NoGeometry then exit;
   result := TAreaElement(Geometry).Area;
end;

function Tgis_LT.getPLT_: string;
var
   i: integer;
begin
   result := PLT;
   i := pos('-',result);
   if i > 0 then
      result := Copy(result,1,i - 1);
end;

function Tgis_LT.GetVymera: double;
begin
   result := FVymera;
end;


procedure Tgis_LT.SetCHS(const Value: integer);
begin
  FCHS := Value;
end;

procedure Tgis_LT.SetLES_OBL(const Value: integer);
begin
  FLES_OBL := Value;
end;

procedure Tgis_LT.SetLO_CAST(const Value: string);
begin
  FLO_CAST := Value;
end;

procedure Tgis_LT.SetLT(const Value: string);
begin
  FLT := Value;
end;

procedure Tgis_LT.SetPCHS(const Value: string);
begin
  FPCHS := Value;
end;

procedure Tgis_LT.SetPLT(const Value: string);
begin
  FPLT := Value;
end;

procedure Tgis_LT.SetPLT_Nazev(const Value: string);
begin
  FPLT_Nazev := Value;
end;

procedure Tgis_LT.SetSLT(const Value: string);
begin
  FSLT := Value;
end;

procedure Tgis_LT.SetTVL(const Value: string);
begin
  FTVL := Value;
end;

procedure Tgis_LT.SetUdrzba(const Value: integer);
begin
  FUdrzba := Value;
end;

procedure Tgis_LT.SetVymera(const Value: double);
begin
   FVymera := Value;
end;

procedure Tgis_LT.SetZmena(const Value: string);
begin
  FZmena := Value;
end;

{ TSRFPlocha }

function TSRFPlocha.GetGroup: integer;
begin
   result := 144;
end;

INITIALIZATION
   RegisterOrbisClass(Tgis_UserAreaElement);
   RegisterOrbisClass(TTEZPlocha);
   RegisterOrbisClass(TSRFPlocha);
   RegisterOrbisClass(TTEZBod);
   RegisterOrbisClass(TSRFBod);
   RegisterOrbisClass(Tgis_LT);
END.
