unit f_Synchronize_TABLE_Majitele;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Gauges, ExtCtrls,
  e_KatastrModel,
  Tools, DB,
{$IFNDEF WIN64}
  DBTables;
{$ELSE}
  DBF;
{$ENDIF}


type
  TSynchronize_TABLE_Majitele_Form = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    ed_TableName: TEdit;
    p_Dioda: TPanel;
    Panel2: TPanel;
    Label2: TLabel;
    Label6: TLabel;
    ed_Vlastnik: TComboBox;
    Panel3: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    ed_MAJ_DRUH: TComboBox;
    ed_MAJ_KOD: TComboBox;
    ed_JMENO: TComboBox;
    ed_PRIJMENI: TComboBox;
    ed_ADRESA: TComboBox;
    ed_COMMENT: TComboBox;
    cb_FixMAJ: TCheckBox;
    Panel4: TPanel;
    Gauge: TGauge;
    l_Err: TLabel;
    cb_Protocol: TCheckBox;
    Panel5: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    cb_Kat: TCheckBox;
    cb_CreateNew: TCheckBox;
    OpenDialog: TOpenDialog;
{$IFNDEF WIN64}
    Table: TTable;
{$ELSE}
    Table: TDBF;
{$ENDIF}
    procedure SpeedButton1Click(Sender: TObject);
    procedure ed_TableNameChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure cb_ProtocolClick(Sender: TObject);
  private
    FProtocol: boolean;
    FMajitele: Tgis_Majitele;
    FFieldList: TStringList;
    FTool: TTool;
    procedure SetFieldList(const Value: TStringList);
    procedure SetMajitele(const Value: Tgis_Majitele);
    procedure SetProtocol(const Value: boolean);
    procedure SetTool(const Value: TTool);
    { Private declarations }
  public
     procedure DoIt;
     function  Check: boolean;
     procedure FillFieldList;
     property FieldList: TStringList read FFieldList write SetFieldList;
     property Majitele: Tgis_Majitele read FMajitele write SetMajitele;
     property Protocol: boolean read FProtocol write SetProtocol;
     property Tool: TTool read FTool write SetTool;
  end;


implementation
uses
   Elements,
   u_String,
   m_Orbis;

{$R *.dfm}

{ TSynchronize_TABLE_Majitele_Form }

procedure TSynchronize_TABLE_Majitele_Form.DoIt;
var
   i: integer;
   Vlastnik: string;
   MAJ_DRUH: integer;
   MAJ_KOD: string;
   F: TField;
   Jmeno: string;
   Prijmeni: string;
   Adresa: string;
   Comment: string;
   FixMaj: boolean;
   CreateNew: boolean;
   M: Tgis_Majitel;
   e: TElement;
   OE: TOwnerEntity;
   OENew: TOwnerEntity;
   Errors,News: integer;
begin
   FixMaj := cb_FixMAJ.Checked;
   Createnew := cb_CreateNew.Checked;
   Table.First;
   Gauge.MaxValue := Table.RecordCount;
   Errors := 0;
   News := 0;
   OE := TOwnerEntity.Create;
   OE.Name := 'Nown';
   Tool.NextElement := OE;
   OENew := TOwnerEntity.Create;
   OENew.Name := 'New Majitel';
   Tool.NextElement := OENew;
   if Protocol then
   begin
      Tool.PostTextMsg(tm_AddToProtocol,'Synchronizace Majitel s tabulkou: '+ed_TableName.Text,nil);
      Tool.PostTextMsg(tm_AddToProtocol,'START****',nil);
   end;
   while not Table.Eof do
   begin
      Gauge.Progress := Table.RecNo;
      F := Table.FieldByName(ed_Vlastnik.Text);
      if F = nil then exit;
      Vlastnik := F.AsString;
      M := Majitele.GetMajitelCislo(Vlastnik);
      if M = nil then
      begin
         if CreateNew then
         begin
            M := Majitele.CreateMajitelCislo(Vlastnik);
            OENew.AddElement(M);
            OE.AddElement(M);
            Inc(News);
            l_Err.Caption := 'Nenalezeno '+IntToStr(Errors)+' Majitel, '+IntToStr(News)+' vytvoeno';
            Application.ProcessMessages;
         end
         else
         begin
            if OENew.FindElementName(Vlastnik) = nil then
            begin
               OENew.CreateElement('TOwnerElement',Vlastnik);
               inc(Errors);
               l_Err.Caption := 'Nenalezeno '+IntToStr(Errors)+' Majitel, '+IntToStr(News)+' vytvoeno';
               Application.ProcessMessages;
            end;
         end;
      end
      else
         OE.AddElement(M);
      if M <> nil then
      begin
         M.FixMaj := FixMaj;
         // MAJ_DRUH
         F := nil;
         if ed_MAJ_DRUH.Text <> '' then
         F := Table.FieldByName(ed_MAJ_DRUH.Text);
         if F <> nil then
            M.MAJ_DRUH := F.AsInteger;
         // MAJ_KOD
         F := nil;
         if ed_MAJ_KOD.Text <> '' then
         F := Table.FieldByName(ed_MAJ_KOD.Text);
         if F <> nil then
            M.MAJ_KOD := F.AsString;
         // Jmeno
         F := nil;
         if ed_Jmeno.Text <> '' then
         F := Table.FieldByName(ed_Jmeno.Text);
         if F <> nil then
         begin
            if F is TStringField then
               TStringField(F).Transliterate := DBTransLiterate;
            M.Jmeno := F.AsString;
         end;
         // Prijmeni
         F := nil;
         if ed_Prijmeni.Text <> '' then
         F := Table.FieldByName(ed_Prijmeni.Text);
         if F <> nil then
         begin
            if F is TStringField then
               TStringField(F).Transliterate := DBTransLiterate;
            M.Prijmeni := F.AsString;
         end;
         // Adresa
         F := nil;
         if ed_Adresa.Text <> '' then
         F := Table.FieldByName(ed_Adresa.Text);
         if F <> nil then
         begin
            if F is TStringField then
               TStringField(F).Transliterate := DBTransLiterate;
            M.Adresa := F.AsString;
         end;
         // Comment
         F := nil;
         if ed_Comment.Text <> '' then
         F := Table.FieldByName(ed_Comment.Text);
         if F <> nil then
         begin
            if F is TStringField then
               TStringField(F).Transliterate := DBTransLiterate;
            M.Comment := F.AsString;
         end;
      end;
      Table.Next;
   end;
   if Protocol then
   begin
      for i := 0 to Majitele.LastIndex do
      begin
         M := Tgis_Majitel(Majitele.Elements[i]);
         if not M.IsMyOwner(OE) then
         begin
            Tool.PostTextMsg(tm_AddToProtocol,' chyb v DB: '+ M.Name+' ('+M.Cislo+')',nil);
            Application.ProcessMessages;
         end;
      end;
      for i := 0 to OENew.LastIndex do
      begin
         e := OENew.Elements[i];
         if CreateNew then
         begin
            M := Tgis_Majitel(e);
            Tool.PostTextMsg(tm_AddToProtocol,' Vytvoen nov: '+ M.Name+' ('+M.Cislo+')',nil);
            Application.ProcessMessages;
         end
         else
         begin
            Tool.PostTextMsg(tm_AddToProtocol,' Chyb v LEDu: '+ e.Name,nil);
            Application.ProcessMessages;
         end;
      end;
      Tool.PostTextMsg(tm_AddToProtocol,'    ****',nil);
      Tool.PostTextMsg(tm_AddToProtocol,'END ****',nil);
      Tool.PostTextMsg(tm_AddToProtocol,'konec Synchronizace Majitel',nil);
      Application.ProcessMessages;
   end;
   OE.Free;
   OENew.Free;
end;

procedure TSynchronize_TABLE_Majitele_Form.FillFieldList;
var
   i: integer;
begin
   if not Table.Active then exit;
   FieldList.Clear;
   Table.First;
   for i := 0 to Table.FieldCount - 1 do
   begin
      FieldList.Add(Table.Fields.Fields[i].FieldName);
   end;
   ed_Vlastnik.Items.Assign(FieldList);
   ed_MAJ_DRUH.Items.Assign(FieldList);
   ed_MAJ_KOD.Items.Assign(FieldList);
   ed_JMENO.Items.Assign(FieldList);
   ed_PRIJMENI.Items.Assign(FieldList);
   ed_ADRESA.Items.Assign(FieldList);
   ed_COMMENT.Items.Assign(FieldList);
end;

function TSynchronize_TABLE_Majitele_Form.Check: boolean;
var
   S: string;
begin
   result := false;
   if not Table.Active then
   begin
      ShowMessage('DB Tabulka nen nastavena nebo nejde otevt ... Dal pokus !');
      ed_TableName.SetFocus;
      exit;
   end;
   S :=  ' je povinn(jako vechno co je erven)... znova!';
   if ed_Vlastnik.Text = '' then
   begin
      ShowMessage('Poloka pro .Vlastnka'+S);
      ed_Vlastnik.SetFocus;
      exit;
   end;
   result := true;
end;

procedure TSynchronize_TABLE_Majitele_Form.SetFieldList(const Value: TStringList);
begin
   if FFieldList <> nil then
      FFieldList.Free;
   FFieldList := Value;
end;

procedure TSynchronize_TABLE_Majitele_Form.SetMajitele(const Value: Tgis_Majitele);
begin
  FMajitele := Value;
end;

procedure TSynchronize_TABLE_Majitele_Form.SetProtocol(const Value: boolean);
begin
  FProtocol := Value;
end;

procedure TSynchronize_TABLE_Majitele_Form.SetTool(const Value: TTool);
begin
  FTool := Value;
end;

procedure TSynchronize_TABLE_Majitele_Form.SpeedButton1Click(Sender: TObject);
begin
   if OpenDialog.Execute then
   begin
      ed_TableName.Text := OpenDialog.FileName;
   end;
end;

procedure TSynchronize_TABLE_Majitele_Form.ed_TableNameChange(Sender: TObject);
begin
   p_Dioda.Color := clRed;
   if FileExists(ed_TableName.Text) then
   begin
      Table.Close;
      Table.TableName := ed_TableName.Text;
      Table.Open;
      if Table.Active then
         p_Dioda.Color := clLime;
      if not Table.Active then exit;
      FillFieldList;
   end;
end;

procedure TSynchronize_TABLE_Majitele_Form.FormCreate(Sender: TObject);
begin
   FieldList := TStringList.Create;
end;

procedure TSynchronize_TABLE_Majitele_Form.FormDestroy(Sender: TObject);
begin
   FieldList := nil;
end;

procedure TSynchronize_TABLE_Majitele_Form.BitBtn1Click(Sender: TObject);
begin
   if not CHeck then exit;
   DoIt;
end;

procedure TSynchronize_TABLE_Majitele_Form.cb_ProtocolClick(
  Sender: TObject);
begin
   Protocol := cb_Protocol.Checked;
end;

end.
