unit i_LHCElements;

interface
uses
   Elements,
   i_AreaGeometryElement;

type

Tgis_ForestUnitInterpret = class(TGeometryAreaElementInterpret)
public
   function   GetElementClass: TElementClass; override;
   function   Get_Color(const Element: TElement): integer; override;
   function   Get_Symbol(const Element: TElement): integer; override;
end;

Tgis_LSInterpret = class(Tgis_ForestUnitInterpret)
public
   function   GetElementClass: TElementClass; override;
end;

Tgis_OddeleniInterpret = class(Tgis_ForestUnitInterpret)
public
   function   GetElementClass: TElementClass; override;
end;

Tgis_PorostInterpret = class(Tgis_ForestUnitInterpret)
public
   function   GetElementClass: TElementClass; override;
end;


Tgis_PorostniSkupinaInterpret = class(Tgis_ForestUnitInterpret)
public
   function   GetElementClass: TElementClass; override;
end;

TSRFPlochaInterpret = class(Tgis_ForestUnitInterpret)
public
   function   GetElementClass: TElementClass; override;
end;

TTezPlochaInterpret = class(Tgis_ForestUnitInterpret)
public
   function   GetElementClass: TElementClass; override;
end;

Tgis_LTInterpret = class(Tgis_ForestUnitInterpret)
public
   function   GetElementClass: TElementClass; override;
end;

Tgis_UserAreaElementInterpret = class(Tgis_ForestUnitInterpret)
public
   function   GetElementClass: TElementClass; override;
end;


implementation
uses
   e_LHCModel,
   e_LHCElements,
   e_Class;


{ Tgis_ForestUnitInterpret }

function Tgis_ForestUnitInterpret.GetElementClass: TElementClass;
begin
   result := Tgis_ForestUnit;
end;

function Tgis_ForestUnitInterpret.Get_Color(const Element: TElement): integer;
begin
   result := Tgis_ForestUnit(Element).Barva;
end;

function Tgis_ForestUnitInterpret.Get_Symbol(const Element: TElement): integer;
begin
   result := Tgis_ForestUnit(Element).Znacka;
end;

{ Tgis_PorostniSkupinaInterpret }

function Tgis_PorostniSkupinaInterpret.GetElementClass: TElementClass;
begin
   result := Tgis_PorostniSkupina;
end;

{ TSRFPlochaInterpret }

function TSRFPlochaInterpret.GetElementClass: TElementClass;
begin
   result := TSRFPlocha;
end;

{ TTezPlochaInterpret }

function TTezPlochaInterpret.GetElementClass: TElementClass;
begin
   result := TTezPlocha;
end;

{ Tgis_PorostInterpret }

function Tgis_PorostInterpret.GetElementClass: TElementClass;
begin
   result := Tgis_Porost;
end;

{ Tgis_LSInterpret }

function Tgis_LSInterpret.GetElementClass: TElementClass;
begin
   result := Tgis_LS;
end;

{ Tgis_OddeleniInterpret }

function Tgis_OddeleniInterpret.GetElementClass: TElementClass;
begin
   result := Tgis_Oddeleni;
end;

{ Tgis_UserAreaElementInterpret }

function Tgis_UserAreaElementInterpret.GetElementClass: TElementClass;
begin
   result := Tgis_UserAreaElement;
end;

{ Tgis_LTInterpret }

function Tgis_LTInterpret.GetElementClass: TElementClass;
begin
   result := Tgis_LT;
end;

INITIALIZATION
    RegisterOrbisClass(Tgis_LSInterpret);
    RegisterOrbisClass(Tgis_OddeleniInterpret);
    RegisterOrbisClass(Tgis_PorostInterpret);
    RegisterOrbisClass(Tgis_PorostniSkupinaInterpret);
    RegisterOrbisClass(TSRFPlochaInterpret);
    RegisterOrbisClass(TTEZPlochaInterpret);
    RegisterOrbisClass(Tgis_UserAreaElementInterpret);
    RegisterOrbisClass(Tgis_LTInterpret);
END.
