unit t_ParcelyUtils;

interface
uses
   e_KatastrModel,
   e_QTree,
   Elements,
   g_Elems,
   Tools;

type
TSetPSKColorByKatastr = class(TTool)
private
    FParcelModel: Tgis_ParcelModel;
    procedure SetParcelModel(const Value: Tgis_ParcelModel);
public
   procedure DoIt; override;
published
   property  ParcelModel: Tgis_ParcelModel read FParcelModel write SetParcelModel;
end;

TRenumberSkupinyParcel = class(TTool)
private
    FParcelModel: Tgis_ParcelModel;
    procedure SetParcelModel(const Value: Tgis_ParcelModel);
public
   procedure DoIt; override;
published
   property  ParcelModel: Tgis_ParcelModel read FParcelModel write SetParcelModel;
end;

TFindParcelyNoParZar = class(TTool)
  private
    FTest: boolean;
    FMinArea: double;
    FComment: string;
    FOE: TRectEntity;
    function GetParcely: TEntity;
    procedure SetMinArea(const Value: double);
    procedure SetTest(const Value: boolean);
    procedure SetComment(const Value: string);
    function GetOE: TRectEntity;
    procedure SetOE(const Value: TRectEntity);
public
   procedure DoIt; override;
   function  IsIslandArea(P: Tgis_ParcelaCast): boolean;
   procedure TestParcast(P: Tgis_ParcelaCast);
   property  Parcely: TEntity read GetParcely;
   property  OE: TRectEntity read GetOE write SetOE;
published
   property Test: boolean read FTest write SetTest;
   property MinArea: double read FMinArea write SetMinArea;
   property Comment: string read FComment write SetComment;
end;

TFindAreasWithLinePresnost = class(TTool)
  private
    FPresnost: integer;
    FAreas: TEntity;
    FLines: TEntity;
    FOE: TRectEntity;
    FComment: string;
    function GetOE: TRectEntity;
    procedure SetAreas(const Value: TEntity);
    procedure SetLines(const Value: TEntity);
    procedure SetPresnost(const Value: integer);
    procedure SetComment(const Value: string);
public
   procedure DoIt; override;
   property  OE: TRectEntity read GetOE;
published
   property Areas: TEntity read FAreas write SetAreas;
   property Lines: TEntity read FLines write SetLines;
   property Presnost: integer read FPresnost write SetPresnost;
   property Comment: string read FComment write SetComment;
end;

{ TODO 2 -oPPK -cOpravit : MultiPlochy u Parcel se zmn - parceln sti maj jen jednu plochu!!! }
TFindMultiAreas = class(TTool)
  private
    FOE: TRectEntity;
    FComment: string;
    function GetOE: TRectEntity;
    procedure SetComment(const Value: string);
public
   procedure DoIt; override;
   property  OE: TRectEntity read GetOE;
published
   property Comment: string read FComment write SetComment;
end;



{ DONE 3 -oPPK -cDodlat : Vyrovnn a identifikace Skupina Parcel ... pedlat na sti parcel !!! }
{ TODO -oPPK -cOpravit : Pro hrabn v katastru udlat univerzlnjho pedka }
TFindSKPInParcelModel = class(TTool)
  private
    FOE: TOwnerEntity;
    FSKPZero: TRectEntity;
    FSKPMulti: TRectEntity;
    FSKPDeviation: TRectEntity;
    FComment: string;
    FByMultiArea: boolean;
    FByZeroParcela: boolean;
    FByDeviation: boolean;
    FReset_KVALP_Vymera: boolean;
    FPText: string;
    FDontUsePARVYM: boolean;
    FaPlochaDigit: integer;
    FaSKPDigit: integer;
    FByMultiParcela: boolean;
    function GetOE: TOwnerEntity;
    procedure SetComment(const Value: string);
    procedure SetByDeviation(const Value: boolean);
    procedure SetByMultiArea(const Value: boolean);
    procedure SetByZeroParcela(const Value: boolean);
    procedure SetReset_KVALP_Vymera(const Value: boolean);
    procedure SetPText(const Value: string);
    procedure SetDontUsePARVYM(const Value: boolean);
    function GetSKPDeviation: TRectEntity;
    function GetSKPMulti: TRectEntity;
    function GetSKPZero: TRectEntity;
    procedure SetaPlochaDigit(const Value: integer);
    procedure SetaSKPDigit(const Value: integer);
    procedure SetByMultiParcela(const Value: boolean);
public
   procedure DoIt; override;
   procedure ProcessSKP(aSkp: Tgis_SkupinaParcel); virtual;
   procedure ProcessKU(aKU: Tgis_Katastr); virtual;
   procedure ProcessBefore; virtual;
   property  OE: TOwnerEntity read GetOE;
   property  SKPZero: TRectEntity read GetSKPZero;
   property  SKPMulti: TRectEntity read GetSKPMulti;
   property  SKPDeviation: TRectEntity read GetSKPDeviation;
   property  PText: string read FPText write SetPText;
published
   property  Comment: string read FComment write SetComment;
   property  aPlochaDigit: integer read FaPlochaDigit write SetaPlochaDigit; // des.mist. plocha
   property  aSKPDigit: integer read FaSKPDigit write SetaSKPDigit;  // des u SKP
   property  ByZeroParcela: boolean read FByZeroParcela write SetByZeroParcela;
   property  ByMultiParcela: boolean read FByMultiParcela write SetByMultiParcela;
   property  ByMultiArea: boolean read FByMultiArea write SetByMultiArea;
   property  ByDeviation: boolean read FByDeviation write SetByDeviation;
   property  Reset_KVALP_Vymera: boolean read FReset_KVALP_Vymera write SetReset_KVALP_Vymera;
   property  DontUsePARVYM: boolean read FDontUsePARVYM write SetDontUsePARVYM;
             // nepouvat vmru parcely, ale jen st parcel.
end;




TVyrovnani_SKP_DET = class(TFindSkpInParcelModel)
  private
    FQE: TQuickEntity;
    FSKPPart: TRectEntity;
    FSKPZeroArea: TRectEntity;
    FSKPNoDET: TRectEntity;
    FaDigit: integer;
    FFillVymeraByPlocha: boolean;
    function GetQE: TQuickEntity;
    procedure SetaDigit(const Value: integer);
    procedure SetFillVymeraByPlocha(const Value: boolean);
    function GetSKPPart: TRectEntity;
    function GetSKPZeroArea: TRectEntity;
    function GetSKPNoDet: TRectEntity;
public
   procedure ProcessSKP(aSkp: Tgis_SkupinaParcel); override;
   property  QE: TQuickEntity read GetQE;
   property  SKPPart: TRectEntity read GetSKPPart;
   property  SKPZeroArea: TRectEntity read GetSKPZeroArea;
   property  SKPNoDet: TRectEntity read GetSKPNoDet;
published
   property  aDigit: integer read FaDigit write SetaDigit;
   property  FillVymeraByPlocha: boolean read FFillVymeraByPlocha write SetFillVymeraByPlocha;
end;

TVyrovnani_SKP_ARES = class(TFindSkpInParcelModel)
  private
    FQE: TQuickEntity;
    FSKPPart: TRectEntity;
    FSKPZeroArea: TRectEntity;
    FSKPNoAres: TRectEntity;
    FSKPPostError: TRectEntity;
    FSKPNotSolvedAres: TRectEntity;
    FSKPSolvedAres: TRectEntity;
    FaDigit: integer;
    FFillVymeraByPlocha: boolean;
    FAres: TEntity;
    FQTree: TRectEntityQTree;
    function GetQE: TQuickEntity;
    procedure SetaDigit(const Value: integer);
    procedure SetFillVymeraByPlocha(const Value: boolean);
    function GetSKPPart: TRectEntity;
    function GetSKPZeroArea: TRectEntity;
    function GetSKPNoARES: TRectEntity;
    procedure SetAres(const Value: TEntity);
    procedure SetQTree(const Value: TRectEntityQTree);
    function GetSKPPostError: TRectEntity;
    function GetSKPNotSolvedAres: TRectEntity;
    function GetSKPSolvedAres: TRectEntity;
public
   procedure DoIt; override;
   procedure ProcessSKP(aSkp: Tgis_SkupinaParcel); override;
   procedure FindNotSolvedAres;
   property  QTree: TRectEntityQTree read FQTree write SetQTree;
   property  QE: TQuickEntity read GetQE;
   property  SKPPart: TRectEntity read GetSKPPart;
   property  SKPZeroArea: TRectEntity read GetSKPZeroArea;
   property  SKPNoARES: TRectEntity read GetSKPNoARES;
   property  SKPPostError: TRectEntity read GetSKPPostError;
   property  SKPNotSolvedAres: TRectEntity read GetSKPNotSolvedAres;
   property  SKPSolvedAres: TRectEntity read GetSKPSolvedAres;
published
   property  Ares: TEntity read FAres write SetAres;
   property  aDigit: integer read FaDigit write SetaDigit;
   property  FillVymeraByPlocha: boolean read FFillVymeraByPlocha write SetFillVymeraByPlocha;
end;


TKontrola_SKP = class(TFindSkpInParcelModel)
  private
    FARE_PAR: TEntity;
    FARE_DET: TEntity;
    function GetEr_EmptyKU: TRectEntity;
    function GetEr_EmptySKP: TRectEntity;
    function GetEr_KUNumbering: TRectEntity;
    function GetEr_MultiPARCheckSum: TRectEntity;
    function GetEr_ParNoSKP: TRectEntity;
    function GetEr_SKP0DET: TRectEntity;
    function GetEr_SKP0Geometry: TRectEntity;
    function GetEr_SKP0Parzar: TRectEntity;
    function GetEr_SKPKvalp: TRectEntity;
    function GetEr_SKPNoDET: TRectEntity;
    function GetEr_SKPNoPAR: TRectEntity;
    function GetEr_SKPPart: TRectEntity;
    function GetEr_SKPParzar: TRectEntity;
    function GetSKP_PARCheckSum: TRectEntity;
    function GetSKP_DETCheckSum: TRectEntity;
    function GetEr_ParNoKU: TRectEntity;
    procedure SetARE_DET(const Value: TEntity);
    procedure SetARE_PAR(const Value: TEntity);
    function GetEr_KUNoPar: TRectEntity;
    function GetEr_KUNoSKP: TRectEntity;
    function GetEr_SKPDETKvalp: TRectEntity;
protected
   function  GetOEEntity(aName: string): TRectEntity;
public
   procedure ProcessSKP(aSkp: Tgis_SkupinaParcel); override;
   procedure ProcessKU(aKU: Tgis_Katastr); override;
   procedure ProcessBefore; override;
published
   // Kontrola KU
   property  Er_MultiPARCheckSum: TRectEntity read GetEr_MultiPARCheckSum;
   property  Er_PARNoSKP: TRectEntity read GetEr_ParNoSKP;
   property  Er_PARNoKU: TRectEntity read GetEr_ParNoKU;
   property  Er_KUNumbering: TRectEntity read GetEr_KUNumbering;
   property  Er_KUNoPAR: TRectEntity read GetEr_KUNoPar;
   property  Er_KUNoSKP: TRectEntity read GetEr_KUNoSKP;
   property  Er_EmptyKU: TRectEntity read GetEr_EmptyKU;
   // kontrola SKP
   property  Er_EmptySKP: TRectEntity read GetEr_EmptySKP;
   property  Er_SKPNoPar: TRectEntity read GetEr_SKPNoPAR;
   property  Er_SKPNoDET: TRectEntity read GetEr_SKPNoDET;
   property  Er_SKP0Parzar: TRectEntity read GetEr_SKP0Parzar;
   property  Er_SKP0Geometry: TRectEntity read GetEr_SKP0Geometry;
   property  Er_SKP0DET: TRectEntity read GetEr_SKP0DET;
   property  Er_SKPParzar: TRectEntity read GetEr_SKPParzar;
   property  Er_SKPPart: TRectEntity read GetEr_SKPPart;
   property  Er_SKP_PARCheckSum: TRectEntity read GetSKP_PARCheckSum;
   property  Er_SKPKvalp: TRectEntity read GetEr_SKPKvalp;
   property  Er_SKPDETKvalp: TRectEntity read GetEr_SKPDETKvalp;
   property  Er_SKP_DETCheckSum: TRectEntity read GetSKP_DETCheckSum;
   property  ARE_DET: TEntity read FARE_DET write SetARE_DET;
   property  ARE_PAR: TEntity read FARE_PAR write SetARE_PAR;
end;


TUpgradeParcelModel = class(TTool)
  private
    FAreas: TEntity;
    FParcelModel: Tgis_ParcelModel;
    FOLHs: TGis_OLHs;
    procedure SetAreas(const Value: TEntity);
    procedure SetParcelModel(const Value: Tgis_ParcelModel);
    procedure SetOLHs(const Value: TGis_OLHs);
public
   procedure DoIt; override;
published
   property ParcelModel: Tgis_ParcelModel read FParcelModel write SetParcelModel;
   property Areas: TEntity read FAreas write SetAreas;
   property OLHs: TGis_OLHs read FOLHs write SetOLHs;
end;


TJoinParcelModel = class(TTool)
private
    FParcelModel1: Tgis_ParcelModel;
    FSKPOnly: boolean;
    FForestOnly: boolean;
    FMajitele: Tgis_Majitele;
    function GetParcelModel: Tgis_ParcelModel;
    procedure SetParcelModel(const Value: Tgis_ParcelModel);
    procedure SetParcelModel1(const Value: Tgis_ParcelModel);
    procedure SetForestOnly(const Value: boolean);
    procedure SetSKPOnly(const Value: boolean);
    procedure SetMajitele(const Value: Tgis_Majitele);
public
   procedure DoIt; override;
   procedure FindMajitele;
   function NumberToPropertyName(aNumber: longInt): string; override;
published
   property ParcelModel: Tgis_ParcelModel read GetParcelModel write SetParcelModel;
   property ParcelModel1: Tgis_ParcelModel read FParcelModel1 write SetParcelModel1;
   property Majitele: Tgis_Majitele read FMajitele write SetMajitele;
   property ForestOnly: boolean read FForestOnly write SetForestOnly;
   property SKPOnly: boolean read FSKPOnly write SetSKPOnly;
end;

// Duplikuje strom struktury parcel pro vybrane parcasti
// Vcetne vytvoreni kopie parcasti
// Input ~ ParcelModel - Novy(Duplikovany ParcelModel)
// Select - Entita vybranych casti parcel ze stareho modelu
// Majitele - Novy seznam majitelu - duplikuje se taky
TDuplicateParcelModelForSelect = class(TJoinParcelModel)
  private
    FSelect: TEntity;
    FPARAreas: TEntity;
    FSelectIsZAK: boolean;
    procedure SetSelect(const Value: TEntity);
    procedure SetPARAreas(const Value: TEntity);
public
   procedure DoIt; override;
   function NumberToPropertyName(aNumber: longInt): string; override;
   function  GetMajitelCopy(const aMajitel: Tgis_Majitel): Tgis_Majitel;
published
   property Select: TEntity read FSelect write SetSelect;
   property PARAreas: TEntity read FPARAreas write SetPARAreas;
end;

TSolveParcelModelMishMash = class(TTool)
private
    FFreeEmptyItems: boolean;
    FEmptyUnits: integer;
    FSilentMode: boolean;
    FPARAreas: TEntity;
    FFreeEmptyMajitel: boolean;
    function GetParcelModel: Tgis_ParcelModel;
    procedure SetParcelModel(const Value: Tgis_ParcelModel);
    procedure SetFreeEmptyItems(const Value: boolean);
    procedure SetEmptyUnits(const Value: integer);
    procedure SetSilentMode(const Value: boolean);
    procedure SetPARAreas(const Value: TEntity);
    procedure SetFreeEmptyMajitel(const Value: boolean);
public
   procedure DoIt; override;
   property  EmptyUnits: integer read FEmptyUnits write SetEmptyUnits;
published
   property ParcelModel: Tgis_ParcelModel read GetParcelModel write SetParcelModel;
   property FreeEmptyItems: boolean read FFreeEmptyItems write SetFreeEmptyItems;
   property FreeEmptyMajitel: boolean read FFreeEmptyMajitel write SetFreeEmptyMajitel;
   property PARAreas: TEntity read FPARAreas write SetPARAreas;
   property SilentMode: boolean read FSilentMode write SetSilentMode;
end;


implementation
uses
   Dialogs,
   Forms,
   u_Math,
   SysUtils,
   e_Class,
   e_Geometry,
   e_GeometryElement,
   e_LHCModel,
   e_Props,
   e_TopolElements,
   e_Type,
   t_LineExtractor,
   t_QTreeTools,
   t_Sort,
   t_ParcelyTestTools;

{ TSetPSKColorByKatastr }

procedure TSetPSKColorByKatastr.DoIt;
var
   col,i,j: integer;
   K: TGis_Katastr;
begin
   if ParcelModel = nil then exit;
   if not (TElement(ParcelModel)is Tgis_ParcelModel) then exit;
   Col := 1;
   for i := 0 to ParcelModel.LastIndex do
   begin
      K := Tgis_Katastr(ParcelModel.Elements[i]);
      if not K.NoSkupinaParcel then
      for j := 0 to K.SkupinyParcel.LastIndex do
      begin
         Tgis_SkupinaParcel(K.SkupinyParcel.Elements[j]).Barva := Col;
      end;
      Inc(Col);
      if Col = 13 then
         Inc(Col);
      if Col = 15 then
         Col := 1;
   end;
end;

procedure TSetPSKColorByKatastr.SetParcelModel(const Value: Tgis_ParcelModel);
begin
  FParcelModel := Value;
end;

{ TRenumberSkupinyParcel }

procedure TRenumberSkupinyParcel.DoIt;
var
   i,j: integer;
   K: TGis_Katastr;
   SK: Tgis_SkupinaParcel;
   ZeroSK: Tgis_SkupinaParcel;
   SKi: integer;
begin
   if ParcelModel = nil then exit;
   if not (TElement(ParcelModel)is Tgis_ParcelModel) then exit;
   for i := 0 to ParcelModel.LastIndex do
   begin
      K := Tgis_Katastr(ParcelModel.Elements[i]);
      if not K.NoSkupinaParcel then
      begin
         for j := K.SkupinyParcel.LastIndex Downto 0 do
         begin
            SK := Tgis_SkupinaParcel(K.SkupinyParcel.Elements[j]);
            if SK.NoParcela and SK.NoParcast and SK.NoGeometry then
               SK.Free;
         end;
         SKi := 1;
         ZeroSK := nil;
         for j := 0 to K.SkupinyParcel.LastIndex do
         begin
            SK  := Tgis_SkupinaParcel(K.SkupinyParcel.Elements[j]);
            if SK.Cislo = 0 then
               ZeroSK := SK
            else
            begin
               SK.Cislo := SKi;
               Inc(SKi);
            end;
         end;
         if ZeroSK <> nil then
         begin
            K.SkupinyParcel.RemoveElement(ZeroSK);
            K.SkupinyParcel.InsertElement(0,ZeroSK);
         end;
      end;
   end;
end;

procedure TRenumberSkupinyParcel.SetParcelModel(const Value: Tgis_ParcelModel);
begin
  FParcelModel := Value;
end;

{ TFindParcelyNoParZar }

procedure TFindParcelyNoParZar.DoIt;
var
   i: integer;
   e: TElement;
   P: Tgis_ParcelaCast;
begin
   Output := OE;
   if Parcely = nil then exit;
   if MinArea = 0 then
      MinArea := 50;
   StartProgress(Comment,0,Parcely.LastIndex);
   for i := 0 to Parcely.LastIndex do
   begin
      if i mod 50 = 0 then
      begin
         Progress := i;
         Application.ProcessMessages;
      end;
      e := Parcely.Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      P := Tgis_ParcelaCast(e);
      if P.IsMyOwner(OE) then continue; // uz byla resena
      if not Test then
         P.ParZar := true; // dokud nen prokzna vina, bude se zaizovat
      TestParCast(P);
      {
      if ((P.Vymera > 0) and (P.Vymera*10000 < MinArea)) or (P.Plocha < MinArea) then  // mal plocha, jestlipak je izolovan?
      begin
         if IsIslandArea(P) then
         begin
            P.ParZar := false;
            OE.AddAndUpdateRect(P);
            ProgressText := IntToStr(OE.Count)+'/'+IntToStr(Parcely.Count);
         end;
      end;
      }
   end;
end;

function TFindParcelyNoParZar.GetOE: TRectEntity;
begin
   if FOE = nil then
   begin
      FOE := TRectEntity.Create;
      FOE.Name := 'PARZAR-';
      AddElement(FOE);
      Output := FOE;
   end;
   result := FOE;
end;

function TFindParcelyNoParZar.GetParcely: TEntity;
begin
   result := nil;
   if Input = nil then exit;
   if not (Input is TEntity) then exit;
   result := TEntity(Input);
end;

function TFindParcelyNoParZar.IsIslandArea(P: Tgis_ParcelaCast): boolean;
var
   T: THraniceSKPTestTool;
   j: integer;
   G: TGeometry;
   A: TAreaElement;
   MA: TMultiAreaElement;

   function CHA: boolean;
   var
      i: integer;
   begin
      result := true;
      if not (A is TPolyLineAreaElement) then exit; // nen-li to lineArea, nelze se patlat v linich
      for i := 0 to A.LastIndex do
      begin
         T.Input := A.Elements[i];
         T.DoIt;
         result := result and not(T.Result);
         if not Result then exit;
      end;
   end;
begin
   result := true;
   T := THraniceSKPTestTool.Create;
   if P.NoGeometry then exit;
   G := P.Geometry;
   A := TAreaElement(G);
   if (A is TMultiAreaElement) then
   begin
      MA := TMultiAreaElement(A);
      for j := 0 to MA.LastIndex do
      begin
         A := TAreaElement(MA.Elements[j]);
         result := CHA;
         if not result then break;
      end;
   end
   else
   begin
      result := CHA;
   end;
   T.Free;
end;

procedure TFindParcelyNoParZar.SetComment(const Value: string);
begin
   FComment := Value;
end;

procedure TFindParcelyNoParZar.SetMinArea(const Value: double);
begin
  FMinArea := Value;
end;

procedure TFindParcelyNoParZar.SetOE(const Value: TRectEntity);
begin
   if FOE <> nil then
   begin
      FOE.Free;
   end;
   FOE := Value;
   FOE.Name := 'PARZAR-';
   AddElement(FOE);
   Output := FOE;
end;

procedure TFindParcelyNoParZar.SetTest(const Value: boolean);
begin
  FTest := Value;
end;

procedure TFindParcelyNoParZar.TestParcast(P: Tgis_ParcelaCast);
var
   ByVymera: boolean;
   SumVymera, SumPlocha: double;
   TestE: TEntity;
   T: THraniceSKPTestTool;
   IsOver: boolean;
   j: integer;
   PCC: Tgis_ParcelaCast;


   procedure SolveCluster(aPC: Tgis_ParcelaCast);
   var
      A: TAreaElement;
      Hole: TPolyLineAreaElement;
      //e: TElement;
      i: integer;
   procedure SolveAre(A: TPolyLineAreaElement);
   var
      PC: Tgis_ParcelaCast;
      Are: TPolyLineAreaElement;
      L: TPolyLineElement;
      i,k: integer;
      e: TElement;
   begin
      for i := 0 to A.LastIndex do // jsou a tedy testujeme linie
      begin
         e := A.Elements[i];
         if not (e is TPolyLineElement) then continue;
         L := TPolyLineElement(e);
         // je to hranice SKP?
         T.Input := L;
         T.DoIt;
         if T.Result then  // pokud neni (result true), hledame okolni plochy
         for k := 0 to L.OwnersCount - 1 do
         begin
            PC := nil;
            e := L.Owners[k];
            if not (e is TPolyLineAreaElement) then continue;
            Are := TPolyLineAreaElement(e);
            if Are.IsHole then
               Are := TPolyLineAreaElement(Are.HoleOwnerArea);
            if Are <> nil then
               PC := Tgis_ParcelaCast(Are.FindClassInOwners(Tgis_ParcelaCast));
            if PC = nil then continue; // jedeme dal
            if PC.IsMyOwner(TestE) then continue; // PC uz byla resena
            SolveCluster(PC);
            if IsOver then exit; // velikost pretekla, utikame pryc
         end;
      end;
   end;
   begin
      SumVymera := SumVymera + aPC.Vymera*10000;
      SumPlocha := SumPlocha + aPC.Plocha;
      if aPC.Vymera = 0 then
         ByVymera := false;
      IsOver := not ((ByVymera and (SumVymera < MinArea)) or (SumPlocha < MinArea));
      if IsOver then exit; // moc velky, deme pryc
      if aPC.NoGeometry then exit; // nema geometrii
      TestE.AddElement(aPC); // pridame do seznamu
      A := TAreaElement(aPC.Geometry);
      if A is TMultiAreaElement then
         A := TMultiAreaElement(A).AreaElement[0];
      if not (A is TPolyLineAreaElement) then exit; // nejsou linie
      SolveAre(TPolyLineAreaElement(A));
      if IsOver then exit;
      // jeste diry
      if A.Holes = nil then exit;
      if A.Holes.NoElements then exit;
      for i := 0 to A.Holes.LastIndex do
      begin
         Hole := TPolyLineAreaElement(A.Holes.Elements[i]);
         SolveAre(Hole);
         if IsOver then exit;
      end;
       { TODO -oPPK -cDodlat : nezarizovane parcely hledat i v dirach }
   end;
begin
   ByVymera := P.Vymera > 0;
   SumVymera := P.Vymera*10000;
   SumPlocha := P.Plocha;
   if (ByVymera and (SumVymera < MinArea)) or (SumPlocha < MinArea) then  // mal plocha, jestlipak je izolovan?
   begin
      TestE := TEntity.Create;
      T := THraniceSKPTestTool.Create;
      SumVymera := 0;
      SumPlocha := 0;
      IsOver := false;
      SolveCluster(P);
      // vyhodnoceni
      if not IsOver then // pokud velikost nepretekla tak...
      begin
         for j := 0 to TestE.LastIndex do
         begin
            PCC := Tgis_ParcelaCast(TestE.Elements[j]);
            PCC.ParZar := false;
            if not PCC.IsMyOwner(OE) then
               OE.AddElement(PCC);
         end;
      end;
      T.Free;
      TestE.Free;
   end;
end;

{ TFindAreasWithLinePresnost }

procedure TFindAreasWithLinePresnost.DoIt;
var
   i,j: integer;
   e: TElement;
   GE: TGeometryElement;
   G: TGeometry;
   LEX: TLineExtractor;
   Q: TQuickEntity;
   L: TPolyLineElement;
   TL: TTopolLineElement;
begin
   if Areas = nil then exit;
   if Lines = nil then exit;
   LEX := TLineExtractor.Create;
   Q := TQuickEntity.Create;
   LEX.Output := Q;
   StartProgress(Comment,0,Areas.LastIndex);
   for i := 0 to Areas.LastIndex do
   begin
      if i mod 50 = 0 then
      begin
         Progress := i;
         Application.ProcessMessages;
      end;
      e := Areas.Elements[i];
      if not (e is TGeometryElement) then continue;
      GE := TGeometryElement(e);
      if GE.NoGeometry then continue;
      G := GE.Geometry;
      Q.Clear;
      LEX.Input := G;
      LEX.DoIt;
      for j := 0 to Q.LastIndex do
      begin
         L := TPolyLineElement(Q.Elements[j]);
         TL := TTopolLineElement(L.FindClassWithOwnerInOwners(TTopolLineElement,Lines));
         if TL = nil then continue;
         if TL.Presnost = Presnost then
         begin
            OE.AddAndUpdateRect(GE);
            ProgressText := IntToStr(OE.Count)+'/'+IntToStr(Areas.Count);
            Application.ProcessMessages;
            Break;
         end;
      end;
   end;
   Q.Clear;
   LEX.Free;
end;

function TFindAreasWithLinePresnost.GetOE: TRectEntity;
begin
   if FOE = nil then
   begin
      FOE := TRectEntity.Create;
      FOE.Name := 'ATR_PUV '+IntToStr(Presnost);
      AddElement(FOE);
      Output := FOE;
   end;
   result := FOE;
end;

procedure TFindAreasWithLinePresnost.SetAreas(const Value: TEntity);
begin
  FAreas := Value;
end;

procedure TFindAreasWithLinePresnost.SetComment(const Value: string);
begin
   FComment := Value;
end;

procedure TFindAreasWithLinePresnost.SetLines(const Value: TEntity);
begin
  FLines := Value;
end;

procedure TFindAreasWithLinePresnost.SetPresnost(const Value: integer);
begin
  FPresnost := Value;
end;

{ TFindMultiAreas }

procedure TFindMultiAreas.DoIt;
var
   Areas: TEntity;
   i: integer;
   e: TElement;
   GE: TGeometryElement;
   G: TGeometry;
   MA: TMultiAreaElement;
begin
   if Input = nil then exit;
   if not (Input is TEntity) then exit;
   Areas := TEntity(Input);
   if Areas.NoElements then exit;
   for i := 0 to Areas.LastIndex do
   begin
      e := Areas.Elements[i];
      if not (e is TGeometryElement) then continue;
      GE := TGeometryElement(e);
      if GE.NoGeometry then continue;
      G := GE.Geometry;
      if not (G is TMultiAreaElement) then continue;
      MA := TMultiAreaElement(G);
      if not (MA.Count > 1) then continue;
      OE.AddAndUpdateRect(GE);
   end;
end;

function TFindMultiAreas.GetOE: TRectEntity;
begin
   if FOE = nil then
   begin
      FOE := TRectEntity.Create;
      FOE.Name := 'Multi-Areas ';
      AddElement(FOE);
      Output := FOE;
   end;
   result := FOE;
end;

procedure TFindMultiAreas.SetComment(const Value: string);
begin
  FComment := Value;
end;

{ TFindSKPInParcelModel }

procedure TFindSKPInParcelModel.DoIt;
var
   i,j: integer;
   K: Tgis_Katastr;
   SKP: Tgis_SkupinaParcel;
   PM: TEntity;
begin
   if Input = nil then exit;
   if not (Input is Tgis_ParcelModel) then exit;
   if aSKPDigit = 0 then
      aSKPDigit := -4;
   if aPlochaDigit = 0 then
      aPlochaDigit := -4;  // pokud neni nastaveno, jedem na 4 des.mista
   OE.Name := 'SKP';
   PM := TEntity(Input);
   StartProgress(Comment,0,0);
   ProcessBefore;
   for i := 0 to PM.LastIndex do
   begin
      K := Tgis_Katastr(PM.Elements[i]);
      ProcessKU(K);
      if K.NoSkupinaParcel then continue;
      MaxProgress := K.SkupinyParcel.LastIndex;
      PText := 'Katastr '+K.Name;
      Application.ProcessMessages;
      for j := 0 to K.SkupinyParcel.LastIndex do
      begin
         Progress := j;
         Application.ProcessMessages;
         SKP := Tgis_SkupinaParcel(K.SkupinyParcel.Elements[j]);
         ProcessSKP(SKP);
      end;

   end;
end;

function TFindSKPInParcelModel.GetOE: TOwnerEntity;
begin
   if FOE = nil then
   begin
      FOE := TOwnerEntity.Create;
      //FOE.Name := 'SKP';
      AddElement(FOE);
      Output := FOE;
   end;
   result := FOE;
end;


function TFindSKPInParcelModel.GetSKPDeviation: TRectEntity;
begin
   if FSKPDeviation = nil then
   begin
      FSKPDeviation := TRectEntity.Create;
      FSKPDeviation.Name := 'Deviation';
      OE.AddElement(FSKPDeviation);
   end;
   result := FSKPDeviation;
end;

function TFindSKPInParcelModel.GetSKPMulti: TRectEntity;
begin
   if FSKPMulti = nil then
   begin
      FSKPMulti := TRectEntity.Create;
      FSKPMulti.Name := 'Multi';
      OE.AddElement(FSKPMulti);
   end;
   result := FSKPMulti;
end;

function TFindSKPInParcelModel.GetSKPZero: TRectEntity;
begin
   if FSKPZero = nil then
   begin
      FSKPZero := TRectEntity.Create;
      if ByMultiParcela then
         FSKPZero.Name := 'Multi Parcela'
      else
         FSKPZero.Name := 'Zero Parcela';
      OE.AddElement(FSKPZero);
   end;
   result := FSKPZero;
end;


procedure TFindSKPInParcelModel.ProcessBefore;
begin

end;

procedure TFindSKPInParcelModel.ProcessKU(aKU: Tgis_Katastr);
begin

end;

procedure TFindSKPInParcelModel.ProcessSKP(aSkp: Tgis_SkupinaParcel);
var
   i,j: integer;
   P: Tgis_Parcela;
   PC: Tgis_ParcelaCast;
   PLHA: double;
   VYMHA: double;
   e: TElement;
   Found: boolean;
begin
   if Reset_KVALP_Vymera then
   begin
      aSKP.KVAL_P := 1;
      aSKP.Vymera := 0;
      PLHA := 0;
      if not aSKP.NoParcela then
      begin
         for i := 0 to aSKP.Parcely.LastIndex do
         begin
            P := Tgis_Parcela(aSKP.Parcely.Elements[i]);
            if DontUsePARVYM then
            begin
               for j := 0 to P.LastIndex do
               begin
                  e := P.Elements[j];
                  if not (e is Tgis_ParcelaCast) then continue;
                  PC := Tgis_ParcelaCast(e);
                  // parzar by melo byt zbytecne
                  //if PC.ParZar then
                     PLHA := PLHA + PC.Vymera;
               end;
            end
            else
            begin
               //if P.ParZar then
                  PLHA := PLHA + P.Vymera;
            end;
         end;
      end;
      if not aSKP.NoParcast then
      begin
         for i := 0 to aSKP.ParCasti.LastIndex do
         begin
            PC := Tgis_ParcelaCast(aSKP.ParCasti.Elements[i]);
            if PC.ParZar then
               PLHA := PLHA + PC.Vymera;
         end;
      end;
      aSKP.Vymera := PLHA;
   end;
   //  verze 4.0.4.0 zmena nulovani u parcel z vice casti
   if ByMultiParcela then
   begin
      Found := false;
      if not aSKP.NoParcela then
      begin
         for i := 0 to aSKP.Parcely.LastIndex do
         begin
            P := Tgis_Parcela(aSKP.Parcely.Elements[i]);
            if P.Vymera = 0 then
            begin
               Found := true;
               SKPZero.AddAndUpdateRect(aSKP);
               if Reset_KVALP_Vymera then
               begin
                  aSKP.KVAL_P := 4;
                  aSKP.Vymera := 0;
               end;
               break;
            end;
         end;
      end;
      if not Found and not aSKP.NoParcast then
      begin
         SKPZero.AddAndUpdateRect(aSKP);
         if Reset_KVALP_Vymera then
         begin
            aSKP.KVAL_P := 4;
            aSKP.Vymera := 0;
         end;
      end;
   end
   else
   if ByZeroParcela then
   begin
      Found := false;
      if not aSKP.NoParcela then
      begin
         for i := 0 to aSKP.Parcely.LastIndex do
         begin
            P := Tgis_Parcela(aSKP.Parcely.Elements[i]);
            if P.Multiparcela or (P.Vymera = 0) then // parcela z vice casti nebo vymera 0
            begin
               Found := true;
               SKPZero.AddAndUpdateRect(aSKP);
               if Reset_KVALP_Vymera then
               begin
                  aSKP.KVAL_P := 4;
                  aSKP.Vymera := 0;
               end;
               break;
            end;
         end;
      end;
      if not Found and not aSKP.NoParcast then
      begin
         for i := 0 to aSKP.ParCasti.LastIndex do
         begin
            PC := Tgis_ParcelaCast(aSKP.ParCasti.Elements[i]);
            if PC.Multiparcela or (PC.Vymera = 0) then   // no aby nebyla
            begin
               SKPZero.AddAndUpdateRect(aSKP);
               if Reset_KVALP_Vymera then
               begin
                  aSKP.KVAL_P := 4;
                  aSKP.Vymera := 0;
               end;
               break;
            end;
         end;
      end;
      {  // puvodni varianta
      Found := false;
      if not aSKP.NoParcela then
      begin
         for i := 0 to aSKP.Parcely.LastIndex do
         begin
            P := Tgis_Parcela(aSKP.Parcely.Elements[i]);
            if DontUsePARVYM then
            begin
               for j := 0 to P.LastIndex do
               begin
                  e := P.Elements[j];
                  if not (e is Tgis_ParcelaCast) then continue;
                  PC := Tgis_ParcelaCast(e);
                  if PC.Vymera = 0 then
                  begin
                     Found := true;
                     break;
                  end;
               end;
            end
            else
            if P.Vymera = 0 then
            begin
               Found := true;
            end;
            if Found then
            begin
               SKPZero.AddAndUpdateRect(aSKP);
               if Reset_KVALP_Vymera then
               begin
                  aSKP.KVAL_P := 4;
                  aSKP.Vymera := 0;
               end;
               break;
            end;
         end;
      end;
      if not Found and not aSKP.NoParcast then
      begin
         for i := 0 to aSKP.ParCasti.LastIndex do
         begin
            PC := Tgis_ParcelaCast(aSKP.ParCasti.Elements[i]);
            if PC.Vymera = 0 then
            begin
               SKPZero.AddAndUpdateRect(aSKP);
               if Reset_KVALP_Vymera then
               begin
                  aSKP.KVAL_P := 4;
                  aSKP.Vymera := 0;
               end;
               break;
            end;
         end;
      end;
      }
   end;
   if ByMultiArea then
   begin
      if not aSKP.NoGeometry and (aSKP.Geometry is TMultiAreaElement) and
         (aSKP.Geometry.Count > 1) then
      begin
         SKPMulti.AddAndUpdateRect(aSKP);
         if Reset_KVALP_Vymera then
         begin
            aSKP.KVAL_P := 4;
            aSKP.Vymera := 0;
         end;
      end;
   end;
   if ByDeviation then
   begin
      if aSKP.KVAL_P = 1 then
      begin
         VYMHA := Simple_RoundTo(aSKP.Vymera,aSKPDigit)*10000;
         PLHA := Simple_RoundTo(aSKP.Plocha_ha, aPlochaDigit)*10000;
         if Abs(VYMHA-PLHA)>(0.005*VYMHA+2.5*SQRT(VYMHA))then
         begin
            SKPDeviation.AddAndUpdateRect(aSKP);
            if Reset_KVALP_Vymera then
            begin
               aSKP.KVAL_P := 4;
               //aSKP.Vymera := 0;
            end;
         end;
      end;
   end;
end;

procedure TFindSKPInParcelModel.SetaPlochaDigit(const Value: integer);
begin
  FaPlochaDigit := Value;
end;

procedure TFindSKPInParcelModel.SetaSKPDigit(const Value: integer);
begin
  FaSKPDigit := Value;
end;

procedure TFindSKPInParcelModel.SetByDeviation(const Value: boolean);
begin
  FByDeviation := Value;
end;

procedure TFindSKPInParcelModel.SetByMultiArea(const Value: boolean);
begin
  FByMultiArea := Value;
end;

procedure TFindSKPInParcelModel.SetByMultiParcela(const Value: boolean);
begin
  FByMultiParcela := Value;
end;

procedure TFindSKPInParcelModel.SetByZeroParcela(const Value: boolean);
begin
  FByZeroParcela := Value;
end;

procedure TFindSKPInParcelModel.SetComment(const Value: string);
begin
   FComment := Value;
end;

procedure TFindSKPInParcelModel.SetDontUsePARVYM(const Value: boolean);
begin
  FDontUsePARVYM := Value;
end;

procedure TFindSKPInParcelModel.SetPText(const Value: string);
begin
  FPText := Value;
end;

procedure TFindSKPInParcelModel.SetReset_KVALP_Vymera(
  const Value: boolean);
begin
  FReset_KVALP_Vymera := Value;
end;

{ TVyrovnani_SKP_DET }

function TVyrovnani_SKP_DET.GetQE: TQuickEntity;
begin
   if FQE = nil then
   begin
      FQE := TQuickEntity.Create;
      AddElement(FQE);
   end;
   result := FQE;
end;

function TVyrovnani_SKP_DET.GetSKPNoDet: TRectEntity;
begin
   if FSKPNoDET = nil then
   begin
      FSKPNoDET := TRectEntity.Create;
      FSKPNoDET.Name := 'CHyb DET';
      OE.AddElement(FSKPNoDET);
   end;
   result := FSKPNoDET;
end;

function TVyrovnani_SKP_DET.GetSKPPart: TRectEntity;
begin
   if FSKPPart = nil then
   begin
      FSKPPart := TRectEntity.Create;
      FSKPPart.Name := 'st SKP';
      OE.AddElement(FSKPPart);
   end;
   result := FSKPPart;
end;

function TVyrovnani_SKP_DET.GetSKPZeroArea: TRectEntity;
begin
   if FSKPZeroArea = nil then
   begin
      FSKPZeroArea := TRectEntity.Create;
      FSKPZeroArea.Name := 'Plocha 0';
      OE.AddElement(FSKPZeroArea);
   end;
   result := FSKPZeroArea;
end;

procedure TVyrovnani_SKP_DET.ProcessSKP(aSkp: Tgis_SkupinaParcel);
var
   i,j,Ai: integer;
   Por: Tgis_Porost;
   PSK: Tgis_PorostniSkupina;
   G: TGeometry;
   A,DArea: TAreaElement;
   refAre: double;
   MA: TMultiAreaElement;
   SumAre,dSumAre,SumAre1: double;
   SKPAre,SKPAre1,SKPAre2: double;
   SKPVymera,SKPVymera1,SKPVymera2: double;
   Ares: Array[0..5]of TAreaElement;
   AreD: Array[0..5]of double;

   procedure SetToAres(Are: TAreaElement);
   var
      ii,ij: integer;
   begin
      for ii := 0 to 5 do
      begin
         if Ares[ii] = nil then
         begin
            Ares[ii] := Are;
            exit;
         end
         else
         begin
            if Are.Area > Ares[ii].Area then
            begin
               for ij := 5 downto ii + 1  do
                  Ares[ij] := Ares[ij - 1];
               Ares[ii] := Are;
            end;
         end;
      end;
   end;
begin
   inherited;
   if aDigit = 0 then
      aDigit := -2;
   if aSKPDigit = 0 then
      aSKPDigit := -4;

   if aSKP.Vymera > 0 then
      aSKP.Vymera := Simple_RoundTo(aSKP.Vymera,aSKPDigit);
   // nalezen porostnch skupin
   ProgressText := PText + ' vyrovnn SKP '+aSKP.Name;
   Application.ProcessMessages;
   QE.Clear;
   // 1) v porostech
   if aSKP.Porosty <> nil then
   for i := 0 to aSKP.Porosty.LastIndex do
   begin
      Por := Tgis_Porost(aSKP.Porosty.Elements[i]);
      if not Por.NoItems then
      for j := 0 to Por.Items.LastIndex do
      begin
         PSK := Tgis_PorostniSkupina(Por.Items.ForestUnit[j]);
         if PSK.NoGeometry then continue;
         if PSK.SkupinaParcel <> aSKP then continue;
         if QE.IndexOf(PSK) < 0 then
            QE.AddElement(PSK);
      end;
   end;
   // 1) ve skupinach
   if aSKP.Skupiny <> nil then
   for i := 0 to aSKP.Skupiny.LastIndex do
   begin
      PSK := Tgis_PorostniSkupina(aSKP.Skupiny.Elements[i]);
      if PSK.NoGeometry then continue;
      if PSK.SkupinaParcel <> aSKP then continue;
      if QE.IndexOf(PSK) < 0 then
         QE.AddElement(PSK);
   end;
   // PredNastaveni vymer a secteni
   SumAre := 0;
   for i := 0 to QE.LastIndex do
   begin
      PSK := Tgis_PorostniSkupina(QE.Elements[i]);
      G := PSK.Geometry;
      if G = nil then continue;
      A := TAreaElement(G);
      if A is TMultiAreaElement then
      begin
         MA := TMultiAreaElement(A);
         for j := 0 to MA.LastIndex do
         begin
            A := MA.AreaElement[j];
            if FillVymeraByPlocha then
               A.FixedArea := Simple_RoundTo(A.Area/10000,aDigit)
            else
               A.FixedArea := 0;
            A.FixedAreaIndex := aSKP.KVAL_P;
            SumAre := SumAre + A.Area;
         end;
      end
      else
      begin
         if FillVymeraByPlocha then
            A.FixedArea := Simple_RoundTo(A.Area/10000,aDigit)
         else
            A.FixedArea := 0;
         A.FixedAreaIndex := aSKP.KVAL_P;
         SumAre := SumAre + A.Area;
      end;
   end;
   //if SumAre = 0 then exit;
   //if aSKP.KVAL_P <> 1 then exit; // nebude se vyrovnvat
   if aSKP.Vymera = 0  then exit; // nebude se vyrovnvat
   // Zjisteni, zda je SKP pokryta cela
   SKPVymera := aSKP.Vymera;
   SKPAre := aSKP.Plocha;
   if QE.NoElements then
   begin
      SKPNoDET.AddAndUpdateRect(aSKP);
      exit;
   end;
   if SKPAre = 0 then
   begin
      SKPZeroArea.AddAndUpdateRect(aSKP);
      exit;
   end;
   SKPAre1 := SumAre;
   SkpAre2 := SKPAre - SKPAre1;
   if (SumAre > 0) and (Abs(SKPAre2) > 10) then  // SKP neni pokryta cela ! musi se predvyrovnat
   begin
      SKPVymera1 := Simple_RoundTo(SKPVymera / SKPAre * SKPAre1,aSKPDigit);
      SKPVymera2 := Simple_RoundTo(SKPVymera / SKPAre * SKPAre2,aSKPDigit);
      DSumAre := SKPVymera - (SKPVymera1+SKPVymera2);
      if DSumAre > 0 then
      begin
         if SKPVymera1 > SKPVymera2 then
            SKPVymera1 := SKPVymera1 + DSumAre
         else
            SKPVymera2 := SKPVymera2 + DSumAre;
      end;
      SKPVymera := SKPVymera1;
      SKPPart.AddAndUpdateRect(aSKP);
   end;
   // zaokrouhleni vymery SKP na stejny pocet mist jako DET
   SKPVymera := Simple_RoundTo(SKPVymera, aDigit);
   for Ai := 0 to 5 do Ares[Ai] := nil;
   SumAre1 := 0;
   refAre := 0;
   DArea := nil;
   for i := 0 to QE.LastIndex do
   begin
      PSK := Tgis_PorostniSkupina(QE.Elements[i]);
      G := PSK.Geometry;
      if G = nil then continue;
      A := TAreaElement(G);
      if A is TMultiAreaElement then
      begin
         MA := TMultiAreaElement(A);
         for j := 0 to MA.LastIndex do
         begin
            A := MA.AreaElement[j];
            A.FixedArea := Simple_RoundTo(SKPVymera / SumAre * A.Area,aDigit);
            SetToAres(A);
            SumAre1 := SumAre1 + A.FixedArea;
         end;
      end
      else
      begin
         A.FixedArea := Simple_RoundTo(SKPVymera / SumAre * A.Area,aDigit);
         SetToAres(A);
         SumAre1 := SumAre1 + A.FixedArea;
      end;
   end;
   // pokud souty nesed, srovnme to.
   SumAre := Simple_RoundTo(SKPVymera-SumAre1,aDigit);
   DSumAre := SumAre;
   SumAre1 := 0;
   for i := 0 to 5 do
      if Ares[i] <> nil then SumAre1 := SumAre1 + Ares[i].Area;
   if (Abs(SumAre)> 0) then
   begin
      for i := 0 to 5 do
      begin
         if Ares[i] = nil then
            AreD[i] := 0
         else
         begin
            AreD[i] := Simple_RoundTo(SumAre / SumAre1 * Ares[i].Area,aDigit);
            Ares[i].FixedArea := Ares[i].FixedArea + AreD[i];
            DSumAre := DSumAre - AreD[i];
         end;
      end;
      if DSumAre <> 0 then
         if Ares[0]<> nil then
            Ares[0].FixedArea := Ares[0].FixedArea + DSumAre;
   end;

   {
   if (Abs(SumAre)> 0) and (DArea <> nil) then
   begin
      DArea.FixedArea := DArea.FixedArea + SumAre;
   end;
   }
   QE.Clear;
end;

procedure TVyrovnani_SKP_DET.SetaDigit(const Value: integer);
begin
  FaDigit := Value;
end;

procedure TVyrovnani_SKP_DET.SetFillVymeraByPlocha(const Value: boolean);
begin
  FFillVymeraByPlocha := Value;
end;

{ TUpgradeParcelModel }

procedure TUpgradeParcelModel.DoIt;
var
   ver: integer;
   i,j,l: integer;
   K: Tgis_Katastr;
   SKP: Tgis_SkupinaParcel;
   P: Tgis_Parcela;
   PC: Tgis_ParcelaCast;
   e: TElement;
   En: TOwnerEntity;
   A: TAreaElement;
   MA: TMultiAreaElement;
   G: TGeometry;
   Prp: TDynamicProperties;
   EOLHID: TTypeELement;
   EOLHPRTIT: TTypeELement;

   procedure ProcessPC;
   var
      pci: integer;
      ip: integer;
      DP: TDynamicProperties;
      TE: TTypeElement;
   begin
      PC := Tgis_ParcelaCast.Create;
      PC.Geometry := A;
      En.AddElement(PC);
      P.AddElement(PC);
      PC.ParZar := P.ParZar;
      PC.KATPAR_KOD := P.KATPAR_KOD;
      PC.Barva := P.Barva;
      PC.Znacka := P.Znacka;
      if P.Properties <> nil then
      begin
         if P.Properties is TDynamicProperties then
         begin
            DP := TDynamicProperties(P.Properties);
            PC.Properties := TDynamicProperties.Create;
            for ip := 0 to DP.LastIndex do
            begin
               TE := TTypeElement(DP.Elements[ip]);
               PC.Properties.SetPropertyStringByName(TE.Name,TE.AsString);
            end;
         end;
      end;
   end;
begin
   if (ParcelModel = nil) or (Areas = nil) then
   begin
      ShowMessage('Upgrade parcely: Hrub chyba - nen nastaven Parcel model nebo vrstva ploch !!!!');
      exit;
   end;
   ver := ParcelModel.Version;
   //if Areas.NoElements then exit;
   //if Areas.Elements[0] is Tgis_ParcelaCast then exit; //to je misto verze, to byla blbost
   if ver = 3 then exit; // verze je v poradku
   if ver = 2 then
   begin
      StartProgress('Upgrade parcel verze 3.0 - LHO',0,Areas.LastIndex);
      if OLHs = nil  then
      begin
         ShowMessage('Upgrade parcely: Hrub chyba - nen nastavena entita OLHs !!!!');
         exit;
      end;
      ParcelModel.Version := 3;
      for i := 0 to Areas.LastIndex do
      begin
         Progress := i;
         Application.ProcessMessages;
         e := Areas.Elements[i];
         if not (e is Tgis_ParcelaCast) then continue;
         PC := Tgis_ParcelaCast(e);
         e := PC.Properties;
         if (e = nil) or not (e is TDynamicProperties)  then
            continue;
         Prp := TDynamicProperties(e);
         e := Prp.FindElementName('OLH_ID');
         if (e = nil) or not (e is TTypeELement) then
            Continue;
         eOLHID := TTypeELement(e);
         eOLHPRTIT := TTypeElement(Prp.FindElementName('OLH_PR_TIT'));
         if EOLHID.AsString <> '' then
         begin
            OLHs.CreateOLH_ID(eOLHID.AsString);
            if EOLHPRTIT <> nil then
               OLHs.ActualOLH.OLH_PR_TIT := EOLHPRTIT.AsString;
            PC.OLH := OLHs.ActualOLH;
         end;
         Prp.FreeElement(EOLHID);
         Prp.FreeElement(EOLHPRTIT);
      end;
      EndProgress;
      exit;
   end;
   // jet kontrola, zda jenom nkdo nezapomnl nastavit verzi
   // pozn se to podle toho, e v Areas jsou Casti parcel a ne parcely
   if not Areas.NoElements then
   begin
      e := Areas.Elements[0];
      if e is Tgis_ParcelaCast then
      begin
         ParcelModel.Version := 2;
         exit;
      end;
   end;
   StartProgress('Upgrade parcel verze 2.0',0,ParcelModel.LastIndex);
   for i := 0 to ParcelModel.LastIndex do
   begin
      e := ParcelModel.Elements[i];
      K := Tgis_Katastr(e);
      Progress := i;
      ProgressText := 'fze 1/2. Katastr: '+K.Name;
      Application.ProcessMessages;
      if K.NoSkupinaParcel then continue;
      for j := 0 to K.SkupinyParcel.LastIndex do
      begin
         e := K.SkupinyParcel.Elements[j];
         SKP := Tgis_SkupinaParcel(e);
         if SKP.NoParcela then continue;
         for l := 0 to SKP.Parcely.LastIndex do
         begin
            e := SKP.Parcely.Elements[l];
            P := Tgis_Parcela(e);
            K.NextParcela := P;
         end;
      end;
   end;
   En := TOwnerEntity.Create;
   MaxProgress := Areas.LastIndex;
   ProgressText := 'fze 2/2';
   for i := Areas.LastIndex downto 0 do
   begin
      Progress := i;
      Application.ProcessMessages;
      e := Areas.Elements[i];
      if not (e is Tgis_Parcela) then continue;
      P := Tgis_Parcela(e);
      if P.NoGeometry then
      begin
         P.Free;
         Continue;
      end;
      if P.Katastr = nil then
      begin
         ParcelModel.CreateKatastrCislo(0);
         ParcelModel.ActualKatastr.NextParcela := P;
      end;
      G := TGeometry(P.Geometry);
      if G is TMultiAreaElement then
      begin
         MA := TMultiAreaElement(G);
         for j := 0 to MA.LastIndex do
         begin
            A := MA.AreaElement[j];
            ProcessPC;
         end;
      end
      else
      begin
         A := TAreaElement(G);
         ProcessPC;
      end;
      P.Geometry := nil;
      P.Properties := nil;
      if P.Count = 1 then   // prenos vymery
      begin
         PC := Tgis_ParcelaCast(P.Elements[0]);
         PC.Vymera := P.Vymera;
      end;
      P.ResetAndUpdate;
   end;
   Areas.FreeAll;
   Areas.AddAllFrom := En;
   En.Free;
   ParcelModel.Version := 2; // nastaveni verze
   ParcelModel.UpdateAll := true;
end;

procedure TUpgradeParcelModel.SetAreas(const Value: TEntity);
begin
  FAreas := Value;
end;

procedure TUpgradeParcelModel.SetOLHs(const Value: TGis_OLHs);
begin
   FOLHs := Value;
end;

procedure TUpgradeParcelModel.SetParcelModel(
  const Value: Tgis_ParcelModel);
begin
  FParcelModel := Value;
end;

{ TKontrola_SKP }

function TKontrola_SKP.GetEr_EmptyKU: TRectEntity;
begin
   result := GetOEEntity('Przdn KU!');
end;

function TKontrola_SKP.GetEr_EmptySKP: TRectEntity;
begin
   result := GetOEEntity('Przdn SKP!');
end;

function TKontrola_SKP.GetEr_KUNoPar: TRectEntity;
begin
   result := GetOEEntity('KU bez PARcel!');
end;

function TKontrola_SKP.GetEr_KUNoSKP: TRectEntity;
begin
   result := GetOEEntity('KU bez SKP!');
end;

function TKontrola_SKP.GetEr_KUNumbering: TRectEntity;
begin
   result := GetOEEntity('slovn SKP!');
end;

function TKontrola_SKP.GetEr_MultiPARCheckSum: TRectEntity;
begin
   result := GetOEEntity('MultiPAR SUM!');
end;

function TKontrola_SKP.GetEr_ParNoKU: TRectEntity;
begin
   result := GetOEEntity('PAR bez KU!');
end;

function TKontrola_SKP.GetEr_ParNoSKP: TRectEntity;
begin
   result := GetOEEntity('PAR bez SKP!');
end;

function TKontrola_SKP.GetEr_SKP0DET: TRectEntity;
begin
   result := GetOEEntity('SKP0 m DET!');
end;

function TKontrola_SKP.GetEr_SKP0Geometry: TRectEntity;
begin
   result := GetOEEntity('SKP0 m Geometrii!');
end;

function TKontrola_SKP.GetEr_SKP0Parzar: TRectEntity;
begin
   result := GetOEEntity('SKP0 obsahuje PARZAR ANO!');
end;

function TKontrola_SKP.GetEr_SKPDETKvalp: TRectEntity;
begin
   result := GetOEEntity('SKP:DET nesoulad KVAL_P!');
end;

function TKontrola_SKP.GetEr_SKPKvalp: TRectEntity;
begin
   result := GetOEEntity('SKP Chybn KVAL_P!');
end;

function TKontrola_SKP.GetEr_SKPNoDET: TRectEntity;
begin
   result := GetOEEntity('SKP nem DET!');
end;

function TKontrola_SKP.GetEr_SKPNoPAR: TRectEntity;
begin
   result := GetOEEntity('SKP neobsahuje PARcely!');
end;

function TKontrola_SKP.GetEr_SKPPart: TRectEntity;
begin
   result := GetOEEntity('SKP st!');
end;

function TKontrola_SKP.GetEr_SKPParzar: TRectEntity;
begin
   result := GetOEEntity('SKP obsahuje PARZAR NE!');
end;

function TKontrola_SKP.GetOEEntity(aName: string): TRectEntity;
begin
   result := TRectEntity(OE.FindOrCreateElementName(TRectEntity,aName));
end;

function TKontrola_SKP.GetSKP_DETCheckSum: TRectEntity;
begin
   result := GetOEEntity('SKP:DET SUM!');
end;

function TKontrola_SKP.GetSKP_PARCheckSum: TRectEntity;
begin
   result := GetOEEntity('SKP:PAR SUM!');
end;

procedure TKontrola_SKP.ProcessBefore;
var
   i: integer;
   e: TElement;
   PC: Tgis_ParcelaCast;
begin
   // chybejici SKP,KU
   if ARE_PAR <> nil then
   begin
      ProgressText := 'Kontrola vrstvy '+ARE_PAR.Name;
      Application.ProcessMessages;
      if ARE_PAR.NoElements then
      begin
         Er_PARNoKU.Name := 'ARE_PAR je przdn!'
      end
      else
      for i := 0 to ARE_PAR.LastIndex do
      begin
         e := ARE_PAR.Elements[i];
         if not (e is Tgis_ParcelaCast) then
         begin
            Er_PARNoKU.Name := 'ARE_PAR neobsahuje parcely, ale '+e.ClassName+' !';
            Break;
         end;
         PC := Tgis_ParcelaCast(e);
         if (PC.Katastr = nil) or (PC.KU_KOD < 1) then
            Er_PARNoKU.AddAndUpdateRect(PC)
         else
         if (PC.SkupinaParcel = nil) or (PC.SKUPAR_CIS < 0) then
            Er_PARNoSKP.AddAndUpdateRect(PC);
      end;
   end
   else
      Er_PARNoKU.Name := 'ARE_PAR nen nastavena!'


end;

procedure TKontrola_SKP.ProcessKU(aKU: Tgis_Katastr);
var
   i,j: integer;
   e: TElement;
   P: Tgis_Parcela;
   //PC: Tgis_ParcelaCast;
   SKP: Tgis_SkupinaParcel;
   //Sum: Double;
   R: TRectEntity;
   aNumber: integer;
   SRT: TSortElementsByInteger;
begin
   aNumber := 0;
   if aKU.NoSkupinaParcel and aKU.NoParcela then
   begin
      Er_EmptyKU.AddAndUpdateRect(aKU);
      exit;
   end;
   if aKU.NoParcela then
   begin
      Er_KUNoPar.AddAndUpdateRect(aKU);
   end
   else
   for i := 0 to aKU.Parcely.LastIndex do
   begin
      P := TGis_parcela(aKU.Parcely.Elements[i]);
      // CheckSum Multiparcel
      //if not P.Multiparcela then continue;
      if Abs(P.Vymera - P.MultiVymera) > 0.00009 then
      begin
         R := TRectEntity.Create;
         R.Name := P.Name + ' V:'+FloatToStr(P.Vymera)+' Sum:'+FloatToStr(P.MultiVymera);
         for j := 0 to P.LastIndex do
         begin
            e := P.Elements[j];
            if not (e is Tgis_ParcelaCast) then continue;
            R.AddAndUpdateRect(e)
         end;
         Er_MultiPARCheckSum.AddAndUpdateRect(R);
      end;
   end;
   if aKU.NoSkupinaParcel then
   begin
      Er_KUNoSKP.AddAndUpdateRect(aKU);
   end
   else
   begin
      R := TRectEntity.Create;
      R.AddAllFrom := aKU.SkupinyParcel;
      SRT := TSortElementsByInteger.Create;
      SRT.Input := R;
      SRT.PropertyName := 'Cislo';
      SRT.DoIt;
      SRT.Free;
      for i := 0 to R.LastIndex do
      begin
         SKP := Tgis_SkupinaParcel(R.Elements[i]);
         if i = 0 then
         begin
            aNumber := SKP.Cislo;
            if (aNumber < 0) or (aNumber > 1) then
            begin
               Er_KUNumbering.AddAndUpdateRect(aKU);
               break;
            end;
         end
         else
         begin
         end;
         if SKP.Cislo <> aNumber then
         begin
            Er_KUNumbering.AddAndUpdateRect(aKU);
            break;
         end;
         Inc(aNumber);
      end;
      R.Free;
   end;
end;

procedure TKontrola_SKP.ProcessSKP(aSkp: Tgis_SkupinaParcel);
var
   i,j: integer;
   NoPar: boolean;
   NoDet: boolean;
   e: TElement;
   P: Tgis_Parcela;
   PC: Tgis_ParcelaCast;
   PARPlocha: double;
   PARVymera: double;
   DETplocha: double;
   DETVymera: double;
   IsParzarANO: boolean;
   IsParzarNE: boolean;
   CastSKP: boolean;
   R: TRectEntity;
begin
   NoPar := aSKP.NoParcela and aSKP.NoParcast;
   NoDet := aSKP.NoPorosty and aSKP.NoSkupiny;
   if NoPar and NoDet then
   begin
      Er_EmptySKP.AddAndUpdateRect(aSKP);
      exit;
   end;
   if NoPar then
   begin
      Er_SKPNoPar.AddAndUpdateRect(aSKP);
      exit;
   end;
   if NoDet and (aSKP.Cislo <> 0) then
   begin
      Er_SKPNoDET.AddAndUpdateRect(aSKP);
   end;
   //Projizdeni parcel (resp.casti)
   PARPlocha := 0;
   PARVymera := 0;
   DETplocha := 0;
   DETVymera := 0;
   IsParzarAno := false;
   IsParzarNe := false;
   if not aSKP.NoParcela then
   begin
      for i := 0 to aSKP.Parcely.LastIndex do
      begin
         P := Tgis_Parcela(aSKP.Parcely.Elements[i]);
         for j := 0 to P.LastIndex do
         begin
            e := P.Elements[j];
            if not (e is Tgis_ParcelaCast) then continue;
            PC := Tgis_ParcelaCast(e);
            if PC.ParZar then
               IsParzarAno := true
            else
               IsParzarNe := true;
         end;
         PARPlocha := PARPlocha + P.Plocha;
         if DontUsePARVYM then
         begin
            for j := 0 to P.LastIndex do
            begin
               e := P.Elements[j];
               if not (e is Tgis_ParcelaCast) then continue;
               PC := Tgis_ParcelaCast(e);
               PARVymera := PARVymera + PC.Vymera;
            end;
         end
         else
         begin
             PARVymera := PARVymera + P.Vymera;
         end;
      end;
   end;
   if not aSKP.NoParcast then
   begin
      for i := 0 to aSKP.ParCasti.LastIndex do
      begin
         PC := Tgis_ParcelaCast(aSKP.ParCasti.Elements[i]);
         if PC.ParZar then
            IsParzarAno := true
         else
            IsParzarNe := true;
         PARPlocha := PARPlocha + PC.Plocha;
         PARVymera := PARVymera + PC.Vymera;
      end;
   end;
   // nezarizovane parcely
   if aSKP.Cislo = 0 then
   begin
      if IsParzarAno then
         Er_SKP0Parzar.AddAndUpdateRect(aSKP);
      if not aSKP.NoGeometry then
         Er_SKP0Geometry.AddAndUpdateRect(aSKP);
      if not NoDET then
         Er_SKP0DET.AddAndUpdateRect(aSKP);
      exit;
   end;
   if IsParzarNe then
      Er_SKPParzar.AddAndUpdateRect(aSKP);
   if Abs(aSKP.Plocha - PARPlocha) > 1 then
   begin
      R := TRectEntity.Create;
      R.Name := aSKP.Name+' P:'+FloatToStr(Simple_RoundTo(aSKP.Plocha,-2))+' SUMp:'+FloatToStr(Simple_RoundTo(PARPlocha,-2));
      R.AddAndUpdateRect(aSKP);
      Er_SKP_PARCheckSum.AddAndUpdateRect(R);
   end;
   if (aSKP.Vymera = 0) and (aSKP.KVAL_P <> 4) then
      Er_SKPKvalp.AddAndUpdateRect(aSKP);
   if aSKP.Vymera > 0 then
   begin
      if Abs(aSKP.Vymera-PARVymera) > 0.0001 then
      begin
         R := TRectEntity.Create;
         R.Name := aSKP.Name+' V:'+FloatToStr(Simple_RoundTo(aSKP.Vymera,-4))+' SUMv:'+FloatToStr(Simple_RoundTo(PARVymera,-4));
         R.AddAndUpdateRect(aSKP);
         Er_SKP_PARCheckSum.AddAndUpdateRect(R);
      end;
   end;
end;

procedure TKontrola_SKP.SetARE_DET(const Value: TEntity);
begin
  FARE_DET := Value;
end;

procedure TKontrola_SKP.SetARE_PAR(const Value: TEntity);
begin
  FARE_PAR := Value;
end;

{ TSolveParcelModelMishMash }

procedure TSolveParcelModelMishMash.DoIt;
var
   i,j,ii: integer;
   K: Tgis_Katastr;
   SKP: Tgis_SkupinaParcel;
   PAR: Tgis_Parcela;
   PARC: Tgis_ParcelaCast;
   PARCi: integer;
   e: TElement;
   M: Tgis_Majitel;
begin
   Error := 0;
   EmptyUnits := 0;
   if (ParcelModel = nil) or not (Input is Tgis_ParcelModel) then
   begin
      ShowMessage('Model Parcel chyb nebo nen modelem Parcel!');
      exit;
   end;
   for i := ParcelModel.LastIndex downto 0 do
   begin
      K := Tgis_Katastr(ParcelModel.Elements[i]);
      if not K.NoParcela then
      for j := K.Parcely.LastIndex downto 0 do
      begin
         PAR := Tgis_Parcela(K.Parcely.Elements[j]);
         PARCi := 0;
         if not PAR.NoElements then
         for ii := PAR.LastIndex downto 0 do
         begin
            e := PAR.Elements[ii];
            if not (e is Tgis_ParcelaCast) then continue;
            PARC := Tgis_ParcelaCast(e);
            if PARC.NoGeometry then
            begin
               M := nil;
               if not PARC.IsKUMajitel then
                  M := PARC.Majitel;
               PARC.Free;
               EmptyUnits := EmptyUnits + 1;
               if (M <> nil) and M.NoElements then
               begin
                  M.Free;
                  EmptyUnits := EmptyUnits + 1;
               end;
               Continue;
            end;
            if PARAreas <> nil then
            if not PARC.IsMyOwner(PARAreas) then
               PARAreas.AddElement(PARC);
            Inc(PARCi)
         end;
         if PARCi = 0 then
         begin
            PAR.Free;
            EmptyUnits := EmptyUnits + 1;
         end;
      end;
      if not K.NoSkupinaParcel then
      for j := K.SkupinyParcel.LastIndex downto 0 do
      begin
         SKP := Tgis_SKupinaParcel(K.SkupinyParcel.Elements[j]);
         if SKP.NoParcela and SKP.NoParcast then
         begin
            SKP.Free;
            EmptyUnits := EmptyUnits + 1;
         end;
      end;
      if K.NoParcela and K.NoSkupinaParcel and K.NoGeometry then
      begin
         K.Free;
         EmptyUnits := EmptyUnits + 1;
      end;
   end;
   //if (Error > 0) or (EmptyUnits > 0) then
   if not SilentMode then
      ShowMessage('V modelu Parcel bylo odstranno '+IntToStr(EmptyUnits)+' przdnch jednotek');
end;

function TSolveParcelModelMishMash.GetParcelModel: Tgis_ParcelModel;
begin
   result := Tgis_ParcelModel(Input);
end;

procedure TSolveParcelModelMishMash.SetEmptyUnits(const Value: integer);
begin
   FEmptyUnits := Value;
end;

procedure TSolveParcelModelMishMash.SetFreeEmptyItems( const Value: boolean);
begin
   FFreeEmptyItems := Value;
   FreeEmptyMajitel := Value;
end;

procedure TSolveParcelModelMishMash.SetFreeEmptyMajitel(
  const Value: boolean);
begin
  FFreeEmptyMajitel := Value;
end;

procedure TSolveParcelModelMishMash.SetPARAreas(const Value: TEntity);
begin
  FPARAreas := Value;
end;

procedure TSolveParcelModelMishMash.SetParcelModel(const Value: Tgis_ParcelModel);
begin
   Input := Value;
end;

procedure TSolveParcelModelMishMash.SetSilentMode(const Value: boolean);
begin
   FSilentMode := value;
end;

{ TJoinParcelModel }

procedure TJoinParcelModel.DoIt;
var
   i,j,ii,jj: integer;
   K,K1: Tgis_Katastr;
   P,P1: Tgis_Parcela;
   PC,PC1: Tgis_ParcelaCast;
   SKP,SKP1: Tgis_SkupinaParcel;
   e: TElement;
   SKP1Cis: integer;
   M,M1: Tgis_Majitel;
begin
   if (ParcelModel = nil) or (ParcelModel1 = nil) then
   begin
      ShowMessage('Chyb jeden z model Parcel pro spojen!');
      exit;
   end;
   FindMajitele;
   for i := 0 to ParcelModel1.LastIndex do
   begin
      K1 := Tgis_Katastr(ParcelModel1.Elements[i]);
      ParcelModel.CreateKatastrCislo(K1.Cislo);
      K := ParcelModel.ActualKatastr;
      if K.Cislo_ <> K1.Cislo_ then
      if K1.Cislo_ > 0 then
         K.Cislo_ := K1.Cislo_;
      if K.Nazev <> K1.Nazev then
      if K1.Nazev <> '' then
         K.Nazev := K1.Nazev;
      if not K1.NoParcela then
      for j := 0 to K1.Parcely.LastIndex do
      begin
          P1 := Tgis_Parcela(K1.Parcely.Elements[j]);
          P := K.CreateParcelaCislo(P1.PARCIS,P1.PARPOD,P1.KATUZE_KOD_PUV,nil);
          for ii := 0 to P1.LastIndex do
          begin
             e := P1.Elements[ii];
             if not (e is Tgis_ParcelaCast) then continue;
             PC1 := Tgis_ParcelaCast(e);
             SKP1 := PC1.SkupinaParcel;
             SKP1Cis := 0;
             if SKP1 <> nil then
                SKP1Cis := SKP1.Cislo;
             if ForestOnly and ((SKP1 = nil) or not SKP1.ForestConnected ) then continue;
             P.Vymera := P1.Vymera;
             P.LV := P1.LV;
             P.Kultura := P1.Kultura;
             P.PUPFL := P1.PUPFL;
             if SKP1 <> nil then
             begin
                if SKPOnly then
                if SKP1Cis <> 0 then
                   SKP1Cis := -SKP1Cis;
                SKP := K.CreateSkupinaParcelCislo(SKP1Cis);
                SKP.Vymera := SKP1.Vymera;
                SKP.KVAL_P := SKP1.KVAL_P;
                SKP.KATPAR_KOD := SKP1.KATPAR_KOD;
             end
             else
                SKP := nil;
             PC := P.GetParCastByXY(PC1.X,PC1.Y);
             if PC = nil then
             begin
                PC := P.CreateParCast;
                PC.Geometry := PC1.Geometry;
             end;
             if Majitele <> nil then
             begin
                if PC1.IsKUMajitel then
                begin
                   M1 := PC1.KUMajitel;
                   M := K.Majitel;
                   K.Majitel := Majitele.CreateMajitelByMajitel(M1);
                end
                else
                begin
                   M := PC.Majitel;
                   M1 := PC1.Majitel;
                   if M1 <> nil then // Majitele resime, jen kdyz ho PC1 ma
                      PC.Majitel := Majitele.CreateMajitelByMajitel(M1);
                end;
             end;
             PC.aID := PC1.aID;
             PC.KATPAR_KOD := PC1.KATPAR_KOD;
             PC.Vymera := PC1.Vymera;
             PC.LVC := PC1.LVC;
             PC.ParZar := PC1.ParZar;
             PC.PUPFLc := PC1.PUPFLc;
             PC.PKCIS  := PC1.PKCIS;
             PC.PKPOD := PC1.PKPOD;
             PC.SuperID := PC1.SuperID;
             PC.Barva := PC1.Barva;
             PC.Znacka := PC1.Znacka;
             PC.PK_Dil := PC1.PK_Dil;
             PC.GP     := PC1.GP;
             PC.Poznamka := PC1.Poznamka;
             PC.KulturaC := PC1.KulturaC;
             PC.NEP := PC1.NEP;
             PC.Zmena := PC1.Zmena;
             if PC1.Properties <> nil then
                PC.Properties := PC1.Properties;
             // dynamicke property !!!
             PC.SkupinaParcel := SKP;
          end;
      end;
   end;
   ParcelModel.UpdateAll := true;
   //ForestModel.Sort := true;
end;

procedure TJoinParcelModel.FindMajitele;
var
   En: TEntity;
   e: TElement;
begin
   Majitele := nil;
   EN := ParcelModel.FindOwnerName('DATA');
   if En = nil then exit;
   e := EN.FindElementClass(Tgis_Majitele);
   if e = nil then exit;
   Majitele := Tgis_Majitele(e);
end;

function TJoinParcelModel.GetParcelModel: Tgis_ParcelModel;
begin
   result := Tgis_ParcelModel(Input);
end;

function TJoinParcelModel.NumberToPropertyName(aNumber: Integer): string;
begin
  case aNumber of
     0: result := 'ParcelModel1';
     1: result := 'ForestOnly';
     2: result := 'SKPOnly';
  end;
end;

procedure TJoinParcelModel.SetForestOnly(const Value: boolean);
begin
  FForestOnly := Value;
end;

procedure TJoinParcelModel.SetMajitele(const Value: Tgis_Majitele);
begin
  FMajitele := Value;
end;

procedure TJoinParcelModel.SetParcelModel(const Value: Tgis_ParcelModel);
begin
   Input := Value;
end;

procedure TJoinParcelModel.SetParcelModel1(const Value: Tgis_ParcelModel);
begin
  FParcelModel1 := Value;
end;

procedure TJoinParcelModel.SetSKPOnly(const Value: boolean);
begin
  FSKPOnly := Value;
end;

{ TDuplicateParcelModelForSelect }

procedure TDuplicateParcelModelForSelect.DoIt;
var
   i: integer;
   e: TElement;
   PC,NPC: Tgis_ParcelaCast;
   PM: Tgis_ParcelModel;
   K: Tgis_Katastr;
   SKP: Tgis_SkupinaParcel;
   P: Tgis_Parcela;
   NewKatastr: boolean;
   NewParcela: boolean;
   NewSKP: boolean;
begin
   PM := ParcelModel;
   if (PM = nil) then
   begin
      ShowMessage('Chyb Model Parcel!');
      exit;
   end;
   if (Select = nil) or Select.NoElements then
      exit;
   for i := 0 to Select.LastIndex do
   begin
      e := Select.Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC := Tgis_ParcelaCast(e);
      // KATASTR
      K := PC.Katastr;
      P := PC.Parcela;
      if P = nil then continue;// nema parcelu, ostuda
      NewKatastr := false;
      if PM.GetKatastrCislo(PC.KU_KOD) = nil then
      begin
         PM.CreateKatastrCislo(PC.KU_KOD);
         NewKatastr := true;
      end;
      if (PM.ActualKatastr <> nil) and (PM.ActualKatastr = K) then
      begin
         ShowMessage('Pokoute se duplikovat model parcel do sebe sama!');
         exit;
      end;
      if NewKatastr and (K <> nil) then
      begin
         PM.ActualKatastr.Cislo_ := K.Cislo_;
         PM.ActualKatastr.Nazev := K.Nazev;
         PM.ActualKatastr.Majitel := GetMajitelCopy(K.Majitel);
      end;
      // Parcela
      NewParcela := false;
      if PM.GetParcelaCislo(P.PARCIS,P.PARPOD,P.KATUZE_KOD_PUV) = nil then
      begin
         PM.CreateParcelaCislo(P.PARCIS,P.PARPOD,P.KATUZE_KOD_PUV);
         NewParcela := true;
      end;
      if NewParcela then
      begin
         PM.ActualParcela.LV := P.LV;
         PM.ActualParcela.Kultura := P.Kultura;
         PM.ActualParcela.PUPFL := P.PUPFL;
         PM.ActualParcela.PK := P.PK;
         PM.ActualParcela.Vymera := P.Vymera;
      end;
      // Cast parcely
      NPC := PM.CreateParCast;
      NPC.LVC := PC.LVC;
      NPC.ParZar := PC.ParZar;
      NPC.PUPFLc := PC.PUPFLc;
      NPC.PKCIS := PC.PKCIS;
      NPC.PKPOD := PC.PKPOD;
      NPC.PK_Dil := PC.PK_Dil;
      NPC.SuperID := PC.SuperID;
      NPC.PK := PC.PK;
      NPC.Vymera := PC.Vymera;
      NPC.KATPAR_KOD := PC.KATPAR_KOD;
      NPC.Barva := PC.Barva;
      NPC.Znacka := PC.Znacka;
      NPC.Geometry := PC.Geometry;
      NPC.Properties := PC.Properties;
      if PARAreas <> nil then
         PARAreas.AddElement(NPC);
      if not PC.IsKUMajitel then
      begin
         NPC.Majitel := GetMajitelCopy(PC.Majitel);
      end;
      // SKupina parcel az na konec
      SKP := PC.SkupinaParcel;
      NewSKP := false;
      if SKP <> nil then
      begin
         if PM.GetSkupinaParcelCislo(SKP.Cislo)=nil then
         begin
            PM.CreateSkupinaParcelCislo(SKP.Cislo);
            NewSKP := true;
         end;
         if NewSKP then
         begin
            PM.ActualSkupinaParcel.Comment := SKP.Comment;
            PM.ActualSkupinaParcel.Vymera := SKP.Vymera;
            PM.ActualSkupinaParcel.KATPAR_KOD := SKP.KATPAR_KOD;
            PM.ActualSkupinaParcel.KVAL_P := SKP.KVAL_P;
            PM.ActualSkupinaParcel.Barva := SKP.Barva;
            PM.ActualSkupinaParcel.Znacka := SKP.Znacka;
         end;
         SKP := PM.ActualSkupinaParcel;
      end;
      NPC.SkupinaParcel := SKP;
   end;
   PM.UpdateAll := true;
   if (PARAreas <> nil) and (PARAreas is TRectEntity) then
      TRectEntity(PARAreas).Update;
end;

function TDuplicateParcelModelForSelect.GetMajitelCopy(const aMajitel: Tgis_Majitel): Tgis_Majitel;
begin
   result := nil;
   if Majitele = nil then
      exit;
   if aMajitel = nil then
      exit;
   result := Majitele.GetMajitelCislo(aMajitel.Cislo);
   if result = nil then // vytvoreni noveho majitele
   begin
      result := Majitele.CreateMajitelCislo(aMajitel.Cislo);
      result.MAJ_DRUH := aMajitel.MAJ_DRUH;
      result.MAJ_KOD := aMajitel.MAJ_KOD;
      result.Jmeno := aMajitel.Jmeno;
      result.Prijmeni := aMajitel.Prijmeni;
      result.Adresa := aMajitel.Adresa;
      result.Comment := aMajitel.Comment;
      result.FixMaj := aMajitel.FixMaj;
      result.SwapJmeno := aMajitel.SwapJmeno;
      result.FullNameToName := aMajitel.FullNameToName;
      result.AdresaToName := aMajitel.AdresaToName;
   end;
end;

function TDuplicateParcelModelForSelect.NumberToPropertyName(aNumber: Integer): string;
begin
  case aNumber of
     0: result := 'Select';
     1: result := 'Majitele';
     2: result := 'PARAreas';
     3: result := 'ForestOnly';
  end;
end;



procedure TDuplicateParcelModelForSelect.SetPARAreas(const Value: TEntity);
begin
  FPARAreas := Value;
end;

procedure TDuplicateParcelModelForSelect.SetSelect(const Value: TEntity);
begin
  FSelect := Value;
end;


{ TVyrovnani_SKP_ARES }

procedure TVyrovnani_SKP_ARES.DoIt;
var
   TQ: TAddEntityToQTree;
   i: integer;
   E: TElement;
begin
   if Ares = nil then
   begin
      Ares := SKPNoARES;
      exit;
   end;
   QTree :=TRectEntityQTree.Create;
   QTree.Name := 'ARES QT';
   AddElement(QTree);
   TQ := TAddEntityToQTree.Create;
   TQ.Input := Ares;
   TQ.Output := QTree;
   TQ.DoIt;
   TQ.Free;
   inherited;
   FindNotSolvedAres;
end;

procedure TVyrovnani_SKP_ARES.FindNotSolvedAres;
var
   i,j: integer;
   e: TElement;
   GE: TGeometryElement;
   G: TGeometry;
   A: TAreaElement;
   MA: TMultiAreaElement;
begin
   for i := 0 to Ares.LastIndex do
   begin
      e := Ares.Elements[i];
      if e is TGeometryElement then
      begin
         GE := TGeometryElement(e);
         G := GE.Geometry;
         if G <> nil then
         begin
            A := TAreaElement(G);
            if A is TMultiAreaElement then
            begin
               MA := TMultiAreaElement(A);
               for j := 0 to MA.LastIndex do
               begin
                  A := MA.AreaElement[j];
                  if not A.IsMyOwner(SKPSolvedAres) then
                     SKPNotSolvedAres.AddAndUpdateRect(A);
               end;
            end
            else
            begin
               if not A.IsMyOwner(SKPSolvedAres) then
                  SKPNotSolvedAres.AddAndUpdateRect(A);
            end;
         end;
      end;
   end;
   SKPSolvedAres.Free;
   FSKPSolvedAres := nil;
end;

function TVyrovnani_SKP_ARES.GetQE: TQuickEntity;
begin
   if FQE = nil then
   begin
      FQE := TQuickEntity.Create;
      AddElement(FQE);
   end;
   result := FQE;
end;

function TVyrovnani_SKP_ARES.GetSKPNoARES: TRectEntity;
begin
   if FSKPNoARES = nil then
   begin
      FSKPNoARES := TRectEntity.Create;
      FSKPNoARES.Name := 'CHyb AREs';
      OE.AddElement(FSKPNoARES);
   end;
   result := FSKPNoAres;
end;

function TVyrovnani_SKP_ARES.GetSKPNotSolvedAres: TRectEntity;
begin
   if FSKPNotSolvedAres = nil then
   begin
      FSKPNotSolvedAres := TRectEntity.Create;
      FSKPNotSolvedAres.Name := 'Neoeten plochy';
      OE.AddElement(FSKPNotSolvedAres);
   end;
   result := FSKPNotSolvedAres;
end;

function TVyrovnani_SKP_ARES.GetSKPPart: TRectEntity;
begin
   if FSKPPart = nil then
   begin
      FSKPPart := TRectEntity.Create;
      FSKPPart.Name := 'st SKP';
      OE.AddElement(FSKPPart);
   end;
   result := FSKPPart;
end;

function TVyrovnani_SKP_ARES.GetSKPPostError: TRectEntity;
begin
   if FSKPPostError = nil then
   begin
      FSKPPostError := TRectEntity.Create;
      FSKPPostError.Name := 'Post Error';
      OE.AddElement(FSKPPostError);
   end;
   result := FSKPPostError;
end;

function TVyrovnani_SKP_ARES.GetSKPSolvedAres: TRectEntity;
begin
   if FSKPSolvedAres = nil then
   begin
      FSKPSolvedAres := TRectEntity.Create;
      FSKPSolvedAres.Name := 'Solved';
      OE.AddElement(FSKPSolvedAres);
   end;
   result := FSKPSolvedAres;
end;

function TVyrovnani_SKP_ARES.GetSKPZeroArea: TRectEntity;
begin
   if FSKPZeroArea = nil then
   begin
      FSKPZeroArea := TRectEntity.Create;
      FSKPZeroArea.Name := 'Plocha 0';
      OE.AddElement(FSKPZeroArea);
   end;
   result := FSKPZeroArea;
end;

procedure TVyrovnani_SKP_ARES.ProcessSKP(aSkp: Tgis_SkupinaParcel);
var
   i,j,Ai: integer;
   Por: Tgis_Porost;
   GE: TGeometryElement;
   G: TGeometry;
   A,DArea: TAreaElement;
   E: TElement;
   refAre: double;
   MA: TMultiAreaElement;
   SumAre,dSumAre,SumAre1: double;
   SKPAre,SKPAre1,SKPAre2: double;
   SKPVymera,SKPVymera1,SKPVymera2: double;
   Ares_: Array[0..5]of TAreaElement;
   AreD: Array[0..5]of double;
   QTW: TQTreeWalker;
   RE: TRectEntity;

   procedure SetToAres_(Are: TAreaElement);
   var
      ii,ij: integer;
   begin
      for ii := 0 to 5 do
      begin
         if Ares_[ii] = nil then
         begin
            Ares_[ii] := Are;
            exit;
         end
         else
         begin
            if Are.Area > Ares_[ii].Area then
            begin
               for ij := 5 downto ii + 1  do
                  Ares_[ij] := Ares_[ij - 1];
               Ares_[ii] := Are;
            end;
         end;
      end;
   end;
begin
   inherited;
   if aDigit = 0 then
      aDigit := -2;
   if aSKPDigit = 0 then
      aSKPDigit := -4;

   if aSKP.Vymera > 0 then
      aSKP.Vymera := Simple_RoundTo(aSKP.Vymera,aSKPDigit);
   // nalezen ploch
   ProgressText := PText + ' vyrovnn SKP '+aSKP.Name;
   Application.ProcessMessages;
   QE.Clear;
   QTW := TQTreeWalker.Create;
   e := QTW.GetFirstElementForRectangle(QTree,aSKP.Minx,aSKP.MinY,aSKP.MaxX,aSKP.MaxY,0);
   while e <> nil do
   begin
      if e is TGeometryElement then
      begin
         GE := TGeometryElement(e);
         G := GE.Geometry;
         if G <> nil then
         begin
            A := TAreaElement(G);
            if A is TMultiAreaElement then
            begin
               MA := TMultiAreaElement(A);
               for j := 0 to MA.LastIndex do
               begin
                  A := MA.AreaElement[j];
                  if QE.IndexOf(A) < 0 then
                  begin
                     if aSKP.IsHitByXY(A.X,A.Y,0) then
                     begin
                        QE.AddElement(A);
                        SKPSolvedAres.AddElement(A);
                     end;
                  end;
               end;
            end
            else
            begin
               if QE.IndexOf(A) < 0 then
               begin
                  if aSKP.IsHitByXY(A.X,A.Y,0) then
                  begin
                     QE.AddElement(A);
                     SKPSolvedAres.AddElement(A);
                  end;
               end;
            end;
         end;
      end;
      e := QTW.GetNextElement;
   end;
   QTW.Free;
   // PredNastaveni vymer a secteni
   SumAre := 0;
   for i := 0 to QE.LastIndex do
   begin
      A := TAreaElement(QE.Elements[i]);
      if FillVymeraByPlocha then
         A.FixedArea := Simple_RoundTo(A.Area/10000,aDigit)
      else
         A.FixedArea := 0;
      A.FixedAreaIndex := aSKP.KVAL_P;
      SumAre := SumAre + A.Area;
   end;
   //if SumAre = 0 then exit;
   //if aSKP.KVAL_P <> 1 then exit; // nebude se vyrovnvat
   // Zjisteni, zda je SKP pokryta cela
   SKPVymera := aSKP.Vymera;
   SKPAre := aSKP.Plocha;
   if QE.NoElements then
   begin
      if aSKP.Cislo > 0 then
         SKPNoARES.AddAndUpdateRect(aSKP);
      QE.Clear;
      exit;
   end;
   if SKPAre = 0 then
   begin
      if aSKP.Cislo > 0 then
         SKPZeroArea.AddAndUpdateRect(aSKP);
      QE.Clear;
      exit;
   end;
   if aSKP.Vymera = 0  then
   begin
      QE.Clear;
      exit; // nebude se vyrovnvat
   end;
   SKPAre1 := SumAre;
   SkpAre2 := SKPAre - SKPAre1;
   if (SumAre > 0) and (Abs(SKPAre2) > 10) then  // SKP neni pokryta cela ! musi se predvyrovnat
   begin
      SKPVymera1 := Simple_RoundTo(SKPVymera / SKPAre * SKPAre1,aSKPDigit);
      SKPVymera2 := Simple_RoundTo(SKPVymera / SKPAre * SKPAre2,aSKPDigit);
      DSumAre := SKPVymera - (SKPVymera1+SKPVymera2);
      if DSumAre > 0 then
      begin
         if SKPVymera1 > SKPVymera2 then
            SKPVymera1 := SKPVymera1 + DSumAre
         else
            SKPVymera2 := SKPVymera2 + DSumAre;
      end;
      SKPVymera := SKPVymera1;
      SKPPart.AddAndUpdateRect(aSKP);
   end;
   // zaokrouhleni SKPVymera na vyslednou presnost
   // jen je-li pocet desetin mensi
   SKPVymera:=Simple_RoundTo(SKPVymera,aDigit);
   for Ai := 0 to 5 do Ares_[Ai] := nil;
   SumAre1 := 0;
   refAre := 0;
   DArea := nil;
   for i := 0 to QE.LastIndex do
   begin
      A := TAreaElement(QE.Elements[i]);
      A.FixedArea := Simple_RoundTo(SKPVymera / SumAre * A.Area,aDigit);
      SetToAres_(A);
      SumAre1 := SumAre1 + A.FixedArea;
   end;
   // pokud souty nesed, srovnme to.
   SumAre :=  SKPVymera-SumAre1;
   DSumAre := SumAre;
   SumAre1 := 0;
   for i := 0 to 5 do
      if Ares_[i] <> nil then SumAre1 := SumAre1 + Ares_[i].Area;
   if (Abs(SumAre)> 0) then
   begin
      for i := 0 to 5 do
      begin
         if Ares_[i] = nil then
            AreD[i] := 0
         else
         begin
            AreD[i] := Simple_RoundTo(SumAre / SumAre1 * Ares_[i].Area,aDigit);
            Ares_[i].FixedArea := Ares_[i].FixedArea + AreD[i];
            DSumAre := DSumAre - AreD[i];
         end;
      end;
      if DSumAre <> 0 then
         if Ares_[0]<> nil then
            Ares_[0].FixedArea := Ares_[0].FixedArea + DSumAre;
   end;

   // post error
   SumAre1 := 0;
   for i := 0 to QE.LastIndex do
   begin
      A := TAreaElement(QE.Elements[i]);
      SumAre1 := SumAre1 + A.FixedArea;
   end;
   // pokud souty nesed, je to blb to.
   SumAre := Simple_RoundTo(Abs(SKPVymera-SumAre1),aDigit);
   if SumAre <> 0 then
   begin
      RE:=TRectEntity.Create;
      RE.Name:=FLoatToStr(SumAre);
      RE.AddAndUpdateRect(aSKP);
      MA:=TMultiAreaElement.Create;
      for i := 0 to QE.LastIndex do
      begin
         A := TAreaElement(QE.Elements[i]);
         MA.AddAndUpdateRect(A);
      end;
      RE.AddAndUpdateRect(MA);
      SKPPostError.AddAndUpdateRect(RE);
   end;
   // post error end
   QE.Clear;
end;

procedure TVyrovnani_SKP_ARES.SetaDigit(const Value: integer);
begin
  FaDigit := Value;
end;

procedure TVyrovnani_SKP_ARES.SetAres(const Value: TEntity);
begin
  FAres := Value;
end;

procedure TVyrovnani_SKP_ARES.SetFillVymeraByPlocha(const Value: boolean);
begin
  FFillVymeraByPlocha := Value;
end;

procedure TVyrovnani_SKP_ARES.SetQTree(const Value: TRectEntityQTree);
begin
  FQTree := Value;
end;



INITIALIZATION
   RegisterOrbisClass(TSetPSKColorByKatastr);
   RegisterOrbisClass(TRenumberSkupinyParcel);
   RegisterOrbisClass(TFindParcelyNoParZar);
   RegisterOrbisClass(TFindAreasWithLinePresnost);
   RegisterOrbisClass(TFindMultiAreas);
   RegisterOrbisClass(TFindSKPInParcelModel);
   RegisterOrbisClass(TVyrovnani_SKP_DET);
   RegisterOrbisClass(TVyrovnani_SKP_ARES);
   RegisterOrbisClass(TKontrola_SKP);
   RegisterOrbisClass(TJoinParcelModel);
   RegisterOrbisClass(TDuplicateParcelModelForSelect);
   RegisterOrbisClass(TSolveParcelModelMishMash);
   RegisterOrbisClass(TUpgradeParcelModel);
END.
