unit I_garea;
{
********************************************************
**                                                    **
**                    ORBIS                           **
**     Skupina interpretr Topolovskch ploch         **
**                                                    **
********************************************************
}


interface

uses
   Graphics,
   Elements,
   e_Device,
   e_Pale,
   e_PlZn,
   //e_Space,
   e_Geometry,
   g_Elems,
   i_GSC,
   t_ITable,
   T_Recurs,
   T_SetEc,
   Tools;



type
{
Hierarchie:
I_GArea:  TGeneralAreaInterpret
I_GSC:    TGeneralSymbolColorInterpret
I_Gener:  TGeneralBrushInterpret
I_Gener:  TGeneralXYInterpret
I_Gener:  TGeneralColorInterpret (ColorByTopol: boolean)
I_Gener:  TGeneralInterpret


Jak pracuje:
    Alespo nco mus bt vdy nastaveno, jinak nic nevykresl
Barva:
   Topolsk vykreslovn:
    ColorByTopol:= true;
    PropColor:= 'BARVA';
    PropBrush:= 'ZNACKA';

}


TGeneralAreaInterpret = class(TGeneralSymbolColorInterpret)
private
   FFillBackground: boolean;
   PlosneZnacky: TPlosneZnacky;
   //Rect: TDoubleRect;
protected
   procedure Process(Element: TElement); override;
   function  IsItsClass(AObject: TObject): boolean; override;
   function  QGoInside(Element: TElement): boolean; override;
   function  QProcessBefore(Element: TElement): boolean; override;
   procedure ProcessAsUserDefinedPattern(aTopPlocha: TAreaElement; anOrigArea: TElement; aZnacka, aColor: integer);
public
   function   CanUniGoInside(Element: TElement): boolean; override;
   procedure  Reset(aDevice: TDevice); override;
   procedure  Close; override;
published
   property   FillBackground: boolean read FFillBackground write FFillBackground;
end;



implementation

uses
   WinTypes,
   WinProcs,
   Dialogs,
   SysUtils,
   ClipArea,
   e_Class,
   E_Color,
   e_GeometryElement,
   u_Symbol,
   e_TopolElements;


{ TGeneralAreaInterpret }


{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!11}
procedure TGeneralAreaInterpret.
          ProcessAsUserDefinedPattern(aTopPlocha: TAreaElement; anOrigArea: TElement; aZnacka, aColor: integer);
var
   Srafa: TPlosnaZnacka;
   Coords, Lengths: pointer;
   aSize, LNumber: integer;
begin
   if aTopPlocha.IsHole then exit;

   Srafa := PlosneZnacky.VratZnackuDleKodu(aZnacka);

   if not assigned(Srafa) then exit;

   Srafa.ExternalColor := aColor;

   if SymbolColorTool <> nil then
   begin
     SymbolColorTool.Input:= Srafa;
     SymbolColorTool.FillBackGround := FillBackGround;
     SymbolColorTool.Palette:= Palette;
     SymbolColorTool.PropColor:=  PropColor;
     SymbolColorTool.ToolColor:= ToolColor;
     SymbolColorTool.Color:= Color;
     SymbolColorTool.UseColor:= UseColor;
     SymbolColorTool.ColorByTopol:= ColorByTopol;
     SymbolColorTool.ColorByPalette:= ColorByPalette;
     SymbolColorTool.Elem:= anOrigArea;
     SymbolColorTool.DoIt
   end;

   Device.PrepareForPolyPolygon(aTopPlocha,Coords,Lengths,aSize,LNumber);
   Srafa.VyplnPlochu(Device, TByteArray(Coords^)[0], TLengthArray(Lengths^)[0], LNumber, aTopPlocha.MinX, aTopPlocha.MaxY);
   freeMem(Coords, aSize);
   freeMem(Lengths, LNumber*sizeOf(TLengthItem));

end;



procedure TGeneralAreaInterpret.Process(Element: TElement);
var
  PlochaBoundary,
  OrigArea,
  NPlocha: TAreaElement;
  aTP: TTopolAreaELement;
  //P: Wintypes.TPoint;
  Barva, Znacka: integer;
  aExColor: integer;
  SimpleArea: boolean;
begin
  NPlocha:= nil;
  try
    aTP := TTopoLAreaElement(Element);
    PlochaBoundary := TAreaElement(aTP.Geometry);
    OrigArea := PlochaBoundary;
    SimpleArea := true;
    if PlochaBoundary is TPolyLineAreaElement then
    begin
      NPlocha:= TPolyLineAreaElement(PlochaBoundary).CreateAreaElement;
      PlochaBoundary:= NPlocha;
      SimpleArea := false;
    end;

    if PlochaBoundary.WholeArea > 0 then
    begin
      if UseColor then
         Barva:= Color
      else
      if ToolColor <> nil then
      begin
         ToolColor.Input := Element;
         ToolColor.DoIt;
         Barva := StrToInt(ToolColor.Result);
      end
      else
      {
      if PropColor = '' then Barva := clWhite
                        else Barva  := StrToInt(Element.GetPropertyStringByName(PropColor));
      }
      if PropColor = '' then Barva := clWhite
      else
      begin
         CommandLine.ActiveElement := Element;
         CommandLine.Lines.Clear;
         CommandLine.Line := PropColor;
         CommandLine.DoIt;
         Barva  := StrToInt(CommandLine.ResultLine);
      end;

      if UseBrush then
      begin
        Znacka:= Brush;
      end
      else
      if ToolBrush <> nil then
      begin
         ToolBrush.Input := Element;
         ToolBrush.DoIt;
         Znacka := StrToInt(ToolBrush.Result);
      end
      else
      if PropBrush = '' then Znacka := longInt(bsSolid)
                        else Znacka := StrToInt(Element.GetPropertyStringByName(PropBrush));

      if Znacka > 999 then
      begin
         if (Barva > -1) and ColorByPalette then
            aExColor := Palette.Color[Barva]
         else
            if (Barva < 0) or  ColorByTopol then
               aExColor := DejBarvicku(Barva)
            else
               aExColor := Barva;
        if NPlocha <> nil then
          ProcessAsUserDefinedPattern(NPlocha, aTP, Znacka, aExColor)
        else
          ProcessAsUserDefinedPattern(PlochaBoundary, aTP, Znacka, aExColor);
      end
      else
      begin
         if (Barva > -1) and ColorByPalette then
            Device.Brush.Color := Palette.Color[Barva]
         else
            if (Barva < 0) or ColorByTopol then
               Device.Brush.Color := DejBarvicku(Barva)
            else
               Device.Brush.Color := Barva;
         if SimpleArea then
         begin
            Device.Pen.Style:= psSolid;
            Device.Pen.Color:= 0;
            Device.Pen.Width:= 1;
         end
         else Device.Pen.Style:= psClear;
         Device.Brush.Style:= bsSolid{TBrushStyle(Znacka)};
         Device.PolyPolygon(PlochaBoundary)
      end;
    end;
{ Kek ? }

    if (NPlocha <> nil) then
    begin
    { POZOR ! nerusit souradnice !}
    {
      NPlocha.Clear;
    }
      NPlocha.Free
    end;
    {
    inherited Process(Element);
    }
  except
//      MessageBeep(Word(-1));
  end;
end;



function  TGeneralAreaInterpret.IsItsClass(AObject: TObject): boolean;
begin
   result := (AObject is TAreaCollection) or (AObject is TTopoLAreaElement);
end;



function  TGeneralAreaInterpret.QGoInside(Element: TElement): boolean;
begin

  Result:=(*
   ((Element is TTopolPlochy) {and ScaleOK(Element)})
           or
           ((Element is TTopolNadPlocha)
             and (TTopolNadPlocha(Element).SubAreasCount > 0))
           or (Element is TSubAreas)
           *)false;
end;



function  TGeneralAreaInterpret.QProcessBefore(Element: TElement): boolean;
var
  ModelLength: double;
begin
  result:= false;
  if (Element is TAreaCollection) then
  begin
    {
    OwnerProps:= TAreaString(Element).Properties;
    }
{
     UseColor := Element.GetPropertyBooleanByName('USECOLOR');
     Color :=    Element.GetPropertyLongIntByName('COLOR');
     UseSymbol:= Element.GetPropertyBooleanByName('USESYMBOL');
     Symbol := Element.GetPropertyBooleanByName('SYMBOL');
}
     exit;
  end;

  if not (Element is TTopoLAreaElement) then exit;
  if TTopoLAreaElement(Element).NoGeometry then exit;
  try
    ModelLength:= Device.Projection.GetModelLength(3);

    if TAreaElement(TTopoLAreaElement(Element).Geometry).GetMaxLength < ModelLength then exit;

    if not TTopoLAreaElement(Element).IsOverRegion
            (Rect.MinX,Rect.MinY,Rect.MaxX,Rect.MaxY) then exit;
    Result:= true

  except
  end;
end;


procedure   TGeneralAreaInterpret.Reset(aDevice: TDevice);
begin
   inherited Reset(aDevice);
   //Rect := Device.Projection.ModelView;
   if SymbolsFile = '' then
      SymbolsFile:= PathOfLibraries+'\Srafy.txt';

   PlosneZnacky := TPlosneZnacky.CreateAll(SymbolsFile);
   PlosneZnacky.Device := Device;
end;

procedure   TGeneralAreaInterpret.Close;
begin
   if PlosneZnacky <> nil then
   begin
      PlosneZnacky.Free;
      PlosneZnacky := nil;
   end;
   inherited Close;
end;


function  TGeneralAreaInterpret.CanUniGoInside(Element: TElement): boolean;
begin
   result := (Element is TAreaCollection) and
      TAreaCollection(Element).IsOverRegion
               (Rect.MinX,Rect.MinY,Rect.MaxX,Rect.MaxY);
end;



BEGIN
   RegisterOrbisClass(TGeneralAreaInterpret);
END.
