unit T_VieMap;

interface
uses
  Elements, Tools, T_InterA, E_Map, E_DeskTp;

type

TMapViewer = class(TTechnology)
private
  FMap: TDeskTop;
  FFormToolManager: TFormToolManager;

public
   procedure  on_tm_QuitTask; override;
   procedure   on_tm_EndTask(var aMessage: TOrbisMessage; var Handled: boolean); override;
   procedure   DoIt; override;
end;

implementation

uses
   Graphics,
   M_Orbis;



procedure   TMapViewer.on_tm_QuitTask;
begin
  inherited on_tm_QuitTask
end;

procedure   TMapViewer.on_tm_EndTask(var aMessage: TOrbisMessage; var Handled: boolean);
begin
  inherited on_tm_EndTask(aMessage, Handled);
  if FMap <> nil then
  begin
{     FMap.FastFreeAll; }
     FreeElement(FMap);
  end;
  PostMsgToOwners(tm_EndTask, Self, DontKill);
end;


procedure TMapViewer.DoIt;
begin
  if not (Input is TDeskTop) then exit;
  FMap:= TDeskTop(Input);
  AddElement(FMap);
  FFormToolManager:= TFormToolManager.Create;
  FFormToolManager.Device.Page.Color:= clSilver;
  AddTool(FFormToolManager);
  FFormToolManager.Input:= Input;
  FFormToolManager.DoIt;
end;


end.
