unit E_zm;

interface
uses
   Graphics,
   Elements,
   AnalInt,
   g_Elems,
   i_Basic,
   Tools;

type


TMapsZM = class(TRectEntity)
private
  FColor: TColor;
  FPenWidth: double;
  FPenStyle: TPenStyle;
  FScale   : longInt;
  FMap200: longInt;
  FMap100: longInt;
  FMap50: longInt;
  FMap25: longInt;
  FMap10: longInt;

  function GetXCorn(aIndex: longInt): double;
  function GetYCorn(aIndex: longInt): double;
  function Index200OK(aIndex200: longInt): boolean;
  procedure SetMap200(aIndex: longInt);
  procedure SetMap100(aIndex: longInt);
  procedure SetMap50(aIndex: longInt);
  procedure SetMap25(aIndex: longInt);
  procedure SetMap10(aIndex: longInt);
  function GetMapName: string;
  procedure SetMapName(aName: string);
  procedure SetScale(aScale: longInt);
  function  GetAngle: double;
protected
   function GetZMCenterX: double;
   function GetZMCenterY: double;

public
  FCorns200: TCorns;
  FCorns100: TCorns;
  FCorns50: TCorns;
  FCorns25: TCorns;
  FCorns10: TCorns;

  constructor Create; override;
  property XCorn[aIndex: longInt]: double read GetXCorn;
  property YCorn[aIndex: longInt]: double read GetYCorn;
  function GetNameByCoords(X, Y: double): string;
published
  property Color: TColor read FColor write FColor;
  property PenWidth: double read FPenWidth write FPenWidth;
  property PenStyle: TPenStyle read FPenStyle write FPenStyle;
  property Scale   : longInt read FScale write SetScale;
  property Map200: longInt read FMap200 write SetMap200;
  property Map100: longInt read FMap100 write SetMap100;
  property Map50: longInt read FMap50 write SetMap50;
  property Map25: longInt read FMap25 write SetMap25;
  property Map10: longInt read FMap10 write SetMap10;
  property ZMCenterX: double read GetZMCenterX stored false;
  property ZMCenterY: double read GetZMCenterY stored false;
  property MapName: string read GetMapName write SetMapName stored false;
  property Angle: double read GetAngle stored false;
end;



TInterpretZM = class(TInterpret)
private
   Rect: TRectangle; {Zjisteny model obdelnik }

   function IsOverCorns(aCorns: TCorns): boolean;
   procedure DrawCorns(aCorns: TCorns);
 protected
   procedure Process(Element: TElement); override;
   function  IsItsClass(AObject: TObject): boolean; override;
   function  QProcessBefore(Element: TElement): boolean; override;
 public
   procedure   DoIt; override;
end;


function CreateRectangleFromCorns(aCorns: TCorns): TRectangle;

function GetZMName(aScale, aX, aY: double) : string;


implementation
uses
  SysUtils, Dialogs,
  E_Class,
  U_String, MathLib;

const
  RohyZM200: array[1..58] of TXY =
  (
  (X: 909652.431; Y:898025.984),  {1}
  (X: 924005.960; Y:805128.319),  {2}

  (X: 936890.985; Y:712015.612),  {3}
  (X: 948304.295; Y:618711.076),  {4}
  (X: 958243.045; Y:525237.972),  {5}
  (X:      0.0  ; Y:     0.0  ),  {6}
  (X:      0.0  ; Y:     0.0  ),  {7}
  (X:      0.0  ; Y:     0.0  ),  {8}
  (X:      0.0  ; Y:     0.0  ),  {9}
  (X:      0.0  ; Y:     0.0  ), {10}
  (X: 984669.564; Y:910223.928), {11}
  (X: 999206.329; Y:816140.335), {12}
  (X:1012255.843; Y:721838.956), {13}
  (X:1023814.856; Y:627343.298), {14}
  (X:1033880.484; Y:532676.920), {15}
  (X:1042450.217; Y:437863.421), {16}
  (X:      0.0  ; Y:     0.0  ), {17}
  (X:      0.0  ; Y:     0.0  ), {18}
  (X:      0.0  ; Y:     0.0  ), {19}
  (X:      0.0  ; Y:     0.0  ), {20}
  (X:1059686.696; Y:922421.873), {21}
  (X:1074406.698; Y:827152.352), {22}
  (X:1087620.702; Y:731662.299), {23}
  (X:1099325.417; Y:635975.520), {24}
  (X:1109517.920; Y:540115.869), {25}
  (X:1118195.676; Y:444107.241), {26}
  (X:1125356.520; Y:347973.572), {27}
  (X:1130998.67 ; Y:251738.83 ), {28}
  (X:1135120.70 ; Y:155427.00 ), {29}
  (X:      0.0  ; Y:     0.0  ), {30}
  (X:1134703.829; Y:934619.816), {31}
  (X:1149607.067; Y:838164.368), {32}
  (X:1162985.561; Y:741485.642), {33}
  (X:1174835.977; Y:644607.742), {34}
  (X:1185155.360; Y:547554.817), {35}
  (X:1193941.137; Y:450351.061), {36}
  (X:1201191.119; Y:353020.707), {37}
  (X:1206903.50 ; Y:255588.02 ), {38}
  (X:1211076.85 ; Y:158077.29 ), {39}
  (X:      0.0  ; Y:     0.0  ), {40}
  (X:      0.0  ; Y:     0.0  ), {41}
  (X:1224807.436; Y:849176.384), {42}
  (X:1238350.418; Y:751308.986), {43}
  (X:1250346.538; Y:653239.964), {44}
  (X:1260792.797; Y:554993.765), {45}
  (X:1269686.596; Y:456594.881), {46}
  (X:1277025.72 ; Y:358067.84 ), {47}
  (X:1282808.33 ; Y:259437.21 ), {48}
  (X:1287033.00 ; Y:160727.58 ), {49}
  (X:      0.0  ; Y:     0.0  ), {50}
  (X:      0.0  ; Y:     0.0  ), {51}
  (X:      0.0  ; Y:     0.0  ), {52}
  (X:      0.0  ; Y:     0.0  ), {53}
  (X:1325857.10 ; Y:661872.19 ), {54}
  (X:1336430.24 ; Y:562432.71 ), {55}
  (X:1345432.06 ; Y:462838.70 ), {56}
  (X:1352860.32 ; Y:363114.98 ), {57}
  (X:1358713.16 ; Y:263286.40 )  {58}
);

constructor TMapsZM.Create;
var
  I: longInt;
begin
  inherited Create;
  FScale:= 200000;
  for I:= 1 to 58 do
  begin
    Map200:= I;
    Rect.UpdateByXY(FCorns200[1].X, FCorns200[1].Y);
    Rect.UpdateByXY(FCorns200[2].X, FCorns200[2].Y);
    Rect.UpdateByXY(FCorns200[3].X, FCorns200[3].Y);
    Rect.UpdateByXY(FCorns200[4].X, FCorns200[4].Y)
  end;
end;



procedure TMapsZM.SetMap200(aIndex: longInt);
begin
  FMap200:= 0;
  if not Index200OK(aIndex) then exit;
  FMap200:= aIndex;
  FCorns200[1].X:= -RohyZM200[aIndex].Y;
  FCorns200[1].Y:= -RohyZM200[aIndex].X;
  FCorns200[2].X:= -RohyZM200[aIndex+1].Y;
  FCorns200[2].Y:= -RohyZM200[aIndex+1].X;
  FCorns200[3].X:= -RohyZM200[aIndex+10].Y;
  FCorns200[3].Y:= -RohyZM200[aIndex+10].X;
  FCorns200[4].X:= -RohyZM200[aIndex+11].Y;
  FCorns200[4].Y:= -RohyZM200[aIndex+11].X;
end;



procedure SetQCorn(SourceCorns: TCorns; aIndex: longInt;
                   var TargCorns: TCorns);
var
  M12,M24,M34,M13,M1234: TXY;

begin
  M12.X:= (SourceCorns[1].X + SourceCorns[2].X)/2;
  M12.Y:= (SourceCorns[1].Y + SourceCorns[2].Y)/2;
  M24.X:= (SourceCorns[2].X + SourceCorns[4].X)/2;
  M24.Y:= (SourceCorns[2].Y + SourceCorns[4].Y)/2;
  M34.X:= (SourceCorns[3].X + SourceCorns[4].X)/2;
  M34.Y:= (SourceCorns[3].Y + SourceCorns[4].Y)/2;
  M13.X:= (SourceCorns[1].X + SourceCorns[3].X)/2;
  M13.Y:= (SourceCorns[1].Y + SourceCorns[3].Y)/2;
  M1234.X:= (M12.X + M34.X)/2;
  M1234.Y:= (M12.Y + M34.Y)/2;

  case aIndex of
  1:
  begin
    TargCorns[1]:= SourceCorns[1];
    TargCorns[2]:= M12;
    TargCorns[3]:= M13;
    TargCorns[4]:= M1234
  end;
  2:
  begin
    TargCorns[1]:= M12;
    TargCorns[2]:= SourceCorns[2];
    TargCorns[3]:= M1234;
    TargCorns[4]:= M24
  end;
  3:
  begin
    TargCorns[1]:= M13;
    TargCorns[2]:= M1234;
    TargCorns[3]:= SourceCorns[3];
    TargCorns[4]:= M34
  end;
  4:
  begin
    TargCorns[1]:= M1234;
    TargCorns[2]:= M24;
    TargCorns[3]:= M34;
    TargCorns[4]:= SourceCorns[4];
  end;
  end { case }
end;


procedure Set25Corn(SourceCorns: TCorns; aIndex: longInt;
                   var TargCorns: TCorns);
var
  Row, Col: longInt;
  D12, D34, DCol13, DCol24: TXY;
  ColCorns: TCorns; { vyznut sloupec Col }
begin
  Col:= aIndex mod 5;
  if Col = 0 then Col:= 5;
  Row:= 1 + (aIndex-1) div 5;

  D12.X:= (-SourceCorns[1].X + SourceCorns[2].X)/5;
  D12.Y:= (-SourceCorns[1].Y + SourceCorns[2].Y)/5;
  D34.X:= (-SourceCorns[3].X + SourceCorns[4].X)/5;
  D34.Y:= (-SourceCorns[3].Y + SourceCorns[4].Y)/5;

{ Vpoet roh sloupce Col }
  ColCorns[1].X:= SourceCorns[1].X + (Col-1) * D12.X;
  ColCorns[1].Y:= SourceCorns[1].Y + (Col-1) * D12.Y;
  ColCorns[2].X:= SourceCorns[1].X + (Col) * D12.X;
  ColCorns[2].Y:= SourceCorns[1].Y + (Col) * D12.Y;
  ColCorns[3].X:= SourceCorns[3].X + (Col-1) * D34.X;
  ColCorns[3].Y:= SourceCorns[3].Y + (Col-1) * D34.Y;
  ColCorns[4].X:= SourceCorns[3].X + (Col) * D34.X;
  ColCorns[4].Y:= SourceCorns[3].Y + (Col) * D34.Y;

  DCol13.X:= (ColCorns[3].X - ColCorns[1].X) /5;
  DCol13.Y:= (ColCorns[3].Y - ColCorns[1].Y) /5;
  DCol24.X:= (ColCorns[4].X - ColCorns[2].X) /5;
  DCol24.Y:= (ColCorns[4].Y - ColCorns[2].Y) /5;
  TargCorns[1].X:= ColCorns[1].X + (Row-1)*DCol13.X;
  TargCorns[1].Y:= ColCorns[1].Y + (Row-1)*DCol13.Y;
  TargCorns[3].X:= ColCorns[1].X + (Row)*DCol13.X;
  TargCorns[3].Y:= ColCorns[1].Y + (Row)*DCol13.Y;
  TargCorns[2].X:= ColCorns[2].X + (Row-1)*DCol24.X;
  TargCorns[2].Y:= ColCorns[2].Y + (Row-1)*DCol24.Y;
  TargCorns[4].X:= ColCorns[2].X + (Row)*DCol24.X;
  TargCorns[4].Y:= ColCorns[2].Y + (Row)*DCol24.Y
end;




function CreateRectangleFromCorns(aCorns: TCorns): TRectangle;
var
  I: longInt;
begin
  result:= TRectangle.Create;
  for I:= 1 to 4 do
    result.UpdateByXY(aCorns[I].X, aCorns[I].Y);
end;



procedure TMapsZM.SetMap100(aIndex: longInt);
begin
  FMap100:= 0;
  if not Index200OK(FMap200) then exit;
  if not (aIndex in [1..4]) then exit;
  FMap100:= aIndex;
  SetQCorn(FCorns200, aIndex, FCorns100);
end;

procedure TMapsZM.SetMap50(aIndex: longInt);
begin
  FMap50:= 0;
  if not (FMap100 in [1..4]) then exit;
  if not (aIndex in [1..4]) then exit;
  FMap50:= aIndex;
  SetQCorn(FCorns100, aIndex, FCorns50);
end;


procedure TMapsZM.SetMap25(aIndex: longInt);
begin
  FMap25:= 0;
  if not (FMap50 in [1..4]) then exit;
  if not (aIndex in [1..4]) then exit;
  FMap25:= aIndex;
  SetQCorn(FCorns50, aIndex, FCorns25);
end;

procedure TMapsZM.SetMap10(aIndex: longInt);
begin
  FMap10:= 0;
  if not (FMap50 in [1..4]) then exit;
  if not (aIndex in [1..25]) then exit;
  FMap10:= aIndex;
  Set25Corn(FCorns50, aIndex, FCorns10);
end;

procedure TMapsZM.SetScale(aScale: longInt);
begin
  FScale:= aScale;
end;


function TMapsZM.GetXCorn(aIndex: longInt): double;
begin
  result:= 0;
  if not (aIndex in [1..4]) then exit;
  case Scale of
{$IFDEF Win32}
  200000: result:= FCorns200[aIndex].X;
  100000: result:= FCorns100[aIndex].X;
   50000: result:= FCorns50[aIndex].X;
{$ENDIF}
   25000: result:= FCorns25[aIndex].X;
   10000: result:= FCorns10[aIndex].X;
  else
    result:= FCorns50[aIndex].X
  end;
end;

function TMapsZM.GetYCorn(aIndex: longInt): double;
begin
  result:= 0;
  if (aIndex < 1) or (aIndex > 58) then exit;
  case Scale of
{$IFDEF Win32}
  200000: result:= FCorns200[aIndex].Y;
  100000: result:= FCorns100[aIndex].Y;
   50000: result:= FCorns50[aIndex].Y;
{$ENDIF}
   25000: result:= FCorns25[aIndex].Y;
   10000: result:= FCorns10[aIndex].Y;
  else
    result:= FCorns50[aIndex].X
  end;
end;


function TMapsZM.GetZMCenterX: double;
begin
  result:= (XCorn[1] + XCorn[2] + XCorn[3] + XCorn[4]) / 4;
end;

function TMapsZM.GetZMCenterY: double;
begin
  result:= (YCorn[1] + YCorn[2] + YCorn[3] + YCorn[4]) / 4;
end;


function  TMapsZM.GetAngle: double;
begin
  result:= ATan2M(XCorn[4] - XCorn[3], YCorn[4] - YCorn[3]);
end;


function TMapsZM.Index200OK(aIndex200: longInt): boolean;
begin
  result:= aIndex200 in [1..4,11..16,21..26,32..35]
end;


function TMapsZM.GetMapName: string;
begin
  result:= '';
  if not Index200OK(Map200) then exit;
  result:= IntToStrZ(Map200, 2, true);
  if Scale < 200000 then
     result:= result + '-' + IntToStr(Map100);
  if Scale < 100000 then
     result:= result + IntToStr(Map50);
  if Scale = 25000 then
     result:= result + IntToStr(Map25)
  else
  if Scale = 10000 then
     result:= result + '-' + IntToStrZ(Map10, 2, true)
end;


procedure TMapsZM.SetMapName(aName: string);
var
  aMap200, aMap100, aMap50, aMap25, aMap10: string;
begin
  Scale:= 10000;
  aMap200:= copy(aName, 1, 2);
  aMap100:= copy(aName, 4, 1);
  aMap50:= copy(aName, 5, 1);
  aMap10:= copy(aName, 7, 2);
  try
  Map200:= strToInt(aMap200);
  Map100:= strToInt(aMap100);
  Map50:= strToInt(aMap50);
  Map10:= strToInt(aMap10)
  except
    ShowMessage('patn jmno mapy ZM: ' + aName)
  end
end;



function TMapsZM.GetNameByCoords(X, Y: double): string;
var
  I, J, K, L: longint;
  OKej: boolean;
begin
  result:= '';
  OKej:= false;
  for I:= 1 to 35 do
  begin
    Map200:= I;
    if not InsideCorns(X, Y, FCorns200) then continue;

    if Scale <= 100000 then
    begin
      for J:= 1 to 4 do
      begin
        Map100:= J;
        if not InsideCorns(X, Y, FCorns100) then continue;

        if Scale <= 50000 then
        begin
          for K:= 1 to 4 do
          begin
            Map50:= K;
            if not InsideCorns(X, Y, FCorns50) then continue;

            if Scale = 25000 then
            begin
              for L:= 1 to 4 do
              begin
                Map25:= L;
                if not InsideCorns(X, Y, FCorns25) then continue;
                OKej:= true;
                break
              end
            end
            else
            if Scale = 10000 then
            begin
              for L:= 1 to 25 do
              begin
                Map10:= L;
                if not InsideCorns(X, Y, FCorns10) then continue;
                OKej:= true;
                break
              end
            end
            else
              OKej:= true;
          if OKej then break
          end
        end
        else
          OKej:= true;
      if OKej then break
      end
    end
    else
      OKej:= true;

    if OKej then break
  end;
  if OKej then
     result:= MapName
end;




function TInterpretZM.IsOverCorns(aCorns: TCorns): boolean;
var
  ZMRect: TRectangle;
begin
  result:= false;
  ZMRect:= CreateRectangleFromCorns(aCorns);
  if ZMRect = nil then exit;
  result:= ZMRect.IsOverLap(Rect);
  ZMRect.Free
end;


procedure TInterpretZM.DrawCorns(aCorns: TCorns);
begin
  with Device do
  begin
    MoveTo(aCorns[1].X, aCorns[1].Y);
    LineTo(aCorns[2].X, aCorns[2].Y);
    LineTo(aCorns[4].X, aCorns[4].Y);
    LineTo(aCorns[3].X, aCorns[3].Y);
    LineTo(aCorns[1].X, aCorns[1].Y);
  end;
end;




procedure TInterpretZM.Process(Element: TElement);
var
  ZM: TMapsZM;
  I, J, K, L: longInt;
begin
  if Device.Projection.Scale > 8000000 then exit;

  if not (Element is TMapsZM) then exit;
  ZM:= TMapsZM(Element);

  Device.Pen.Style:= ZM.PenStyle;
  Device.Pen.Color:= ZM.Color;
  Device.PenWidth := ZM.PenWidth;
  Device.Pen.Mode := pmCopy;

  ZM.Map100:= 0;
  ZM.Map50:=  0;
  ZM.Map25:=  0;
  ZM.Map10:=  0;

  for I:= 1 to 35 do
  begin
    ZM.Map200:= I;
    if not IsOverCorns(ZM.FCorns200) then continue;
    DrawCorns(ZM.FCorns200);

    if (ZM.Scale <= 100000) and
       (Device.Projection.Scale < 4000000) then
    begin
      for J:= 1 to 4 do
      begin
        ZM.Map100:= J;
        if not IsOverCorns(ZM.FCorns100) then continue;
        DrawCorns(ZM.FCorns100);

        if (ZM.Scale <= 50000)  and
           (Device.Projection.Scale < 2000000) then
        begin
          for K:= 1 to 4 do
          begin
            ZM.Map50:= K;
            if not IsOverCorns(ZM.FCorns50) then continue;
            DrawCorns(ZM.FCorns50);

            if (ZM.Scale = 25000)  and
               (Device.Projection.Scale < 1000000) then
            begin
              for L:= 1 to 4 do
              begin
                ZM.Map25:= L;
                if not IsOverCorns(Zm.FCorns25) then continue;
                DrawCorns(ZM.FCorns25);
              end
            end;

            if (ZM.Scale = 10000)  and
               (Device.Projection.Scale < 400000) then
            begin
              for L:= 1 to 25 do
              begin
                ZM.Map10:= L;
                if not IsOverCorns(Zm.FCorns10) then continue;
                DrawCorns(ZM.FCorns10);
              end
            end
          end
        end
      end
    end;

    ZM.Map100:= 0;
  end
end;



function  TInterpretZM.IsItsClass(AObject: TObject): boolean;
begin
  Result := (AObject is TMapsZM)
end;

function  TInterpretZM.QProcessBefore(Element: TElement): boolean;
begin
  Result:= (Element.ClassType = TMapsZM);
end;


procedure TInterpretZM.DoIt;
var
  aRect: TDoubleRect;
begin
   aRect := Device.Projection.ModelView;
   Rect:= TRectangle.Create;

   Rect.MinX:= aRect.MinX;
   Rect.MinY:= aRect.MinY;
   Rect.MaxX:= aRect.MaxX;
   Rect.MaxY:= aRect.MaxY;

   inherited DoIt;

   Rect.Free
end;


function GetZMName(aScale, aX, aY: double) : string;
var
  ZM: TMapsZM;
begin
  ZM:= TMapsZM.Create;
  ZM.Scale:= round(aScale);
  result:= ZM.GetNameByCoords(aX, aY);
  ZM.Free;
end;



INITIALIZATION
   RegisterOrbisClass(TMapsZM);
   RegisterOrbisClass(TInterpretZM);
END.
