unit F_edums;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls,
// KERNEL
  Elements,
  Tools,
// GLIB
  G_Elems,
// MAPPER  
  t_Editor;

type
  TF_UMSedForm = class(TForm)
    GroupBox1: TGroupBox;
    edYmin: TEdit;
    edXmin: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edWidth: TEdit;
    Label4: TLabel;
    edHeight: TEdit;
    Label5: TLabel;
    edXmax: TEdit;
    Label6: TLabel;
    edYmax: TEdit;
    Label7: TLabel;
    edX: TEdit;
    Label8: TLabel;
    edY: TEdit;
    BitBtn1: TBitBtn;
    B_Close: TBitBtn;
    Image1: TImage;
    Image2: TImage;
    Label11: TLabel;
    ed_Name: TEdit;
    Timer1: TTimer;
    b_Undo: TBitBtn;
    Panel1: TPanel;
    rbM: TRadioButton;
    rbCM: TRadioButton;
    rbMM: TRadioButton;
    Panel2: TPanel;
    Label12: TLabel;
    ed_Scale: TEdit;
    GroupBox2: TGroupBox;
    Label13: TLabel;
    Label14: TLabel;
    ed_PageWidth: TEdit;
    ed_PageHeight: TEdit;
    Label15: TLabel;
    Image4: TImage;
    Label9: TLabel;
    Label16: TLabel;
    FixPage: TCheckBox;
    Label17: TLabel;
    b_Rect: TSpeedButton;
    b_Page: TSpeedButton;
    procedure edXExit(Sender: TObject);
    procedure edYExit(Sender: TObject);
    procedure edWidthExit(Sender: TObject);
    procedure edHeightExit(Sender: TObject);
    procedure edXminExit(Sender: TObject);
    procedure edYminExit(Sender: TObject);
    procedure edXmaxExit(Sender: TObject);
    procedure edYmaxExit(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormHide(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure b_UndoClick(Sender: TObject);
    procedure B_CloseClick(Sender: TObject);
    procedure rbMClick(Sender: TObject);
    procedure rbCMClick(Sender: TObject);
    procedure rbMMClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ed_ScaleExit(Sender: TObject);
    procedure ed_PageWidthExit(Sender: TObject);
    procedure ed_PageHeightExit(Sender: TObject);
    procedure FixPageClick(Sender: TObject);
  private
    { Private declarations }
    aLeft: integer;
    aTop: integer;
    OPageWidth, OPageHeight, OMinx, OMinY, OMaxX, OMaxY, OScale: double;
    OName : string;
    Koef: double;
    DesMist: integer;
    function StrToFloatM(aValue: string): double;
    function FloatToStrM(aValue: double): string;
    function StrToFloatD(aValue: string): double;
    function FloatToStrD(aValue: double): string;
    procedure CheckScaleWidth; virtual;
    procedure CheckScaleHeight; virtual;
    procedure CheckScale; virtual;
    procedure SaveRect;
    procedure LoadRect;

  public
    Tool: TTool;
    Editor: TRectEntityEditor;
    ShiftRect: Wintypes.TRect;
    UndoToGo: integer;
    function GetX: double;
    function GetY: double;
    function GetWidth: double;
    function GetHeight: double;
    function GetXmin: double;
    function GetXmax: double;
    function GetYmin: double;
    function GetYmax: double;
    procedure SetX(aValue: double);
    procedure SetY(aValue: double);
    procedure SetWidth(aValue: double);
    procedure SetHeight(aValue: double);
    procedure SetXmin(aValue: double);
    procedure SetXmax(aValue: double);
    procedure SetYmin(aValue: double);
    procedure SetYmax(aValue: double);
    function  GetScale: double;
    procedure SetScale(aValue: double);
    function  GetPageWidth: double;
    procedure SetPageWidth(aValue: double);
    function  GetPageHeight: double;
    procedure SetPageHeight(aValue: double);
  published
    property X: double read GetX write SetX;
    property Y: double read GetY write SetY;
    property RectWidth: double read GetWidth write SetWidth;
    property RectHeight: double read GetHeight write SetHeight;
    property Xmin: double read GetXmin write SetXmin;
    property Xmax: double read GetXmax write SetXmax;
    property Ymin: double read GetYmin write SetYmin;
    property Ymax: double read GetYmax write SetYmax;
    property Scale: double read GetScale write SetScale;
    property PageWidth: double read GetPageWidth write SetPageWidth;
    property PageHeight: double read GetPageHeight write SetPageHeight;
  end;




implementation

{$R *.DFM}
uses
//KERNEL
  m_Orbis,
  U_String,
// MAPPER
  E_MSpace,
// APP
  m_Proj;


function TF_UMSedForm.StrToFloatM(aValue: string): double;
begin
  try
    result:= strToFloat(aValue)/Koef;
  except
    result:= 0
  end
end;


function TF_UMSedForm.FloatToStrM(aValue: double): string;
begin
  result:= DoubleToStr(aValue*Koef, 15, DesMist)
end;


function TF_UMSedForm.StrToFloatD(aValue: string): double;
begin
  try
    result:= strToFloat(aValue);
  except
    result:= 0
  end
end;


function TF_UMSedForm.FloatToStrD(aValue: double): string;
begin
  result:= DoubleToStr(aValue, 15, DesMist)
end;


procedure TF_UMSedForm.CheckScaleWidth;
begin
  if not FixPage.Checked then ed_PageWidth.Text :=  FloatToStrM(RectWidth/Scale)
                         else CheckScale;
end;

procedure TF_UMSedForm.CheckScaleHeight;
begin
  if not FixPage.Checked then ed_PageHeight.Text :=  FloatToStrM(RectHeight/Scale)
                      else CheckScale;
end;


procedure TF_UMSedForm.CheckScale;
var
  S1, S2: double;
begin
   S1 := RectWidth / PageWidth;
   S2 := RectHeight / PageHeight;
   if S1 > S2 then ed_Scale.Text := DoubleToStr(S1, 15, 3)
              else ed_Scale.Text := DoubleToStr(S2, 15, 3);
end;






function TF_UMSedForm.GetX: double;
begin
  result:= StrToFloatD(edX.Text);
end;

function TF_UMSedForm.GetY: double;
begin
  result:= StrToFloatD(edY.Text);
end;

function TF_UMSedForm.GetWidth: double;
begin
  result:= StrToFloatD(edWidth.Text);
end;

function TF_UMSedForm.GetHeight: double;
begin
  result:= StrToFloatD(edHeight.Text);
end;

function TF_UMSedForm.GetXmin: double;
begin
  result:= StrToFloatD(edXmin.Text);
end;

function TF_UMSedForm.GetXmax: double;
begin
  result:= StrToFloatD(edXmax.Text);
end;

function TF_UMSedForm.GetYmin: double;
begin
  result:= StrToFloatD(edYmin.Text);
end;

function TF_UMSedForm.GetYmax: double;
begin
  result:= StrToFloatD(edYmax.Text);
end;

procedure TF_UMSedForm.SetX(aValue: double);
begin
  edX.Text:= FloatToStrD(aValue);
  edXmin.Text:= FloatToStrD(aValue - RectWidth/2);
  edXmax.Text:= FloatToStrD(aValue + RectWidth/2);
  b_Undo.Visible := false;
end;

procedure TF_UMSedForm.SetY(aValue: double);
begin
  edY.Text:= FloatToStrD(aValue);
  edYmin.Text:= FloatToStrD(aValue - RectHeight/2);
  edYmax.Text:= FloatToStrD(aValue + RectHeight/2);
  b_Undo.Visible := false;
end;

procedure TF_UMSedForm.SetWidth(aValue: double);
begin
  edWidth.Text:= FloatToStrD(abs(aValue));
  edXmin.Text:= FloatToStrD(X - abs(aValue)/2);
  edXmax.Text:= FloatToStrD(X + abs(aValue)/2);
  CheckScaleWidth;
  b_Undo.Visible := false;
end;

procedure TF_UMSedForm.SetHeight(aValue: double);
begin
  edHeight.Text:= FloatToStrD(abs(aValue));
  edYmin.Text:= FloatToStrD(Y - abs(aValue)/2);
  edYmax.Text:= FloatToStrD(Y + abs(aValue)/2);
  CheckScaleHeight;
  b_Undo.Visible := false;
end;

procedure TF_UMSedForm.SetXmin(aValue: double);
begin
  edXmin.Text:= FloatToStrD(aValue);
  edWidth.Text:= FloatToStrD(abs(Xmax-Xmin));
  edX.Text := FloatToStrD(XMin + RectWidth/2);
  CheckScaleWidth;
  if UndoToGo > 0 then Dec(UndoToGo)
                  else b_Undo.Visible := false;
end;


procedure TF_UMSedForm.SetXmax(aValue: double);
begin
  edXmax.Text:= FloatToStrD(aValue);
  edWidth.Text:= FloatToStrD(abs(Xmax-Xmin));
  edX.Text := FloatToStrD(XMin + RectWidth/2);
  CheckScaleWidth;
  if UndoToGo > 0 then Dec(UndoToGo)
                  else b_Undo.Visible := false;
end;

procedure TF_UMSedForm.SetYmin(aValue: double);
begin
  edYmin.Text:= FloatToStrD(aValue);
  edHeight.Text:= FloatToStrD(abs(Ymax-Ymin));
  edY.Text := FloatToStrD(YMin + RectHeight/2);
  CheckScaleHeight;
  if UndoToGo > 0 then Dec(UndoToGo)
                  else b_Undo.Visible := false;
end;

procedure TF_UMSedForm.SetYmax(aValue: double);
begin
  edYmax.Text:= FloatToStrD(aValue);
  edHeight.Text:= FloatToStrD(abs(Ymax-Ymin));
  edY.Text := FloatToStrD(YMin + RectHeight/2);
  CheckScaleHeight;
  if UndoToGo > 0 then Dec(UndoToGo)
                  else b_Undo.Visible := false;
end;

function  TF_UMSedForm.GetScale: double;
begin
  result:= StrToFloatD(ed_Scale.Text);
end;

procedure TF_UMSedForm.SetScale(aValue: double);
begin
   if aValue < 0.01 then aValue := 0.01;
   ed_Scale.Text := FloatToStrD(aValue);
   if not b_Page.Down then
   begin
      edWidth.Text := FloatToStrD(PageWidth * Scale);
      edHeight.Text := FloatToStrD(PageHeight * Scale);
      edXMin.Text := FloatToStrD(X - RectWidth/2);
      edYMin.Text := FloatToStrD(y - RectHeight/2);
      edXMax.Text := FloatToStrD(X + RectWidth/2);
      edYMax.Text := FloatToStrD(y + RectHeight/2);
   end
   else
   begin
      ed_PageWidth.Text := FloatToStrM(RectWidth / aValue);
      ed_PageHeight.Text := FloatToStrM(RectHeight / aValue);
   end;
   b_Undo.Visible := false;
end;

function  TF_UMSedForm.GetPageWidth: double;
begin
   result := StrToFloatM(ed_PageWidth.Text);
end;

procedure TF_UMSedForm.SetPageWidth(aValue: double);
begin
   ed_PageWidth.Text := FloatToStrM(aValue);
   if not b_Page.Down then
   begin
      edWidth.Text := FloatToStrD(PageWidth * Scale);
      edXMin.Text  := FloatToStrD(X - RectWidth/2);
      edXMax.Text  := FloatToStrD(X + RectWidth/2);
   end
   else
   begin
      CheckScale;
   end;
   if FixPage.Checked then Editor.Ratio := PageWidth/PageHeight;
   b_Undo.Visible := false;
end;


function  TF_UMSedForm.GetPageHeight: double;
begin
   result := StrToFloatM(ed_PageHeight.Text);
end;

procedure TF_UMSedForm.SetPageHeight(aValue: double);
begin
   ed_PageHeight.Text := FloatToStrM(aValue);
   if not b_Page.Down then
   begin
      edHeight.Text := FloatToStrD(PageHeight * Scale);
      edYMin.Text  := FloatToStrD(Y - RectHeight/2);
      edYMax.Text  := FloatToStrD(Y + RectHeight/2);
   end
   else
   begin
      CheckScale;
   end;
   if FixPage.Checked then Editor.Ratio := PageWidth/PageHeight;
   b_Undo.Visible := false;
end;


procedure TF_UMSedForm.edXExit(Sender: TObject);
begin
  SetX(StrToFloatD(edX.Text))
end;

procedure TF_UMSedForm.edYExit(Sender: TObject);
begin
  SetY(StrToFloatD(edY.Text))
end;

procedure TF_UMSedForm.edWidthExit(Sender: TObject);
begin
  SetWidth(StrToFloatD(edWidth.Text))
end;

procedure TF_UMSedForm.edHeightExit(Sender: TObject);
begin
  SetHeight(StrToFloatD(edHeight.Text))
end;

procedure TF_UMSedForm.edXminExit(Sender: TObject);
begin
  SetXmin(StrToFloatD(edXmin.Text))
end;

procedure TF_UMSedForm.edYminExit(Sender: TObject);
begin
  SetYmin(StrToFloatD(edYmin.Text))
end;

procedure TF_UMSedForm.edXmaxExit(Sender: TObject);
begin
  SetXmax(StrToFloatD(edXmax.Text))
end;

procedure TF_UMSedForm.edYmaxExit(Sender: TObject);
begin
  SetYmax(StrToFloatD(edYmax.Text))
end;

procedure TF_UMSedForm.FormResize(Sender: TObject);
begin
   //Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;

procedure TF_UMSedForm.FormDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
   //Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;

procedure TF_UMSedForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   //Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;

procedure TF_UMSedForm.Timer1Timer(Sender: TObject);
begin
(*
   if (aLeft <> Left) or (aTop <> Top) then
   begin
      aLeft := Left;
      aTop  := Top;
      Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
   end;
*)
end;

procedure TF_UMSedForm.FormActivate(Sender: TObject);
begin
   //Timer1.Enabled := true;
end;

procedure TF_UMSedForm.FormDeactivate(Sender: TObject);
begin
   Timer1.Enabled := false;
end;

procedure TF_UMSedForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   try
      Tool.PostMsg(tm_SizePanelOff, Tool, nil, DontKill);
   except
   end;
end;

procedure TF_UMSedForm.FormHide(Sender: TObject);
begin
   try
      //Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
   except
   end;
end;

procedure TF_UMSedForm.BitBtn1Click(Sender: TObject);
var
   E: TRectEntity;
begin
   E := Editor.SelectedElement;
   if E = nil then exit;
   OMinx := E.MinX;
   OMinY := E.MinY;
   OMaxX := E.MaxX;
   OMaxY := E.MaxY;
   OName := E.Name;
   if E is TUserMapSpace then
      OScale:= TUserMapSpace(E).Scale;
   E.Name := ed_Name.Text;
   E.Minx := GetXMin;
   E.MinY := GetYMin;
   E.MaxX := GetXMax;
   E.MaxY := GetYMax;

   if E is TUserMapSpace then
      TUserMapSpace(E).Scale:= Scale;
   b_Undo.Visible := true;
   UndoToGo := 4;
   Editor.SelectedElement := E;
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;

procedure TF_UMSedForm.b_UndoClick(Sender: TObject);
var
   E: TRectEntity;
begin
   E := Editor.SelectedElement;
   if E = nil then exit;
   E.Name := OName;
   E.Minx := OMinx;
   E.MinY := OMinY;
   E.MaxX := OMaxX;
   E.MaxY := OMaxY;
   if E is TUserMapSpace then
      TUserMapSpace(E).Scale:= OScale;
   b_Undo.Visible := false;
   Editor.SelectedElement := E;
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;

procedure TF_UMSedForm.B_CloseClick(Sender: TObject);
begin
   Close;
end;

procedure TF_UMSedForm.SaveRect;
begin
  OPageWidth := PageWidth;
  OPageHeight:= PageHeight;
end;

procedure TF_UMSedForm.LoadRect;
begin
   PageWidth  := OPageWidth;
   PageHeight := OPageHeight;
end;

procedure TF_UMSedForm.rbMClick(Sender: TObject);
begin
  SaveRect;
  Koef:= 1;
  DesMist:= 3;
  LoadRect
end;

procedure TF_UMSedForm.rbCMClick(Sender: TObject);
begin
  SaveRect;
  Koef:= 100;
  DesMist:= 2;
  LoadRect
end;

procedure TF_UMSedForm.rbMMClick(Sender: TObject);
begin
  SaveRect;
  Koef:= 1000;
  DesMist:= 2;
  LoadRect
end;

procedure TF_UMSedForm.FormCreate(Sender: TObject);
begin
  rbMM.Enabled:= true;
  Koef:= 1000;
  DesMist:= 2;
end;

procedure TF_UMSedForm.ed_ScaleExit(Sender: TObject);
begin
   Scale := StrToFloatD(ed_Scale.Text);
end;

procedure TF_UMSedForm.ed_PageWidthExit(Sender: TObject);
begin
   PageWidth := StrToFloatM(ed_PageWidth.Text);
end;

procedure TF_UMSedForm.ed_PageHeightExit(Sender: TObject);
begin
   PageHeight := StrToFloatM(ed_PageHeight.Text);
end;

procedure TF_UMSedForm.FixPageClick(Sender: TObject);
begin
   if FixPage.Checked then
   begin
      Editor.FixedRatio := true;
      Editor.Ratio := PageWidth/PageHeight;
   end
   else
   begin
      Editor.FixedRatio := false;
   end;
end;

end.
