unit I_txtblk;
{****************************************************************************}
{                                                                            }
{          ORBIS ... Interpret True Type Textu                               }
{                    (c) 1996                                                }
{                                                                            }
{****************************************************************************}

interface
uses
   Wintypes,
   Elements,
   e_View,
   i_Basic;

type
  TTextBlockInterpret = class(TInterpret)
  protected
    function  QGoInside(Element: TElement): boolean; override;
    function  QProcessBefore(Element: TElement): boolean; override;
    procedure Process(Element: TElement); override;
    function  IsItsClass(AObject: TObject): boolean; override;
  end;



implementation
uses
   Graphics,
   e_TXTBlk,
   g_Elems,
   M_Orbis,
   //i_TopoL,
   e_Device,
   Tools;

function  TTextBlockInterpret.QGoInside(Element: TElement): boolean;
begin
  Result:= false
{  Result:= (Element is TEntity) and not ((Element is TView)or(Element is TText));}
end;

function  TTextBlockInterpret.QProcessBefore(Element: TElement): boolean;
begin
  Result:= (Element is TTextBlock);
end;


procedure TTextBlockInterpret.Process(Element: TElement);
var
  aX, aY: double;
  I: longInt;
  R: TDoubleRect;
  TTT: TTextBlock;
begin
  if (Element is TTextBlock) then
  begin
    TTT:= TTextBlock(Element);
    if TTT.LinesCount <= 0 then exit;
    aX := TTT.MinX;
    aY := TTT.MaxY;
    if Device is TCanvasDevice then
    begin
       if TTT.TextHeight <> 0 then
          Device.Font.Height:=
                    -Device.Projection.GetPageLengthVert1(TTT.TextHeight);
       Device.Font.Name:= TTT.FontName;
       Device.Font.Color:= TTT.Color;
       Device.Font.Style:= TTT.FontStyle;
       Device.Font.CharSet:= TTT.CharSet;
       Device.SetTextOrientation(0);
    end;
    for i := 0 to TTT.LinesCount-1 do
    begin
       if aY < TTT.MinY then break;
       Device.TextOut(aX, aY, TTT.Lines.Strings[i]);
       aY := aY - TTT.LineHeight;
    end;
  end;
end;



function TTextBlockInterpret.IsItsClass(AObject: TObject): boolean;
begin
   result := AObject is TTextBlock;
end;

END.
