unit T_guide;
{
*********************************************************************
*                                                                   *
*  ORBIS ... Nstroj pro zobrazen prvodce                         *
*                                                                   *
*                       Topol Pro 1996                             *
*********************************************************************
}


interface
uses
   Controls,
   Menus,
   Elements, G_Elems,
   e_Guide,
   m_InterA,
   f_Guide,
   f_EdUMS,
   t_InterA,
   t_SelG,
   T_MsEd;

type


{ TGuideFormTool }

TGuideFormTool = class(TFormToolManager)
 private
   FForm: TGuideForm;
   FCorb: TGuide;
   FSelecting: boolean;
   FAuto: boolean;
   FSizePanel: TF_UMSedForm;
   FiniFileName: string;
   FStream3: string;
   function    GetSelected: TEntity;
   function    GetSizePanel: TF_UMSedForm; virtual;
    procedure SetiniFileName(const Value: string);
 protected
   function    GetLeft: longInt; override;
   function    GetTop: longInt; override;
   function    GetWidth: longInt; override;
   function    GetHeight: longInt; override;
   procedure   SetLeft(aValue: longInt); override;
   procedure   SetTop(aValue: longInt); override;
   procedure   SetWidth(aValue: longInt); override;
   procedure   SetHeight(aValue: longInt); override;
   procedure   ShowScale(aVal: string); override;

   function    GetProjectMainDirectory : string;

   procedure   SetInput(aInput: TElement); override;
   procedure   CreateForm; override;
   procedure   LinkDeviceToForm; override;
   procedure   CreateInterpret; override;
   procedure   CreateTools; override;
   function    GetVisible: boolean; override;
   procedure   SetVisible(aVisible: boolean); override;
   function    GetMainMenu: TMainMenu; override;
   function    GetCaption: string; override;
   procedure   SetCaption(const aValue: string); override;
   function    GetGuide: TGuide; virtual;
   procedure   SetGuide(aValue: TGuide); virtual;
   procedure   SetCorb(aValue: TGuide); virtual;
   procedure   SaveGuide;
   procedure   SaveProjection;
   procedure   SetSelecting(aValue: boolean);
   function    GetSelector: TGuideSelector;
   function    GetFormCursor: TCursor; override;
   procedure   SetFormCursor(aValue: TCursor); override;
   procedure   CheckDeviceSize(Review: boolean);
 public
   function    GetProjectFileName: string;

   constructor Create; override;
   destructor  Destroy; override;
   procedure   LoadAll;
   procedure   on_tm_Open(var Handled: boolean); override;
   procedure   on_tm_SaveAs(var Handled: boolean); override;
   procedure   on_tm_ImportBlk(var Handled: boolean); virtual;
   //procedure   on_tm_PrintForm(var Handled: boolean); override;
   procedure   On_tm_Review(var aMessage: TOrbisMessage; var Handled: boolean); override;
   procedure   On_tm_RePaint(var Handled: boolean); override;
   procedure   on_tm_QuitTask; override;
   procedure   on_tm_CreateGuideAuto(var Handled: boolean); virtual;
   procedure   on_tm_CreateGuideMan(var Handled: boolean); virtual;
   procedure   on_tm_GuideOK;
   procedure   on_tm_GuideCancel;
   procedure   on_tm_ToolSelected(var aMessage: TOrbisMessage; var Handled: boolean); override;
   procedure   on_tm_Viewer(var Handled: boolean); virtual;
   procedure   on_tm_Selector(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure   on_tm_DeleteSelected(var Handled: boolean);
   procedure   on_tm_InvertSelected(var Handled: boolean);
   procedure   on_tm_SetPropertyEditors(var Handled: boolean); virtual;
   procedure   on_tm_SelectSizeChange(var Handled: boolean); virtual;
   procedure   on_tm_GuideSelect(var Handled: boolean); virtual;
   procedure   on_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure   on_tm_ViewBySelect(var Handled: boolean); virtual;
   procedure   on_tm_ViewByVectors(var Handled: boolean); virtual;
   procedure   on_tm_NewUserSpace(var Handled: boolean); virtual;
   procedure   on_tm_EditUserSpace(var Handled: boolean); virtual;
   procedure   on_tm_SizePanelOn (var Handled: boolean); virtual;
   procedure   on_tm_SizePanelOff (var Handled: boolean); virtual;
   procedure   HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;

   property    GForm: TGuideForm read FForm;
   property    Guide: TGuide read GetGuide write SetGuide;
   property    Corb: TGuide read FCorb write setCorb;
   property    Selected: TEntity read GetSelected;
   property    Stream3: string read FStream3 write FStream3;
   property    Selecting: boolean read FSelecting write SetSelecting;
   property    Selector: TGuideSelector read GetSelector;
   property    SizePanel: TF_UMSedForm read GetSizePanel;
   property    iniFileName: string read FiniFileName write SetiniFileName;
end;




implementation


uses
   Dialogs,
   WinTypes, IniFiles, SysUtils, Graphics, Forms, Classes,
   //e_PWorld,
   e_Device,
   t_EdiPro,
   f_GCrea,
   D_STDImg,
   e_MSpace,
   ed_UMS,
   f_GuideV,
   m_Orbis,
   m_Proj,
   i_Guide,
   t_Editor,
   t_GuideU,
   t_Loader,
   t_MainTl,
   t_TopImp,
   f_LayImp,
   t_LMCre,
   t_Layscr,
   t_Saver,
   //T_PZ,
   u_String,
   Worlds,
   U_Cursor;


{ TGuideFormTool }

procedure  TGuideFormTool.CheckDeviceSize(Review: boolean);
begin
   if GForm = nil then exit;
   GForm.Image.Picture.Bitmap.Height:= GForm.Image.Height;
   GForm.Image.Picture.Bitmap.Width:= GForm.Image.Width;
   if not GForm.Visible then exit;
   if not Review then exit;
   PostMsg(tm_ReSize, Self, nil, DontKill);

end;



function TGuideFormTool.GetProjectFileName: string;
begin
  result:= '';
  {
  if (World is TRTProjectWorld) and (TRTProjectWorld(World).Project <> nil) then
     result := TRTProjectWorld(World).Project.FileName
  else
  if (World is TDProjectWorld) and (TDProjectWorld(World).Project <> nil) then
     result := TDProjectWorld(World).Project.FileName
  }
end;


function TGuideFormTool.GetProjectMainDirectory: string;
begin
   GetDir(0, result);
   {
   if (World is TRTProjectWorld) and (TRTProjectWorld(World).Project <> nil) then
      result := TRTProjectWorld(World).Project.MainDirectory
   else
   if (World is TDProjectWorld) and (TDProjectWorld(World).Project <> nil) then
      result := TDProjectWorld(World).Project.MainDirectory;
   }
end;


constructor TGuideFormTool.Create;
begin
   inherited Create;

   Device.Page.Color := clSilver;
   GForm.Panel1.Visible := false;
   //GForm.IniFileName := iniFileName;
end;


destructor  TGuideFormTool.Destroy;
begin
  SaveGuide;
  SaveProjection;
  if FForm <> nil then
     FForm.Free;
  inherited Destroy;
end;



function    TGuideFormTool.GetLeft: longInt;
begin
   result := GForm.Left;
end;

function    TGuideFormTool.GetTop: longInt;
begin
   result := GForm.Top;
end;

function    TGuideFormTool.GetWidth: longInt;
begin
   result := GForm.Width;
end;

function    TGuideFormTool.GetHeight: longInt;
begin
   result := GForm.Height;
end;

procedure   TGuideFormTool.SetLeft(aValue: longInt);
begin
   GForm.Left := aValue;
end;

procedure   TGuideFormTool.SetTop(aValue: longInt);
begin
   GForm.Top := aValue;
end;

procedure   TGuideFormTool.SetWidth(aValue: longInt);
begin
   GForm.Width := aValue;
end;

procedure   TGuideFormTool.SetHeight(aValue: longInt);
begin
   GForm.Height := aValue;
end;

procedure   TGuideFormTool.ShowScale(aVal: string);
begin
  GForm.l_M.Caption:= aVal
end;



procedure   TGuideFormTool.SaveGuide;
var
   Saver: TSave;
begin
   if Guide = nil then exit;
   //Guide.ResetID;
   Saver := TSave.CreateAll(Stream3);
   Saver.Input := Guide;
   Saver.DoIt;
   Saver.Free
end;

procedure TGuideFormTool.SaveProjection;
var
   Ini: TIniFile;
   s: string;
   E: extended;
   GI: TGuideInterpret;
begin
  GI := TGuideInterpret(Interpret);
  if GI = nil then exit;
  if GI.Device = nil then exit;
  if GI.Device.Projection = nil then exit;

  Ini := TIniFile.Create(IniFileName);
  E := GI.Device.Projection.CenterPoint.x;
  s := FloatToStr(E);
  Ini.WriteString('Guide','X', s);
  E := GI.Device.Projection.CenterPoint.y;
  s := FloatToStr(E);
  Ini.WriteString('Guide','y', s);
  E := GI.Device.Projection.Scale;
  s := FloatToStr(E);
  Ini.WriteString('Guide','Scale', s);
  Ini.Free
end;


procedure   TGuideFormTool.SetSelecting(aValue: boolean);
begin
   FSelecting := aValue;
   try
      //Selector.InfoSelect := aValue;
   except
   end;

   //GForm.cbMakeDetail.Checked:= aValue;

   if aValue then
   begin
      GForm.Panel1.Visible := true;
      //GForm.cbMakeDetail.Checked:= aValue;
      CheckDeviceSize(false);
   end;
end;



function    TGuideFormTool.GetSelector: TGuideSelector;
begin
   result := TGuideSelector(Tools.FindElementClass(TGuideSelector));
end;


function    TGuideFormTool.GetFormCursor: TCursor;
begin
   result := GForm.Image.Cursor;
end;


procedure   TGuideFormTool.SetFormCursor(AValue: TCursor);
begin
   GForm.Image.Cursor := aValue;
end;





procedure   TGuideFormTool.on_tm_QuitTask;
begin
   SizePanel.Free;
   GForm.Free;
   FForm:= nil;
   inherited on_tm_QuitTask;
end;



procedure   TGuideFormTool.on_tm_Open(var Handled: boolean);
var
   Loader: TLoad;
   SelEl: TElement;
   G: TGuide;
   SwapG: boolean;
begin
   G:= nil;
   Loader:= nil;
   if GForm.OpenDialog.Execute then
   begin
      SwapG := true;
      try
         Loader := TLoad.CreateAll(GForm.OpenDialog.FileName);
         GForm.OpenDialog.InitialDir := ExtractFilePath(GForm.OpenDialog.FileName);
         Loader.DoIt;
         G := TGuide(Loader.Output);
         SelEl:= G.FindElementClass(TSelectedElement);
         if SelEl <> nil then
            Guide.FreeElement(SelEl)
      except
         SwapG := false;
      end;
      if not (TElement(G) is TGuide) then SwapG := false;
      if SwapG then
      begin
         Guide := G;
         PostMsg(tm_Review, Self, nil, DontKill);
      end
      else
      begin
         ShowMessage('Vybran soubor byl patrn pokozen, nebo nen souborem prvodce ... ponechvm pvodn.');
         if assigned(G) then
            G.Free;
      end;
      if assigned(Loader) then
         Loader.Free;
   end
end;


procedure   TGuideFormTool.on_tm_SaveAs(var Handled: boolean);
var
   Saver: TSave;
begin
   GForm.SaveDialog.InitialDir := GForm.OpenDialog.InitialDir;
   GForm.SaveDialog.FileName   := GForm.OpenDialog.FileName;
   if GForm.SaveDialog.Execute then
   begin
      GForm.OpenDialog.InitialDir := ExtractFilePath(GForm.SaveDialog.FileName);
      GForm.OpenDialog.FileName := GForm.SaveDialog.FileName;
      if Guide = nil then exit;
      Guide.ResetID;
      Saver := TSave.CreateAll(GForm.SaveDialog.FileName);
      Saver.Input := Guide;
      Saver.DoIt;
      Saver.Free
   end;
end;

procedure   TGuideFormTool.on_tm_ImportBlk(var Handled: boolean);
var
//   BR: TTopoLBlokReader;
   E: TEntity;
   DD: TLayerImportDialog;
   MSC: TModelScriptCreator;
   MBSC: TModelByScriptCreator;
   Dlg: TGuideVectorsDlg;
   DS: string;
begin
   E:= nil;
   if Guide = nil then exit;
   try

      DD := TLayerImportDialog.Create;
      MSC := TModelScriptCreator.Create;
      MBSC := TModelByScriptCreator.Create;
      try
         DS := TOldmainTool(world.MainTool).OptionPropString('DataDirectory');
         DD.InitialDir := DS;
         DD.DoIt;
         MSC.Input := DD.Output;
         MSC.DataDirectory := DS;
         MSC.DoIt;
         MBSC.Input := MSC.Output;
         MBSC.DoIt;
         MBSC.Output.Name := 'DATA';
         E := TEntity(MBSC.Output);
      except
      end;
      DD.Free;
      MSC.Free;
      MBSC.Free;

      if E= nil then exit;

      if Guide.Vectors.Count > 0 then
      begin
          Application.CreateForm(TGuideVectorsDlg, Dlg);
          if Dlg.ShowModal = mrOK then
          begin
             case DLG.Radio.ItemIndex of
                0:
                begin
                   Guide.Vectors.FreeAll;
                   Guide.Vectors.AddElement(E);
                end;
                1:
                begin
                   Guide.Vectors.AddElement(E);
                end;
             else
                if E <> nil then E.Free;
             end;
          end
          else if E <> nil then E.Free;
          DLG.Free;
      end
      else Guide.Vectors.AddElement(E);

   except
   end;
   Handled := true;
   PostMsg(tm_ReView, Self, nil, DontKill);
end;

(*
procedure   TGuideFormTool.on_tm_PrintForm(var Handled: boolean);
begin
  Interpret.Reset(Device);
  Device.Clear;
  inherited on_tm_PrintForm(Handled);
  Device.Close;
  Interpret.Close
end;
*)



procedure   TGuideFormTool.On_tm_ReView(var aMessage: TOrbisMessage; var Handled: boolean);
begin
  try
   Application.ProcessMessages;
   Interpret.Reset(Device);
   Device.Clear;
   inherited On_tm_ReView(aMessage, Handled);
   SaveProjection;
   Device.Close;
   Interpret.Close
  except
  end
end;

procedure TGuideFormTool.On_tm_RePaint(var Handled: boolean);
begin
   Handled := true;
   {
   PostMsg(tm_BreakInterpret, Self, nil, DontKill);
   }
   GForm.Image.Refresh;
end;



procedure   TGuideFormTool.on_tm_CreateGuideAuto(var Handled: boolean);
var
   G: TGuide;
begin
  try
    if GForm.Panel1.Visible = true then exit;
    FAuto := true;
    Selecting := false;
    GForm.Panel1.Visible := true;
    CHeckDeviceSize(false);
    G := TGuide.Create;
    G.CreateByRasters;
    {
    G.FreeEmptySpaces(false);
    G.UpdateRect;
    }
    Guide := G;
    PostMsg(tm_ReView, Self, nil, DontKill);
  except
  end
end;



procedure   TGuideFormTool.on_tm_CreateGuideMan(var Handled: boolean);
var
    G: TGuide;
begin
    if GForm.Panel1.Visible = true then exit;
    FAuto := false;
    Selecting := false;
    TGuideInterpret(Interpret).Show_50 := true;

    GForm.b_50.Down := true;
    GForm.Panel1.Visible := true;
    CheckDeviceSize(false);
    G := TGuide.Create;
    G.CreateByStandardScript;
    Guide := G;
    PostMsg(tm_ReView, Self, nil, DontKill);
end;


function    TGuideFormTool.GetSelected: TEntity;
var
   Sel: TSelectGuide;
begin
  result:= nil;
  if Guide = nil then exit;
  Guide.ResetID;
  Sel := TSelectGuide.Create;
  Sel.Input := Guide;
  Sel.SelectZM  := GForm.b_ZM.Down;
  Sel.SelectU  := GForm.b_U.Down;
  Sel.Select10 := GForm.b_10.Down;
  Sel.Select5  := GForm.b_5.Down;
  Sel.Select2  := GForm.b_2.Down;
  Sel.Select25 := GForm.b_25.Down;
  Sel.Select50 := GForm.b_50.Down;
  Sel.DoIt;
  result:= TEntity(Sel.Output);
  Sel.Free;
  if not (TElement(result) is TEntity) then
     result:= nil
end;


function    TGuideFormTool.GetSizePanel: TF_UMSedForm;
begin
   if FSizePanel = nil then
   begin
      Application.CreateForm(TF_UMSedForm, FSizePanel);
      FSizePanel.Tool := Self;
      FSizePanel.Editor := TRectEntityEditor(Tools.FindElementClass(TRectEntityEditor));
   end;
   result := FSizePanel;
end;



procedure   TGuideFormTool.on_tm_GuideOK;
var
   Sel: TSelectGuide;
   Saver: TSaver;
   s: string;
begin

   try
      Corb := nil;
   except
   end;

   FCorb := nil;
   if Selecting then
   begin
      Guide.ResetID;
      Sel := TSelectGuide.Create;
      Sel.Input := Guide;
      Sel.DoIt;
      s := GetProjectMainDirectory;
      s := CheckBackSlash(s)+'Select.ORB';
      Saver := TSaver.CreateAll(s);
      Saver.Input := Sel.Output;
      Saver.DoIt;
      Saver.Free;
      Sel.Free;
      PostMsg(tm_SelectOK, World.MainTool, nil, DontKill);
   end
   else
   begin
      {
      try
         Corb := nil;
      except
      end;
      Guide.FreeEmptySpaces(not FAuto);
      Guide.UpdateRect;
      Guide := Guide;
      FCorb := nil;
      }
   end;
   FAuto := false;
   Selecting := true;
   GForm.Panel1.Visible := false;
   CheckDeviceSize(true);
   //PostMsg(tm_ReView, Self, nil, DontKill);
   SaveGuide;
   PostMsg(tm_CloseGuide, World.MainTool, nil, DontKill);
end;


procedure   TGuideFormTool.on_tm_GuideCancel;
var
   G: TGuide;
begin
   try
      G     := Corb;
      FCorb := nil;
      Guide := G;
      Corb  := nil;
   except
   end;
   Selecting := true;
   GForm.Panel1.Visible := false;
   FAuto := false;
   CheckDeviceSize(false);
   //PostMsg(tm_ReView, Self, nil, DontKill);
   PostMsg(tm_SelectCancel, World.MainTool, nil, DontKill);
   PostMsg(tm_CloseGuide, World.MainTool, nil, DontKill);
end;


procedure   TGuideFormTool.on_tm_ToolSelected(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aClass: TClass;
begin
   {
   GForm.Panel1.Visible := false;
   }
   inherited on_tm_ToolSelected(aMessage, Handled);
   Handled := true;
   aClass := aMessage.Data.ClassType;
   (*
   if (aClass = TGuide_5_Selector) or
      (aClass = TGuide_10_Selector) or
      (aClass = TGuide_50_Selector) or
      (aClass = TGuide_25_Selector)
      then  GForm.Panel1.Visible := true;
   *)
   if aClass = TViewer then GForm.b_Viewer.Down := true else
   if aClass = TGuideSelector then GForm.b_GuideSelector.Down := true;
end;


procedure   TGuideFormTool.on_tm_Viewer(var Handled: boolean);
begin
   try
      FindMenuItemIn('Tools','TViewer').OnClick(nil);
   except
   end;
end;


procedure   TGuideFormTool.on_tm_Selector(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   try
      FindMenuItemIn('Tools','TGuideSelector').OnClick(nil);
      Application.ProcessMessages;
      if aMessage.Data <> nil then
      begin
         Selector.MakeDetail := true;
         GForm.b_MakeDetail.Down := true;
      end
      else Selector.MakeDetail := false;
   except
   end;
end;

procedure TGuideFormTool.on_tm_DeleteSelected(var Handled: boolean);
var
  SG: TSelectGuide;
  Entita: TEntity;
  I: longINt;
begin
  try
    SG:= TSelectGuide.Create;
    SG.Input:= Guide;
    SG.Select10 := GForm.b_10.Down;
    SG.Select5  := GForm.b_5.Down;
    SG.Select2  := GForm.b_2.Down;
    SG.Select25 := GForm.b_25.Down;
    SG.Select50 := GForm.b_50.Down;
    SG.SelectU := GForm.b_U.Down;
    SG.DoIt;
    Entita:= TEntity(SG.Output);
    SG.Free;
    if Entita <> nil then
    for I:= Entita.Count-1 downto 0 do
    begin
      Entita.Elements[I].Free
    end;
    Entita.Free;
  except
  end;
  PostMsg(tm_ReView, Self, nil, DontKill);
end;


procedure TGuideFormTool.on_tm_InvertSelected(var Handled: boolean);
var
  SG: TInvertGuide;
//  Entita: TEntity;
begin
  try
    SG:= TInvertGuide.Create;
    SG.Input:= Guide;
    SG.Select10 := GForm.b_10.Down;
    SG.Select5  := GForm.b_5.Down;
    SG.Select2  := GForm.b_2.Down;
    SG.Select25 := GForm.b_25.Down;
    SG.Select50 := GForm.b_50.Down;
    SG.Selectu := GForm.b_u.Down;
    SG.DoIt;
//    Entita:= TEntity(SG.Output);
    SG.Free;
  except
  end;
  PostMsg(tm_ReView, Self, nil, DontKill);
end;



procedure   TGuideFormTool.on_tm_SelectSizeChange(var Handled: boolean);
var
   E: TRectEntityEditor;
   El: TRectEntity;
   D: TDoublerect;
begin
   E := TRectEntityEditor(Tools.FindElementClass(TRectEntityEditor));
   if E = nil then exit;
   El := E.SelectedElement;
   if TElement(El) is TRectEntity then
   begin
      D := E.Device.Projection.GetModelRect(E.ShiftRect.Left,E.ShiftRect.Top,E.ShiftRect.Right,E.ShiftRect.Bottom);
      SizePanel.XMin := D.Minx;
      SizePanel.YMin := D.Miny;
      SizePanel.XMax := D.Maxx;
      SizePanel.YMax := D.Maxy;
   end;
end;


procedure   TGuideFormTool.on_tm_SetPropertyEditors(var Handled: boolean);
var
   E: TRectEntityEditor;
   El: TRectEntity;
begin
   E := TRectEntityEditor(Tools.FindElementClass(TRectEntityEditor));
   if E = nil then exit;
   El := E.SelectedElement;
   if El = nil then exit;
   if TElement(El) is TRectEntity then
   begin
      SizePanel.SetXMin(El.Minx);
      SizePanel.SetYMin(El.Miny);
      SizePanel.SetXMax(El.Maxx);
      SizePanel.SetYMax(El.Maxy);
      SizePanel.ed_Name.Text := El.Name;
      if El is TMapSpace then SizePanel.ed_Scale.Text := FloatToStr(TMapSpace(El).Scale);
   end;
end;



procedure   TGuideFormTool.on_tm_GuideSelect(var Handled: boolean);
begin
    Corb := Guide;
    Selecting := true;
    GForm.Panel1.Visible := true;
    CheckDeviceSize(true);
    //PostMsg(tm_ReView, Self, nil, DontKill);
end;


procedure   TGuideFormTool.On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   Guide: TGuide;
//   Guide_50: TGuidePage_50;
//   Guide_10: TGuidePage_10;
//   Guide_5: TGuidePage_5;
   Coord: TDoubleCoord;
   S50, S25, S10, S5, S2: string;
begin
    Handled := true;
    begin
        try
           Coord := Device.Projection.GetModelPoint(aMessage.x, aMessage.y);
           GForm.l_x.Caption := FloatToStrF(Coord.x, ffFixed, 12, 2);
           GForm.l_y.Caption := FloatToStrF(Coord.y, ffFixed, 12, 2);

           if Input = nil then exit;
           if Input is TGuide then Guide := TGuide(Input)
                              else Guide := TGuide(TEntity(Input).FindElementClass(TGuide));
           if Guide = nil then exit;
           if GForm.b_ZM.Down then
           begin
              S50 := Guide.ZM.GetNameByCoords(Coord.x,Coord.Y);
              if GForm.l_50.Caption <> S50 then GForm.l_50.Caption := S50;
              if GForm.l_25.Caption <> '' then GForm.l_25.Caption := '';
              if GForm.l_10.Caption <> '' then GForm.l_10.Caption := '';
              if GForm.l_5.Caption <> '' then GForm.l_5.Caption := '';
              if GForm.l_2.Caption <> '' then GForm.l_2.Caption := '';
           end
           else
           begin
              Guide.GetSMONamesByCoord (Coord.x, Coord.y, S50, S25, S10, S5, S2);
              if GForm.l_50.Caption <> S50 then GForm.l_50.Caption := S50;
              if GForm.l_25.Caption <> S50 then GForm.l_25.Caption := S25;
              if GForm.l_10.Caption <> S10 then GForm.l_10.Caption := S10;
              if GForm.l_5.Caption <> S5 then GForm.l_5.Caption := S5;
              if GForm.l_2.Caption <> S2 then GForm.l_2.Caption := S2;
           end;
        except
        end;
    end;
end;


procedure   TGuideFormTool.on_tm_ViewBySelect(var Handled: boolean);
var
   T: TRecGuideSelect;
   R: TRectangle;
begin
   T := TRecGuideSelect.Create;
   T.Select10 := TGuideInterpret(Interpret).Show_10;
   T.Select5  := TGuideInterpret(Interpret).Show_5;
   T.Select2  := TGuideInterpret(Interpret).Show_2;
   T.Select25  := TGuideInterpret(Interpret).Show_25;
   T.Select50  := TGuideInterpret(Interpret).Show_50;
   T.SelectU  := TGuideInterpret(Interpret).Show_U;
   T.SelectVectors := false;
   T.Input := Guide;
   T.DoIt;
   R := TRectangle(T.Output);
   if R <> nil then
      Device.Projection.ChangeProjectionByRectangle(R, Device.Page);
   PostMsg(tm_Review, Self, nil, DontKill);
   R.Free;
   T.Free;
end;

procedure   TGuideFormTool.on_tm_ViewByVectors(var Handled: boolean);
var
   T: TRecGuideSelect;
   R: TRectangle;
begin
   T := TRecGuideSelect.Create;
   T.Select50 := false;
   T.Select25 := false;
   T.Select10 := false;
   T.Select5  := false;
   T.Select2  := false;
   T.SelectU  := false;
   T.SelectVectors := true;
   T.Input := Guide;
   T.DoIt;
   R := TRectangle(T.Output);
   if R <> nil then
      Device.Projection.ChangeProjectionByRectangle(R, Device.Page);
   PostMsg(tm_Review, Self, nil, DontKill);
   R.Free;
   T.Free;
end;


procedure   TGuideFormTool.on_tm_NewUserSpace(var Handled: boolean);
begin
   try
      FindMenuItemIn('Tools','TNewUserMapSpace').OnClick(nil);
   except
   end;
end;

procedure   TGuideFormTool.on_tm_EditUserSpace(var Handled: boolean);
begin
   try
      FindMenuItemIn('Tools','TUserMapSpaceEditor').OnClick(nil);
   except
   end;
end;

procedure   TGuideFormTool.on_tm_SizePanelOn (var Handled: boolean);
begin
   SizePanel.Visible := true;
end;


procedure   TGuideFormTool.on_tm_SizePanelOff (var Handled: boolean);
begin
   SizePanel.Visible := false;
   GForm.b_Size.Down := false;
end;



procedure   TGuideFormTool.SetInput(aInput: TElement);
begin
   if FInput <> nil then
   begin
      Corb := TGuide(FInput);
      FInput := nil;
   end;
   FInput := aInput;
   AddElement(aInput);
   try
      if aInput is TRectEntity then
      begin
         Device.Projection.ChangeProjectionByRectangle(TRectEntity(aInput).Rect, Device.Page);
      end;
      Interpret.Input := Input;
   except
   end;
end;


procedure   TGuideFormTool.CreateForm;
begin
   Application.CreateForm(TGuideForm, FForm);
   GForm.Tool := Self;
   GForm.IsPossibleToClose := false;
   {
   Form := TStandardForm(GForm);
   }
end;


procedure   TGuideFormTool.LinkDeviceToForm;
begin
//   with TCanvasToBMPDevice(Device) do
//   with TCanvasBMPDoubleDevice(Device) do
   with TImageCanvasDevice(Device) do
   begin
//      Canvas := Form.PaintBox.Canvas;
      Canvas := GForm.Image.Canvas;
      Bitmap := GForm.Image.Picture.Bitmap;
   end;
end;

procedure   TGuideFormTool.CreateInterpret;
begin
   Interpret := TGuideInterpret.Create;
   TGuideInterpret(Interpret).Show_5 := true;
   TGuideInterpret(Interpret).Show_Text := true;
   TGuideInterpret(Interpret).Fill_Page  := true;
end;


procedure   TGuideFormTool.CreateTools;
begin
   NextTool := TGuideSelector.Create;
   {
   NextTool := TGuide_10_Selector.Create;

   NextTool := TGuide_5_Selector.Create;
   }
   NextTool := TNewUserMapSpace.Create;
   NextTool := TUserMapSpaceEditor.Create;

   NextTool := TViewer.Create;
end;

function    TGuideFormTool.GetVisible: boolean;
begin
   try
      result := GForm.Visible;
   except
      result := false;
   end;
end;

procedure   TGuideFormTool.SetVisible(aVisible: boolean);
begin
   try
      GForm.Visible := aVisible;
      Device.SetupPage(nil);
   except
   end;
end;


function    TGuideFormTool.GetMainMenu: TMainMenu;
begin
   result := GForm.MainMenu;
end;


function    TguideFormTool.GetCaption: string;
begin
   result := GForm.Caption;
end;

procedure   TguideFormTool.SetCaption(const aValue: string);
begin
   GForm.Caption := aValue;
end;


function    TguideFormTool.GetGuide: TGuide;
begin
   result := TGuide(FInput);
end;



procedure   TguideFormTool.SetGuide(aValue: TGuide);
begin
   SetInput(aValue);
end;


procedure   TguideFormTool.SetCorb(aValue: TGuide);
begin
   if (FCorb <> nil) and (FCorb <> FInput) then
   begin
      FreeElement(FCorb);
      FCorb := nil;
   end;
   FCorb := aValue;
end;





procedure TGuideFormTool.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
      tm_CreateGuideAuto: on_tm_CreateGuideAuto(Handled);
      tm_CreateGuideMan : on_tm_CreateGuideMan(Handled);
      tm_GuideOK        : on_tm_GuideOK;
      tm_GuideCancel    : on_tm_GuideCancel;
      tm_Viewer         : on_tm_Viewer(Handled);
      tm_Selector       : on_tm_Selector(aMessage, Handled);
      tm_DeleteSelected : on_tm_DeleteSelected(Handled);
      tm_InvertSelected : on_tm_InvertSelected(Handled);

      tm_GuideSelect    : on_tm_GuideSelect(Handled);
      tm_ViewBySelect   : on_tm_ViewBySelect(Handled);
      tm_ViewByVectors  : on_tm_ViewByVectors(Handled);
      tm_NewUserSpace   : on_tm_NewUserSpace(Handled);
      tm_EditUserSpace  : on_tm_EditUserSpace(Handled);
      tm_SizePanelOn    : on_tm_SizePanelOn(Handled);
      tm_SizePanelOff   : on_tm_SizePanelOff(Handled);
      tm_SelectSizeChange: on_tm_SelectSizeChange(Handled);
      tm_SetPropertyEditors:on_tm_SetPropertyEditors(Handled);
      tm_ImportBlk      : on_tm_ImportBlk(Handled);
   end;
end;





procedure TGuideFormTool.SetiniFileName(const Value: string);
begin
   FiniFileName := Value;
   FStream3 := ChangeFileExt(Value,'.MPG');
end;


procedure TGuideFormTool.LoadAll;
var
   GI: TGuideInterpret;
   GS: TGuideSelector;
//   G: TGuide;
//   D: TCreateGuideDialog;
   Loader: TLoad;
   Ini: TIniFile;
   DC: TDoubleCoord;
   E: extended;
   Scale: double;
   SelEl: TElement;
   S: string;
begin
   //Device.Page.Color := clSilver;

   GI := TGuideInterpret(Interpret);

   //GForm.Panel1.Visible := false;
//   CheckDeviceSize;
   S := Stream3;
   if FileExists(S) then
   begin
      Loader := TLoad.CreateAll(S);
      try
        Loader.DoIt;
        Guide := TGuide(Loader.Output);
        SelEl:= Guide.FindElementClass(TSelectedElement);
        if SelEl <> nil then
           Guide.FreeElement(SelEl)
      except
         ShowMessage('Soubor prvodce byl patrn pokozen, bude vytvoen nov .. ');
         PostMsg(tm_CreateGuideMan,  Self, nil, DontKill);
      end;
      Loader.Free;
   end
   else
   begin

      if true{TOldMainTool(World.MainTool).NoProject} then
      begin
         PostMsg(tm_CreateGuideMan,  Self, nil, DontKill);
      end
{      else
      begin
         Application.CreateForm(TCreateGuideDialog, D);
         D.Left := GForm.Left;
         D.Top  := GForm.Top;
         if D.ShowModal = mrOK then
         case d.r_Kind.ItemIndex of
            0: PostMsg(tm_CreateGuideAuto, Self, nil, DontKill);
            1: PostMsg(tm_CreateGuideMan,  Self, nil, DontKill);
         end;
         D.Free;
      end;
}
   end;
   begin
      Ini := TIniFile.Create(IniFileName);
      E := GI.Device.Projection.CenterPoint.x;
      E := StrToFloat(Ini.ReadString('Guide','X', FloatToStr(E)));
      DC.x := E;
      E := GI.Device.Projection.CenterPoint.y;
      E := StrToFloat(Ini.ReadString('Guide','y', FloatToStr(E)));
      DC.y := E;
      E := GI.Device.Projection.Scale;
      E := StrToFloat(Ini.ReadString('Guide','Scale', FloatToStr(E)));
      Scale := E;
      GI.Device.Projection.ChangeProjection(DC, Scale, GI.Device.Page);
      GI.Show_U  := Ini.ReadBool('GuideForm','U', true);
      GI.Show_2  := Ini.ReadBool('GuideForm','2', true);
      GI.Show_5  := Ini.ReadBool('GuideForm','5', true);
      GI.Show_10 := Ini.ReadBool('GuideForm','10',false);
      GI.Show_25 := Ini.ReadBool('GuideForm','25',false);
      GI.Show_50 := Ini.ReadBool('GuideForm','50',false);
      GI.Show_Text:= Ini.ReadBool('GuideForm','Texty',true);
      GI.Fill_Page := Ini.ReadBool('GuideForm','Fill',true);
      GS := TGuideSelector(Tools.FindElementClass(TGuideSelector));
      GS.Select2 := GI.Show_2;
      GS.Select5 := GI.Show_5;
      GS.Select10 := GI.Show_10;
      GS.Select25 := GI.Show_25;
      GS.Select50 := GI.Show_50;
      GS.SelectU := GI.Show_U;
      Ini.Free;
   end;

   GForm.b_50.Down := GI.Show_50;
   GForm.b_25.Down := GI.Show_25;
   GForm.b_10.Down := GI.Show_10;
   GForm.b_5.Down  := GI.Show_5;
   GForm.b_2.Down  := GI.Show_2;
   GForm.b_U.Down  := GI.Show_U;
   GForm.b_Texty.Down  := GI.Show_Text;
   GForm.b_Fill.Down   := GI.Fill_Page;
   Selecting := true; {sem to samozejm nepat, ale kam jsem to ml strit, e ? }
   GForm.Panel1.Visible := false;
   CheckDeviceSize(false);
end;

END.
