unit T_lhpmap;
{ Tvorba map LHP vyaduje
  - ablonu obsahujc
    . rzn statick prvky
    . pojmenovan dynamick texty
      . nzev mapovho listu v rmci listokladu
      . mtko
      . datum a dal mnn popisy
    . pojmenovan pohledy
  - mtko, umstn a nzev mapovho listu v rmci listokladu
  - obsah pohledu

  Cel se to d jednm textovm INI souborem
  [GENERAL]
  TEMPLATE = C:\TEMPLATES\PORMAP.MSD
  Nsleduj odkazy na jednotliv pojmenovan poloky ablony
  [ZPRACOVAL]  textov komponent
  TEXT = Josef Novk
  FORM=1                               poloha v zadvacm formuli
  DESCRIPTION= Jmno zpracovatele      jmno pro zadvac formul
  [POHLED1]    pohled komponent
  SCALE=5000
  CENTERX=
  CENTERY=
  LIN=DET.BLK
  =DRUH=2
  ARE=
  PNT=
  RAS=
  TXT=
  [POHLED2]

  nstroj pro tvorbu map LHP
  TLHPMapSheetGenerator    (TMSTemplateGenerator)

 Vstup : properta - soubor *.MSD
 DoIt  : - nate a zalo mapov list
         - nathne bloky k jednotlivm pohledm
         - nastaven dynamickch text - sputn zadvacho formule
         - nastaven relnho prostoru pro jednotliv pohledy

 Vstup: Nastaven mapov list, kter je mon zobrazit i vytisknout,
         um zpstupnit pohledy a texty nzvem


TMapSheetPreparator = class(TMSTemplateGenerator)
Zajist naten vrstev pohled i s jejich vlastnostmi do StringElement

Nzev StringElementu vrstvy: LIN, ARE, ...
Nzev vlastnosti zan na @ (nap. @COLOR) ale pi ukldn
do StringElement se tento znak vyhod


TMapSheetFiller = class(TTool)
Napln MapSheet konkrtnm seznamem adres blok a rastr (FillWildNames) dle
FDataDir, nastav mapov prostory dle FMapSpace (FillMapSpaces).
Provede vlastn naten grafickch objekt dle jejich adres a vlastnost
(ReadGraphics).

}

interface
uses
  Elements, E_View, Tools, E_Type,
  E_MSpace,// T_PZ,
  E_Map, T_MapSh, E_TlView, e_LayScr;

type



(*
 TLHPMapSheetGenerator = class(TMSTemplateGenerator)
 protected
 {
   procedure AddViewParameter(aParameterName: string; aView: TView); override;
 }
 public
   procedure   DoIt; override;
 end;
*)

TMapSheetFiller = class(TTool)
private
  FMapSpace: TMapSpace;
  FTemplateFileName: string;
  FFillGraphics: boolean;
  FMINDs: TEntity;
    FNoMIND: boolean;
    FActualDataDir: string;
  procedure SetMapSpace(aMapSpace: TMapSpace);
  procedure SetStringElement(aStringElement: TStringElement);
  function  GetString(aName: string): string;
  function  GetMap: TMapSheet;
  procedure FillMapSpaces(aMap: TMapSheet);
  procedure FillWildNames(aMap: TEntity; aDataDir: string);
  procedure AskTexts(aMap: TMapSheet);
  procedure FillTexts(aMap: TMapSheet);
  procedure ReadGraphics(aMap: TEntity);
  function  MIND_Check(aDataDir: string): TEntity;
    function GetMINDs: TEntity;
    procedure SetMINDs(const Value: TEntity);
    procedure SetNoMIND(const Value: boolean);
    procedure SetActualDataDir(const Value: string);
protected
  procedure   SetInput(aInput: TElement); override;
public
  procedure DoIt; override;
  property  MINDs: TEntity read GetMINDs;
published
  property FillGraphics: boolean read FFillGraphics write FFillGraphics;
  property NoMIND: boolean read FNoMIND write SetNoMIND;
  property ActualDataDir: string read FActualDataDir write SetActualDataDir;
end;

(*
procedure CreateMapSheetL;

procedure CreateMapSheetForName(aName: string);
*)

implementation
uses
  Forms,
  Dialogs,
  SysUtils,
  System.DateUtils,
  System.Math,
  e_Class,
  e_Files,
  E_Guide,
  //E_TopMdl,
{$IFDEF BINRAS}
  E_TopRas,
{$ENDIF}
  //F_Main,
  G_Elems,
  M_Orbis,
  M_Proj,
  //T_Guide,
  t_MSCIp,
  T_TopImp,
  T_VarTXT,
  {!T_Main,}
  //E_ZM,
  u_String,
  t_Loader,
  E_DeskTp,
  Worlds;




procedure TMapSheetFiller.SetMapSpace(aMapSpace: TMapSpace);
begin
  if FMapSpace <> nil then
  begin
    FreeElement(FMapSpace);
    FMapSpace:= nil
  end;

  FMapSpace:= aMapSpace;
  AddElement(aMapSpace)
end;



procedure TMapSheetFiller.SetMINDs(const Value: TEntity);
begin
   FMINDs := Value;
end;

procedure TMapSheetFiller.SetNoMIND(const Value: boolean);
begin
  FNoMIND := Value;
end;

procedure TMapSheetFiller.SetStringElement(aStringElement: TStringElement);
var
  StringElement: TStringElement;
begin
  StringElement:= TStringElement(FindElementName(aStringElement.Name));
  if (StringElement <> nil) and (TElement(StringElement) is TStringElement) then
  begin
    FreeElement(StringElement)
  end;

  AddElement(aStringElement)
end;



function  TMapSheetFiller.GetString(aName: string): string;
var
  StringElement: TStringElement;
begin
  result:= '';
  StringElement:= TStringElement(FindElementName(aName));
  if (StringElement <> nil) and (TElement(StringElement) is TStringElement) then
     result:= StringElement.Text
end;


function TMapSheetFiller.MIND_Check(aDataDir: string): TEntity;
var
   e,ee: TElement;
   En: TEntity;
   MIND: TEntity;
   Props: TStringListElement;
   MindFileName: string;
   i: integer;
   FE: TFileElement;
   prop: TPathRectInfoElement;
   err: integer;
   errs: string;
   SSlozka: string;
   aCHeckSum: Double;
begin
   result := nil;
   e := MINDs.FindElementName(aDataDir); // hledame jestli uz je nacten
   if e = nil then                       // pokud ne, podivame se jestli tam neco je .. jako na disku
   begin
      MindFileName := IncludeTrailingPathDelimiter(aDataDir) + 'MIND.mix';
      SSlozka := 'Sloka ' + aDataDir + ' ';
      if not FileExists(MindFileName) then   // no jasne .... neni!
      begin
         i := MessageDlg(SSlozka + 'nem jet asn super index - vytvoit?',mtConfirmation,mbYesNo,0);
         if i <> 6 then exit;
         ActualDataDir := aDataDir;
         PostTextMsg(tm_Run,'Mapper\Mapper_Create_MIND.oil',nil);
         Application.ProcessMessages;
         if not FileExists(MindFileName) then exit;
      end;
      // nacteni indexu
      err := 0;
      errs := '';
      MIND := TEntity(_Load(MindFileName));
      // kontrola
      ee := MIND.FindElementName('PROP');
      if (ee = nil) or not(ee is TPathRectInfoElement)  then
      begin
         err := 1;
         errs := ' Chybn index';
      end;
      if err = 0 then
      begin
         prop := TPathRectInfoElement(ee);
         // kontrola cesty
         if prop.Path <> AnsiUpperCase(aDataDir) then
         begin
            err := 1;
            errs := ' Chybn index - Nesouhlas cesta';
         end
         else
         // kontrola Time
         begin
            aCheckSum := GetDirectoryCheckSum(aDataDir) + 1; // +1 je kvuli kontrole ORBu
            i := CompareValue(aCheckSum,Prop.CheckSum,1E-7);
            if i <> 0 then
            begin
               err := 2;
               errs := ''
            end;
         end;
      end;
      if err > 0  then
      begin
         MIND.Free;
         MIND := nil;
         ActualDataDir := aDataDir;
         if err = 1 then
         begin
            i := MessageDlg(SSlozka + errs +' - vytvoit nov?',mtConfirmation,mbYesNo,0);
            if i <> 6 then exit;
            PostTextMsg(tm_Run,'Mapper\Mapper_Create_MIND.oil',nil);
            Application.ProcessMessages;
         end
         else
         if err = 2 then
         begin
            PostTextMsg(tm_Run,'Mapper\Mapper_Create_MIND_Reindex.oil',nil);
            Application.ProcessMessages;
         end;
         MIND := TEntity(_Load(MindFileName));
      end;
      En := TEntity(MINDs.FindOrCreateElementName(TOwnerEntity,aDataDir));
      En.FreeAll;
      EN.NextElement := MIND;
   end
   else
   begin
      En := TEntity(e);
      MIND := TEntity(En.FindElementName('MIND'));
   end;
   // kontrola cesty
   // kontrola casoveho razitka
   // a pokud je vsechno v poradku ....
   e :=  MIND.FindElementName('Seznam');
   result := TEntity(e);
end;

function  TMapSheetFiller.GetMap: TMapSheet;
var
  TemplName: string;
  Preparator: TMSTemplateGenerator;
begin
  result:= nil;
  TemplName:= GetString('TEMPLATE');
  FTemplateFileName := TemplName;
  if (TemplName = '') or not fileExists(TemplName) then exit;

  {Generovani mapoveho listu}
  Preparator := TMSTemplateGenerator.Create;
  Preparator.TemplateFileName:= TemplName;
  Preparator.DoIt;
  result:= TMapSheet(Preparator.Output);
  Preparator.Free;
end;




function TMapSheetFiller.GetMINDs: TEntity;
begin
   if FMinds = nil then
   begin
      FMinds := TOwnerEntity.Create;
      FMINDs.Name := 'MINDs';
      AddElement(FMinds);
   end;
   result := FMinds;
end;

procedure TMapSheetFiller.SetActualDataDir(const Value: string);
begin
  FActualDataDir := Value;
end;

procedure TMapSheetFiller.SetInput(aInput: TElement);
begin
  if (aInput = nil) or (aInput is TMapSpace) then
     SetMapSpace(TMapSpace(aInput))
  else
  if aInput is TStringElement then
     SetStringElement(TStringElement(aInput))
end;



procedure TMapSheetFiller.FillMapSpaces(aMap: TMapSheet);
var
   ViewSMO: TView;
begin
{naplnn View}
   ViewSMO:= nil;

   if FMapSpace is TSMO_10 then
      ViewSMO:= aMap.GetViewByName('SMO10')
   else
   if FMapSpace is TSMO_5 then
      ViewSMO:= aMap.GetViewByName('SMO5');

   if (ViewSMO = nil) and (TElement(FMapSpace) is TMapSpace) then
      ViewSMO:= aMap.GetViewByName('MAIN');

   if ViewSMO = nil then
     ShowMessage('Pro ' + FMapSpace.Name + ' nebyl nalezen clov pohled');

   if ViewSMO <> nil then
   begin
     ViewSMO.Projection.Center_X:= FMapSpace.CenterX;
     ViewSMO.Projection.Center_Y:= FMapSpace.CenterY;
     if (FMapSpace.Scale > 0) and (ViewSMO.Projection.Scale=0) then
        ViewSMO.Projection.Scale:= FMapSpace.Scale;
   end;

end;


procedure TMapSheetFiller.FillTexts(aMap: TMapSheet);
var
   Delimiters : TDelimiters;
   Delimiter: char;
   Position: longInt;
   S: string;
   i: longInt;
   T: Ttext;
begin
   Delimiters := ['.','(',')',':'];
   for i := 0 to aMap.Count-1 do
   begin
      if aMap.Elements[i] is Ttext then
      begin
         T := TText(aMap.Elements[i]);
         S := ReadToDelimiterWithoutWS(T.Text,  Delimiters, 1, Delimiter, Position);
         if (Delimiter = ':') and (S = '!') then
         begin
            try
               S := T.Text;
               S := Copy(S, Position, (Length(S) - Position)+1);
               T.Text := aMap.ExecuteCommandLine(S);
            except
            end;
         end;
      end;
   end;
end;



procedure TMapSheetFiller.AskTexts(aMap: TMapSheet);
var
   Delimiters : TDelimiters;
   Delimiter: char;
   Position: longInt;
   S: string;
   i: longInt;
   T: Ttext;
   VTD: TVarTextDialog;
   E: TEntity;
begin
   Delimiters := ['.','(',')',':'];

   E := TEntity.Create;
   VTD := TVarTextDialog.Create;


   for i := 0 to aMap.Count-1 do
   begin
      if aMap.Elements[i] is Ttext then
      begin
         T := TText(aMap.Elements[i]);
         S := ReadToDelimiterWithoutWS(T.Text,  Delimiters, 1, Delimiter, Position);
         if (Delimiter = ':') and (S = '?') then
         begin
           T.Text := Copy(T.Text, Position, (Length(T.Text) - Position)+1);
           E.AddElement(T);
         end;
      end;
   end;

   if E.Count > 0 then
   begin
     VTD.Input := E;
     VTD.DoIt;
   end;

   E.Free;
   VTD.Free;
end;



procedure TMapSheetFiller.FillWildNames(aMap: TEntity; aDataDir: string);
var
  I: longInt;
  aScript: TModelScript;
  DDir: string;
  aView: TView;
  MIND: TEntity;
begin
  for I:= 0 to aMap.Count-1 do
  begin
    if aMap.Elements[I] is TView then
    begin
      aView := TView(aMap.Elements[I]);
      if aView.DataDirectory <> '' then
         DDir := aView.DataDirectory
      else
         DDir := aDataDir;
      aScript:= aView.GetModelScript;
      if aScript <> nil then
      begin
        MIND := nil;
        if not (NoMIND or aView.NoMIND) then
           MIND := MIND_Check(DDir);
        aScript.FillWildNames(DDir,MIND)
      end
    end
    else
    if aMap.Elements[I] is TDeskTop then
       FillWildNames(TEntity(aMap.Elements[I]), aDataDir)
  end;
end;


procedure TMapSheetFiller.ReadGraphics(aMap: TEntity);
var
  I: longInt;
  aView: TView;

begin
  for I:= 0 to aMap.Count-1 do
  begin
    if aMap.Elements[I] is TView then
    begin
      aView:= TView(aMap.Elements[I]);

      if not aView.ReadAfter then
         aView.ReadGraphics;
    end
    else
    if aMap.Elements[I] is TDeskTop then
       ReadGraphics(TEntity(aMap.Elements[I]))
  end;
end;


procedure TMapSheetFiller.DoIt;
var
  Map: TMapSheet;
  S: string;
  MSC: TMSCInterpret;
begin
{ ml bych mt k dispozici
  1. Vybranou ablonu: SelectedTemplate: string;
  2. Vybran prostor:  SelectedMapSpace: TMapSpace;
  3. Pracovn adres: DataDirectory: string}
  StartProgress('Tvorba mapy ...',0,0);
  ProgressText := 'Zpracovn ablony';
  Application.ProcessMessages;
  Map:= GetMap;

  if Map = nil then
  begin
     EndProgress;
     exit;
  end;
{
  TMainTool(World.MainTool).MapSheets.AddElement(Map);
}
  if FMapSpace <> nil then
  begin
  { pokusme se uplatnit Map prostor }
    Map.MapSpace := FMapSpace;
    FillMapSpaces(Map)
  end;

  {
  AskTexts(Map);
  FillTexts(Map);
  }
  ProgressText := 'Hledn soubor ...';
  Application.ProcessMessages;
  FillWildNames(Map, GetString('DATADIR'));

  if FillGraphics then
  begin
     ProgressText := 'ten dat ...';
     Application.ProcessMessages;
     ReadGraphics(Map);
     S := FTemplateFileName;
     S := ChangeFileExt(S, '.M3C');
     if not FileExists(S)then
        S := ChangeFileExt(S, '.MSC');
     MSC := TMSCInterpret.CreateAll(S);
     MSC.Input := Map;
     MSC.DoIt;
     MSC.Free;
  end;
  Output:= Map;
  EndProgress;
end;



begin

end.

