unit E_type;
{
[Unit_Description]
Description=Tdy typovch element
Admin=Petr
TechTopic=Elements
Topic=System
Version=1.0
}
{
*********************************************************************
*                                                                   *
*  ORBIS ... Tdy zkladn typov elementy                         *
*                                                                   *
*                       Topol Pro 1996                             *
*********************************************************************
}

interface
uses
  Classes,
  Elements;


type
 TType=(_Boolean,_Char,_Byte,_Float,_String,_Integer,_Pointer,_Other);


TTypeElement = class(TOwnerElement)
protected
   function  GetType:TType; virtual;
   function  GetTypeAsString: string; virtual;
   function  GetAsByte: byte; virtual;
   procedure SetAsByte(aValue: byte); virtual;
   function  GetAsInteger:longint; virtual;
   procedure SetAsInteger(aValue: longint); virtual;
   function  GetAsChar: char; virtual;
   procedure SetAsChar(aValue: char); virtual;
   function  GetAsString: string; virtual;
   procedure SetAsString(aValue: string); virtual;
   function  GetAsFloat: double; virtual;
   procedure SetAsFloat(aValue: double); virtual;
   function  GetAsBoolean: boolean; virtual;
   procedure SetAsBoolean(aValue: boolean); virtual;
   function  GetAsPointer: pointer; virtual;
   procedure SetAsPointer(aValue: pointer); virtual;
   function  GetUpperName: string; virtual;
public
   property AsPointer: pointer read GetAsPointer write SetAsPointer;
published
   property Typ:Ttype read GetType stored false;
   property TypeAsString: string read GetTypeAsString stored false;
   property AsByte: byte       read GetAsByte    write SetAsByte stored false;
   property AsInteger: longint read GetAsInteger write SetAsInteger stored false;
   property AsChar: Char       read GetAsChar    write SetAsChar stored false;
   property AsString: string   read GetAsString  write SetAsString stored false;
   property AsFloat: double    read GetAsFloat   write SetAsFloat stored false;
   property AsBoolean: boolean read GetAsBoolean write SetAsBoolean stored false;
   property Text: string read GetAsString write SetAsString stored false;
   property UpperName: string read GetUpperName stored false;
end;

TBooleanElement=class(TTypeElement)
 private
   FValue:boolean;
   {no char,float,integer}
   procedure SetAsBoolean(aValue:boolean); override;
   procedure SetAsByte(aValue:byte); override;
   procedure SetAsString(aValue:string);  override;
   function GetAsBoolean:boolean; override;
   function GetAsByte:byte; override;
   function GetAsString:string;  override;
   function  GetTypeAsString: string;override;
   function  GetType:TType;override;
 public
   constructor CreateValue(aValue:boolean);
   constructor CreateAll(aName: string; aValue:boolean);
  published
   property Value:boolean read GetAsBoolean write SetAsBoolean;
 end;

 TCharElement=class(TTypeElement)
 private{?}
   FValue:char;
   {no boolean}
   {no float}
   procedure SetAsChar(aValue:char); override;
   procedure SetAsByte(aValue:byte); override;
   procedure SetAsString(aValue:string); override;
   procedure SetAsInteger(aValue:longint); override;
   function GetAsChar:char; override;
   function GetAsByte:byte; override;
   function GetAsString:string; override;
   function GetAsInteger:longint{?}; override;
   function  GetTypeAsString: string;override;
   function  GetType:TType;override;
  public
   constructor CreateValue(aValue:char);
   constructor CreateAll(aName: string; aValue:char);
  published
   property Value:char read GetAsChar write SetAsChar;
  end;

 TByteElement=class(TTypeElement)
 private{?}
   FValue:byte;
    {no boolen}
   procedure SetAsBoolean(aValue:boolean); override;
   procedure SetAsChar(aValue:char); override;
   procedure SetAsByte(aValue:byte); override;
   procedure SetAsFloat(aValue:double{?}); override;
   procedure SetAsString(aValue:string); override;
   procedure SetAsInteger(aValue:longint{?}); override;
   function GetAsBoolean:boolean; override;
   function GetAsChar:char; override;
   function GetAsByte:byte; override;
   function GetAsFloat:double{?}; override;
   function GetAsString:string; override;
   function GetAsInteger:longint{?}; override;
   function  GetTypeAsString: string;override;
   function  GetType:TType;override;
  public
   constructor CreateValue(aValue:byte);
   constructor CreateAll(aName: string; aValue:byte);
  published
   property Value:byte read GetAsByte write SetAsByte;
  end;


 TFloatElement=class(TTypeElement)
 private{?}
   FValue:double;
    {no boolen,char,byte}
   procedure SetAsFloat(aValue:double{?}); override;
   procedure SetAsString(aValue:string); override;
   function  GetTypeAsString: string;override;
   function  GetType:TType;override;
   procedure SetAsInteger(aValue:longint{?}); override;
   function GetAsFloat:double{?}; override;
   function GetAsString:string; override;
   function GetAsInteger:longint{?}; override;
  public
   constructor CreateValue(aValue: double);
   constructor CreateAll(aName: string; aValue: double);
  published
   property Value:double read GetAsFloat write SetAsFloat;
  end;


TIntegerListElement = class(TEntity)
private
   FSorted: boolean;
   FDuplicates: boolean;
   function  GetInteger(aIndex: longInt): longInt;
   procedure PutInteger(aIndex: longInt; aValue: longInt);
public
   procedure AddInteger(aValue: longInt);
   function  ValueExists(aValue: longInt): boolean;
   property  Integers[aIndex: longInt]: longInt read GetInteger write PutInteger;
   property  Sorted: boolean read FSorted write FSorted;
   property  Duplicates: boolean read FDuplicates write FDuplicates;
   property  NoValue: boolean read NoElements;
end;


TStringElement = class(TTypeElement)
private
   FValue:string;
    {no boolen,char,byte,float,intege}
protected
   procedure SetAsString(aValue:string); override;
   function  GetAsString:string; override;
   function  GetTypeAsString: string;override;
   function  GetType:TType;override;
   procedure SetNameIsValue(aValue: string);
   function  GetNameIsValue: string;
   procedure SetAsInteger(aValue:longint); override;
   function  GetAsInteger:longint; override;
   function  GetAsFloat: double; override;
   procedure SetAsFloat(aValue: double); override;
   function  GetAsBoolean: boolean; override;
   procedure SetAsBoolean(aValue: boolean); override;
public
   constructor CreateValue(aValue: string);
   constructor CreateAll(aName, aValue: string);
   constructor CreateAllFromString(aValue: string;CPP: integer = 0);
   function    GetLongInt(aValue: longInt; var OKej: boolean): longInt;
   function    GetBoolean(aValue: boolean; var OKej: boolean): boolean;
   function    GetDouble (aValue: double;  var OKej: boolean): double;
   procedure   SetLongInt(aValue: longInt);
   procedure   SetDouble (aValue: double);
   function    CreateIntegerList: TIntegerListElement;
published
   property Value:string read GetAsString write SetAsString;
   property NameIsValue: string read GetNameIsValue write SetNameIsValue stored false;
  end;


TIntegerElement = class(TTypeElement)
 private
   FValue:longint;
    {no boolen,char}
   procedure SetAsBoolean(aValue:boolean); override;
   procedure SetAsByte(aValue:byte); override;
   procedure SetAsFloat(aValue:double{?}); override;
   procedure SetAsString(aValue:string); override;
   procedure SetAsInteger(aValue:longint{?}); override;
   function GetAsBoolean:boolean; override;
   function GetAsByte:byte; override;
   function GetAsFloat:double{?}; override;
   function GetAsString:string; override;
   function GetAsInteger:longint{?}; override;
   procedure SetAsPointer(aValue:pointer);override;
   function GetAsPointer:pointer; override;
   function  GetTypeAsString: string;override;
   function  GetType:TType;override;
  public
   constructor CreateValue(aValue: longInt);
   constructor CreateAll(aName: string; aValue: longInt);
  published
   property Value:longint read GetAsInteger write SetAsInteger;
  end;



TPointerElement = class(TTypeElement)
 private
   FValue:pointer;
   FClassName:string;
   procedure SetAsInteger(aValue:longint{?}); override;
   function GetAsInteger:longint{?}; override;
   procedure SetAsPointer(aValue:pointer);override;
   function GetAsPointer:pointer; override;
   procedure SetAsString(aValue:string);override;
   function GetAsString:string; override;
   function  GetTypeAsString: string;override;
   function  GetType:TType;override;
  public
   constructor CreateValue(aValue: pointer);
   constructor CreateAll(aName: string; aValue: pointer);
   property Value:pointer read GetAsPointer write SetAsPointer;
   property aClassName:string read FClassName write FClassName;
  end;


TPathElement = class(TStringElement)
end;

TStringListElement = class(TOwnerEntity) { zmena 3.3.98 z TNameEntity }
protected
   function  GetString(aIndex: longInt): string;
   procedure PutString(aIndex: longInt; aValue: string);
   function  GetNameAtIndex(aIndex: longInt): string;
   function  GetUpperName(aIndex: longInt): string;
   procedure PutName(aIndex: longInt; aValue: string);
   function  GetSElems(aIndex: longInt): TStringElement;
   procedure PutSElems(aIndex: longInt; aValue: TStringElement);
   procedure AddFile(aFileName: string);
   procedure IntoFile(aFileName: string);
   procedure AddName(aName: string);
public
   constructor CreateFromStringList(aStringList: TStringList);
   function    CreateStringList: TStringList;
   procedure AddStringList(aStringList: TStringList);
   procedure   ParamToNames;
   procedure AddString(aValue: string);
   function  AddNameString(aName, aValue: string): TStringElement;
   procedure AddNameIsValue(aValue: string);
   function  GetStringElementByName(aName: string): TStringElement;
   function  GetStringByName(aName: string): string;
   function  GetIntegerByName(aName: string): longInt;
   function  GetBooleanByName(aName: string): boolean;
   function  GetDoubleByName(aName: string): double;
   procedure  SetStringByName(aName: string; aValue: string);
   procedure  SetIntegerByName(aName: string; aValue: longInt);
   procedure  SetDoubleByName(aName: string;  aValue: double);

   function   GetPropertyStringByName(AName: string): string; override;
   procedure  SetPropertyStringByName(AName: string; aValue: string); override;

   property  Strings[aIndex: longInt]: string read GetString write PutString;
   property  Names[aIndex: longInt]: string read GetNameAtIndex write PutName;
   property  UpperNames[aIndex: longInt]: string read GetUpperName;
   property  StringElements[aIndex: longInt]: TStringElement read GetSElems write PutSElems;
published
   property  NextValue: string write AddString stored false;
   property  NextName: string write AddName stored false;
   property  NextNameIsValue: string write AddNameIsValue stored false;
   property  NextStringList: TStringList write AddStringList stored false;
   property  LoadFromFile: string write AddFile stored false;
   property  SaveToFile  : string write IntoFile stored false;
end;


TPropertyList = class(TStringListElement)
private
  FDelimiter: string;
{napln uveden property }
  procedure SetByElement(anElement: TElement);
  function GetCatenation: string;
published
  property Element: TElement write SetByElement;
  property Catenation: string read GetCatenation;
  property Delimiter: string read FDelimiter write FDelimiter;
end;



function CreateIntegerListElementFromString(aName, aValue: string): TIntegerListElement;




implementation

uses
  SysUtils,
  {!T_Main,}
   e_Class,
   u_Props,
   u_String,
   CtiRadek;


       { TTypeElement }


procedure TTypeElement.SetAsBoolean(aValue:boolean);
begin
end;

procedure TTypeElement.SetAsChar(aValue:char);
begin
end;

procedure TTypeElement.SetAsByte(aValue:byte);
begin
end;

procedure TTypeElement.SetAsFloat(aValue:double{?});
begin
end;

procedure TTypeElement.SetAsString(aValue:string);
begin
end;

procedure TTypeElement.SetAsInteger(aValue:longint{?});
begin
end;

function TTypeElement.GetAsBoolean:boolean;
begin
  result:= false
end;

function TTypeElement.GetAsChar:char;
begin
  result:= #0
end;

function TTypeElement.GetAsByte:byte;
begin
  result:= 0
end;

function TTypeElement.GetAsFloat:double{?};
begin
  result:= 0
end;

function TTypeElement.GetAsString:string;
begin
  result:= ''
end;

function TTypeElement.GetAsInteger:longint{?};
begin
  result:= 0
end;

function  TTypeElement.GetTypeAsString: string;
begin
  result:= ''
end;

function  TTypeElement.GetType:TType;
begin
  result:= _Other
end;


function  TTypeElement.GetAsPointer: pointer;
begin
   result := nil;
end;

procedure TTypeElement.SetAsPointer(aValue: pointer);
begin
end;



function  TTypeElement.GetUpperName: string;
begin
  result:= UpperCase(Name)
end;


 {Boolean}
  function  TBooleanElement.GetType:TType;
  begin
   result:=_boolean;
  end;

  function  TBooleanElement.GetTypeAsString:String;
  begin
   result:='boolean';
  end;

   procedure TBooleanElement.SetAsBoolean(aValue:boolean);
    begin
      FValue:=aValue;
    end;

   procedure TBooleanElement.SetAsByte(aValue:byte);
    begin
      if aValue=0 then Value:=false else Value:=true;
    end;

   procedure TBooleanElement.SetAsString(aValue:string);
     begin
      if aValue='true' then Value:=true else
      if aValue='false' then Value:=false;
     end;

   function TBooleanElement.GetAsBoolean:boolean;
     begin
      Result:=FValue;
     end;

   function TBooleanElement.GetAsByte:byte;
     begin
      if Value then Result:=1 else Result:=0;
     end;

   function TBooleanElement.GetAsString:string;
     begin
      if Value then Result:='true' else Result:='false';
     end;

   constructor TBooleanElement.CreateValue(aValue:boolean);
    begin
     inherited create;
     FValue:=aValue;
    end;

constructor TBooleanElement.CreateAll(aName: string; aValue: boolean);
 begin
  CreateValue(aValue);
  Name:= aName
 end;

   {Char}
 function  TCharElement.GetType:TType;
  begin
   result:=_char;
  end;

 function  TCharElement.GetTypeAsString:String;
  begin
   result:='char';
  end;

   procedure TCharElement.SetAsChar(aValue:char);
    begin
     FValue:=aValue;
    end;

   procedure TCharElement.SetAsByte(aValue:byte);
     begin
      Value:=char(aValue);
     end;

   procedure TCharElement.SetAsString(aValue:string);
     begin
      if aValue<>'' then Value:=aValue[1]
      else aValue:=#0;
     end;

   procedure TCharElement.SetAsInteger(aValue:longint{?});
     begin
      if (aValue>0) and (aValue<256) then Value:=Char(avalue);
     end;

   function TCharElement.GetAsChar:char;
     begin
      Result:=FValue;
     end;

   function TCharElement.GetAsByte:byte;
     begin
      Result:=Ord(Value);
     end;

   function TCharElement.GetAsString:string;
     begin
      Result:=Value;
     end;

   function TCharElement.GetAsInteger:longint{?};
    begin
     Result:=Ord(Value);
    end;

constructor TCharElement.CreateValue(aValue:char);
    begin
     inherited create;
     FValue:=aValue;
    end;

constructor TCharElement.CreateAll(aName: string; aValue:char);
 begin
  CreateValue(aValue);
  Name:= aName
 end;

  {Byte}
 function  TByteElement.GetType:TType;
  begin
   result:=_byte;
  end;

 function  TByteElement.GetTypeAsString:String;
  begin
   result:='byte';
  end;

  procedure TByteElement.SetAsBoolean(aValue:boolean);
    begin
     if aValue then Value:=1 else Value:=0;
    end;

   procedure TByteElement.SetAsChar(aValue:char);
    begin
     Value:=Ord(aValue);
    end;

   procedure TByteElement.SetAsByte(aValue:byte);
    begin
     FValue:=aValue;
    end;

   procedure TByteElement.SetAsFloat(aValue:double{?});
   var Tmp:byte;
    begin
     try
       Tmp:=Trunc(aValue);
       Value:=Tmp;
     except
       on EIntError do
        exit;
     end;
    end;

   procedure TByteElement.SetAsString(aValue:string);
   var Tmp:byte;
       Code:Integer;
    begin
     try
      val(aValue,tmp,Code);
      if Code=0 then Value:=tmp;
     except
      on EIntError do exit;
     end;
    end;

   procedure TByteElement.SetAsInteger(aValue:longint{?});
   var Tmp:longint;
    begin
     try
      Tmp:=trunc(aValue);
      Value:=Tmp;
     except
      on EIntError do exit;
     end;
    end;

   function TByteElement.GetAsBoolean:boolean;
     begin
      if Value=0 then result:=false else result:=true;
     end;

   function TByteElement.GetAsChar:char;
     begin
      Result:=Char(Value);
     end;

   function TByteElement.GetAsByte:byte;
     begin
      Result:=FValue;
     end;

   function TByteElement.GetAsFloat:double{?};
     begin
      Result:=Value;
     end;

   function TByteElement.GetAsString:string;
     begin
      Str(Value,Result);
     end;

   function TByteElement.GetAsInteger:longint{?};
     begin
      Result:=Value;
     end;

constructor TByteElement.CreateValue(aValue:byte);
    begin
     inherited create;
     FValue:=aValue;
    end;

constructor TByteElement.CreateAll(aName: string; aValue:byte);
 begin
  CreateValue(aValue);
  Name:= aName
 end;


 {Float}
 function  TFloatElement.GetType:TType;
  begin
   result:=_float;
  end;

 function  TFloatElement.GetTypeAsString:String;
  begin
   result:='float';
  end;

   procedure TFloatElement.SetAsFloat(aValue:double{?});
    begin
     FValue:=aValue;
    end;

   procedure TFloatElement.SetAsString(aValue:string);
   var Tmp:double;
       Code:Integer;
    begin
     try
      val(aValue,Tmp,Code);
      if Code=0 then Value:=Tmp;
     except
      on EIntError do exit;
     end;
    end;

  procedure TFloatElement.SetAsInteger(aValue:longint{?});
    begin
     FValue:=aValue;
    end;

   function TFloatElement.GetAsFloat:double{?};
    begin
     result:=FValue;
    end;

   function TFloatElement.GetAsString:string;
    begin {formatovat}
     Str(Value,Result);
    end;

   function TFloatElement.GetAsInteger:longint{?};
    var Tmp:longint;
    begin
     result := 0;
     try
      Tmp:=trunc(Value);
      Result:=Tmp;
     except
       on EIntError do exit;
      end;
    end;

constructor TFloatElement.CreateValue(aValue:double);
   begin
    inherited create;
    FValue:=aValue;
   end;

constructor TFloatElement.CreateAll(aName: string; aValue:double);
 begin
  CreateValue(aValue);
  Name:= aName
 end;


  {String}
function  TStringElement.GetType:TType;
begin
   result:=_string;
end;

function  TStringElement.GetTypeAsString:String;
begin
   result:='string';
end;

procedure TStringElement.SetAsString(aValue:string);
begin
   FValue:=avalue;
end;

function TStringElement.GetAsString:string;
begin
   Result:=FValue;
end;


procedure TStringElement.SetAsInteger(aValue:longint);
begin
  FValue:= IntToStr(aValue);
end;

function  TStringElement.GetAsInteger:longint;
var
  Code: integer;
begin
  //result:= 0;
  val(Fvalue, result, Code);
  if Code <> 0 then
  begin
     result:= 0;
     exit;
  end;
end;


function  TStringElement.GetAsFloat: double;
begin
   result := StrToExtended(FValue);
end;


procedure TStringElement.SetAsFloat(aValue: double);
begin
   FValue := FloatToStr(aValue);
end;


function  TStringElement.GetAsBoolean: boolean;
var
   S: string;
begin
   //result := false;
   if StringIsFloat(FValue) then
   begin
      result := GetAsFloat <> 0;
   end
   else
   begin
      S := UpperCase(FValue);
      result := ((S='TRUE') or (S = 'ANO'));
   end;
end;


procedure TStringElement.SetAsBoolean(aValue: boolean);
begin
   if aValue then FValue := 'TRUE'
             else FValue := 'FALSE'
end;


constructor TStringElement.CreateValue(aValue:string);
   begin
    inherited create;
    FValue:=aValue;
   end;

constructor TStringElement.CreateAll(aName: string; aValue:string);
 begin
  CreateValue(aValue);
  Name:= aName
 end;

 {kvuli kompatibilite}
function TStringElement.GetLongInt(aValue: longInt; var OKej: boolean): longInt;
var
  Code: integer;
begin
  val(Fvalue, aValue, Code);
  OKej:= Code = 0;
  result:= aValue;
end;


function   TStringElement.GetBoolean(aValue: boolean; var OKej: boolean): boolean;
begin
  result:= GetAsBoolean;
  OKej:= true
end;



function  TStringElement.GetDouble (aValue: double;  var OKej: boolean): double;
begin
  OKej:= true;
  try
    result:= StrToFloat(FValue)
  except
    OKej:= false;
    result:= 0
  end;
end;

procedure TStringElement.SetLongInt(aValue: longInt);
begin
  FValue:= IntToStr(aValue);
end;

procedure TStringElement.SetDouble (aValue: double);
begin
  FValue:= floatToStr(aValue)
end;


function TStringElement.CreateIntegerList: TIntegerListElement;
var
  CR: TCtiRadekClass;
  LI: longInt;
begin
  result:= TIntegerListElement.Create;
  if result = nil then exit;
  CR:= TCtiRadekClass.Create(FValue);
  if CR = nil then exit;

  while not CR.DosloKChybe do
  begin
    LI:= CR.DejLongInt;
    if not CR.DosloKChybe then
    begin
      result.AddInteger(LI);
    end;
  end;

  if result.Count < 1 then
  begin
    result.Free;
    result:= nil
  end;

  CR.Free;
end;




procedure TStringElement.SetNameIsValue(aValue: string);
var
  aName, aSavedValue: string;
begin
  if aValue = '' then exit;
  StringAsParameter(aValue, aName, aSavedValue);
  if aName = '' then exit;
  if aSavedValue = '' then
     Value:= aName
  else
  begin
    Name:= aName;
    Value:= aSavedValue
  end
end;



constructor TStringElement.CreateAllFromString(aValue: string; CPP: integer = 0);
 begin
  inherited Create;
  SetNameIsValue(aValue)
 end;



function  TStringElement.GetNameIsValue: string;
begin
  result:= Name + '=' + Value
end;




 {Integer}

 function  TIntegerElement.GetType:TType;
  begin
   result:=_integer;
  end;

  function  TIntegerElement.GetTypeAsString:String;
  begin
   result:='integer';
  end;

   procedure TIntegerElement.SetAsBoolean(aValue:boolean);
    begin
     if aValue then Value:=1 else Value:=0;
    end;

   procedure TIntegerElement.SetAsByte(aValue:byte);
     begin
      Value:=aValue;
     end;

   procedure TIntegerElement.SetAsFloat(aValue:double{?});
    var Tmp:longint;
    begin
     try
       Tmp:=Trunc(aValue);
       Value:=Tmp;
     except
       on EIntError do
        exit;
     end;
    end;

   procedure TIntegerElement.SetAsString(aValue:string);
   var Tmp:longint;
       Code:Integer;
    begin
     try
      val(aValue,tmp,Code);
      if Code=0 then Value:=tmp;
     except
      on EIntError do exit;
     end;
    end;

   procedure TIntegerElement.SetAsInteger(aValue:longint{?});
    begin
     FValue:=aValue;
    end;

   procedure TIntegerElement.SetAsPointer(aValue:pointer);
     begin
      Value:=integer(aValue);
     end;

   function TIntegerElement.GetAsBoolean:boolean;
     begin
      if Value=0 then result:=false else result:=true;
     end;

   function TIntegerElement.GetAsByte:byte;
   begin
    result := 0;
    try
     Result:=Value;
    except
     on EIntError do
    end;
   end;

   function TIntegerElement.GetAsFloat:double{?};
     begin
      Result:=Value;
     end;

   function TIntegerElement.GetAsString:string;
     begin
      Str(Value,Result);
     end;

   function TIntegerElement.GetAsInteger:longint{?};
     begin
      Result:=FValue;
     end;

  function TIntegerElement.GetAsPointer:pointer;
    begin
     Result:=pointer(Value);
    end;


constructor TIntegerElement.CreateValue(aValue:longint);
   begin
    inherited create;
    FValue:=aValue;
   end;

constructor TIntegerElement.CreateAll(aName: string; aValue:longint);
 begin
  CreateValue(aValue);
  Name:= aName
 end;

 {Pointer}

 function  TPointerElement.GetType:TType;
  begin
   result:=_pointer;
  end;

  function  TPointerElement.GetTypeAsString:String;
  begin
   result:='pointer';
  end;

   procedure TPointerElement.SetAsInteger(aValue:longint{?});
    begin
     FValue:=pointer(aValue);
    end;

procedure TPointerElement.SetAsPointer(aValue:pointer);
     begin
      FValue:=aValue;
     end;

function TPointerElement.GetAsInteger:longint{?};
     begin
      Result:=longInt(Value);
     end;

function TPointerElement.GetAsString:string;
var s:string;
     begin
      str(GetASInteger,s);
      Result:=s;
     end;

procedure TPointerElement.SetAsString(aValue:string);
var v:longint;
    dumm:integer;
     begin
     val(aValue,v,dumm);
     SetAsInteger(v);
     end;


function TPointerElement.GetAsPointer:pointer;
    begin
     Result:=FValue;
    end;

constructor TPointerElement.CreateValue(aValue:pointer);
   begin
    inherited create;
    FValue:=aValue;
   end;

constructor TPointerElement.CreateAll(aName: string; aValue:pointer);
 begin
  CreateValue(aValue);
  Name:= aName
 end;

{ TIntegerListElement }

function  TIntegerListElement.GetInteger(aIndex: longInt): longInt;
begin
  result := TIntegerElement(Elements[aIndex]).Value;
end;


procedure TIntegerListElement.PutInteger(aIndex: longInt; aValue: longInt);
begin
   TIntegerElement(Elements[aIndex]).Value:= aValue;
end;


procedure TIntegerListElement.AddInteger(aValue: longInt);
var
   IE: TIntegerElement;
   i: longInt;
begin
   if Sorted then
   begin
      if not Duplicates and ValueExists(aValue) then exit;
      IE := TIntegerElement.CreateValue(aValue);
      for i := 0 to LastIndex do
      begin
         if aValue < Integers[i] then
         begin
            InsertElement(i, IE);
            Exit;
         end;
      end;
      AddElement(IE);
   end
   else
   begin
      IE := TIntegerElement.CreateValue(aValue);
      AddElement(IE);
   end;
end;

function  TIntegerListElement.ValueExists(aValue: longInt): boolean;
var
   i: longInt;
begin
   result := true;
   for i := 0 to LastIndex do
   begin
      if aValue = Integers[i] then exit;
   end;
   result := false;
end;


{ TStringListElement }

function  TStringListElement.GetString(aIndex: longInt): string;
begin
   result := TStringElement(Elements[aIndex]).Text;
end;

procedure TStringListElement.PutString(aIndex: longInt; aValue: string);
begin
   TStringElement(Elements[aIndex]).Text := aValue;
end;

function  TStringListElement.GetNameAtIndex(aIndex: longInt): string;
begin
   result := TStringElement(Elements[aIndex]).Name;
end;

function  TStringListElement.GetUpperName(aIndex: longInt): string;
begin
   result := TStringElement(Elements[aIndex]).UpperName;
end;

procedure TStringListElement.PutName(aIndex: longInt; aValue: string);
begin
   TStringElement(Elements[aIndex]).Name := aValue;
end;



function  TStringListElement.GetStringElementByName(aName: string): TStringElement;
var
  I: longInt;
begin
  result:= nil;
  aName:= UpperCase(aName);
  for I:= 0 to Count-1 do
  begin
    if UpperNames[I] = aName then
    begin
      result:= StringElements[I];
      break
    end
  end
end;



function  TStringListElement.GetStringByName(aName: string): string;
var
  I: longInt;
begin
  result:= '';
  aName:= UpperCase(aName);
  for I:= 0 to Count-1 do
  begin
    if UpperNames[I] = aName then
    begin
      result:= Strings[I];
      break
    end
  end
end;


function  TStringListElement.GetIntegerByName(aName: string): longInt;
var
  SE: TStringElement;
  OKej: boolean;
begin
  result:= 0;
  SE:= GetStringElementByName(aName);
  if SE = nil then exit;
  result:= SE.GetLongInt(0, OKej);
end;


function  TStringListElement.GetBooleanByName(aName: string): boolean;
var
  SE: TStringElement;
  OKej: boolean;
begin
  result:= false;
  SE:= GetStringElementByName(aName);
  if SE = nil then exit;
  result:= SE.GetBoolean(true, OKej);
end;




function  TStringListElement.GetDoubleByName(aName: string): double;
var
  SE: TStringElement;
  OKej: boolean;
begin
  result:= 0;
  SE:= GetStringElementByName(aName);
  if SE = nil then exit;
  result:= SE.GetDouble(0, OKej);
end;


procedure  TStringListElement.SetStringByName(aName: string; aValue: string);
var
  SE: TStringElement;
begin
  SE:= GetStringElementByName(aName);
  if SE = nil then
     SE:= AddNameString(aName, '');
  SE.Value:= aValue
end;


procedure  TStringListElement.SetIntegerByName(aName: string; aValue: longInt);
var
  SE: TStringElement;
begin
  SE:= GetStringElementByName(aName);
  if SE = nil then
     SE:= AddNameString(aName, '');
  SE.SetLongInt(aValue)
end;


procedure  TStringListElement.SetDoubleByName(aName: string;  aValue: double);
var
  SE: TStringElement;
begin
  SE:= GetStringElementByName(aName);
  if SE = nil then
     SE:= AddNameString(aName, '');
  SE.SetDouble(aValue)
end;


function  TStringListElement.GetSElems(aIndex: longInt): TStringElement;
begin
   result := TStringElement(Elements[aIndex]);
end;

procedure TStringListElement.PutSElems(aIndex: longInt; aValue: TStringElement);
begin
   Elements[aIndex] := aValue;
end;

procedure TStringListElement.AddString(aValue: string);
var
   SE: TStringElement;
begin
   SE := TStringElement.CreateValue(aValue);
   AddElement(SE);
end;


function TStringListElement.AddNameString(aName, aValue: string): TStringElement;
var
   SE: TStringElement;
begin
   SE := TStringElement.CreateAll(aName, aValue);
   AddElement(SE);
   result:= SE
end;



procedure TStringListElement.AddName(aName: string);
var
   SE: TStringElement;
begin
  SE:= TStringElement.Create;
  SE.Name:= aName;
  AddElement(SE);
end;



procedure TStringListElement.AddNameIsValue(aValue: string);
var
   SE: TStringElement;
begin
  if pos('=', aValue) = 0 then exit;
  SE := TStringElement.CreateAllFromString(aValue);
  AddElement(SE);
end;



procedure TStringListElement.AddStringList(aStringList: TStringList);
{ generuje stringlistelement. Pokud polozky obsahuji rovnitko, tak polozky
  rozlozi }
var
  I: longInt;
  aVal: string;
begin
  if aStringList = nil then exit;
  for I:= 0 to aStringList.Count-1 do
  begin
    aVal:= aStringList.Strings[I];
    if aVal='' then Continue else
    begin
       if pos('=', aVal) = 0 then
          AddName(aVal)
       else
         AddNameIsValue(aVal)
    end;
  end;
end;


procedure TStringListElement.AddFile(aFileName: string);
var
   S: TStringList;
begin
   if not FileExists(aFileName) then exit;
   S := TStringList.Create;
   S.LoadFromFile(aFileName);
   AddStringList(S);
   S.Free;
end;


procedure TStringListElement.IntoFile(aFileName: string);
var
   S: TStringList;
   i: longInt;
begin
   S := TStringList.Create;
   for I:= 0 to Count - 1 do
   begin
     S.Add(Names[I] + '=' + Strings[I])
   end;

   S.SaveToFile(aFileName);
   S.Free;
end;


constructor TStringListElement.CreateFromStringList(aStringList: TStringList);
begin
  inherited Create;
  AddStringList(aStringList)
end;

function    TStringListElement.CreateStringList: TStringList;
var
   i: longInt;
begin
   result := TStringList.Create;
   for i := 0 to Count -1 do result.Add(Strings[i]);
end;

function TStringListElement.GetPropertyStringByName(AName: string): string;
begin
  result := inherited GetPropertyStringByName(aName);
  if result <> '' then exit;
  result:= GetStringByName(aName)
end;


procedure TStringListElement.SetPropertyStringByName(AName: string; aValue: string);
var
  I: longInt;
begin
  I:= GetPropIndex(Self, aName);
  if I > -1 then
  begin
    SetPropString(Self, I, aValue);
    exit
  end;
  SetStringByName(aName, aValue)
end;

procedure   TStringListElement.ParamToNames;
var
   i: longInt;
   aName, aValue: string;
begin
   for i := 0 to Count -1 do
   begin
      if StringAsParameter(Strings[i], aName, aValue) then
      begin
         Names[i] := aName;
         Strings[i] := aValue;
      end;
   end;
end;



                { TPropertyList }

function TPropertyList.GetCatenation: string;
var
  I: integer;
begin
  result:= '';
  if Count = 0 then exit;
  result:= Strings[0];
  if Count < 2 then exit;
  for I:= 1 to count-1 do
  begin
    result:= result + Delimiter + Strings[I]
  end
end;



procedure TPropertyList.SetByElement(anElement: TElement);
var
  I: longInt;
  PropName: string;
  aMinus: boolean;
begin
  if count=0 then exit;
  if anElement=nil then exit;
  for I:= 0 to Count-1 do
  begin
    PropName:= Names[I];

    aMinus:= false;
    if PropName[1] = '-' then
    begin
      PropName:= copy(PropName,2, 255);
      aMinus:= true;
    end;

    PropName:= anElement.GetPropertyStringByName(PropName);
    if aMinus then
    begin
      if PropName[1] = '-' then
         PropName:= copy(PropName,2, 255)
      else
         PropName:= '-' + PropName
    end;

    Strings[I]:= PropName
  end
end;


function CreateIntegerListElementFromString(aName, aValue: string): TIntegerListElement;
var
  CR: TCtiRadekClass;
  LI: longInt;
begin
  result:= TIntegerListElement.Create;
  if result = nil then exit;
  CR:= TCtiRadekClass.Create(aValue);
  if CR = nil then exit;

  while not CR.DosloKChybe do
  begin
    LI:= CR.DejLongInt;
    if not CR.DosloKChybe then
    begin
      result.AddInteger(LI);
    end;
  end;

  if result.Count < 1 then
  begin
    result.Free;
    result:= nil
  end;

  CR.Free;
end;



BEGIN
   RegisterOrbisClass(TTypeElement);
   RegisterOrbisClass(TBooleanElement);
   RegisterOrbisClass(TCharElement);
   RegisterOrbisClass(TByteElement);
   RegisterOrbisClass(TFloatElement);
   RegisterOrbisClass(TIntegerListElement);
   RegisterOrbisClass(TStringElement);
   RegisterOrbisClass(TIntegerElement);
   RegisterOrbisClass(TPointerElement);
   RegisterOrbisClass(TStringListElement);
   RegisterOrbisClass(TPathElement);
   RegisterOrbisClass(TPropertyList);
END.