unit T_Comp1;
interface

uses
     {!t_main,}
     Elements,
     T_Comp,
     language,
     Tools,
     T_Oper,
     E_Type,
     Classes;


type

{THandleCompileError=procedure(Line,Pos:integer);}

TPreCompiler=class(TTechnology)
   private
    FSource:TStringList;
    FAsterixComment:boolean;
    FComment:boolean;
    FOutSource:TStringList;
    procedure SetSource(aText:TStringList);virtual;
    function GetSource:TStringList;virtual;
    procedure SetOutSource(aText:TStringList);virtual;
    function GetOutSource:TStringList;virtual;
   protected
    property AsterixComment:boolean read FAsterixComment write FAsterixComment;
   public
    destructor Destroy;override;
    property Source:TStringList read GetSource write SetSource;
    property OutSource:TStringList read GetOutSource write SetOutSource;
    property Comment:boolean read FComment write FComment;
    procedure DoIt;override;
   end;

TSelectingCompiler=class(TVariableCompiler)
FMainProgram:TProgram;
   private
    FForCompiler:TForCompiler;
    FIfCompiler:TIfCompiler;
    FWhileCompiler:TWhileCompiler;
    FRepeatCompiler:TRepeatCompiler;
    FCaseCompiler:TCaseCompiler;
    FCaseItemCompiler:TCaseItemCompiler;
    FDeclarationCompiler:TDeclarationCompiler;
    FAssignCompiler:TAssignCompiler;
    FThenCompiler:TThenCompiler;
    FDoCompiler:TDoCompiler;
    FUntilCompiler:TUntilCompiler;
    FElseCompiler:TElseCompiler;
    FLineExpCompiler:TLineExpCompiler;
    FEndCompiler:TEndCompiler;
    procedure SetLineList(aList:TOwnerEntity);override;
    function GetLineList:TOwnerEntity;override;
    function GetMainProgram:TProgram;virtual;
    procedure SetMainProgram(aProg:TProgram);virtual;
    function GetForCompiler:TForCompiler;override;
    procedure SetForCompiler(aComp:TForCompiler);override;
    function GetIfCompiler:TIfCompiler;override;
    procedure SetIfCompiler(aComp:TIfCompiler);override;
    function GetWhileCompiler:TWhileCompiler;override;
    procedure SetWhileCompiler(aComp:TWhileCompiler);override;
    function GetRepeatCompiler:TRepeatCompiler;override;
    procedure SetRepeatCompiler(aComp:TRepeatCompiler);override;
    function GetCaseCompiler:TCaseCompiler;override;
    procedure SetCaseCompiler(aComp:TCaseCompiler);override;
    function GetCaseItemCompiler:TCaseItemCompiler;override;
    procedure SetCaseItemCompiler(aComp:TCaseItemCompiler);override;
    function GetDeclarationCompiler:TDeclarationCompiler;override;
    procedure SetDeclarationCompiler(aComp:TDeclarationCompiler);override;
    function GetAssignCompiler:TAssignCompiler;override;
    procedure SetAssignCompiler(aComp:TAssignCompiler);override;
    function GetThenCompiler:TThenCompiler;override;
    procedure SetThenCompiler(aComp:TThenCompiler);override;
    function GetDoCompiler:TDoCompiler;override;
    procedure SetDoCompiler(aComp:TDoCompiler);override;
    function GetUntilCompiler:TUntilCompiler;override;
    procedure SetUntilCompiler(aComp:TUntilCompiler);override;
    function GetElseCompiler:TElseCompiler;override;
    procedure SetElseCompiler(aComp:TElseCompiler);override;
    function GetEndCompiler:TEndCompiler;override;
    procedure SetEndCompiler(aComp:TEndCompiler);override;
    function GetLineExpCompiler:TLineExpCompiler;override;
    procedure SetLineExpCompiler(aComp:TLineExpCompiler);override;
   protected
   public
    property MainProgam:TProgram read GetMainProgram write SetMainProgram;
    procedure DoIt;override;
   end;



 TMainCompiler=class(TSimpleCompiler)
   private
    FSelectingCompiler:TSelectingCompiler;
    {FErrorHandleRoutine:THandleCompileError;}
    {FStartLine:longint;}
    FPreCompiler:TPreCompiler;
    FSource:TStringList;
    FMainProgram:TProgram;
    FPrgReset:boolean;
    procedure SetSource(aText:TStringList);
    function GetSource:TStringList;
    procedure SetLineList(aList:TOwnerEntity);override;
    function GetLineList:TOwnerEntity;override;
    function GetMainProgram:TProgram;virtual;
    procedure SetMainProgram(aPrg:TProgram);virtual;
    procedure ProgramReset;virtual;
    function GetSelectingCompiler:TSelectingCompiler;virtual;
    procedure SetSelectingCompiler(aComp:TSelectingCompiler);virtual;
    function GetPreCompiler:TPreCompiler;virtual;
    procedure SetPreCompiler(aComp:TPreCompiler);virtual;
    {function GetHandleRoutine:THandleCompileError;virtual;
    procedure SetHandleRoutine(aRoutin:THandleCompileError);virtual;}
   protected
    property SelectingCompiler:TSelectingCompiler read GetSelectingCompiler write SetSelectingCompiler;
   public
    destructor Destroy;override;
    constructor Create;override;
    property PreCompiler:TPreCompiler read GetPreCompiler write SetPreCompiler;
    property ProgramSource:TStringList read GetSource write SetSource;
    property MainProgram:TProgram read GetMainProgram write SetMainProgram;
{    property HandleCompileError:THandleCompileError read GetHandleRoutine write SetHandleRoutine;}
    procedure DoIt;override;
   published
    {property StartingLine:longint read FStartLine write FStartLine;}
    property NewProgram:boolean read FPrgReset write FPrgReset;
   end;



implementation
uses
dialogs,
U_String,
T_Errors;

{PreCompiler}
destructor TPreCompiler.Destroy;
begin
if assigned(FSource) then
   FSource.Free;
if assigned(FOutSource) then
   FOutSource.Free;
inherited Destroy;
end;



procedure TPreCompiler.SetSource(aText:TStringList);
          begin
          if assigned(FSource) then FSource.Free;
          if assigned(aText) then
             begin
             FSource:=TStringList.Create;
             FSource.Assign(aText);
             end
          else FSource:=nil;
          end;

function TPreCompiler.GetSource:TStringList;
   begin
   if not assigned(FSource) then FSource:=TSTringlist.create;
   result:=FSource;
   end;

procedure TPreCompiler.SetOutSource(aText:TStringList);
          begin
          if assigned(FOutSource) then FOutSource.Free;
          if assigned(aText) then
             begin
             FOutSource:=TStringList.Create;
             FOutSource.Assign(aText);
             end
          else FOutSource:=nil;
          end;

function TPreCompiler.GetOutSource:TStringList;
   begin
   if not assigned(FOutSource) then FOutSource:=TStringList.create;
   result:=FOutSource;
   end;


procedure TPreCompiler.Doit;
var i,j,k,TmpPos,Startpos,BPos:longint;
    St:string;
    InString:boolean;
    Delimiters:TDelimiters;
    StringKind,ResChar:char;
    skip:boolean;
begin
    InString:=false;
    i:=Source.Count;
    Output:=nil;
    Comment:=false;
    if i>0 then for j:=0 to i-1 do
    begin
    skip:=false;
    OutSource.Add('');
    k:=OutSource.Count-1;
    St:=Source.Strings[k];
    St:=BezVnejsichMezer(St);
    if (St='') then
      begin
      OutSource.Strings[k]:='';
      skip:=true;
      end;
    if St[1]='*' then
      begin
      if AsterixComment then
            begin
            Asterixcomment:=false;
            Delete(St,1,1);
            end
            else
            begin
            AsterixComment:=true;
            OutSource.Strings[k]:='';
            St:='';
            skip:=true;
            end;
      end
    else
    if AsterixComment then
               begin
               OutSource.Strings[k]:='';
               St:='';
               skip:=true;
               end;
    if (St[1]=';')  then
             begin
             OutSource.Strings[k]:='';
             St:='';
             skip:=true;
             end;
    {vystriha poznamky}
    if not skip then
    begin
    TmpPos:=1;
    startPos:=1;
    repeat
    if InString then Delimiters:=[StringKind]
     else if Comment then Delimiters:=['{','}','''','"']else Delimiters:=['{','''','"'];
    ReadToDelimiterWithoutWS(St,Delimiters,Tmppos,ResChar,BPos);
    if reschar<>#0 then
       begin
       TmpPos:=BPos;
       if InString then InString:=false
         else
            begin
            if ResChar='{' then
               begin
                Comment:=true;
                StartPos:=BPos-1;
               end
            else
            if ResChar='}' then
               begin
               Comment:=false;
               Delete(St,StartPos,Bpos-StartPos);
               TmpPos:=StartPos;
               end
            else
               begin
               InString:=true;
               StringKind:=ResChar;
               end;
            end;
       end;
    until ResChar=#0;
    if Comment then Delete(St,StartPos,length(St)-StartPos+1);
    if InString then raise TCompilerError.CreatePos(16,j,BPos,'');
    OutSource.Strings[k]:=BezVnejsichMezer(St);
    end;{for}
    end;
end;



{SelectingCompiler}
procedure TSelectingCompiler.SetLineList(aList:TOwnerEntity);
    begin
    if assigned(FLineList) then FreeElement(FLineList);
    FLineList:=aList;
    AddElement(aList);
    FLineList:=aList;
    ForCompiler.Linelist:=aList;
    IfCompiler.Linelist:=aList;
    WhileCompiler.Linelist:=aList;
    RepeatCompiler.Linelist:=aList;
    CaseCompiler.Linelist:=aList;
    DeclarationCompiler.Linelist:=aList;
    AssignCompiler.Linelist:=aList;
    ThenCompiler.Linelist:=aList;
    DoCompiler.Linelist:=aList;
    UntilCompiler.Linelist:=aList;
    ElseCompiler.Linelist:=aList;
    EndCompiler.Linelist:=aList;
    PathCompiler.Linelist:=aList;
    {ExpressionCompiler.Linelist:=aList;}
    {VariableCompiler.Linelist:=aList;}
    ToolCompiler.Linelist:=aList;
    FunctionCompiler.Linelist:=aList;
    {procedura}
    end;

function TSelectingCompiler.GetLineList:TOwnerEntity;
    begin
    if not assigned(FLineList) then
       begin
       FLineList:=TOwnerEntity.Create;
       AddElement(FLineList);
       ForCompiler.Linelist:=FLineList;
       IfCompiler.Linelist:=FLineList;
       WhileCompiler.Linelist:=FLineList;
       RepeatCompiler.Linelist:=FLineList;
       CaseCompiler.Linelist:=FLineList;
       DeclarationCompiler.Linelist:=FLineList;
       AssignCompiler.Linelist:=FLineList;
       ThenCompiler.Linelist:=FLineList;
       DoCompiler.Linelist:=FLineList;
       UntilCompiler.Linelist:=FLineList;
       ElseCompiler.Linelist:=FLineList;
       EndCompiler.Linelist:=FLineList;
       PathCompiler.Linelist:=FLineList;
       {ExpressionCompiler.Linelist:=FLineList;}
       {VariableCompiler.Linelist:=FLineList;}
       ToolCompiler.Linelist:=FLineList;
       FunctionCompiler.Linelist:=FLineList;
       {procedura}
       end;
    result:=FLineList;
    end;

function TSelectingCompiler.GetForCompiler:TForCompiler;
  begin
   if not assigned(FForCompiler) then
       begin
       FForCompiler:=TForCompiler.Create;
       AddTool(FForCompiler);
       FForCompiler.LineList:=LineList;
       end;
   result:=FForCompiler;
   end;


procedure TSelectingCompiler.SetForCompiler(aComp:TForCompiler);
   begin
   if assigned(FForCompiler) then FreeTool(FForCompiler);
   AddTool(aComp);
   FForCompiler:=aComp;
   FForCompiler.LineList:=LineList;
   end;

function TSelectingCompiler.GetIfCompiler:TIfCompiler;
  begin
   if not assigned(FIfCompiler) then
       begin
       FIfCompiler:=TIfCompiler.Create;
       AddTool(FIfCompiler);
       FIfCompiler.LineList:=LineList;
       end;
   result:=FIfCompiler;
   end;

function TSelectingCompiler.GetWhileCompiler:TWhileCompiler;
  begin
   if not assigned(FWhileCompiler) then
       begin
       FWhileCompiler:=TWhileCompiler.Create;
       AddTool(FWhileCompiler);
       FWhileCompiler.LineList:=LineList;
       end;
   result:=FWhileCompiler;
   end;


procedure TSelectingCompiler.SetWhileCompiler(aComp:TWhileCompiler);
   begin
   if assigned(FWhileCompiler) then FreeTool(FWhileCompiler);
   AddTool(aComp);
   FWhileCompiler:=aComp;
   FWhileCompiler.LineList:=LineList;
   end;


procedure TSelectingCompiler.SetIfCompiler(aComp:TIfCompiler);
   begin
   if assigned(FIfCompiler) then FreeTool(FIfCompiler);
   AddTool(aComp);
   FIfCompiler:=aComp;
   FIfCompiler.LineList:=LineList;
   end;

function TSelectingCompiler.GetRepeatCompiler:TRepeatCompiler;
  begin
   if not assigned(FRepeatCompiler) then
       begin
       FRepeatCompiler:=TRepeatCompiler.Create;
       AddTool(FRepeatCompiler);
       FRepeatCompiler.LineList:=LineList;
       end;
   result:=FRepeatCompiler;
   end;


procedure TSelectingCompiler.SetRepeatCompiler(aComp:TRepeatCompiler);
   begin
   if assigned(FRepeatCompiler) then FreeTool(FRepeatCompiler);
   AddTool(aComp);
   FRepeatCompiler:=aComp;
   FRepeatCompiler.LineList:=LineList;
   end;

function TSelectingCompiler.GetCaseCompiler:TCaseCompiler;
  begin
   if not assigned(FCaseCompiler) then
       begin
       FCaseCompiler:=TCaseCompiler.Create;
       AddTool(FCaseCompiler);
       FCaseCompiler.LineList:=LineList;
       end;
   result:=FCaseCompiler;
   end;


procedure TSelectingCompiler.SetCaseCompiler(aComp:TCaseCompiler);
   begin
   if assigned(FCaseCompiler) then FreeTool(FCaseCompiler);
   AddTool(aComp);
   FCaseCompiler:=aComp;
   FCaseCompiler.LineList:=LineList;
   end;

function TSelectingCompiler.GetCaseItemCompiler:TCaseItemCompiler;
  begin
   if not assigned(FCaseItemCompiler) then
       begin
       FCaseItemCompiler:=TCaseItemCompiler.Create;
       AddTool(FCaseItemCompiler);
       FCaseItemCompiler.LineList:=LineList;
       end;
   result:=FCaseItemCompiler;
   end;


procedure TSelectingCompiler.SetCaseItemCompiler(aComp:TCaseItemCompiler);
   begin
   if assigned(FCaseItemCompiler) then FreeTool(FCaseItemCompiler);
   AddTool(aComp);
   FCaseItemCompiler:=aComp;
   FCaseItemCompiler.LineList:=LineList;
   end;

function TSelectingCompiler.GetDeclarationCompiler:TDeclarationCompiler;
  begin
   if not assigned(FDeclarationCompiler) then
       begin
       FDeclarationCompiler:=TDeclarationCompiler.Create;
       AddTool(FDeclarationCompiler);
       FDeclarationCompiler.LineList:=LineList;
       end;
   result:=FDeclarationCompiler;
   end;


procedure TSelectingCompiler.SetDeclarationCompiler(aComp:TDeclarationCompiler);
   begin
   if assigned(FDeclarationCompiler) then FreeTool(FDeclarationCompiler);
   AddTool(aComp);
   FDeclarationCompiler:=aComp;
   FDeclarationCompiler.LineList:=LineList;
   end;

function TSelectingCompiler.GetAssignCompiler:TAssignCompiler;
  begin
   if not assigned(FAssignCompiler) then
       begin
       FAssignCompiler:=TAssignCompiler.Create;
       AddTool(FAssignCompiler);
       FAssignCompiler.LineList:=LineList;
       end;
   result:=FAssignCompiler;
   end;


procedure TSelectingCompiler.SetAssignCompiler(aComp:TAssignCompiler);
   begin
   if assigned(FAssignCompiler) then FreeTool(FAssignCompiler);
   AddTool(aComp);
   FAssignCompiler:=aComp;
   FAssignCompiler.LineList:=LineList;
   end;

function TSelectingCompiler.GetThenCompiler:TThenCompiler;
  begin
   if not assigned(FThenCompiler) then
       begin
       FThenCompiler:=TThenCompiler.Create;
       AddTool(FThenCompiler);
       FThenCompiler.LineList:=LineList;
       end;
   result:=FThenCompiler;
   end;


procedure TSelectingCompiler.SetThenCompiler(aComp:TThenCompiler);
   begin
   if assigned(FThenCompiler) then FreeTool(FThenCompiler);
   AddTool(aComp);
   FThenCompiler:=aComp;
   FThenCompiler.LineList:=LineList;
   end;

function TSelectingCompiler.GetDoCompiler:TDoCompiler;
  begin
   if not assigned(FDoCompiler) then
       begin
       FDoCompiler:=TDoCompiler.Create;
       AddTool(FDoCompiler);
       FDoCompiler.LineList:=LineList;
       end;
   result:=FDoCompiler;
   end;


procedure TSelectingCompiler.SetDoCompiler(aComp:TDoCompiler);
   begin
   if assigned(FDoCompiler) then FreeTool(FDoCompiler);
   AddTool(aComp);
   FDoCompiler:=aComp;
   FDoCompiler.LineList:=LineList;
   end;

function TSelectingCompiler.GetUntilCompiler:TUntilCompiler;
  begin
   if not assigned(FUntilCompiler) then
       begin
       FUntilCompiler:=TUntilCompiler.Create;
       AddTool(FUntilCompiler);
       FUntilCompiler.LineList:=LineList;
       end;
   result:=FUntilCompiler;
   end;


procedure TSelectingCompiler.SetUntilCompiler(aComp:TUntilCompiler);
   begin
   if assigned(FUntilCompiler) then FreeTool(FUntilCompiler);
   AddTool(aComp);
   FUntilCompiler:=aComp;
   FUntilCompiler.LineList:=LineList;
   end;

function TSelectingCompiler.GetElseCompiler:TElseCompiler;
  begin
   if not assigned(FElseCompiler) then
       begin
       FElseCompiler:=TElseCompiler.Create;
       AddTool(FElseCompiler);
       FElseCompiler.LineList:=LineList;
       end;
   result:=FElseCompiler;
   end;


procedure TSelectingCompiler.SetElseCompiler(aComp:TElseCompiler);
   begin
   if assigned(FElseCompiler) then FreeTool(FElseCompiler);
   AddTool(aComp);
   FElseCompiler:=aComp;
   FElseCompiler.LineList:=LineList;
   end;

function TSelectingCompiler.GetEndCompiler:TEndCompiler;
  begin
   if not assigned(FEndCompiler) then
       begin
       FEndCompiler:=TEndCompiler.Create;
       AddTool(FEndCompiler);
       FEndCompiler.LineList:=LineList;
       end;
   result:=FEndCompiler;
   end;


procedure TSelectingCompiler.SetEndCompiler(aComp:TEndCompiler);
   begin
   if assigned(FEndCompiler) then FreeTool(FEndCompiler);
   AddTool(aComp);
   FEndCompiler:=aComp;
   FEndCompiler.LineList:=LineList;
   end;

function TSelectingCompiler.GetLineExpCompiler:TLineExpCompiler;
  begin
   if not assigned(FLineExpCompiler) then
       begin
       FLineExpCompiler:=TLineExpCompiler.Create;
       AddTool(FLineExpCompiler);
       FLineExpCompiler.LineList:=LineList;
       end;
   result:=FLineExpCompiler;
   end;


procedure TSelectingCompiler.SetLineExpCompiler(aComp:TLineExpCompiler);
   begin
   if assigned(FLineExpCompiler) then FreeTool(FLineExpCompiler);
   AddTool(aComp);
   FLineExpCompiler:=aComp;
   FLineExpCompiler.LineList:=LineList;
   end;


function TSelectingCompiler.GetMainProgram:TProgram;
  begin
   if not assigned(FMainProgram) then
       begin
       FMainProgram:=TProgram.Create;
       AddElement(FMainProgram);
       end;
   result:=FMainProgram;
   end;

procedure TSelectingCompiler.SetMainProgram(aProg:TProgram);
   begin
   if assigned(FMainProgram) then FreeElement(FMainProgram);
   AddElement(aProg);
   FMainProgram:=aProg;
   end;

procedure TSelectingCompiler.DoIt;
var s:string;
    LInfo:TLineInfo;
    Res:TPrgline;

function WorkWithCompiler(aComp:TCompiler):boolean;
begin
 result:=false;
 Res:=nil;
 aComp.CompLine:=CompLine;
 aComp.StartPos:=Startpos;
 if aComp.SupposedToCompile then
 begin
 aComp.DoIt;
 StartPos:=aComp.StartPos;
 Res:=TPrgLine(aComp.Output);
 result:=true;
 end;
end;

procedure ReadFromCompiler(aComp:TCompiler);
begin
    case LInfo.BlockType of
     t_Else,t_Then,t_Procedure,t_Do,t_CaseBlock,t_Function:TPrgBlock(LInfo.Line).AddPrgLine(Res);
     t_Repeat:if not(aComp is TUntilCompiler) then TPrgBlock(LInfo.Line).AddPrgLine(Res);
     t_SingleThen:
        begin
        TIfLine(LInfo.Line).ThenBlock:=Res;
         LInfo.BlockType:=t_DoneThen;
        end;
     t_SingleDo,t_SingleElse:
        begin
         case LInfo.BlockType of
          t_SingleDo:
                 begin
                 if LInfo.Line is TForLine then
                 TForLine(LInfo.Line).Block:=Res
                 else TWhileLine(LInfo.Line).Block:=Res;
                 end;
          t_SingleElse:TIfLine(LInfo.Line).ElseBlock:=Res;
          end;{case}
          LInfo.BlockType:=t_Done;
        end;
     t_SingleRepeat:
        begin
        TRepeatLine(LInfo.Line).Block:=Res;
        LInfo.BlockType:=t_Until;
        end;
     t_SingleCase:
        begin
        TCaseLine(LInfo.Line).BlockItem[TCaseLine(LInfo.Line).BlockList.Count]:=Res;
        LInfo.BlockType:=t_Case;
        end;
     end;{case}
end;

{hlavni blok}
begin
try
Output:=nil;
S:=CompLine;
repeat
if S='' then
   begin
   Startpos:=0;
   exit;
   end;
LInfo:=CurrentLineInfo;
case LInfo.BlockType of
    {Vynucene kompilace}
    t_Done:FreeCurrentLineInfo;
    t_For,t_While:
           begin
           DoCompiler.CompLine:=CompLine;
           DoCompiler.StartPos:=StartPos;
           DoCompiler.DoIt;
           case LInfo.BlockType of
                t_For:TForLine(LInfo.Line).Block:=TPrgLine(DoCompiler.Output);
                t_While:TWhileLine(LInfo.Line).Block:=TPrgLine(DoCompiler.Output);
                t_Repeat:TrepeatLine(LInfo.Line).Block:=TPrgLine(DoCompiler.Output);
                end;
           StartPos:=DoCompiler.StartPos;
           end;
    t_If:
           begin
           ThenCompiler.CompLine:=CompLine;
           ThenCompiler.StartPos:=Startpos;
           ThenCompiler.DoIt;
           TIfLine(LInfo.Line).ThenBlock:=TPrgLine(ThenCompiler.Output);
           StartPos:=ThenCompiler.StartPos;
           end;
    t_Until:
           begin
           UntilCompiler.CompLine:=CompLine;
           UntilCompiler.StartPos:=Startpos;
           UntilCompiler.DoIt;
           StartPos:=0;
           end;
    t_DoneThen:
           begin
           if WorkWithCompiler(ElseCompiler) then
           begin
           TIfLine(LInfo.Line).ElseBlock:=Res;
           end
           else LInfo.BlockType:=t_Done;

           {
           ElseCompiler.CompLine:=CompLine;
           ElseCompiler.StartPos:=Startpos;
           if ElseCompiler.SupposedToCompile then
               begin
               ElseCompiler.DoIt;
               Res:=TPrgLine(ElseCompiler.Output);
               StartPos:=ElseCompiler.StartPos;
               end
               else
               begin
               LInfo.BlockType:=t_Done;
               end;
             }
           end;
     t_Case:
           begin
           if not WorkWithCompiler(EndCompiler) then
           begin
           if  WorkWithCompiler(ElseCompiler) then
               begin
               TCaseLine(LInfo.Line).ElseBlock:=Res;
               end
           else
               begin
               CaseItemCompiler.CompLine:=CompLine;
               CaseItemCompiler.StartPos:=Startpos;
               CaseItemCompiler.DoIt;
               TCaseLine(LInfo.Line).BlockItem[TCaseLine(LInfo.Line).BlockList.Count]:=TPrgLine(CaseItemCompiler.Output);
               StartPos:=CaseItemCompiler.StartPos;
               end;
           end;
           end;
    {Konec vynucenych kompilaci}
    else
    (*t_SingleThen,t_SingleDo,t_SingleElse,t_SingleRepeat,
    t_Else,t_Then,t_Procedure,t_Do,t_Function,t_Repeat:*){totez co else}
      begin
         {vlozit ProcedureCompiler}
       if not WorkWithCompiler(FunctionCompiler) then
       if WorkWithCompiler(ForCompiler) then ReadFromCompiler(ForCompiler)
       else if WorkWithCompiler(IfCompiler) then ReadFromCompiler(IfCompiler)
       else if WorkWithCompiler(WhileCompiler) then ReadFromCompiler(WhileCompiler)
       else if WorkWithCompiler(RepeatCompiler) then ReadFromCompiler(RepeatCompiler)
       else if WorkWithCompiler(CaseCompiler) then ReadFromCompiler(CaseCompiler)
     {B-skupina}
       else if not WorkWithCompiler(ThenCompiler) then
       if not WorkWithCompiler(DoCompiler) then
       if WorkWithCompiler(UntilCompiler) then  ReadFromCompiler(UntilCompiler)
       else if  WorkWithCompiler(ElseCompiler) then
          begin
           case CurrentLineInfo.BlockType of
           t_Else:
                 begin
                 LineList.FreeElement(LInfo);
                 TIfLine(LineInfo[Linelist.Count-2].Line).ElseBlock:=Res;
                 end;
           t_SingleElse:
                 begin
                 FreeCurrentLineInfo;
                 CurrentLineInfo.BlockType:=t_SingleElse;
                 end;
                 end;
          end
       else if WorkWithCompiler(EndCompiler) then
        begin
              case LInfo.BlockType of
                 t_Then,t_Else,t_Do:FreeCurrentLineInfo;
                 t_Procedure,t_Function:;{ulozit proceduru}
                end;{case}
        end
     {C-skupina}
       else if WorkWithCompiler(DeclarationCompiler) then
              begin
              if assigned(Res) then ReadFromCompiler(DeclarationCompiler);
              end
       else if WorkWithCompiler(AssignCompiler) then ReadFromCompiler(AssignCompiler)
       else if WorkWithCompiler(LineExpCompiler) then ReadFromCompiler(LineExpCompiler)
       else    raise TCompilerError.CreatePos(3,0,StartPos,'');


      end;
    end;{case}
until Startpos=0
finally end;
end;

{MainCompiler}
destructor TMainCompiler.Destroy;
begin
if assigned(FSource) then FSource.Free;
inherited Destroy;
end;

procedure TMainCompiler.SetSource(aText:TStringList);
   begin
   if assigned(FSource) then FSource.Free;
   if assigned(aText) then
      begin
      FSource:=TStringList.Create;
      FSource.Assign(aText);
      end
      else FSource:=nil;
   end;

function TMainCompiler.GetSource:TStringList;
   begin
   if not assigned(FSource) then FSource:=TSTringlist.create;
   result:=FSource;
   end;

function TMainCompiler.GetPreCompiler:TPreCompiler;
 begin
   if not assigned(FPreCompiler) then
       begin
       FPreCompiler:=TPreCompiler.Create;
       AddTool(FPreCompiler);
       FPreCompiler.Source:=ProgramSource;
       end;
   result:=FPreCompiler;
   end;

procedure TMainCompiler.SetPreCompiler(aComp:TPreCompiler);
   begin
   if assigned(FPreCompiler) then
      FreeTool(FPreCompiler);
   FPreCompiler:=aComp;
   if assigned(FPreCompiler) then
    begin
    AddTool(aComp);
    end;
   end;

procedure TMainCompiler.SetSelectingCompiler(aComp:TSelectingCompiler);
   begin
   if assigned(FSelectingCompiler) then
      FreeTool(FSelectingCompiler);
   FSelectingCompiler:=aComp;
   if assigned(FSelectingCompiler) then
    begin
    AddTool(aComp);
    FSelectingCompiler.LineList:=LineList;
    {FSelCompiler.MainProgram:=MainProgram;}
    end;
   {FSelCompiler.MainCompiler:=self;}
   end;

function TMainCompiler.GetSelectingCompiler:TSelectingCompiler;
 begin
   if not assigned(FSelectingCompiler) then
       begin
       FSelectingCompiler:=TSelectingCompiler.Create;
       AddTool(FSelectingCompiler);
       FSelectingCompiler.LineList:=LineList;
       {FSelectingCompiler.MainProgram:=MainProgram;
       {FSelCompiler.MainCompiler:=self;}
       end;
   result:=FSelectingCompiler;
   end;




procedure TMainCompiler.SetLineList(aList:TOwnerEntity);
    begin
    if assigned(FLineList) then FreeElement(FLineList);
    AddElement(aList);
    FLineList:=aList;
    if assigned(FSelectingCompiler) then SelectingCompiler.LineList:=aList;
    end;

function TMainCompiler.GetLineList:TOwnerEntity;
    begin
    if not assigned(FlineList) then
       begin
       FLineList:=nil;
       FLineList:=TOwnerEntity.Create;
       AddElement(FLineList);
       if assigned(FSelectingCompiler) then SelectingCompiler.LineList:=FLineList;
       end;
    result:=FLineList;
    end;

procedure TMainCompiler.SetMainProgram(aPrg:TProgram);
   begin
   if (assigned(FMainProgram)) and (aPrg<>FMainProgram) then
   begin
   FreeElement(FMainprogram);
   AddElement(aPrg);
   FMainProgram:=aPrg;
   end;
   end;

function TMainCompiler.GetMainProgram:TProgram;
   begin
   if not assigned(FMainprogram) then
      begin
      FMainProgram:=TProgram.Create;
      AddElement(FMainProgram);
      end;
   result:=FMainprogram;
   end;


procedure TMainCompiler.ProgramReset;
  var
  Blk:TLineInfo;
  Pr:TProcInfo;
  SPInf:TShortProcInfo;
  begin
  {novy program a stack}
  {SelectingCompiler:=nil;}
  MainProgram:=TProgram.Create;
  LineList:=TOwnerEntity.Create;
  {zarazeni hlavniho bloku jako prave zpracovavaneho}
  Blk:=TLineInfo.Create;
  Blk.BlockType:=t_procedure;
  Blk.Line:=MainProgram;
  MainProgram.VarNumber:=3;
  MainProgram.varInfolist.AddElement(TVarInfo.Create);
  MainProgram.VarType[WorldIndex]:=_pointer;
  MainProgram.VarName[WorldIndex]:='TELEMENT';
  MainProgram.VarInfolist.AddElement(TVarInfo.Create);
  MainProgram.VarType[MToolIndex]:=_pointer;
  MainProgram.VarName[MToolIndex]:='TTOOL';
  MainProgram.VarInfolist.AddElement(TVarInfo.Create);
  MainProgram.VarType[ActiveElIndex]:=_pointer;
  MainProgram.VarName[ActiveElIndex]:='TELEMENT';
  Mainprogram.Calls:=0;
  {zadani hlavnich promennych do stacku}
  Pr:=TProcInfo.Create;
  {Pr.Calls:=0;}
  Pr.Calls:=0;
  Pr.VarNumber:=3;
  Pr.VarName[WorldIndex+1]:=kw_World;
  Pr.VarName[MToolIndex+1]:=kw_MTool;
  Pr.VarName[ActiveElIndex+1]:=kw_ActivEl;
  Blk.ProcInfo:=Pr;
  NewCurrentLineInfo(Blk);
  end;

{function TMainCompiler.GetHandleRoutine:THandleCompileError;
begin
result:=FErrorHandleRoutine;
end;

procedure TMainCompiler.SetHandleRoutine(aRoutin:THandleCompileError);
begin
FErrorHandleRoutine:=aRoutin;
end;
 }
constructor TMainCompiler.Create;
begin
NewProgram:=true;
inherited create;
end;

procedure TMainCompiler.DoIt;
var {Blk:TLineInfo;
    pr:TProcInfo;}
    i,j:longint;
    ClearText:TStringList;
    s1,s2:string;
    {EditedBlock:TBlockInfo;}
   begin
   {velmi prozatimni   reseni}
   Output:=nil;
   try
   if Newprogram then ProgramReset;
   PreCompiler.Source:=ProgramSource;
   PreCompiler.DoIt;
   ClearText:=TStringList.Create;
   ClearText.Assign(PreCompiler.OutSource);
   try
   for i:=0 to ClearText.Count-1 do
      begin
      SelectingCompiler.StartPos:=1;
      SelectingCompiler.CompLine:=ClearText.Strings[i];
      try
      SelectingCompiler.DoIt;
      except
       on E:TCompilerError do
       begin
       E.Line:=i;
       raise
       end;
      end;
      if LineList.Count=0 then raise TCompilerError.CreatePos(1,i+1,0,'konec programu')
      end;
      J:=LineList.Count;
   while (j>0) and ((LineInfo[j-1].BlockType=t_Done)or(LineInfo[j-1].BlockType=t_DoneThen)) do dec(j);
   if j>1 then raise TCompilerError.CreatePos(17,ClearText.Count,0,'');
   Output:=MainProgram;
   finally
   ClearText.Free;
   {reraise};
   end;
   except
    on E:TCompilerError do
     begin
     str(E.line+1,s1);str(E.Position,s2);
     showmessage(E.Message+':  dka '+s1+' pozice '+s2);
     {HandleCompileError;}
     raise;
     end;
   end;
   end;


end.
