unit Syntax;
// v cele unite jsou nahrazena hledani setu s prvnim znakem 'A' znakem '@'  kvuli dynamickejm promenejm....
//
interface
uses SysUtils;

TYPE
      TKeyWord=(_start,_MATCH,_CONTAINSTEXT,_STARTSTEXT,_ENDSTEXT,_FINDTOLEVEL,_CLASS,
      _ANCESTOR,_EXISTSPROP,_ROUND,_TRUNC,_COS,_SIN,_ARCTAN,_EXP,_FRAC,_LN,
      _SQR,_SQRT,_ODD,_ABS,_NOT,_AND,_OR,_MOD,_DIV,_SMALLER,_GREATER,_EQUAL,_SE,_GE,_NE,
      _ADD,_SUBTRACT,_MULTIPL,_DIVIDE,_TOBOOLEAN,_TOCHAR,_TOBYTE,_TOFLOAT,_TOSTRING,
      _TOINTEGER,_IS,_NIL,_stop);

SyntaxExcept=class(Exception)
 private
 TPosition:integer;
 public
  constructor CreatePos(Msg:string;aPos:integer);
  property Pos:integer read TPosition write TPosition ;
 end;

const  KeyWord:array[TKeyWord] of string=('','MATCH','CONTAINSTEXT','STARTSTEXT',
       'ENDSTEXT','FINDTOLEVEL','CLASS','ANCESTOR','EXISTSPROP',
       'ROUND','TRUNC','COS','SIN','ARCTAN','EXP','FRAC','LN',
       'SQR','SQRT','ODD','ABS','NOT','AND','OR','MOD','DIV','<','>','=','<=','>=','<>',
       '+','-','*','/','TOBOOLEAN','TOCHAR','TOBYTE','TOFLOAT','TOSTRING',
       'TOINTEGER','IS','NIL','');

procedure Skip(St:string;var n:integer);
function GetKeyWord(St:string):TKeyWord;
function MyReadString(St:string;var n:integer):string;
function ReadWord(St:string;var n:integer):string;
function ReadNumString(St:string;var n:integer):string;
function ReadToDblQuote(St:string;var n:integer):string;
function StrEmpty(St:string;n:integer):boolean;
function ReadBrackets(St:string;var n:integer):string;
function FindBinaryOperator(St:string;var n:integer;var resSt:string):boolean;

implementation
uses dialogs;

constructor SyntaxExcept.CreatePos(Msg:string;aPos:integer);
begin
 inherited create(Msg);
 self.Message:=Msg;
 Pos:=aPos
end;

function GetKeyWord(St:string):TKeyWord;
 var i:TKeyword;
 begin
 result:=_start;
 St:=UpperCase(St);
 i:=_start;
 inc(i);
 while(i<_stop) and (result=_start) do
  begin
   if St=KeyWord[i] then result:=i;
   inc(i);
  end;
 end;

function InSet(ch:char):boolean;
begin
   result:=ch in ['a'..'z','@'..'Z','0'..'9','_','.'];
end;

{function InMinusSet(ch:char):boolean;
 begin
  result:=ch in ['a'..'z','A'..'Z','0'..'9','_','-'];
 end;}

procedure Skip(St:string;var n:integer);
var
   l:integer;
begin
   l:=length(St);
   if (n>l) or (n=0) then
      n:=0
   else
   begin
      while (n<=l) and (St[n]=' ') do inc(n);
      if (n>l) and (St[l]=' ') then
         n:=0;
   end;
end;

function ReadWord(St:string;var n:integer):string;
var
   l,p:integer;
begin
   l:=length(St);
   skip(St,n);
   if n=0 then
      result:=''
   else
   begin
      p:=n;
      while (n<=l) and InSet(St[n]) do inc(n);
      result:=copy(St,p,n-p);
      if n>l then
         n:=0;
   end;
end;

{function ReadSignWord(St:string;var n:integer):string;
var l,p:integer;
  begin
  l:=length(St);
  skip(St,n);
  if n=0 then result:=''
   else
   begin
    p:=n;
    while (n<=l) and (not InSet(St[n])) and (not (St[n] in ['-','+'])) do inc(n);
    result:=copy(St,p,n-p);
    if n>l then n:=0;
   end;
 end;           }

function ReadNumString(St:string;var n:integer):string;
var l,p:integer;
  begin
  l:=length(St);
  skip(St,n);
  if n=0 then result:=''
   else
   begin
    p:=n;
    while (n<=l) and (St[n] in ['0'..'9','.']) do inc(n);
    result:=copy(St,p,n-p);
    if n>l then n:=0;
   end;
 end;

function ReadToDblQuote(St:string;var n:integer):string;
var l,p:integer;
  begin
  l:=length(St);
  skip(St,n);
  if n=0 then result:=''
   else
   begin
    p:=n;
    while (n<=l) and (St[n]<>':') do inc(n);
    result:=copy(St,p,n-p);
    if n>l then n:=0;
   end;
 end;

 function MyReadString(St:string;var n:integer):string;
 var l,p:integer;
  begin
  l:=length(St);
  skip(St,n);
  inc(n);
  if n=0 then result:=''
   else
   begin
    p:=n;
    while (n<=l) and (St[n]<>#39) do inc(n);
    result:=copy(St,p,n-p);
    inc(n);
    if n>l then n:=0;
   end;
 end;


 function StrEmpty(St:string;n:integer):boolean;
 begin
  skip(St,n);
  if n=0 then result:=true
  else result:=false;
 end;

function ReadBrackets(St:string;var n:integer):string;
var n1,l,count:integer;
begin
 n1:=n;
 skip(St,n);
 l:=length(St);
 if n1=0 then n1:=l+1;
 try
 if (n=0) then raise SyntaxExcept.CreatePos('Ocekavam: (',n1);
 if St[n]<>'(' then raise SyntaxExcept.CreatePos('Ocekavam: (',n);
 count:=1;
 inc(n);
 n1:=n;
 while (n<=l) and (count>0) do
   begin
    if St[n]='(' then inc(count);
    if St[n]=')' then dec(count);
    inc(n);
   end;
  if count=0 then result:=copy(St,n1,n-n1-1) else
    raise SyntaxExcept.CreatePos('Ocekavam: )',l+1);
  if n>l then n:=0;
 finally;
 end;
end;

function FindBinaryOperator(St:string; var n:integer; var resSt:string): boolean;
var
   l:integer;
   tn:integer;

   procedure SkiptoEndOfStr;
   var
      l:integer;
   begin
      l:=length(St);
      if (tn > l) or (tn = 0) then
         tn:=0
      else
      begin
         while (tn <= l) and (St[tn] <> #39) do inc(tn);
         if (tn > l) and (St[l] <> #39) then
            tn:=0;
      end;
   end;

   procedure FindKey(const aKey: string; var aFree,aResult: boolean);
   var
      tmpS: string;
      ls: integer;
   begin
      if afree then
      begin;
         ls := length(aKey);
         afree:=false;
         tmpS:=copy(St,tn,ls);
         if uppercase(tmpS)=aKey then
         if (tn+ls>l) or not(St[tn+ls] in ['a'..'z','@'..'Z']) then
         begin
            tn:=tn+ls-1;
            resSt:=TmpS;
            n:=tn;
            aresult:=true;
            afree:=true;
         end;
      end;
   end;

   function GetAndOr: boolean;
   var
      tmpSt:string;
      free:boolean;
   begin
      result:=false;
      tn:=1;
      free:=true;
      while (tn<l) and (tn>0) do
      begin
         case St[tn] of
            '(':
            begin
               ReadBrackets(St,tn);
               dec(tn);
               free:=true
            end;
            #39:
            begin
               inc(tn);
               SkiptoEndOfStr;
               free:=true;
            end;
            'a','A':
            if free then
            begin;
               free:=false;
               tmpSt:=copy(St,tn,3);
               if uppercase(tmpSt)='AND' then
               if (tn+3>l) or not(St[tn+3] in ['a'..'z','@'..'Z']) then
               begin
                  tn:=tn+2;
                  resSt:=TmpSt;
                  n:=tn;
                  result:=true;
                  free:=true;
               end;
            end;
            'o','O':
            if free then
            begin;
               free:=false;
               tmpSt:=copy(St,tn,2);
               if uppercase(tmpSt)='OR' then
               if (tn+2>l) or not(St[tn+2] in ['a'..'z','@'..'Z']) then
               begin
                  tn:=tn+1;
                  resSt:=TmpSt;
                  n:=tn;
                  result:=true;
                  free:=true;
               end;
            end;
            else
               if St[tn] in ['a'..'z','@'..'Z'] then
                  free:=false
               else
                  free:=true;
         end;{case}
         inc(tn);
      end;
   end;

   function GetModDiv:boolean;
   var
      tmpSt:string;
      free:boolean;
   begin
      result:=false;
      tn:=1;
      free:=true;
      while (tn<l) and (tn>0) do
      begin
         case St[tn] of
            '(':
            begin
               ReadBrackets(St,tn);
               dec(tn);
               free:=true
            end;
            #39:
            begin
               inc(tn);
               SkiptoEndOfStr;
               free:=true;
            end;
            'c','C': FindKey('CONTAINSTEXT',Free, result);
            's','S': FindKey('STARTSTEXT',Free, result);
            'e','E': FindKey('ENDSTEXT',Free, result);
            'i','I':
            if free then
            begin
               free:=false;
               tmpSt:=copy(St,tn,2);
               if (uppercase(tmpSt)='IS') then
               if (tn+2>l) or not(St[tn+2] in ['a'..'z','@'..'Z','_','0'..'9']) then
               begin
                  tn:=tn+1;
                  resSt:=TmpSt;
                  n:=tn;
                  result:=true;
                  free:=true;
               end;
            end;
            'm','M','d','D':
            begin
               if UpperCase(St[tn + 1]) = 'A' then
                  FindKey('MATCH',Free, result)
               else
               if free then
               begin
                  free:=false;
                  tmpSt:=copy(St,tn,3);
                  if (uppercase(tmpSt)='MOD') or (uppercase(tmpSt)='DIV') then
                  if (tn+3>l) or not(St[tn+3] in ['a'..'z','@'..'Z']) then
                  begin
                     tn:=tn+2;
                     resSt:=TmpSt;
                     n:=tn;
                     result:=true;
                     free:=true;
                  end;
               end
            end;
            else
               if St[tn] in ['a'..'z','@'..'Z'] then
                  free:=false
               else
                  free:=true;
         end;{case}
         inc(tn);
      end;
   end;


   function GetBooleanOp:boolean;
   begin
      result:=false;
      tn:=1;
      while  (tn<=l)and (tn>0) do
      begin
         case St[tn] of
            '(':
            begin
               ReadBrackets(St,tn);
               dec(tn);
            end;
            #39:
            begin
               inc(tn);
               SkiptoEndOfStr;
            end;
            '<':
            begin;
               resSt:=St[tn];
               if (tn < l) and (St[tn + 1] in ['>','='])then
               begin
                  Inc(tn);
                  resSt := resSt+St[tn]
               end;
               n:=tn;
               result:=true;
            end;
            '>':
            begin;
               resSt:=St[tn];
               if (tn < l) and (St[tn + 1] = '=')then
               begin
                  Inc(tn);
                  resSt := resSt+St[tn]
               end;
               n:=tn;
               result:=true;
            end;
            '=':
            begin;
               resSt:=St[tn];
               n:=tn;
               result:=true;
            end;
         end;{case}
         inc(tn);
      end;
   end;

   function GetPlusMinus:boolean;
   var
      free:boolean;
   begin
      result:=false;
      tn:=1;
      free:=false;
      while  (tn<=l)and (tn>0) do
      begin
         case St[tn] of
            '(':
            begin
               ReadBrackets(St,tn);
               dec(tn);
               free:=true;
            end;
            #39:
            begin
               inc(tn);
               SkiptoEndOfStr;
               free:=true;
            end;
            '+','-':
            if free then
            begin
               resSt:=St[tn];
               n:=tn;
               result:=true;
               free:=false;
            end;
            '*','/': free:=false;
            else
               if St[tn]<>' ' then
                  free:=true;
         end;{case}
         inc(tn);
      end;
   end;

   function GetMultiply:boolean;
   begin
      result:=false;
      tn:=1;
      while  (tn<=l)and (tn>0) do
      begin
         case St[tn] of
            '(':
            begin
               ReadBrackets(St,tn);
               dec(tn);
            end;
            #39:
            begin
               inc(tn);
               SkiptoEndOfStr;
            end;
            '*','/':
            begin;
               resSt:=St[tn];
               n:=tn;
               result:=true;
            end;
         end;{case}
         inc(tn);
      end;
   end;

begin
   l:=length(St);
   result:=true;
   if not GetAndOr then
   if not GetBooleanOp then
   if not GetModDiv then
   if not GetPlusMinus then
   if not GetMultiply then
      result:=false;
   inc(n);
   if n>l then
      n:=0;
   {
   if result then showmessage('nalezen operator: '+resst)
     else showmessage('zadny operator');
   }
end;

end.
