unit E_objenv;

interface
uses
  Classes,
// KERNEL
  Elements,
  E_Props;

type

TObjectEnvelope = class(TInstanceProperties)
private
  procedure DoCreateClass(aClassName: string);
  procedure SetLife(aVal: boolean);
  procedure SetInstanceName(aName: string);
protected
  FClass: TClass;
  procedure CreateInstance; virtual;
  procedure SetName(aName: string); override;
published
  property CreateClass: string write DoCreateClass;
  property Life: boolean write SetLife;
end;

implementation
uses
  Dialogs, Forms, ExtCtrls,
// KERNEL
  E_Class,
  U_Props,
  U_String;





procedure TObjectEnvelope.SetInstanceName(aName: string);
var
  EndNumber: integer;
  Rep: integer;
  OKej: boolean;
  BasicName: string;
begin
  if Instance = nil then exit;
  PropName:= 'NAME';
  if PropIndex = -1 then exit;
  PropString:= aName;

  if PropString <> aName then
  begin
    BasicName:= GetNameWithoutNumber(aName);
    EndNumber:= GetNameEndNumber(aName);
    Rep:= 0;
    repeat
      inc(EndNumber);
      inc(Rep);
      aName:= BasicName
    until OKej or (Rep > 999);
    if Rep > 999 then
       ShowMessage('Not possible to set correct component name: ' + aName)
  end
end;


procedure TObjectEnvelope.SetName(aName: string);
begin
  inherited SetName(aName);

  if Instance <> nil then
  begin
    SetInstanceName(aName);
    exit
  end;

  if FClass <> nil then exit;

  try
    FClass := GetClass(aName);
  except
  end
end;


procedure TObjectEnvelope.CreateInstance;
var
  aPersistent: TPersistent;
begin
  if FClass = nil then exit;
  aPersistent:= TPersistent(FClass.create);
  instance:= aPersistent
end;


procedure TObjectEnvelope.SetLife(aVal: boolean);
begin
  if aVal then
  begin
    if Instance = nil then
       CreateInstance
  end
  else
  begin
    if Instance <> nil then
       Instance.Free
  end
end;



procedure TObjectEnvelope.DoCreateClass(aClassName: string);
begin
  try
    FClass := GetClass(aClassName);

    if FClass = nil then
    begin
      aClassName:= 'T' + aClassName;
      FClass := GetClass(aClassName)
    end;

    if FClass = nil then
    begin
      MessageDlg('Neregistrovan tda TPersistent: '+ aClassName, mtError, [mbOK], 0);
      exit
    end;

    CreateInstance
  except
  end;
end;


BEGIN
   RegisterOrbisClass(TObjectEnvelope);
end.
