unit i_ChkFile;

interface
uses
  Elements,
  e_Device,
  e_Files,
  I_Chk;

type

TTestFileInterpret = class(TTestInterpret)
  private
    FDir: TDirectoryElement;
    procedure SetDir(const Value: TDirectoryElement);
protected
   procedure Process(Element: TElement); override;
   procedure WriteInfo(Element: TElement); override;
public
   procedure Reset(aDevice: TDevice); override;
   procedure Close; override;
   property  Dir: TDirectoryElement read FDir write SetDir;
end;


implementation
uses
   Forms,
   e_Class,
   t_Main,
   Worlds;


{ TTestFileInterpret }

procedure TTestFileInterpret.Close;
var
   i: integer;
begin
   EndProgress;
   Application.ProcessMessages;
   Dir := nil;
   for i := 0 to Tools.LastIndex do
   begin
      Tools.Elements[i].SetPropertyLongIntByName('Dir',0);
   end;
   inherited;
end;

procedure TTestFileInterpret.Process(Element: TElement);
var
   S: string;
begin
   if not (Element is TFileElement) then exit;
   TestCount := TestCount + 1;
   ProgressText := TFileElement(Element).FileName;
   Application.ProcessMessages;
   inherited;
end;


procedure TTestFileInterpret.Reset(aDevice: TDevice);
var
   i: integer;
begin
   inherited Reset(aDevice);
   StartProgress(Name,0,0);
   ProgressText := 'analza adresov struktury...';
   Application.ProcessMessages;
   Dir := TDirectoryElement.Create;
   Dir.FileName := TMainTool(World.MainTool).Options.DataDirectory; //!!!!!!!!!!!!
   for i := 0 to Tools.LastIndex do
   begin
      Tools.Elements[i].SetPropertyIntByName('Dir',NativeInt(Dir));
   end;
end;

procedure TTestFileInterpret.SetDir(const Value: TDirectoryElement);
begin
   ExchangeFieldElement(TElement(FDir), Value);
end;

procedure TTestFileInterpret.WriteInfo(Element: TElement);
begin
  Device.WriteLnText(' ' + TFileElement(Element).FileName);
end;

INITIALIZATION
   RegisterOrbisClass(TTestFileInterpret);
END.
