unit f_TransformationTableDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CheckLst, ExtCtrls, Buttons,
  e_Transformation,
  t_Transformation;

type
  TTransformationTableDialog_Form = class(TForm)
    Panel1: TPanel;
    LB: TCheckListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    procedure LBClickCheck(Sender: TObject);
  private
    FTrTable: TTransformationTable;
    FTransformation: TTransformation;
    procedure SetTrTable(const Value: TTransformationTable);
    procedure SetTransformation(const Value: TTransformation);
    { Private declarations }
  public
     property TrTable: TTransformationTable read FTrTable write SetTrTable;
     property Transformation: TTransformation read FTransformation write SetTransformation;
    { Public declarations }
  end;
{
 1: New
 2: Storno
 -: Differences;
 4: Continue
 6: Use
 -: Storno
}

implementation

{$R *.DFM}

{ TTransformationTableDialog_Form }

procedure TTransformationTableDialog_Form.SetTransformation(
  const Value: TTransformation);
begin
   FTransformation := Value;
end;

procedure TTransformationTableDialog_Form.SetTrTable(const Value: TTransformationTable);
var
   i: integer;
   S: string;
   B: TIDBod;
begin
   FTrTable := Value;
   LB.Clear;
   if Value = nil then exit;
   for i := 0 to Value.LastIndex do
   begin
      B := Value.IDBod[i];
      S := '        '+IntToStr(B.Cislo)+'.  dx:'+FormatFloat('"+"0.000;"-"0.000',B.OdchX)+'  dy:'+FormatFloat('"+"0.000;"-"0.000',B.OdchY);
      LB.Items.Add(S);
      LB.Checked[i] := B.Active;
   end;
end;

procedure TTransformationTableDialog_Form.LBClickCheck(Sender: TObject);
var
   i: integer;
begin
   if Transformation = nil then exit;
   i := LB.ItemIndex;
   TrTable.IDBod[i].Active := not TrTable.IDBod[i].Active;
   Transformation.Initialize;
   Transformation.EvaluateDifferences;
   TrTable := TrTable;
   LB.ItemIndex := i;
end;

end.
