unit T_qtfind;

interface
uses
// KERNEL
  Elements,
  Tools,
// SPACE
  E_QTree,
  e_Space;

type

TFindFirstSpaceEntityForXY = class(TTool)
private
  FX, FY: double;
  function GetQTreeForXY(aQT: TSpaceEntityQTree): TSpaceEntityQTree;
  function GetSpaceEntityForXY(aQT: TSpaceEntityQTree): TSpaceEntity;
public
  procedure DoIt; override;
published
  property X: double read FX write FX;
  property Y: double read FY write FY;
end;







implementation
uses
// KErNEL
  e_Class,
// GLIB
  g_Elems;


function TFindFirstSpaceEntityForXY.GetQTreeForXY(aQT: TSpaceEntityQTree): TSpaceEntityQTree;
var
  aaQT: TSpaceEntityQTree;
  I: longInt;

begin
  result:= nil;

  if aQT.IsLeaf then
  begin
    result:= aQT;
    exit;
  end;

  for I:= 0 to aQT.Count-1 do
  begin
    aaQT:= TSpaceEntityQTree(aQT.Elements[I]);
    if not (aaQT is TSpaceEntityQTree) then continue;

    if aaQT.XYIsIn(X, Y) then
    begin
      result:= GetQTreeForXY(aaQT);
      break
    end;
  end;
end;




function TFindFirstSpaceEntityForXY.GetSpaceEntityForXY(aQT: TSpaceEntityQTree): TSpaceEntity;
var
  I: longInt;
  Found: boolean;
  SE: TSpaceEntity;
  CE: T2DCoordinate;
begin
  CE:= T2DCoordinate.Create;
  CE.X:= X;
  CE.Y:= Y;
  result:= nil;
  I:= 0;
  for I:= 0 to aQT.Count-1 do
  begin
    SE:= TSpaceEntity(aQT.Elements[I]);
    if not (SE is TSpaceEntity) then continue;
    if SE.IsHit(CE, 0) then
    begin
      result:= SE;
      break
    end;
  end;

  CE.Free;
end;




procedure TFindFirstSpaceEntityForXY.DoIt;
var
  aQT: TSpaceEntityQTree;

begin
  if not (Input is TSpaceEntityQTree) then exit;
  Output:= nil;

  if not TSpaceEntityQTree(Input).XYIsIn(X, Y) then exit;

  aQT:= GetQTreeForXY(TSpaceEntityQTree(Input));
  if aQT = nil then exit;

  Output:= GetSpaceEntityForXY(aQT)
end;

initialization
   RegisterOrbisClass(TFindFirstSpaceEntityForXY);
end.
