unit T_TlDBF;


interface

{ penos poloek z jedn databze do druh
  Definin soubor penosu
  ZdrPol CilPol
}

uses
// KERNEL
  Elements;
type

TSourTarNames = class(TElement)
private
  FSourName, FTarName: string;
public
  procedure SetNames(aSour, aTar: string);
  function GetSource: string;
  function GetTarget: string;
end;

TMovedItemContainer = class(TEntity)
private
  FFileName: string;
public
  procedure ReadItems(FileName: string);

  function GetSourceItem(Index: longInt): string;
  function GetTargetItem(Index: longInt): string;
published
  property FileName: string read FFileName write ReadItems;
end;

implementation
uses
  SysUtils,
// KERNEL
  CtiRadek, {StrProc, }
  U_String;

procedure TSourTarNames.SetNames(aSour, aTar: string);
begin
  FSourName:= aSour;
  FTarName:= aTar
end;


function  TSourTarNames.GetSource: string;
begin
  result:= FSourName
end;


function  TSourTarNames.GetTarget: string;
begin
  result:= FTarName
end;




procedure TMovedItemContainer.ReadItems(FileName: string);
var
  F: text;
  Radek: string;
  RO: TCtiRadekClass;
  SrcN, TarN: string;
  Jmena: TSourTarNames;
begin
  system.assign(F, FileName);

  {$I-} reset(F) {$I+};
  if IOResult = 0 then
  begin
    if Count > 0 then
       FreeAll;
    while not eof(F) do
    begin
      readLn(F, Radek);

      RO:= TCtiRadekClass.Create(Radek);
      if not RO.DosloKChybe then
      with RO do
      begin
        PreskocMezery;
        SrcN:= UpperCase(BezVnejsichMezer(DejStringPoZnak(' ')));
        TarN:= UpperCase(BezVnejsichMezer(DejString(255)));
        if not DosloKChybe and (SrcN <> '') and (TarN <> '') then
        begin
          Jmena:= TSourTarNames.Create;
          Jmena.SetNames(SrcN, TarN);
          AddElement(Jmena)
        end
      end;
      RO.Free;
    end;
    {$I-} close(F); {$I+}
    if IOResult = 0 then
    begin
    end
  end;
end;



function TMovedItemContainer.GetSourceItem(Index: longInt): string;
begin
  result:= '';
  if (Count > 0) and (Index < Count) then
  begin
    result:= TSourTarNames(Elements[Index]).GetSource
  end
end;



function TMovedItemContainer.GetTargetItem(Index: longInt): string;
begin
  result:= '';
  if (Count > 0) and (Index < Count) then
  begin
    result:= TSourTarNames(Elements[Index]).GetTarget
  end
end;


end.
