{$N+}
unit TrPC;


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} interface {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses
     StrProc, PakTrans, Header, MyStream, FuncType;


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}


procedure TransformujRastr2AJ(
{$IFDEF Windows}
                                    DalsiKrokAbortNMCallBackPr,
                                    BylUserAbortAbortNMCallBackPr,
                                    KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                                    Cislo                       : integer;
                                    TransfPtr                   : PTransformace;
                              const JmenoNovehoRastru           : TPathStr;
                                    fSt                         : PPRStreamRas;
                                    fN                          : PPRWStream;
                                    Radku   , Sloupcu,
                                    SloupcuN, RadkuN            : integer;
                                    MinSSloupcuN , MinSRadkuN,
                                    CSloupcuN    , CRadkuN,
                                    MinSRadkuNObr, MaxSRadkuNObr: extended;
                                    Obrazec                     : PObrazec;
                                    Natoceni, Rychlost          : boolean;
                              var   EscDone                     : boolean);


{$IFDEF Windows}
export;
{$ENDIF}

procedure TransformujRastr256AJ(
{$IFDEF Windows}
                                      DalsiKrokAbortNMCallBackPr,
                                      BylUserAbortAbortNMCallBackPr,
                                      KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                                      Cislo                       : integer;
                                      TransfPtr                   : PTransformace;
                                const JmenoNovehoRastru           : TPathStr;
                                      fSt                         : PPRStreamRas;
                                      fN                          : PPRWStream;
                                      Radku   , Sloupcu,
                                      SloupcuN, RadkuN            : integer;
                                      MinSSloupcuN , MinSRadkuN,
                                      CSloupcuN    , CRadkuN,
                                      MinSRadkuNObr, MaxSRadkuNObr: extended;
                                      Obrazec                     : PObrazec;
                                      Natoceni, Rychlost          : boolean;
                               var    EscDone                     : boolean);


{$IFDEF Windows}
export;
{$ENDIF}

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} implementation {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses Strings,
     TranType, PTranPoV, PTranPoR,
     RasGlob;



{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}



type
  TPrus    = array[1..4] of integer;

procedure urci(
               var ObrazS;
               var ObrazN;
                   k,j   : integer); assembler;
asm
        PUSH DS
        LDS SI,OBRAZS
        MOV DX,K
        MOV BX,DX
        MOV CL,3
        SHR BX,CL
        ADD SI,BX
        SHL BX,CL
        XOR DX,BX
        MOV CL,DL
        MOV BL,128
        SHR BL,CL
        TEST DS:[SI],BL
        JNZ @@1
        LDS SI,OBRAZN
        MOV DX,J
        MOV BX,DX
        MOV CL,3
        SHR BX,CL
        ADD SI,BX
        SHL BX,CL
        XOR DX,BX
        MOV CL,DL
        MOV BL,128
        SHR BL,CL
        not bl
        AND BYTE PTR DS:[SI],BL
@@1:    POP DS

end;



procedure WindowLine(
                     var ObrazSt;
                     var ObrazNo;
                         PocatekSt, PocatekNo, Pocet: word) ; assembler;
asm
        PUSH DS
        LDS SI,OBRAZST
        CLD
        MOV DX,PocatekSt
        MOV BX,DX
        MOV CL,3
        SHR BX,CL
        ADD SI,BX
        SHL BX,CL
        XOR DX,BX
        MOV CL,DL
        MOV BL,128
        SHR BL,CL
        MOV AH,BL
        LES DI,OBRAZNO
        MOV DX,PocatekNo
        MOV BX,DX
        MOV CL,3
        SHR BX,CL
        ADD DI,BX
        SHL BX,CL
        XOR DX,BX
        MOV CL,DL
        MOV BH,128
        SHR BH,CL
        MOV CX,Pocet
        LODSB
@@2:    TEST AL,AH
        JNZ @@1
        MOV BL,BH
        NOT BL
        AND  BYTE PTR ES:[DI],BL
@@1:    SHR BH,1
        JNZ  @@4
        MOV BH,128
        INC DI
@@4:    SHR AH,1
        JNZ  @@3
        LODSB
        MOV AH,128
@@3:    LOOP @@2
        POP DS

END;


procedure PrusecikSLinii(
                             Pom , Nasl    : TSourInt;
                             Radka, Sloupcu: integer;
                         var Prusecik1,
                             Prusecik2     : integer;
                         var Neprotinase   : boolean;
                         var ObsahujeLinii : boolean;
                         var ProtinaVrchol : boolean);

var
   Svisla: boolean;
   K: double;
   XR, YR, RadkaR: double;

begin
  ObsahujeLinii := false;
  ProtinaVrchol := false;
  Neprotinase   := false;
  if ((Pom.X > Radka) and (Nasl.X > Radka))
     or
     ((Pom.X < Radka) and (Nasl.X < Radka)) then
    Neprotinase := true
  else
  begin
    if (Pom.X = Radka) and (Nasl.X = Radka) then
    begin
      ObsahujeLinii := true;
      if Pom.Y  <  1   then Pom.Y  := 1;
      if Pom.Y  >  Sloupcu  then Pom.Y  := Sloupcu;
      if Nasl.Y <  1   then Nasl.Y := 1;
      if Nasl.Y >  Sloupcu  then Nasl.Y := Sloupcu;
      Prusecik1 := Pom.Y;
      Prusecik2 := Nasl.Y;
    end else
    begin
      if Pom.X = Radka then
      begin
        ProtinaVrchol := true;
        Prusecik1     := Pom.Y;
      end else
      begin
        if Nasl.X = Radka then
        begin
          ProtinaVrchol := true;
          Prusecik1     := Nasl.Y;
        end else
        begin
          XR := Pom.X;
          YR := Pom.Y;

          Pom.X := 0;
          Pom.Y := 0;

          Nasl.X  := round(Nasl.X - XR);
          Nasl.Y  := round(Nasl.Y - YR);

          RadkaR := Radka - XR;

          Svisla := true;
          if abs(Nasl.X) > 1E-6 then
          begin
            K := Nasl.Y/Nasl.X;
            Svisla := false;
          end;

          if Svisla then
            Prusecik1 := round(YR)
          else
            Prusecik1 := round(K*RadkaR + YR);
        end;
      end;
    end;
  end;
end;




procedure UrciPrusecikySRadkou(
                                   Radka, Sloupcu: integer;
                                   Obrazec       : PObrazec;
                               var Rada          : TPrus;
                               var Pocet         : integer);
var
  i, j: integer;
  Neprotinase, ObsahujeLinii, ProtinaVrchol: boolean;
  PomPtr, NaslPtr: PObrazec;
  Prusecik1, Prusecik2: integer;
  pomRada: integer;

begin
  Pocet   := 0;

  NaslPtr := Obrazec^.Dalsi;
  PomPtr  := Obrazec;

  while NaslPtr <> nil do
  begin
    PrusecikSLinii(PomPtr^.Sour, NaslPtr^.Sour,
                   Radka, Sloupcu,
                   Prusecik1, Prusecik2,
                   Neprotinase , ObsahujeLinii, ProtinaVrchol);
    if not Neprotinase then
    begin
      if ProtinaVrchol then
      begin
        inc(Pocet);
        Rada[Pocet] := Prusecik1;
      end else
      begin
        inc(Pocet);
        Rada[Pocet] := Prusecik1;
        if ObsahujeLinii then
        begin
          inc(Pocet);
          Rada[Pocet] := Prusecik2;
          break;
        end;
      end;
    end;
    PomPtr      := NaslPtr;
    NaslPtr     := PomPtr^.Dalsi;
  end;

  if Pocet > 1 then
  begin
    repeat
      j := 0;
      for i := 1 to pred(Pocet) do
      begin
        if Rada[i] > Rada[succ(i)] then
        begin
          pomRada       := Rada[succ(i)];
          Rada[succ(i)] := Rada[i];
          Rada[i]       := pomRada;
          inc(j);
        end;
      end;
    until j = 0;
    i := 1;
    repeat
      if Rada[i] = Rada[succ(i)] then
      begin
        for j := succ(i) to pred(Pocet) do
          Rada[j] := Rada[succ(j)];
        dec(Pocet);
      end
      else
        inc(i);
    until i = Pocet;
  end;
end;



procedure TransformujRastr2AJ(
{$IFDEF Windows}
                                    DalsiKrokAbortNMCallBackPr,
                                    BylUserAbortAbortNMCallBackPr,
                                    KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                                    Cislo                       : integer;
                                    TransfPtr                   : PTransformace;
                              const JmenoNovehoRastru           : TPathStr;
                                    fSt                         : PPRStreamRas;
                                    fN                          : PPRWStream;
                                    Radku   , Sloupcu,
                                    SloupcuN, RadkuN            : integer;
                                    MinSSloupcuN , MinSRadkuN,
                                    CSloupcuN    , CRadkuN,
                                    MinSRadkuNObr, MaxSRadkuNObr: extended;
                                    Obrazec                     : PObrazec;
                                    Natoceni, Rychlost          : boolean;
                              var   EscDone                     : boolean);

label
  1,2,3,4;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  i, j, sp, k, l, sl, kSt, p, q, r, k_r: longint;
  dxC, dyC, a1, a2, a3, b1, b2, b3, a1_1,
  bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  BodZdr, BodCil, PomBodCil, PomBodZdr: TranType.Bod;
  Rada: TPrus;
  Pocet: integer;
  MinSloupecN, MaxSloupecN, MinRadkaN, MaxRadkaN, MaxMin: longInt;
  Zapisovat: boolean;

begin
  sl := -2147483640;

  EscDone := false;

  MinRadkaN   := round((MinSRadkuNObr - MinSRadkuN) / CRadkuN) + 1;
  MaxRadkaN   := round((MaxSRadkuNObr - MinSRadkuN) / CRadkuN) + 1;

  with TransfPtr^ do
  begin
    if Natoceni then
    begin
      if Rychlost then
      begin
        a1   := InvKlic[1];
        a2   := InvKlic[2];
        a3   := InvKlic[3];
        b1   := InvKlic[4];
        b2   := InvKlic[5];
        b3   := InvKlic[6];
        a1_1 := 1-a1*CSloupcuN;

        if abs(b1)   < eps then b1   := 0;
        if abs(a1_1) < eps then a1_1 := 0;

        BodZdr.Y := MinSRadkuNObr - CRadkuN;

        if b1 <> 0 then
          bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + CSloupcuN + CilStred.X - MinSSloupcuN)/CSloupcuN;
        if a1_1 <> 0 then
        begin
          apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
          apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
        end;

        for i := MinRadkaN to MaxRadkaN do
        begin
          fN^.Read(ObrazN, pred(i));

          UrciPrusecikySRadkou(i, Sloupcu, Obrazec, Rada, Pocet);
          if Pocet = 1 then
          begin
            j  := Rada[1] - 1;
            BodZdr.Y := BodZdr.Y + CRadkuN;
            BodZdr.X := (SloupcuN - Rada[1]) * CSloupcuN + MinSSloupcuN;
            InvTransformuj(BodZdr, BodCil);
            k := round(Sloupcu-BodCil.X);
            l := round(BodCil.Y);
            if sl <> l then
            begin
              if (l > 0) and (l <= Radku) then
              begin
                Zapisovat := true;
                fSt^.Read(ObrazS, pred(l));
              end
              else
                Zapisovat := false;
              sl := l;
            end;
            if Zapisovat then
              urci(ObrazS^, ObrazN^, k, j);
          end else
          begin
            BodZdr.X := (SloupcuN - Rada[1]) * CSloupcuN + MinSSloupcuN;
            BodZdr.Y := BodZdr.Y + CRadkuN;
            InvTransformuj(BodZdr, BodCil);

            BodZdr.X := BodZdr.X - CSloupcuN;
            InvTransformuj(BodZdr, PomBodCil);
            BodZdr.X := BodZdr.X + CSloupcuN;

            dxC := PomBodCil.Y - BodCil.Y;
            dyC := PomBodCil.X - BodCil.X;

            MinSloupecN := Rada[1];
            MaxSloupecN := Rada[2];

            PomBodZdr.Y := (BodZdr.Y - CilStred.Y);
            bpom3       := PomBodZdr.Y*b2;
            if a1_1 <> 0 then
              apom3     := PomBodZdr.Y*a2/a1_1;

            j  := pred(MinSloupecN);
            repeat
              k := round(Sloupcu-BodCil.X);
              l := round(BodCil.Y);

              if sl <> l then
              begin
                if (l > 0) and (l <= Radku) then
                begin
                  Zapisovat := true;
                  fSt^.Read(ObrazS, pred(l));
                end
                else
                  Zapisovat := false;
                sl := l;
              end;

              PomBodZdr.X := BodZdr.X - CilStred.X;
              kSt         := round(BodCil.X);

              if b1 < 0 then
                p := trunc(SloupcuN - ((l - bpom3)/(b1*CSloupcuN) + bpom1))
              else
                p := pred(MaxSloupecN);

              if a1_1 > 0 then
                q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
              else
                if a1_1 < 0 then
                  q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
                else
                  q := pred(MaxSloupecN - j);

              if p-j < q then
                r := succ(p-j)
              else
                r := succ(q);

              if r > pred(MaxSloupecN) - j then
                r := pred(MaxSloupecN) - j;

              if r < 1 then
                r := 1;

              k_r := k+r;

              if (k >= 0) and (k < Sloupcu) and (k_r < Sloupcu) then
              begin
                if Zapisovat then
                  WindowLine(ObrazS^, ObrazN^, k, j, r);
              end
              else
                if k < 0 then
                begin
                  if k_r >= 0 then
                  begin
                    inc(j, -k);
                    inc(r,  k);
                    if r >= Sloupcu then
                    begin
                      if Zapisovat then
                        WindowLine(ObrazS^, ObrazN^, 0, j, Sloupcu);
                      goto 1;
                    end else
                    begin
                      BodCil.X := BodCil.X - k*dyC;
                      BodCil.Y := BodCil.Y - k*dxC;
                      BodZdr.X := BodZdr.X + k*CSloupcuN;
                      if Zapisovat and (r > 0) then
                        WindowLine(ObrazS^, ObrazN^, 0, j, r);
                    end;
                  end;
                end else
                begin
                  if Zapisovat and (k < Sloupcu) then
                    WindowLine(ObrazS^, ObrazN^, k, j, succ(Sloupcu-r));
                  goto 1;
                end;

              inc(j, r);
              BodCil.X := BodCil.X + r*dyC;
              BodCil.Y := BodCil.Y + r*dxC;
              BodZdr.X := BodZdr.X - r*CSloupcuN;
            until j >= MaxSloupecN;
          end;

        1:DalsiKrokAbortNMCallBackPr(0, 0);
          KeepWindowsAliveCallBackPr(0, 0);
          if BylUserAbortAbortNMCallBackPr(0, 0) then
          begin
            EscDone := true;
            exit;
          end;
        end;
      end else
      begin
        BodZdr.Y := MinSRadkuNObr - CRadkuN;
        for i := MinRadkaN to MaxRadkaN do
        begin
          fN^.Read(ObrazN, pred(i));

          UrciPrusecikySRadkou(i, Sloupcu, Obrazec, Rada, Pocet);
          if Pocet = 1 then
          begin
            j  := Rada[1] - 1;
            BodZdr.Y := BodZdr.Y + CRadkuN;
            BodZdr.X := (SloupcuN - Rada[1]) * CSloupcuN + MinSSloupcuN;
            InvTransformuj(BodZdr, BodCil);
            k := round(Sloupcu-BodCil.X);
            l := round(BodCil.Y);
            if sl <> l then
            begin
              if (l > 0) and (l <= Radku) then
              begin
                Zapisovat := true;
                fSt^.Read(ObrazS, pred(l));
              end
              else
                Zapisovat := false;
              sl := l;
            end;
            if Zapisovat then
              urci(ObrazS^, ObrazN^, k, j);
          end else
          begin
            BodZdr.X := (SloupcuN - Rada[1]) * CSloupcuN + MinSSloupcuN;
            BodZdr.Y := BodZdr.Y + CRadkuN;
            InvTransformuj(BodZdr, PomBodCil);

            BodZdr.X := BodZdr.X - CSloupcuN;
            InvTransformuj(BodZdr, BodCil);

            dxC := BodCil.Y - PomBodCil.Y;
            dyC := BodCil.X - PomBodCil.X;

            BodCil.X := PomBodCil.X - dyC;
            BodCil.Y := PomBodCil.Y - dxC;

            MinSloupecN := Rada[1];
            MaxSloupecN := Rada[2];

            j := pred(pred(MinSloupecN));
            repeat
              inc(j);
              if j = MaxSloupecN then goto 2;
              BodCil.X := BodCil.X + dyC;
              BodCil.Y := BodCil.Y + dxC;
              k := round(Sloupcu-BodCil.X);
              l := round(BodCil.Y);
            until (k >= 0) and (k < Sloupcu) and (l > 0) and (l <= Radku);
            sp := j;

            if sl <> l then
            begin
              sl := l;
              fSt^.Read(ObrazS, pred(sl));
            end;
            urci(ObrazS^, ObrazN^, k, j);
            for j := succ(sp) to pred(MaxSloupecN) do
            begin
              BodCil.X := BodCil.X + dyC;
              BodCil.Y := BodCil.Y + dxC;
              k  := round(Sloupcu-BodCil.X);
              l  := round(BodCil.Y);
              if (k < 0) or (k >= Sloupcu) or (l < 1) or (l > Radku) then
                goto 2
              else
              begin
                if sl <> l then
                begin
                  sl := l;
                  fSt^.Read(ObrazS, pred(sl));
                end;
                urci(ObrazS^,ObrazN^,k,j);
              end;
            end;
          end;

        2:DalsiKrokAbortNMCallBackPr(0, 0);
          KeepWindowsAliveCallBackPr(0, 0);
          if BylUserAbortAbortNMCallBackPr(0, 0) then
          begin
            EscDone := true;
            exit;
          end;
        end;
      end
    end else
    begin
      if Rychlost then
      begin
        a1   := InvKlic[1];
        a2   := InvKlic[2];
        a3   := InvKlic[3];
        b1   := InvKlic[4];
        b2   := InvKlic[5];
        b3   := InvKlic[6];
        a1_1 := 1-a1*CSloupcuN;

        if abs(b1)   < eps then b1   := 0;
        if abs(a1_1) < eps then a1_1 := 0;

        BodZdr.Y := MinSRadkuNObr - CRadkuN;

        if b1 <> 0 then
          bpom1 := ((-ZdrojStred.Y - 0.5 - b3)/b1 + CSloupcuN + CilStred.X - MinSSloupcuN)/CSloupcuN;
        if a1_1 <> 0 then
        begin
          apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
          apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
        end;
        for i := MinRadkaN to MaxRadkaN do
        begin
          fN^.Read(ObrazN, pred(i));

          UrciPrusecikySRadkou(i, Sloupcu, Obrazec, Rada, Pocet);
          if Pocet = 1 then
          begin
            j  := Rada[1] - 1;
            BodZdr.Y := BodZdr.Y + CRadkuN;
            BodZdr.X := (SloupcuN - Rada[1]) * CSloupcuN + MinSSloupcuN;
            InvTransformuj(BodZdr, BodCil);
            k := round(Sloupcu-BodCil.X);
            l := round(BodCil.Y);
            if sl <> l then
            begin
              if (l > 0) and (l <= Radku) then
              begin
                Zapisovat := true;
                fSt^.Read(ObrazS, pred(l));
              end
              else
                Zapisovat := false;
              sl := l;
            end;
            if Zapisovat then
              urci(ObrazS^, ObrazN^, k, j);
          end else
          begin
            BodZdr.X := (SloupcuN - Rada[1]) * CSloupcuN + MinSSloupcuN;
            BodZdr.Y := BodZdr.Y + CRadkuN;
            InvTransformuj(BodZdr, BodCil);

            BodZdr.X := BodZdr.X - CSloupcuN;
            InvTransformuj(BodZdr, PomBodCil);
            BodZdr.X := BodZdr.X + CSloupcuN;

            dxC := PomBodCil.Y - BodCil.Y;
            dyC := PomBodCil.X - BodCil.X;

            MinSloupecN := Rada[1];
            MaxSloupecN := Rada[2];

            PomBodZdr.Y := (BodZdr.Y - CilStred.Y);
            bpom3       := PomBodZdr.Y*b2;
            if a1_1 <> 0 then
              apom3     := PomBodZdr.Y*a2/a1_1;

            j  := pred(MinSloupecN);
            repeat
              k := round(Sloupcu-BodCil.X);
              l := round(BodCil.Y);

              if sl <> l then
              begin
                if (l > 0) and (l <= Radku) then
                begin
                  Zapisovat := true;
                  fSt^.Read(ObrazS, pred(l));
                end
                else
                  Zapisovat := false;
                sl := l;
              end;

              PomBodZdr.X := BodZdr.X - CilStred.X;
              kSt         := round(BodCil.X);

              if b1 > 0 then
                p := trunc(SloupcuN - ((l - bpom3)/(b1*CSloupcuN) + bpom1))
              else
                p := pred(MaxSloupecN);

              if a1_1 > 0 then
                q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
              else
                if a1_1 < 0 then
                  q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
                else
                  q := pred(MaxSloupecN - j);

              if p-j < q then
                r := succ(p-j)
              else
                r := succ(q);

              if r > pred(MaxSloupecN) - j then
                r := pred(MaxSloupecN) - j;

              if r < 1 then
                r := 1;

              k_r := k+r;

              if (k >= 0) and (k < Sloupcu) and (k_r < Sloupcu) then
              begin
                if Zapisovat then
                  WindowLine(ObrazS^, ObrazN^, k, j, r);
              end
              else
                if k < 0 then
                begin
                  if k_r >= 0 then
                  begin
                    inc(j, -k);
                    inc(r,  k);
                    if r >= Sloupcu then
                    begin
                      if Zapisovat then
                        WindowLine(ObrazS^, ObrazN^, 0, j, Sloupcu);
                      goto 3;
                    end else
                    begin
                      BodCil.X := BodCil.X - k*dyC;
                      BodCil.Y := BodCil.Y - k*dxC;
                      BodZdr.X := BodZdr.X + k*CSloupcuN;
                      if Zapisovat and (r > 0) then
                        WindowLine(ObrazS^, ObrazN^, 0, j, r);
                    end;
                  end;
                end else
                begin
                  if Zapisovat and (k < Sloupcu) then
                    WindowLine(ObrazS^, ObrazN^, k, j, succ(Sloupcu-r));
                  goto 3;
                end;

              inc(j, r);
              BodCil.X := BodCil.X + r*dyC;
              BodCil.Y := BodCil.Y + r*dxC;
              BodZdr.X := BodZdr.X - r*CSloupcuN;
            until j >= MaxSloupecN;
          end;

        3:DalsiKrokAbortNMCallBackPr(0, 0);
          KeepWindowsAliveCallBackPr(0, 0);
          if BylUserAbortAbortNMCallBackPr(0, 0) then
          begin
            EscDone := true;
            exit;
          end;
        end;
      end else
      begin
        BodZdr.Y := MinSRadkuNObr - CRadkuN;

        for i := MinRadkaN to MaxRadkaN do
        begin
          fN^.Read(ObrazN, pred(i));

          UrciPrusecikySRadkou(i, Sloupcu, Obrazec, Rada, Pocet);
          if Pocet = 1 then
          begin
            j  := Rada[1] - 1;
            BodZdr.Y := BodZdr.Y + CRadkuN;
            BodZdr.X := (SloupcuN - Rada[1]) * CSloupcuN + MinSSloupcuN;
            InvTransformuj(BodZdr, BodCil);
            k := round(Sloupcu-BodCil.X);
            l := round(BodCil.Y);
            if sl <> l then
            begin
              if (l > 0) and (l <= Radku) then
              begin
                Zapisovat := true;
                fSt^.Read(ObrazS, pred(l));
              end
              else
                Zapisovat := false;
              sl := l;
            end;
            if Zapisovat then
              urci(ObrazS^, ObrazN^, k, j);
          end else
          begin
            BodZdr.Y := BodZdr.Y + CRadkuN;
            BodZdr.X := (SloupcuN - Rada[2]) * CSloupcuN + MinSSloupcuN;
            InvTransformuj(BodZdr, PomBodCil);

            BodZdr.X := BodZdr.X + CSloupcuN;
            InvTransformuj(BodZdr, BodCil);

            dxc := BodCil.Y - PomBodCil.Y;
            dyc := BodCil.X - PomBodCil.X;

            BodCil.X := PomBodCil.X - dyC;
            BodCil.Y := PomBodCil.Y - dxC;

            MinSloupecN := Rada[1];
            MaxSloupecN := Rada[2];

            j := MaxSloupecN;
            dec(MinSloupecN);
            repeat
              dec(j);
              if j = pred(MinSloupecN) then goto 4;
              BodCil.X := BodCil.X + dyC;
              BodCil.Y := BodCil.Y + dxC;
              k := round(Sloupcu-BodCil.X);
              l := round(BodCil.Y);
            until (k >= 0) and (k < Sloupcu) and (l > 0) and (l <= Radku);
            sp := j;

            if sl <> l then
            begin
              sl := l;
              fSt^.Read(ObrazS, pred(sl));
            end;
            urci(ObrazS^, ObrazN^, k, j);
            for j := pred(sp) downto MinSloupecN do
            begin
              BodCil.X := BodCil.X + dyC;
              BodCil.Y := BodCil.Y + dxC;
              k  := round(Sloupcu-BodCil.X);
              l  := round(BodCil.Y);
              if (k < 0) or (k >= Sloupcu) or (l < 1) or (l > Radku) then
                goto 4
              else
              begin
                if sl <> l then
                begin
                  sl := l;
                  fSt^.Read(ObrazS, pred(sl));
                end;
                urci(ObrazS^,ObrazN^,k,j);
              end;
            end;
          end;

        4:DalsiKrokAbortNMCallBackPr(0, 0);
          KeepWindowsAliveCallBackPr(0, 0);
          if BylUserAbortAbortNMCallBackPr(0, 0) then
          begin
            EscDone := true;
            exit;
          end;
        end;
      end;
    end;
  end;
end;




procedure TransformujRastr256AJ(
{$IFDEF Windows}
                                      DalsiKrokAbortNMCallBackPr,
                                      BylUserAbortAbortNMCallBackPr,
                                      KeepWindowsAliveCallBackPr    : TFunctionDLL;
{$ENDIF}
                                      Cislo                       : integer;
                                      TransfPtr                   : PTransformace;
                                const JmenoNovehoRastru           : TPathStr;
                                      fSt                         : PPRStreamRas;
                                      fN                          : PPRWStream;
                                      Radku   , Sloupcu,
                                      SloupcuN, RadkuN            : integer;
                                      MinSSloupcuN , MinSRadkuN,
                                      CSloupcuN    , CRadkuN,
                                      MinSRadkuNObr, MaxSRadkuNObr: extended;
                                      Obrazec                     : PObrazec;
                                      Natoceni, Rychlost          : boolean;
                                var   EscDone                     : boolean);

label
  1,2,3,4;

const
  eps = 1E-5;

var
  ObrazN, ObrazS: pointer;
  i, j, sp, k, l, sl, kSt, p, q, r, k_r: longint;
  dxC, dyC, a1, a2, a3, b1, b2, b3, a1_1,
  bpom1, bpom2, bpom3, apom1, apom2, apom3: extended;
  BodZdr, BodCil, PomBodCil, PomBodZdr: TranType.Bod;
  Rada: TPrus;
  Pocet: integer;
  MinSloupecN, MaxSloupecN, MinRadkaN, MaxRadkaN, MaxMin: longInt;
  Zapisovat: boolean;

begin
  sl := -2147483640;

  EscDone := false;

  MinRadkaN   := round((MinSRadkuNObr - MinSRadkuN) / CRadkuN) + 1;
  MaxRadkaN   := round((MaxSRadkuNObr - MinSRadkuN) / CRadkuN) + 1;

  with TransfPtr^ do
  begin
    if Natoceni then
    begin
      if Rychlost then
      begin
        a1   := InvKlic[1];
        a2   := InvKlic[2];
        a3   := InvKlic[3];
        b1   := InvKlic[4];
        b2   := InvKlic[5];
        b3   := InvKlic[6];
        a1_1 := 1-a1*CSloupcuN;

        if abs(b1)   < eps then b1   := 0;
        if abs(a1_1) < eps then a1_1 := 0;

        BodZdr.Y := MinSRadkuNObr - CRadkuN;

        if b1 <> 0 then
          bpom1 := ((-ZdrojStred.Y + 0.5 - b3)/b1 + CSloupcuN + CilStred.X - MinSSloupcuN)/CSloupcuN;
        if a1_1 <> 0 then
        begin
          apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
          apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
        end;

        for i := MinRadkaN to MaxRadkaN do
        begin
          fN^.Read(ObrazN, pred(i));

          UrciPrusecikySRadkou(i, Sloupcu, Obrazec, Rada, Pocet);
          if Pocet = 1 then
          begin
            j  := Rada[1] - 1;
            BodZdr.Y := BodZdr.Y + CRadkuN;
            BodZdr.X := (SloupcuN - Rada[1]) * CSloupcuN + MinSSloupcuN;
            InvTransformuj(BodZdr, BodCil);
            k := round(Sloupcu-BodCil.X);
            l := round(BodCil.Y);
            if sl <> l then
            begin
              if (l > 0) and (l <= Radku) then
              begin
                Zapisovat := true;
                fSt^.Read(ObrazS, pred(l));
              end
              else
                Zapisovat := false;
              sl := l;
            end;
            if Zapisovat then
              PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
          end else
          begin
            BodZdr.X := (SloupcuN - Rada[1]) * CSloupcuN + MinSSloupcuN;
            BodZdr.Y := BodZdr.Y + CRadkuN;
            InvTransformuj(BodZdr, BodCil);

            BodZdr.X := BodZdr.X - CSloupcuN;
            InvTransformuj(BodZdr, PomBodCil);
            BodZdr.X := BodZdr.X + CSloupcuN;

            dxC := PomBodCil.Y - BodCil.Y;
            dyC := PomBodCil.X - BodCil.X;

            MinSloupecN := Rada[1];
            MaxSloupecN := Rada[2];

            PomBodZdr.Y := (BodZdr.Y - CilStred.Y);
            bpom3       := PomBodZdr.Y*b2;
            if a1_1 <> 0 then
              apom3     := PomBodZdr.Y*a2/a1_1;

            j := pred(MinSloupecN);
            repeat
              k := round(Sloupcu-BodCil.X);
              l := round(BodCil.Y);

              if sl <> l then
              begin
                if (l > 0) and (l <= Radku) then
                begin
                  Zapisovat := true;
                  fSt^.Read(ObrazS, pred(l));
                end
                else
                  Zapisovat := false;
                sl := l;
              end;

              PomBodZdr.X := BodZdr.X - CilStred.X;
              kSt         := round(BodCil.X);

              if b1 < 0 then
                p := trunc(SloupcuN - ((l - bpom3)/(b1*CSloupcuN) + bpom1))
              else
                p := pred(MaxSloupecN);

              if a1_1 > 0 then
                q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
              else
                if a1_1 < 0 then
                  q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
                else
                  q := pred(MaxSloupecN - j);

              if p-j < q then
                r := succ(p-j)
              else
                r := succ(q);

              if r > pred(MaxSloupecN) - j then
                r := pred(MaxSloupecN) - j;

              if r < 1 then
                r := 1;

              k_r := k+r;

              if (k >= 0) and (k < Sloupcu) and (k_r < Sloupcu) then
              begin
                if Zapisovat then
                  move(PBuffer0(ObrazS)^[k], PBuffer0(ObrazN)^[j], r)
              end
              else
                if k < 0 then
                begin
                  if k_r >= 0 then
                  begin
                    inc(j, -k);
                    inc(r,  k);
                    if r >= Sloupcu then
                    begin
                      if Zapisovat then
                        move(PBuffer0(ObrazS)^[0], PBuffer0(ObrazN)^[j], Sloupcu);
                      goto 1;
                    end else
                    begin
                      BodCil.X := BodCil.X - k*dyC;
                      BodCil.Y := BodCil.Y - k*dxC;
                      BodZdr.X := BodZdr.X + k*CSloupcuN;
                      if Zapisovat and (r > 0) then
                        move(PBuffer0(ObrazS)^[0], PBuffer0(ObrazN)^[j], r)
                    end;
                  end;
                end else
                begin
                  if Zapisovat and (k < Sloupcu) then
                    move(PBuffer0(ObrazS)^[k], PBuffer0(ObrazN)^[j], succ(Sloupcu-r));
                  goto 1;
                end;

              inc(j, r);
              BodCil.X := BodCil.X + r*dyC;
              BodCil.Y := BodCil.Y + r*dxC;
              BodZdr.X := BodZdr.X - r*CSloupcuN;
            until j >= MaxSloupecN;
          end;

        1:DalsiKrokAbortNMCallBackPr(0, 0);
          KeepWindowsAliveCallBackPr(0, 0);
          if BylUserAbortAbortNMCallBackPr(0, 0) then
          begin
            EscDone := true;
            exit;
          end;
        end;
      end else
      begin
        BodZdr.Y := MinSRadkuNObr - CRadkuN;
        for i := MinRadkaN to MaxRadkaN do
        begin
          fN^.Read(ObrazN, pred(i));

          UrciPrusecikySRadkou(i, Sloupcu, Obrazec, Rada, Pocet);
          if Pocet = 1 then
          begin
            j  := Rada[1] - 1;
            BodZdr.Y := BodZdr.Y + CRadkuN;
            BodZdr.X := (SloupcuN - Rada[1]) * CSloupcuN + MinSSloupcuN;
            InvTransformuj(BodZdr, BodCil);
            k := round(Sloupcu-BodCil.X);
            l := round(BodCil.Y);
            if sl <> l then
            begin
              if (l > 0) and (l <= Radku) then
              begin
                Zapisovat := true;
                fSt^.Read(ObrazS, pred(l));
              end
              else
                Zapisovat := false;
              sl := l;
            end;
            if Zapisovat then
              PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
          end else
          begin
            BodZdr.X := (SloupcuN - Rada[1]) * CSloupcuN + MinSSloupcuN;
            BodZdr.Y := BodZdr.Y + CRadkuN;
            InvTransformuj(BodZdr, PomBodCil);

            BodZdr.X := BodZdr.X - CSloupcuN;
            InvTransformuj(BodZdr, BodCil);

            dxC := BodCil.Y - PomBodCil.Y;
            dyC := BodCil.X - PomBodCil.X;

            BodCil.X := PomBodCil.X - dyC;
            BodCil.Y := PomBodCil.Y - dxC;

            MinSloupecN := Rada[1];
            MaxSloupecN := Rada[2];

            j := pred(pred(MinSloupecN));
            repeat
              inc(j);
              if j = MaxSloupecN then goto 2;
              BodCil.X := BodCil.X + dyC;
              BodCil.Y := BodCil.Y + dxC;
              k := round(Sloupcu-BodCil.X);
              l := round(BodCil.Y);
            until (k >= 0) and (k < Sloupcu) and (l > 0) and (l <= Radku);
            sp := j;

            if sl <> l then
            begin
              sl := l;
              fSt^.Read(ObrazS, pred(sl));
            end;
            PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
            for j := succ(sp) to pred(MaxSloupecN) do
            begin
              BodCil.X := BodCil.X + dyC;
              BodCil.Y := BodCil.Y + dxC;
              k  := round(Sloupcu-BodCil.X);
              l  := round(BodCil.Y);
              if (k < 0) or (k >= Sloupcu) or (l < 1) or (l > Radku) then
                goto 2
              else
              begin
                if sl <> l then
                begin
                  sl := l;
                  fSt^.Read(ObrazS, pred(sl));
                end;
                PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
              end;
            end;
          end;

        2:DalsiKrokAbortNMCallBackPr(0, 0);
          KeepWindowsAliveCallBackPr(0, 0);
          if BylUserAbortAbortNMCallBackPr(0, 0) then
          begin
            EscDone := true;
            exit;
          end;
        end;
      end
    end else
    begin
      if Rychlost then
      begin
        a1   := InvKlic[1];
        a2   := InvKlic[2];
        a3   := InvKlic[3];
        b1   := InvKlic[4];
        b2   := InvKlic[5];
        b3   := InvKlic[6];
        a1_1 := 1-a1*CSloupcuN;

        if abs(b1)   < eps then b1   := 0;
        if abs(a1_1) < eps then a1_1 := 0;

        BodZdr.Y := MinSRadkuNObr - CRadkuN;

        if b1 <> 0 then
          bpom1 := ((-ZdrojStred.Y - 0.5 - b3)/b1 + CSloupcuN + CilStred.X - MinSSloupcuN)/CSloupcuN;
        if a1_1 <> 0 then
        begin
          apom1 := ( -ZdrojStred.X + 0.5 - a3)/a1_1;
          apom2 := ( -ZdrojStred.X - 0.5 - a3)/a1_1;
        end;
        for i := MinRadkaN to MaxRadkaN do
        begin
          fN^.Read(ObrazN, pred(i));

          UrciPrusecikySRadkou(i, Sloupcu, Obrazec, Rada, Pocet);
          if Pocet = 1 then
          begin
            j  := Rada[1] - 1;
            BodZdr.Y := BodZdr.Y + CRadkuN;
            BodZdr.X := (SloupcuN - Rada[1]) * CSloupcuN + MinSSloupcuN;
            InvTransformuj(BodZdr, BodCil);
            k := round(Sloupcu-BodCil.X);
            l := round(BodCil.Y);
            if sl <> l then
            begin
              if (l > 0) and (l <= Radku) then
              begin
                Zapisovat := true;
                fSt^.Read(ObrazS, pred(l));
              end
              else
                Zapisovat := false;
              sl := l;
            end;
            if Zapisovat then
              PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
          end else
          begin
            BodZdr.X := (SloupcuN - Rada[1]) * CSloupcuN + MinSSloupcuN;
            BodZdr.Y := BodZdr.Y + CRadkuN;
            InvTransformuj(BodZdr, BodCil);

            BodZdr.X := BodZdr.X - CSloupcuN;
            InvTransformuj(BodZdr, PomBodCil);
            BodZdr.X := BodZdr.X + CSloupcuN;

            dxC := PomBodCil.Y - BodCil.Y;
            dyC := PomBodCil.X - BodCil.X;

            MinSloupecN := Rada[1];
            MaxSloupecN := Rada[2];

            PomBodZdr.Y := (BodZdr.Y - CilStred.Y);
            bpom3       := PomBodZdr.Y*b2;
            if a1_1 <> 0 then
              apom3     := PomBodZdr.Y*a2/a1_1;

            j  := pred(MinSloupecN);
            repeat
              k := round(Sloupcu-BodCil.X);
              l := round(BodCil.Y);

              if sl <> l then
              begin
                if (l > 0) and (l <= Radku) then
                begin
                  Zapisovat := true;
                  fSt^.Read(ObrazS, pred(l));
                end
                else
                  Zapisovat := false;
                sl := l;
              end;

              PomBodZdr.X := BodZdr.X - CilStred.X;
              kSt         := round(BodCil.X);

              if b1 > 0 then
                p := trunc(SloupcuN - ((l - bpom3)/(b1*CSloupcuN) + bpom1))
              else
                p := pred(MaxSloupecN);

              if a1_1 > 0 then
                q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom1 - apom3)
              else
                if a1_1 < 0 then
                  q := trunc((kSt - a1*PomBodZdr.X)/a1_1 + apom2 - apom3)
                else
                  q := pred(MaxSloupecN - j);

              if p-j < q then
                r := succ(p-j)
              else
                r := succ(q);

              if r > pred(MaxSloupecN) - j then
                r := pred(MaxSloupecN) - j;

              if r < 1 then
                r := 1;

              k_r := k+r;

              if (k >= 0) and (k < Sloupcu) and (k_r < Sloupcu) then
              begin
                if Zapisovat then
                  move(PBuffer0(ObrazS)^[k], PBuffer0(ObrazN)^[j], r)
              end
              else
                if k < 0 then
                begin
                  if k_r >= 0 then
                  begin
                    inc(j, -k);
                    inc(r,  k);
                    if r >= Sloupcu then
                    begin
                      if Zapisovat then
                        move(PBuffer0(ObrazS)^[0], PBuffer0(ObrazN)^[j], Sloupcu);
                      goto 3;
                    end else
                    begin
                      BodCil.X := BodCil.X - k*dyC;
                      BodCil.Y := BodCil.Y - k*dxC;
                      BodZdr.X := BodZdr.X + k*CSloupcuN;
                      if Zapisovat and (r > 0) then
                        move(PBuffer0(ObrazS)^[0], PBuffer0(ObrazN)^[j], r);
                    end;
                  end;
                end else
                begin
                  if Zapisovat and (k < Sloupcu) then
                    move(PBuffer0(ObrazS)^[k], PBuffer0(ObrazN)^[j], succ(Sloupcu-r));
                  goto 3;
                end;

              inc(j, r);
              BodCil.X := BodCil.X + r*dyC;
              BodCil.Y := BodCil.Y + r*dxC;
              BodZdr.X := BodZdr.X - r*CSloupcuN;
            until j >= MaxSloupecN;
          end;

        3:DalsiKrokAbortNMCallBackPr(0, 0);
          KeepWindowsAliveCallBackPr(0, 0);
          if BylUserAbortAbortNMCallBackPr(0, 0) then
          begin
            EscDone := true;
            exit;
          end;
        end;
      end else
      begin
        BodZdr.Y := MinSRadkuNObr - CRadkuN;

        for i := MinRadkaN to MaxRadkaN do
        begin
          fN^.Read(ObrazN, pred(i));

          UrciPrusecikySRadkou(i, Sloupcu, Obrazec, Rada, Pocet);
          if Pocet = 1 then
          begin
            j  := Rada[1] - 1;
            BodZdr.Y := BodZdr.Y + CRadkuN;
            BodZdr.X := (SloupcuN - Rada[1]) * CSloupcuN + MinSSloupcuN;
            InvTransformuj(BodZdr, BodCil);
            k := round(Sloupcu-BodCil.X);
            l := round(BodCil.Y);
            if sl <> l then
            begin
              if (l > 0) and (l <= Radku) then
              begin
                Zapisovat := true;
                fSt^.Read(ObrazS, pred(l));
              end
              else
                Zapisovat := false;
              sl := l;
            end;
            if Zapisovat then
              PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
          end else
          begin
            BodZdr.Y := BodZdr.Y + CRadkuN;
            BodZdr.X := (SloupcuN - Rada[2]) * CSloupcuN + MinSSloupcuN;
            InvTransformuj(BodZdr, PomBodCil);

            BodZdr.X := BodZdr.X + CSloupcuN;
            InvTransformuj(BodZdr, BodCil);

            dxc := BodCil.Y - PomBodCil.Y;
            dyc := BodCil.X - PomBodCil.X;

            BodCil.X := PomBodCil.X - dyC;
            BodCil.Y := PomBodCil.Y - dxC;

            MinSloupecN := Rada[1];
            MaxSloupecN := Rada[2];

            j := MaxSloupecN;
            dec(MinSloupecN);
            repeat
              dec(j);
              if j = pred(MinSloupecN) then goto 4;
              BodCil.X := BodCil.X + dyC;
              BodCil.Y := BodCil.Y + dxC;
              k := round(Sloupcu-BodCil.X);
              l := round(BodCil.Y);
            until (k >= 0) and (k < Sloupcu) and (l > 0) and (l <= Radku);
            sp := j;

            if sl <> l then
            begin
              sl := l;
              fSt^.Read(ObrazS, pred(sl));
            end;
            PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
            for j := pred(sp) downto MinSloupecN do
            begin
              BodCil.X := BodCil.X + dyC;
              BodCil.Y := BodCil.Y + dxC;
              k  := round(Sloupcu-BodCil.X);
              l  := round(BodCil.Y);
              if (k < 0) or (k >= Sloupcu) or (l < 1) or (l > Radku) then
                goto 4
              else
              begin
                if sl <> l then
                begin
                  sl := l;
                  fSt^.Read(ObrazS, pred(sl));
                end;
                PBuffer0(ObrazN)^[j] := PBuffer0(ObrazS)^[k];
              end;
            end;
          end;

        4:DalsiKrokAbortNMCallBackPr(0, 0);
          KeepWindowsAliveCallBackPr(0, 0);
          if BylUserAbortAbortNMCallBackPr(0, 0) then
          begin
            EscDone := true;
            exit;
          end;
        end;
      end;
    end;
  end;
end;





end.
