unit F_CreIdx;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls,
   StdCtrls, Buttons, ExtCtrls, DB, DBTables,
   u_DBLib, u_BDELib,BDE, F_SaveAs;

type
  TTypeDb = (NoDb, dBase, Pdx, SQL);

  TF_CreateIdx = class(TForm)
    Panel3: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    PaneldBase: TPanel;
    Label2: TLabel;
    ListBoxdBaseField: TListBox;
    GroupBox2: TGroupBox;
    ChkBoxUniqdBase: TCheckBox;
    ChkBoxMnteddBase: TCheckBox;
    ChkBoxDescdBase: TCheckBox;
    Label3: TLabel;
    EdtdBaseIdxField: TEdit;
    Label4: TLabel;
    EdtdBaseExprIdx: TEdit;
    Label5: TLabel;
    EdtdBaseFiltrExprIdx: TEdit;
    BtndBaseExprIdx: TButton;
    PanelOther: TPanel;
    Label6: TLabel;
    Label7: TLabel;
    IncludeBtn: TSpeedButton;
    ExcludeBtn: TSpeedButton;
    Label8: TLabel;
    SBtnMoveUp: TSpeedButton;
    SBtnMoveDown: TSpeedButton;
    ListBoxFields: TListBox;
    ListBoxIdxFields: TListBox;
    GroupBox3: TGroupBox;
    ChkBoxUniqSQL: TCheckBox;
    ExAllBtn: TSpeedButton;
    GroupBox1: TGroupBox;
    ChkBoxUniqPdx: TCheckBox;
    ChkBoxMntedPdx: TCheckBox;
    ChkBoxCaseSensPdx: TCheckBox;
    GroupBox4: TGroupBox;
    RdBtnAsc: TRadioButton;
    RdBtnDesc: TRadioButton;
    procedure RdBtnDescClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure IncludeBtnClick(Sender: TObject);
    procedure ExcludeBtnClick(Sender: TObject);
    procedure ExcAllBtnClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);


  private
    { Private declarations }
    aTbl: TTable;
    aTypeDb: String;

    function  GetDbiName(aText: String): DBINAME;
    function  GetDbiTblName(aText: String): DBITBLNAME;
    function  GetFirstSelection(List: TCustomListBox): Integer;

    procedure MoveSelected(List: TCustomListBox; Items: TStrings);
    procedure NastavPaneldBase;
    procedure NastavPanelPdx;
    procedure NastavPanelSQL;
    procedure SetButtons;
    procedure SetItem(List: TListBox; Index: Integer);
    procedure UkazPanel(aPanel: TPanel);
  public
    { Public declarations }
     function MyShowModal(Sender: TObject): Integer; virtual;
  protected
  end;

var
  F_CreateIdx: TF_CreateIdx;

implementation


{$R *.DFM}



function TF_CreateIdx.MyShowModal(Sender: TObject): Integer;
begin

   if TTable(Sender) is TTable then
   begin
      aTbl := TTable.Create(F_CreateIdx);
      aTbl := TTable(Sender);
   end
   else
      exit; // nen TTable

   if not orbOpenTable(aTbl) then exit; // Nepodailo se otevt Table

   aTypeDb := orbSetTypeDb(aTbl);

   if aTypeDb = 'NODB' then exit; // Je to ASCII a ne TTable, proto konec

   if aTypeDb = 'PDX' then
      NastavPanelPdx
   else if aTypeDb = 'DBASE' then
      NastavPaneldBase
   else if aTypeDb = 'SQL' then
      NastavPanelSQL;

   Screen.Cursor := crDefault;
   Result := ShowModal;
end;



procedure TF_CreateIdx.NastavPaneldBase;
begin
   Caption := 'Definovn indexu';
   UkazPanel(PaneldBase);
   u_DBLib.orbAddDbFieldsToListBox(aTbl, ListBoxFields);
end;



procedure TF_CreateIdx.NastavPanelPdx;
var
   i: Integer;
begin
   Caption := 'Definovn sekundrnho indexu';
   UkazPanel(PanelOther);
   GroupBox3.Visible := False;
   u_DBLib.orbAddDbFieldsToListBox(aTbl, ListBoxFields);
end;



procedure TF_CreateIdx.NastavPanelSQL;
begin
   Caption := 'Definovn indexu';
   UkazPanel(PanelOther);
   GroupBox1.Visible := False;
   u_DBLib.orbAddDbFieldsToListBox(aTbl, ListBoxFields);
end;



procedure TF_CreateIdx.UkazPanel(aPanel: TPanel);
begin
   if aPanel.Visible = False then aPanel.Visible := True;

   aPanel.BringToFront;
end;



procedure TF_CreateIdx.RdBtnDescClick(Sender: TObject);
begin
//   RdBtnDesc.Checked := True;
end;



procedure TF_CreateIdx.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   aTbl.Free;
   Action := caFree;
end;



procedure TF_CreateIdx.IncludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(ListBoxFields);
  MoveSelected(ListBoxFields, ListBoxIdxFields.Items);
  SetItem(ListBoxFields, Index);
end;



procedure TF_CreateIdx.ExcludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(ListBoxIdxFields);
  MoveSelected(ListBoxIdxFields, ListBoxFields.Items);
  SetItem(ListBoxIdxFields, Index);
end;



procedure TF_CreateIdx.ExcAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to ListBoxIdxFields.Items.Count - 1 do
    ListBoxFields.Items.AddObject(ListBoxIdxFields.Items[I],
      ListBoxIdxFields.Items.Objects[I]);

  ListBoxIdxFields.Items.Clear;
  SetItem(ListBoxIdxFields, 0);
end;



procedure TF_CreateIdx.MoveSelected(List: TCustomListBox; Items: TStrings);
var
  I: Integer;
begin
  for I := List.Items.Count - 1 downto 0 do
    if List.Selected[I] then
    begin
      Items.AddObject(List.Items[I], List.Items.Objects[I]);
      List.Items.Delete(I);
    end;
end;



procedure TF_CreateIdx.SetButtons;
var
  SrcEmpty, DstEmpty, DstUpEmpty: Boolean;
begin
  SrcEmpty := ListBoxFields.Items.Count = 0;
  DstEmpty := ListBoxIdxFields.Items.Count = 0;
  DstUpEmpty := ListBoxIdxFields.Items.Count < 2;
  IncludeBtn.Enabled := not SrcEmpty;
  ExcludeBtn.Enabled := not DstEmpty;
  ExAllBtn.Enabled := not DstEmpty;
  SBtnMoveUp.Enabled := not DstUpEmpty;
  SBtnMoveDown.Enabled := not DstUpEmpty;
end;



function TF_CreateIdx.GetFirstSelection(List: TCustomListBox): Integer;
begin
  for Result := 0 to List.Items.Count - 1 do
    if List.Selected[Result] then Exit;
  Result := LB_ERR;
end;



procedure TF_CreateIdx.SetItem(List: TListBox; Index: Integer);
var
  MaxIndex: Integer;
begin
  with List do
  begin
    SetFocus;
    MaxIndex := List.Items.Count - 1;
    if Index = LB_ERR then Index := 0
    else if Index > MaxIndex then Index := MaxIndex;
    Selected[Index] := True;
  end;
  SetButtons;
end;



procedure TF_CreateIdx.BitBtn1Click(Sender: TObject);
var
   NewIndex: IDXDesc;
   pszDriveType: PChar;
begin

   NewIndex.bPrimary:= FALSE;

   if aTypeDb = 'PDX' then
   begin
      pszDriveType := szPARADOX;

      NewIndex.szName := GetDbiTblName(FSaveAs.TextDlg);
      NewIndex.bUnique:= ChkBoxUniqPdx.Checked;
      NewIndex.iIndexId:= 0;
      NewIndex.bDescending:= RdBtnDesc.Checked;
      NewIndex.bMaintained:= ChkBoxMntedPdx.Checked;
      NewIndex.bSubset:= FALSE;
      NewIndex.bExpIdx:= FALSE;
      NewIndex.iFldsInKey:= 1;
      NewIndex.aiKeyFld[0]:= 2;
      NewIndex.bCaseInsensitive:= not ChkBoxCaseSensPdx.Checked;

   end
   else if aTypeDb = 'DBASE' then
   begin
      pszDriveType := szDBASE;

      NewIndex.szTagName:= GetDbiName(FSaveAs.TextDlg);
      NewIndex.bUnique:= ChkBoxUniqdBase.Checked;
      NewIndex.bDescending:= ChkBoxDescdBase.Checked;
      NewIndex.bMaintained:= ChkBoxMnteddBase.Checked;
      NewIndex.bSubset:= FALSE;
      NewIndex.iFldsInKey:= 1;
      NewIndex.aiKeyFld[0]:= 2;

      if EdtdBaseExprIdx.Text = '' then
         NewIndex.bExpIdx:= FALSE
      else
         NewIndex.bExpIdx:= TRUE;

//      NewIndex.szKeyExp:= EdtdBaseExprIdx.Text;   // Although this is not an Expression index,

//      NewIndex.szKeyCond:= EdtdBaseFiltrExprIdx.Text;  // szKeyExp and szKeyCond must be set blank

      NewIndex.bCaseInsensitive:= FALSE;
      NewIndex.iBlockSize:= 0;

   end
   else if aTypeDb = 'SQL' then
      pszDriveType := nil;

   orbfDbiAddIndex(aTbl, pszDriveType, NewIndex);
end;



function TF_CreateIdx.GetDbiName(aText: String): DBINAME;
begin
   StrPCopy(Result, aText);
end;



function TF_CreateIdx.GetDbiTblName(aText: String): DBITBLNAME;
begin
   StrPCopy(Result, aText);
end;


end.
